// Copyright (c) Naiky Company. All rights reserved.
//
// Abstract:
// ɾظļӹ  2010-5-4
///////////////////////////////////////////////////////////
#include "stdafx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

inline bool _equal(double x, double y, double epslon)
{
	ASSERT(_IsValid(x));
	ASSERT(_IsValid(y));
	ASSERT(epslon > 0.);
	return (fabs(x - y) < epslon);
}

inline bool _great(double x, double y, double epslon)
{
	ASSERT(_IsValid(x));
	ASSERT(_IsValid(y));
	ASSERT(epslon > 0.);
	return (x >= y + epslon);
}

inline bool _less(double x, double y, double epslon)
{
	ASSERT(IsValidDouble(x));
	ASSERT(IsValidDouble(y));
	ASSERT(epslon > 0.);
	return (x <= y - epslon);
}

const double c_nPERCENT_FOR_COMPARE0 = 1.0;
const double c_nPERCENT_FOR_COMPARE1 = 1.e-1;
const double c_nPERCENT_FOR_COMPARE2 = 1.e-2;
// const double c_nPERCENT_FOR_COMPARE3 = 1.e-3;

//#define _less_percent(x, y)		abs(y) > c_nPERCENT_FOR_COMPARE1 ? _less (x / abs(y), y / abs(y), c_nPERCENT_FOR_COMPARE1) : _less (x, y, c_nPERCENT_FOR_COMPARE1)
//#define _equal_percent(x, y)	abs(y) > c_nPERCENT_FOR_COMPARE1 ? _equal (x / abs(y), y / abs(y), c_nPERCENT_FOR_COMPARE1) : _equal(x, y, c_nPERCENT_FOR_COMPARE1)
//#define _great_percent(x, y)	abs(y) > c_nPERCENT_FOR_COMPARE1 ? _great(x / abs(y), y / abs(y), c_nPERCENT_FOR_COMPARE1) : _great(x, y, c_nPERCENT_FOR_COMPARE1)

#define _float_less(x,y) _less (x, y, c_nPERCENT_FOR_COMPARE2/*c_nPERCENT_FOR_COMPARE3*/)
#define _float_equ(x,y) _equal(x, y, c_nPERCENT_FOR_COMPARE2/*c_nPERCENT_FOR_COMPARE3*/)
#define _float_great(x,y) _great(x, y, c_nPERCENT_FOR_COMPARE2/*c_nPERCENT_FOR_COMPARE3*/)
#define _float_ge(x, y) (_float_great(x, y) || _float_equ(x, y)) /* x >= y */
#define _float_le(x, y) (_float_less(x, y) || _float_equ(x, y)) /* x <= y */
// ؾ1.e-1ȽϾ 崺 2012-7-26
#define _float_less_CoeB(x,y) ((x > 100 || x < -100) ? _less(x, y, c_nPERCENT_FOR_COMPARE0/*c_nPERCENT_FOR_COMPARE2*/) : _less(x, y, c_nPERCENT_FOR_COMPARE1/*c_nPERCENT_FOR_COMPARE3*/))
#define _float_equ_CoeB(x,y) ((x > 100 || x < -100) ? _equal(x, y, c_nPERCENT_FOR_COMPARE0/*c_nPERCENT_FOR_COMPARE2*/) : _equal(x, y, c_nPERCENT_FOR_COMPARE1/*c_nPERCENT_FOR_COMPARE3*/))

using namespace nce;

CCamRepeatedDelete::CCamRepeatedDelete()
{
}

CCamRepeatedDelete::~CCamRepeatedDelete()
{
}

void CCamRepeatedDelete::CamRepeatedDelete(IN const CCamGroup* pSrcCamGroup_,IN OUT CCamGroup* pDestCamGroup_)
{
	//ɾPath͵ĶظߣʱȲõ㱣浽pDesCadGroup_
	CamRepeatedDelete_Path(pSrcCamGroup_, pDestCamGroup_);
	//ɾHole͵Ķ  2010-7-12
	CamRepeatedDelete_Hole(pDestCamGroup_);
}

void CCamRepeatedDelete::CamRepeatedDelete_Path(IN const CCamGroup* pSrcCamGroup_,IN OUT CCamGroup* pDestCamGroup_)
{
	CCamGroup* _pCamGroupPath = new CCamGroup;
	// _pCamGroupPath->m_nOwnerGroupId = pDestCamGroup_->m_nID;

	CamObjectList::const_iterator _it;
	for (_it = pSrcCamGroup_->GetObjectsList()->begin(); _it != pSrcCamGroup_->GetObjectsList()->end(); ++_it)
	{
		const CCamObject* _pCamObject = (*_it);
		CamRepeatedDelete_Path(_pCamObject, _pCamGroupPath);
	}

	if (GetCamgroupSize(_pCamGroupPath))
	{
		pDestCamGroup_->GetObjectsList()->push_back(_pCamGroupPath);
	}
	else
	{
		delete _pCamGroupPath;
	}
	return;
}

void CCamRepeatedDelete::CamRepeatedDelete_Path(IN const CCamObject* pCamObject_,IN OUT CCamGroup* pCamGroup_)
{
	switch(pCamObject_->GetType())
	{
	case nce::campath:
		CamRepeatedDelete_Path(reinterpret_cast<const nce::CCamPath*>(pCamObject_), pCamGroup_);
		break;

	case nce::camhole:
		{
			//úɾpath͵ظߣΪͣȽõ㱣浽pCamGroup_Уpath͵Ķ  2010-7-12
			CCamHole* _pHole = (CCamHole*)pCamObject_->Clone();
			//_pHole->m_nOwnerGroupId = pCamGroup_->m_nID;
			pCamGroup_->GetObjectsList()->push_back(_pHole);
		}
		break;

	case nce::camgroup:
		CamRepeatedDelete_Path(reinterpret_cast<const nce::CCamGroup*>(pCamObject_), pCamGroup_);
		break;

	case nce::camscanlines:
		ASSERT(FALSE);
		break;
	default:
		ASSERT(false);
		break;
	}

	return;
}

void CCamRepeatedDelete::CamRepeatedDelete_Path(IN const CCamPath* pPath_,IN  OUT CCamGroup* pCamGroup_)
{
	CCamPath* _pDesPath = new CCamPath;
	_pDesPath->SetParamIndex(pPath_->GetParamIndex());
	_pDesPath->SetParamString(pPath_->GetParamString());
	//_pDesPath->m_nOwnerGroupId = pCamGroup_->m_nID;

	// void* _pData = pPath_->m_pNodes;
	// BYTE* _pTypes = pPath_->m_pTypes;
	// ASSERT(NULL != _pData && NULL != _pTypes);
	int _nNodeCount = pPath_->GetNodeCount();

	DPOINT3 _ptCurPoint = pPath_->GetStartPoint();
	_pDesPath->SetStartPoint(_ptCurPoint);
	DPOINT3 _ptNextPoint = _ptCurPoint;

	for (int _i = 0; _i < _nNodeCount; ++_i)
	{
		nce::CCamPath::NODE _node = pPath_->GetNode(_i);
		switch(_node.nType & 0xF0)
		{
		case CCamPath::nt_line:
			{
				GetLineNode(_node, _ptNextPoint);
				//߶εյ߶εϢظ߶Ϣ  2010-7-12
				LineInfo _pLineInfo = CalculateLineFormula(_ptCurPoint, _ptNextPoint);
				if (ModifyLine(&_pLineInfo))
				{
					//ModifyLine()trueʾöֱظѾɾ  2010-7-12
					if (_pLineInfo.vecPositions.size() == 0)
					{
						//ɾö߶в߶ˣʾö߶αɾ  2010-7-12
						if (_pDesPath->GetNodeCount() != 0)
						{
							AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
						}

						_pDesPath->SetStartPoint(_ptNextPoint);
					}
					else
					{
						//ɾö߶л߶Σ߶ȡӵ_pDesPathС
						//ö߶αָɲСΣڲĵطҪȽǰ_pDesPath浽pCamGroup_У
						//newһµCCamPath_pDesPath¼  2010-7-12
						if (_pLineInfo.bDirReversed == false)
						{
							//_pLineInfoм¼߶Ϣǰxķ¼ģԭ߶εķ෴bDirReversedΪfalseʾԭ߶η෴
							//ԭ߶εķxķģ_pLineInfoдͷβȡɾظ߶κ߶ӵ_pDesPath
							//ǰ߶αָɲСε  2010-7-12
							if (DPOINT3_EQU(_pLineInfo.vecPositions.front().ptStartPoint, _pDesPath->GetEndPoint()) && 
								DPOINT3_EQU(_pLineInfo.vecPositions.back().ptEndPoint, _ptNextPoint))
							{
								ASSERT(_pLineInfo.vecPositions.size() > 1);
								for (std::list<LinePosition>::iterator _it = _pLineInfo.vecPositions.begin(); _it != _pLineInfo.vecPositions.end(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptEndPoint);

									std::list<LinePosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.end())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									}
								}
							}
							else if (DPOINT3_EQU(_pLineInfo.vecPositions.front().ptStartPoint, _pDesPath->GetEndPoint()) && 
									 !DPOINT3_EQU(_pLineInfo.vecPositions.back().ptEndPoint, _ptNextPoint))
							{
								for (std::list<LinePosition>::iterator _it = _pLineInfo.vecPositions.begin(); _it != _pLineInfo.vecPositions.end(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptEndPoint);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<LinePosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.end())
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
							else if ((DPOINT3)_pLineInfo.vecPositions.front().ptStartPoint != (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_pLineInfo.vecPositions.back().ptEndPoint == _ptNextPoint)
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_pLineInfo.vecPositions.front().ptStartPoint);

								for (std::list<LinePosition>::iterator _it = _pLineInfo.vecPositions.begin(); _it != _pLineInfo.vecPositions.end(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptEndPoint);

									std::list<LinePosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.end())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									}
								}
							}
							else
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_pLineInfo.vecPositions.front().ptStartPoint);

								for (std::list<LinePosition>::iterator _it = _pLineInfo.vecPositions.begin(); _it != _pLineInfo.vecPositions.end(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptEndPoint);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<LinePosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.end())
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
						}
						else
						{
							//_pLineInfoм¼߶Ϣǰxķ¼ģԭ߶εķ෴bDirReversedΪtrueʾԭ߶η෴
							//ԭ߶εķxСķģ_pLineInfoȡ߶ʱҪvecPositionsĩβͷȡ  2010-7-12
							if ((DPOINT3)_pLineInfo.vecPositions.back().ptEndPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
								(DPOINT3)_pLineInfo.vecPositions.front().ptStartPoint == _ptNextPoint)
							{
								ASSERT(_pLineInfo.vecPositions.size() > 1);
								for (std::list<LinePosition>::reverse_iterator _it = _pLineInfo.vecPositions.rbegin(); _it != _pLineInfo.vecPositions.rend(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptStartPoint);

									std::list<LinePosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.rend())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									}
								}
							}
							else if ((DPOINT3)_pLineInfo.vecPositions.back().ptEndPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_pLineInfo.vecPositions.front().ptStartPoint != _ptNextPoint)
							{
								for (std::list<LinePosition>::reverse_iterator _it = _pLineInfo.vecPositions.rbegin(); _it != _pLineInfo.vecPositions.rend(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptStartPoint);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<LinePosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.rend())
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
							else if ((DPOINT3)_pLineInfo.vecPositions.back().ptEndPoint != (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_pLineInfo.vecPositions.front().ptStartPoint == _ptNextPoint)
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_pLineInfo.vecPositions.back().ptEndPoint);

								for (std::list<LinePosition>::reverse_iterator _it = _pLineInfo.vecPositions.rbegin(); _it != _pLineInfo.vecPositions.rend(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptStartPoint);

									std::list<LinePosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.rend())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									}
								}
							}
							else
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_pLineInfo.vecPositions.back().ptEndPoint);

								for (std::list<LinePosition>::reverse_iterator _it = _pLineInfo.vecPositions.rbegin(); _it != _pLineInfo.vecPositions.rend(); ++_it)
								{
									_pDesPath->AddLine((*_it).ptStartPoint);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<LinePosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _pLineInfo.vecPositions.rend())
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
						}
					}
				}
				else
				{
					_pDesPath->AddLine(_ptNextPoint);
				}

				_ptCurPoint = _ptNextPoint;
			}
			break;

		case CCamPath::nt_arc:
			{
				double _nBulgeOriginal = 0;
				GetArcNode(_node, _ptNextPoint, _nBulgeOriginal);
				//Բ㡢յ㡢͹ȼԲϢظԲϢ  2010-7-12
				ArcInfo _ArcInfo = CalculateArcInfo(_ptCurPoint, _ptNextPoint, _nBulgeOriginal);
				if (ModifyArc(&_ArcInfo))
				{
					//ModifyLine()trueʾöԲظѾɾ  2010-7-12
					if (_ArcInfo.vecPositions.size() == 0)
					{
						if (_pDesPath->GetNodeCount() != 0)
						{
							//ɾöԲвԲˣʾöԲαɾ  2010-7-12
							AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
						}

						_pDesPath->SetStartPoint(_ptNextPoint);
					}
					else
					{
						//ɾöԲлԲΣԲȡӵ_pDesPathС
						//öԲָɲСΣڲĵطҪȽǰ_pDesPath浽pCamGroup_У
						//newһµCCamPath_pDesPath¼  2010-7-12
						if (_ArcInfo.bDirReversed == false)
						{
							//_ArcInfoм¼ԲϢǰʱתķ¼ģԭԲķ෴bDirReversedΪfalseʾԭԲ෴
							//ԭԲķǰʱתķģ_ArcInfoдͷβȡɾظԲκԲӵ_pDesPath
							//ǰԲָɲСε  2010-7-12
							if ((DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
								(DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == _ptNextPoint)
							{
								ASSERT(_ArcInfo.vecPositions.size() > 1);
								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									}
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint != _ptNextPoint)
							{
								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint != (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == _ptNextPoint)
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.front().ptStartPoint);

								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									}
								}
							}
							else
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.front().ptStartPoint);

								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
						}
						else
						{
							//_ArcInfoм¼ԲϢǰʱתķ¼ģԭԲķ෴bDirReversedΪtrueʾԭԲ෴
							//ԭԲķ˳ʱתķģ_ArcInfoȡԲʱҪvecPositionsĩβͷȡ  2010-7-12
							if ((DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
								(DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == _ptNextPoint)
							{
								ASSERT(_ArcInfo.vecPositions.size() > 1);
								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									}
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint != _ptNextPoint)
							{
								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint != (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == _ptNextPoint)
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.back().ptEndPoint);

								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									}
								}
							}
							else
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.back().ptEndPoint);

								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
						}
					}
				}
				else
				{
					_pDesPath->AddArc(_ptNextPoint , _nBulgeOriginal, CCamPath::nt_arc_xy);
				}

				_ptCurPoint = _ptNextPoint;
			}
			break;

		case CCamPath::nt_circle:
			{
				//ԲĴԲƣԲĴ  2010-7-12
				double _nRadius = 0;
				GetCircleNode(_node, _ptNextPoint, _nRadius);
				ArcInfo _ArcInfo = CalculateArcInfo(_ptCurPoint, _ptNextPoint, _nRadius, _node.nType/* _pTypes[_i]*/);
				if (ModifyArc(&_ArcInfo))
				{
					if (_ArcInfo.vecPositions.size() == 0)
					{
						if (_pDesPath->GetNodeCount() != 0)
						{
							AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
						}

						_pDesPath->SetStartPoint(_ptNextPoint);
					}
					else
					{
						if (_ArcInfo.bDirReversed == false)
						{
							if ((DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
								(DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == _ptNextPoint)
							{
								ASSERT(_ArcInfo.vecPositions.size() > 1);
								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									}
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint != _ptNextPoint)
							{
								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint != (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == _ptNextPoint)
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.front().ptStartPoint);

								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									}
								}
							}
							else
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.front().ptStartPoint);

								for (std::list<ArcPosition>::iterator _it = _ArcInfo.vecPositions.begin(); _it != _ArcInfo.vecPositions.end(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nStartAngle, (*_it).nEndAngle);
									_pDesPath->AddArc((*_it).ptEndPoint, _nBulge, CCamPath::nt_arc_xy);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<ArcPosition>::iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.end())
										_pDesPath->SetStartPoint((*_itt).ptStartPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
						}
						else
						{
							if ((DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
								(DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == _ptNextPoint)
							{
								ASSERT(_ArcInfo.vecPositions.size() > 1);
								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									}
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint == (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint != _ptNextPoint)
							{
								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									else
										_pDesPath->SetStartPoint(_ptNextPoint);
								}
							}
							else if ((DPOINT3)_ArcInfo.vecPositions.back().ptEndPoint != (DPOINT3)_pDesPath->GetEndPoint() && 
									 (DPOINT3)_ArcInfo.vecPositions.front().ptStartPoint == _ptNextPoint)
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.back().ptEndPoint);

								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									}
								}
							}
							else
							{
								if (_pDesPath->GetNodeCount() != 0)
								{
									AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
								}

								_pDesPath->SetStartPoint(_ArcInfo.vecPositions.back().ptEndPoint);

								for (std::list<ArcPosition>::reverse_iterator _it = _ArcInfo.vecPositions.rbegin(); _it != _ArcInfo.vecPositions.rend(); ++_it)
								{
									double _nBulge = CalculateBulge((*_it).nEndAngle, (*_it).nStartAngle);
									_pDesPath->AddArc((*_it).ptStartPoint, _nBulge, CCamPath::nt_arc_xy);

									std::list<ArcPosition>::reverse_iterator _itt = _it;
									++_itt;
									if (_itt != _ArcInfo.vecPositions.rend())
									{
										AddPath(pCamGroup_, _pDesPath, pPath_->GetParamIndex());
										_pDesPath->SetStartPoint((*_itt).ptEndPoint);
									}
								}
							}
						}
					}
				}
				else
				{
					_pDesPath->AddCircle(_ArcInfo.ptCenterPoint, _node.nType);
				}
				_ptCurPoint = _ptNextPoint;
			}
			break;

		default:
			ASSERT(false);
			break;
		}
	}

	if (_pDesPath->GetNodeCount() != 0)
		pCamGroup_->GetObjectsList()->push_back(_pDesPath);
	else
		delete _pDesPath;

	return;
}

//߶εյ߶εϢظ߶Ϣ  2010-7-12
LineInfo CCamRepeatedDelete::CalculateLineFormula(DPOINT3 ptStartPoint_, DPOINT3 ptEndPoint_)
{
	LineInfo _LineInfo;
	if (_float_equ(ptStartPoint_.x, ptEndPoint_.x))
	{
		//ö߶xᴹֱûб
		_LineInfo.bSlopeExist = false;
		//nCoefficientA¼Ǹö߶εxֵ
		_LineInfo.nCoefficientA = ptStartPoint_.x;

		//yķ¼ö߶εʼy  2010-7-12
		if (ptStartPoint_.y < ptEndPoint_.y)
		{
			LinePosition _LinePosition(ptStartPoint_, ptEndPoint_);
			_LineInfo.vecPositions.push_back(_LinePosition);
		}
		else
		{
			//ö߶yСķģ¼԰yķ¼bDirReversedֵΪtrueʾ_LinePosition¼߶ԭ߶η෴
			LinePosition _LinePosition(ptEndPoint_, ptStartPoint_);
			_LineInfo.bDirReversed = true;
			_LineInfo.vecPositions.push_back(_LinePosition);
		}
	}
	else
	{
		//߶βxᴹֱnCoefficientAnCoefficientBֱ¼Ǹö߶εбؾ  2010-7-12
		_LineInfo.bSlopeExist = true;
		_LineInfo.nCoefficientA = (ptEndPoint_.y - ptStartPoint_.y) / (ptEndPoint_.x - ptStartPoint_.x);
		_LineInfo.nCoefficientB = ptStartPoint_.y - _LineInfo.nCoefficientA * ptStartPoint_.x;

		//xķ¼߶εյxֵ߶εյyֵͨxֵбؾ  2010-7-12
		if (_float_less(ptStartPoint_.x, ptEndPoint_.x))
		{
			LinePosition _LinePosition(ptStartPoint_, ptEndPoint_);
			_LineInfo.vecPositions.push_back(_LinePosition);
		}
		else
		{
			//ö߶ԭǰxСķģ¼ʱ԰xķ¼,bDirReversedֵΪtrueʾ_LinePosition¼߶ԭ߶η෴
			LinePosition _LinePosition(ptEndPoint_, ptStartPoint_);
			_LineInfo.bDirReversed = true;
			_LineInfo.vecPositions.push_back(_LinePosition);
		}
	}

	return _LineInfo;
}

//Բ㡢յ㡢͹ȼԲϢظԲϢ  2010-7-12
ArcInfo CCamRepeatedDelete::CalculateArcInfo(DPOINT3 ptStartPoint_, DPOINT3 ptEndPoint_, double nBulge_)
{
	ASSERT(nBulge_ != 0.);
	ASSERT((ptStartPoint_ - ptEndPoint_).GetLength() > 0.);
	if (nBulge_ > 0.)
	{
		//͹ȴ0Բΰʱ뷽ת
		ArcInfo _ArcInfo;
		DPOINT3 _center;
		double _nAngleStart, _nAngleEnd, _nRadius;
		double _nBulge = nBulge_;
		RetrieveArcInf(ptStartPoint_, ptEndPoint_, _nBulge, &_center, &_nAngleStart, &_nAngleEnd, &_nRadius);
		_ArcInfo.ptCenterPoint = _center;
		_ArcInfo.nRadius = _nRadius;
		ArcPosition _ArcPosition(_nAngleStart, _nAngleEnd, ptStartPoint_, ptEndPoint_);
		_ArcInfo.vecPositions.push_back(_ArcPosition);
		return _ArcInfo;
	}
	else
	{
		//͹С0Բΰ˳ʱ뷽ת򱣴ԲϢʱʱ뷽򱣴棬bDirReversedΪtrueʾ¼ԲϢԭԲķ෴
		ArcInfo _ArcInfo;
		_ArcInfo.bDirReversed = true;
		DPOINT3 _center;
		double _nAngleStart, _nAngleEnd, _nRadius;
		double _nBulge = - nBulge_;
		RetrieveArcInf(ptEndPoint_, ptStartPoint_, _nBulge, &_center, &_nAngleStart, &_nAngleEnd, &_nRadius);
		_ArcInfo.ptCenterPoint = _center;
		_ArcInfo.nRadius = _nRadius;
		ArcPosition _ArcPostion(_nAngleStart, _nAngleEnd, ptEndPoint_, ptStartPoint_);
		_ArcInfo.vecPositions.push_back(_ArcPostion);
		return _ArcInfo;
	}
}

//Բ㣬Բģ뾶˳/ʱתԲϢظԲϢ  2010-7-12
ArcInfo CCamRepeatedDelete::CalculateArcInfo(DPOINT3 ptStartPoint_, DPOINT3 ptCenterPoint_, double nRadius_, BYTE nType_)
{
	ArcInfo _ArcInfo;
	DPOINT3 _ptCenter(ptCenterPoint_.x, ptCenterPoint_.y, ptCenterPoint_.z);
	_ArcInfo.ptCenterPoint = _ptCenter;
	_ArcInfo.nRadius = nRadius_;
	_ArcInfo.bDirReversed = (nType_ == CCamPath::nt_circle_xy_ccw) ? false : true;
	double _nAngle = ncmath::D2GetNormalAngle(ptStartPoint_.x - ptCenterPoint_.x, ptStartPoint_.y - ptCenterPoint_.y);
	ArcPosition _ArcPosition(_nAngle, _nAngle + 2 * ncmath::c_nPIE, ptStartPoint_, ptStartPoint_);
	_ArcInfo.vecPositions.push_back(_ArcPosition);
	return _ArcInfo;
}

void CCamRepeatedDelete::RetrieveArcInf(IN const DPOINT3& ptStart_, IN const DPOINT3&ptEnd_, IN const double& nBulge_,
					OUT DPOINT3* pptCenter_, OUT double* pnStartAngle_, OUT double* pnEndAngle_, OUT double* pnRadius_)
{
	DPOINT3 _ptFromTo = (DPOINT3)ptEnd_ - (DPOINT3)ptStart_;
	double _nLen = _ptFromTo.GetLength();
	ASSERT(DOUBLE_GE_ZERO(_nLen));
	if (DOUBLE_EQU_ZERO(_nLen))
	{
		pptCenter_->x = ptStart_.x;
		pptCenter_->y = ptStart_.y;
		*pnStartAngle_ = 0.;
		*pnEndAngle_ = 0.;
		*pnRadius_ = 0.;
		return;
	}

	// Inner angle
	double _alpha = atan(nBulge_) * 4.;
	ASSERT(DOUBLE_NOT_ZERO(_alpha));

	// 1) Radius
	double _nRadius = _nLen * 0.5 / sin(_alpha * 0.5);
	*pnRadius_ = fabs(_nRadius);

	// 2) Circle centre
	// 2-1) proportional translate
	ASSERT(DOUBLE_NOT_ZERO(_nLen));
	double _nK = _nRadius / _nLen;

	DPOINT2 _ptByPropTrans;
	_ptByPropTrans.x = _ptFromTo.x * _nK;
	_ptByPropTrans.y = _ptFromTo.y * _nK;

	// 2-2) revolving transform
	double _theta = (ncmath::c_nPIE - _alpha) * 0.5;
	DPOINT2 _ptByRevTrans;
	_ptByRevTrans.x = cos(_theta) * _ptByPropTrans.x - sin(_theta) * _ptByPropTrans.y;
	_ptByRevTrans.y = sin(_theta) * _ptByPropTrans.x + cos(_theta) * _ptByPropTrans.y;

	// 2-3) Get circle center 
	pptCenter_->x = ptStart_.x + _ptByRevTrans.x;
	pptCenter_->y = ptStart_.y + _ptByRevTrans.y;
	ASSERT(ptStart_.z == ptEnd_.z);
	pptCenter_->z = ptStart_.z;

	// 3) Start angle
	*pnStartAngle_ = ncmath::D2GetNormalAngle(ptStart_.x - pptCenter_->x, ptStart_.y - pptCenter_->y);

	// 4) End angle
	*pnEndAngle_ = *pnStartAngle_ + _alpha;

	return;
}

//ظöֱǷ޸ĹֱĳֱظĲֱɾʾ䱻޸Ĺ֮pLineInfo_еظֽɾ  2010-7-12
bool CCamRepeatedDelete::ModifyLine(LineInfo* pLineInfo_)
{
	if (pLineInfo_->bSlopeExist)
	{
		//ö߶бʣm_vecLineInfo_SlopeExistҸ߶ǷвѴڵ߶ظ
		if (m_vecLineInfo_SlopeExist.size() != 0)
		{
			lineinfo_holder::const_iterator _itMiddle = bsearchLineInfo(pLineInfo_, m_vecLineInfo_SlopeExist);
			for (lineinfo_holder::iterator _it = m_vecLineInfo_SlopeExist.begin(); _it != m_vecLineInfo_SlopeExist.end(); ++_it)
			{
				bool _b = _float_less((*_it).nCoefficientA, pLineInfo_->nCoefficientA);
				bool _b2 = _float_equ((*_it).nCoefficientA, pLineInfo_->nCoefficientA);
				bool _b3 = _float_less_CoeB((*_it).nCoefficientB, pLineInfo_->nCoefficientB);
				if (_b || (_b2 && _b3))
					continue;
				else if (_float_equ((*_it).nCoefficientA, pLineInfo_->nCoefficientA) && _float_equ_CoeB((*_it).nCoefficientB, pLineInfo_->nCoefficientB))
				{
					ASSERT(pLineInfo_->vecPositions.size() == 1);
					DPOINT3 _ptStartPoint = pLineInfo_->vecPositions.front().ptStartPoint;
					DPOINT3 _ptEndPoint = pLineInfo_->vecPositions.front().ptEndPoint;
					pLineInfo_->vecPositions.clear();
					bool _bModified = false;
					for (std::list<LinePosition>::iterator _iter = (*_it).vecPositions.begin(); _iter != (*_it).vecPositions.end(); ++_iter)
					{
						if (_float_ge(_ptStartPoint.x, (*_iter).ptEndPoint.x))
							continue;
						else if (_float_less(_ptStartPoint.x, (*_iter).ptStartPoint.x) && _float_great(_ptEndPoint.x, (*_iter).ptEndPoint.x))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = (*_iter).ptStartPoint;
							_LinePosition.ptEndPoint.y = pLineInfo_->nCoefficientA * (*_iter).ptStartPoint.x + pLineInfo_->nCoefficientB;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.x, _LinePosition.ptStartPoint.x))
								{
									(*_iter).ptStartPoint = (*_itera).ptStartPoint;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).ptStartPoint = _LinePosition.ptStartPoint;
							}
							else
								(*_iter).ptStartPoint = _LinePosition.ptStartPoint;

							_ptStartPoint.x = (*_iter).ptEndPoint.x;
							_ptStartPoint.y = pLineInfo_->nCoefficientA * (*_iter).ptEndPoint.x + pLineInfo_->nCoefficientB;
							_bModified = true;
						}
						else if (_float_less(_ptStartPoint.x, (*_iter).ptStartPoint.x)
								 && _float_great(_ptEndPoint.x, (*_iter).ptStartPoint.x) && _float_le(_ptEndPoint.x, (*_iter).ptEndPoint.x))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = (*_iter).ptStartPoint;
							_LinePosition.ptEndPoint.y = pLineInfo_->nCoefficientA * (*_iter).ptStartPoint.x + pLineInfo_->nCoefficientB;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.x, _LinePosition.ptStartPoint.x))
								{
									(*_iter).ptStartPoint = (*_itera).ptStartPoint;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).ptStartPoint = _LinePosition.ptStartPoint;
							}
							else
								(*_iter).ptStartPoint = _LinePosition.ptStartPoint;

							return true;
						}
						else if (_float_less(_ptStartPoint.x, (*_iter).ptStartPoint.x) && _float_equ(_ptEndPoint.x, (*_iter).ptStartPoint.x))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = (*_iter).ptStartPoint;
							_LinePosition.ptEndPoint.y = pLineInfo_->nCoefficientA * (*_iter).ptStartPoint.x + pLineInfo_->nCoefficientB;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.x, _LinePosition.ptStartPoint.x))
								{
									(*_iter).ptStartPoint.x = (*_itera).ptStartPoint.x;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).ptStartPoint.x = _LinePosition.ptStartPoint.x;
							}
							else
								(*_iter).ptStartPoint.x = _LinePosition.ptStartPoint.x;

							return _bModified;
						}
						else if (_float_less(_ptStartPoint.x, (*_iter).ptStartPoint.x) && _float_less(_ptEndPoint.x, (*_iter).ptStartPoint.x))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = _ptEndPoint;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.x, _LinePosition.ptStartPoint.x))
									(*_itera).ptEndPoint.x = _LinePosition.ptEndPoint.x;
								else
									_iter = (*_it).vecPositions.insert(_iter, _LinePosition);
							}
							else
								_iter = (*_it).vecPositions.insert(_iter, _LinePosition);

							return _bModified;
						}
						else if (_float_ge(_ptStartPoint.x, (*_iter).ptStartPoint.x) && _float_great(_ptEndPoint.x, (*_iter).ptEndPoint.x))
						{
							_ptStartPoint.x = (*_iter).ptEndPoint.x;
							_ptStartPoint.y = pLineInfo_->nCoefficientA * (*_iter).ptEndPoint.x + pLineInfo_->nCoefficientB;
							_bModified = true;
						}
						else if (_float_ge(_ptStartPoint.x, (*_iter).ptStartPoint.x) && _float_le(_ptEndPoint.x, (*_iter).ptEndPoint.x))
						{
							return true;
						}
					}

					LinePosition _LinePosition;
					_LinePosition.ptStartPoint = _ptStartPoint;
					_LinePosition.ptEndPoint = _ptEndPoint;
					pLineInfo_->vecPositions.push_back(_LinePosition);

					std::list<LinePosition>::iterator _iter = (*_it).vecPositions.end();
					--_iter;
					if (_float_equ((*_iter).ptEndPoint.x, _LinePosition.ptStartPoint.x))
					{
						(*_iter).ptEndPoint = _LinePosition.ptEndPoint;
					}
					else
						(*_it).vecPositions.push_back(_LinePosition);

					return _bModified;
				}
				else
				{
					m_vecLineInfo_SlopeExist.insert(_it, *pLineInfo_);
					return false;
				}
			}

			m_vecLineInfo_SlopeExist.push_back(*pLineInfo_);
			return false;
		}
		else
		{
			m_vecLineInfo_SlopeExist.push_back(*pLineInfo_);
			return false;
		}
	}
	else
	{
		//ö߶ûбʣm_vecLineInfo_SlopeUnExistҸ߶ǷвѴڵ߶ظ
		if (m_vecLineInfo_SlopeUnExist.size() != 0)
		{
			for (lineinfo_holder::iterator _it = m_vecLineInfo_SlopeUnExist.begin(); _it != m_vecLineInfo_SlopeUnExist.end(); ++_it)
			{
				if (_less((*_it).nCoefficientA, pLineInfo_->nCoefficientA, c_nPERCENT_FOR_COMPARE1))
					continue;
				else if (_equal((*_it).nCoefficientA, pLineInfo_->nCoefficientA, c_nPERCENT_FOR_COMPARE1))
				{
					ASSERT(pLineInfo_->vecPositions.size() == 1);
					DPOINT3 _ptStartPoint = pLineInfo_->vecPositions.front().ptStartPoint;
					DPOINT3 _ptEndPoint = pLineInfo_->vecPositions.front().ptEndPoint;
					pLineInfo_->vecPositions.clear();
					bool _bModified = false;
					for (std::list<LinePosition>::iterator _iter = (*_it).vecPositions.begin(); _iter != (*_it).vecPositions.end(); ++_iter)
					{
						if (_float_ge(_ptStartPoint.y, (*_iter).ptEndPoint.y))
							continue;
						else if (_float_less(_ptStartPoint.y, (*_iter).ptStartPoint.y) && _float_great(_ptEndPoint.y, (*_iter).ptEndPoint.y))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = _ptStartPoint;
							_LinePosition.ptEndPoint.y = (*_iter).ptStartPoint.y;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.y, _LinePosition.ptStartPoint.y))
								{
									(*_iter).ptStartPoint.y = (*_itera).ptStartPoint.y;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).ptStartPoint.y = _LinePosition.ptStartPoint.y;
							}
							else
								(*_iter).ptStartPoint = _LinePosition.ptStartPoint;

							_ptStartPoint.y = (*_iter).ptEndPoint.y;
							_bModified = true;
						}
						else if (_float_less(_ptStartPoint.y, (*_iter).ptStartPoint.y)
								 && _float_great(_ptEndPoint.y, (*_iter).ptStartPoint.y) && _float_le(_ptEndPoint.y, (*_iter).ptEndPoint.y))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = _ptStartPoint;
							_LinePosition.ptEndPoint.y = (*_iter).ptStartPoint.y;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.y, _LinePosition.ptStartPoint.y))
								{
									(*_iter).ptStartPoint.y = (*_itera).ptStartPoint.y;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).ptStartPoint.y = _LinePosition.ptStartPoint.y;
							}
							else
								(*_iter).ptStartPoint.y = _LinePosition.ptStartPoint.y;

							return true;
						}
						else if (_float_less(_ptStartPoint.y, (*_iter).ptStartPoint.y) && _float_equ(_ptEndPoint.y, (*_iter).ptStartPoint.y))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = _ptStartPoint;
							_LinePosition.ptEndPoint.y = (*_iter).ptStartPoint.y;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.y, _LinePosition.ptStartPoint.y))
								{
									(*_iter).ptStartPoint.y = (*_itera).ptStartPoint.y;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).ptStartPoint.y = _LinePosition.ptStartPoint.y;
							}
							else
								(*_iter).ptStartPoint.y = _LinePosition.ptStartPoint.y;

							return _bModified;
						}
						else if (_float_less(_ptStartPoint.y, (*_iter).ptStartPoint.y) && _float_less(_ptEndPoint.y, (*_iter).ptStartPoint.y))
						{
							LinePosition _LinePosition;
							_LinePosition.ptStartPoint = _ptStartPoint;
							_LinePosition.ptEndPoint = _ptEndPoint;
							pLineInfo_->vecPositions.push_back(_LinePosition);

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<LinePosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).ptEndPoint.y, _LinePosition.ptStartPoint.y))
									(*_itera).ptEndPoint.y = _LinePosition.ptEndPoint.y;
								else
									_iter = (*_it).vecPositions.insert(_iter, _LinePosition);
							}
							else
								_iter = (*_it).vecPositions.insert(_iter, _LinePosition);

							return _bModified;
						}
						else if (_float_ge(_ptStartPoint.y, (*_iter).ptStartPoint.y) && _float_great(_ptEndPoint.y, (*_iter).ptEndPoint.y))
						{
							_ptStartPoint.y = (*_iter).ptEndPoint.y;
							_bModified = true;
						}
						else if (_float_ge(_ptStartPoint.y, (*_iter).ptStartPoint.y) && _float_le(_ptEndPoint.y, (*_iter).ptEndPoint.y))
						{
							return true;
						}
					}

					LinePosition _LinePosition;
					_LinePosition.ptStartPoint = _ptStartPoint;
					_LinePosition.ptEndPoint = _ptEndPoint;
					pLineInfo_->vecPositions.push_back(_LinePosition);

					std::list<LinePosition>::iterator _iter = (*_it).vecPositions.end();
					--_iter;
					if (_float_equ((*_iter).ptEndPoint.y, _LinePosition.ptStartPoint.y))
					{
						(*_iter).ptEndPoint.y = _LinePosition.ptEndPoint.y;
					}
					else
						(*_it).vecPositions.push_back(_LinePosition);

					return _bModified;
				}
				else
				{
					m_vecLineInfo_SlopeUnExist.insert(_it, *pLineInfo_);
					return false;
				}
			}

			m_vecLineInfo_SlopeUnExist.push_back(*pLineInfo_);
			return false;
		}
		else
		{
			m_vecLineInfo_SlopeUnExist.push_back(*pLineInfo_);
			return false;
		}
	}
}

//ظöԲǷ޸ĹԲĳԲظĲֱɾʾ䱻޸Ĺ,֮pArcInfo_еظֽɾ  2010-7-12
bool CCamRepeatedDelete::ModifyArc(ArcInfo* pArcInfo_)
{
	double _nRadius = pArcInfo_->nRadius;
	DPOINT3 _ptCenterPoint = pArcInfo_->ptCenterPoint;
	ASSERT(pArcInfo_->vecPositions.size() == 1);
	std::list<ArcPosition> _ArcPositionOrig;
	_ArcPositionOrig.clear();
	_ArcPositionOrig.push_back(pArcInfo_->vecPositions.front());

	if (_ArcPositionOrig.front().nEndAngle > 2 * ncmath::c_nPIE)
	{
		//ԲյǶȴ2pie򽫸ԲֳʼǶȵ2pie2pieֹǶȵԲ
		double _nEndAngle = _ArcPositionOrig.front().nEndAngle;
		DPOINT3 _ptEndPoint =_ArcPositionOrig.front().ptEndPoint;
		_ArcPositionOrig.front().nEndAngle = 2 * ncmath::c_nPIE;
		DPOINT3 _ptMiddlePoint = CalcPoint(_ptCenterPoint, _nRadius, 0.);
		_ArcPositionOrig.front().ptEndPoint = _ptMiddlePoint;

		ArcPosition _ArcPosition(0., _nEndAngle - 2 * ncmath::c_nPIE, _ptMiddlePoint, _ptEndPoint);
		_ArcPositionOrig.push_back(_ArcPosition);
	}

	if (m_vecArcInfo.size() != 0)
	{
		for (arcinfo_holder::iterator _it = m_vecArcInfo.begin(); _it != m_vecArcInfo.end(); ++_it)
		{
			if (_float_equ((*_it).nRadius, pArcInfo_->nRadius)
					 && _float_equ((*_it).ptCenterPoint.x, pArcInfo_->ptCenterPoint.x)
					 && _float_equ((*_it).ptCenterPoint.y, pArcInfo_->ptCenterPoint.y))
			{
				pArcInfo_->vecPositions.clear();

				int _nRound = 0;
				bool _bRound = _ArcPositionOrig.size() == 1 ? false : true;
				bool _bModified = false;
				for (std::list<ArcPosition>::iterator _iterOrig = _ArcPositionOrig.begin(); _iterOrig != _ArcPositionOrig.end(); ++_iterOrig, ++_nRound)
				{
					double _nStartAngle = (*_iterOrig).nStartAngle;
					double _nEndAngle = (*_iterOrig).nEndAngle;
					DPOINT3 _ptStartPoint = (*_iterOrig).ptStartPoint;
					DPOINT3 _ptEndPoint = (*_iterOrig).ptEndPoint;
					bool _bFinished = false;

					for (std::list<ArcPosition>::iterator _iter = (*_it).vecPositions.begin(); _iter != (*_it).vecPositions.end(); ++_iter)
					{
						if (_float_ge(_nStartAngle, (*_iter).nEndAngle))
							continue;
						else if (_float_less(_nStartAngle, (*_iter).nStartAngle) && _float_great(_nEndAngle, (*_iter).nEndAngle))
						{
							DPOINT3 _ptEnd = CalcPoint(_ptCenterPoint, _nRadius, (*_iter).nStartAngle);
							if (pArcInfo_->vecPositions.size() != 0 && DOUBLE_EQU(pArcInfo_->vecPositions.back().nEndAngle, _nStartAngle + 2 * ncmath::c_nPIE))
							{
								pArcInfo_->vecPositions.back().nEndAngle = (*_iter).nStartAngle + 2 * ncmath::c_nPIE;
								pArcInfo_->vecPositions.back().ptEndPoint = _ptEnd;
							}
							else
							{
								ArcPosition _ArcPosition(_nStartAngle, (*_iter).nStartAngle, _ptStartPoint, _ptEnd);
								pArcInfo_->vecPositions.push_back(_ArcPosition);
							}

#ifdef _DEBUG
							DPOINT3 _ptStart = CalcPoint((*_it).ptCenterPoint, (*_it).nRadius, _nStartAngle);
#endif

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<ArcPosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).nEndAngle, _nStartAngle))
								{
									(*_iter).nStartAngle = (*_itera).nStartAngle;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).nStartAngle = _nStartAngle;
							}
							else
								(*_iter).nStartAngle = _nStartAngle;

							_nStartAngle = (*_iter).nEndAngle;
							_ptStartPoint = CalcPoint(_ptCenterPoint, _nRadius, (*_iter).nEndAngle);
							_bModified = true;
						}
						else if (_float_less(_nStartAngle, (*_iter).nStartAngle) && _float_great(_nEndAngle, (*_iter).nStartAngle) && _float_le(_nEndAngle, (*_iter).nEndAngle))
						{
							DPOINT3 _ptEnd = CalcPoint(_ptCenterPoint, _nRadius, (*_iter).nStartAngle);
							if (pArcInfo_->vecPositions.size() != 0 && DOUBLE_EQU(pArcInfo_->vecPositions.back().nEndAngle, _nStartAngle + 2 *ncmath::c_nPIE))
							{
								pArcInfo_->vecPositions.back().nEndAngle = (*_iter).nStartAngle + 2 *ncmath::c_nPIE;
								pArcInfo_->vecPositions.back().ptEndPoint = _ptEnd;
							}
							else
							{
								ArcPosition _ArcPosition(_nStartAngle, (*_iter).nStartAngle, _ptStartPoint, _ptEnd);
								pArcInfo_->vecPositions.push_back(_ArcPosition);
							}
#ifdef _DEBUG
							DPOINT3 _ptStart = CalcPoint((*_it).ptCenterPoint, (*_it).nRadius, (*_iter).nStartAngle);
#endif

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<ArcPosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).nEndAngle, _nStartAngle))
								{
									(*_iter).nStartAngle = (*_itera).nStartAngle;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).nStartAngle = _nStartAngle;
							}
							else
								(*_iter).nStartAngle = _nStartAngle;

							if (_nRound || !_bRound)
								return true;
							else
							{
								_bModified = true;
								_bFinished = true;
								break;
							}
						}
						else if (_float_less(_nStartAngle, (*_iter).nStartAngle) && _float_equ(_nEndAngle, (*_iter).nStartAngle))
						{
							DPOINT3 _ptEnd = CalcPoint(_ptCenterPoint, _nRadius, (*_iter).nStartAngle);
							if (pArcInfo_->vecPositions.size() != 0 && DOUBLE_EQU(pArcInfo_->vecPositions.back().nEndAngle, _nStartAngle + 2 * ncmath::c_nPIE))
							{
								pArcInfo_->vecPositions.back().nEndAngle = (*_iter).nStartAngle + 2 *ncmath::c_nPIE;
								pArcInfo_->vecPositions.back().ptEndPoint = _ptEnd;
							}
							else
							{
								ArcPosition _ArcPosition(_nStartAngle, (*_iter).nStartAngle, _ptStartPoint, _ptEnd);
								pArcInfo_->vecPositions.push_back(_ArcPosition);
							}
#ifdef _DEBUG
							DPOINT3 _ptStart = CalcPoint((*_it).ptCenterPoint, (*_it).nRadius, _nStartAngle);
#endif

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<ArcPosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).nEndAngle, _nStartAngle))
								{
									(*_iter).nStartAngle = (*_itera).nStartAngle;
									(*_it).vecPositions.erase(_itera);
								}
								else
									(*_iter).nStartAngle = _nStartAngle;
							}
							else
								(*_iter).nStartAngle = _nStartAngle;

							if (_nRound || !_bRound)
								return _bModified;
							else
							{
								_bFinished = true;
								break;
							}
						}
						else if (_float_less(_nStartAngle, (*_iter).nStartAngle) && _float_less(_nEndAngle, (*_iter).nStartAngle))
						{
							ArcPosition _ArcPosition(_nStartAngle, _nEndAngle, _ptStartPoint, _ptEndPoint);
							if (pArcInfo_->vecPositions.size() != 0 && DOUBLE_EQU(pArcInfo_->vecPositions.back().nEndAngle, _nStartAngle + 2 * ncmath::c_nPIE))
							{
								pArcInfo_->vecPositions.back().nEndAngle = (*_iter).nStartAngle + 2 * ncmath::c_nPIE;
								pArcInfo_->vecPositions.back().ptEndPoint = _ptEndPoint;
							}
							else
							{
								pArcInfo_->vecPositions.push_back(_ArcPosition);
							}
#ifdef _DEBUG
							DPOINT3 _ptStart = CalcPoint((*_it).ptCenterPoint, (*_it).nRadius, _nStartAngle);
							DPOINT3 _ptEnd = CalcPoint((*_it).ptCenterPoint, (*_it).nRadius, _nEndAngle);
#endif

							if (_iter != (*_it).vecPositions.begin())
							{
								std::list<ArcPosition>::iterator _itera = _iter;
								--_itera;
								if (_float_equ((*_itera).nEndAngle, _nStartAngle))
									(*_itera).nEndAngle = _nEndAngle;
								else
									_iter = (*_it).vecPositions.insert(_iter, _ArcPosition);
							}
							else
								_iter = (*_it).vecPositions.insert(_iter, _ArcPosition);

							if (_nRound || !_bRound)
								return _bModified;
							else
							{
								_bFinished = true;
								break;
							}
						}
						else if (_float_ge(_nStartAngle, (*_iter).nStartAngle) && _float_great(_nEndAngle, (*_iter).nEndAngle))
						{
							_nStartAngle = (*_iter).nEndAngle;
							_ptStartPoint = CalcPoint(_ptCenterPoint, _nRadius, (*_iter).nEndAngle);
#ifdef _DEBUG
							DPOINT3 _ptStart = CalcPoint((*_it).ptCenterPoint, (*_it).nRadius, (*_iter).nEndAngle);
#endif
							_bModified = true;
						}
						else if (_float_ge(_nStartAngle, (*_iter).nStartAngle) && _float_le(_nEndAngle, (*_iter).nEndAngle))
						{
							if (_nRound || !_bRound)
								return true;
							else
							{
								_bFinished = true;
								_bModified = true;
								break;
							}
						}
					}

					if (!_bFinished)
					{
						ArcPosition _ArcPosition(_nStartAngle, _nEndAngle, _ptStartPoint, _ptEndPoint);
						pArcInfo_->vecPositions.push_back(_ArcPosition);

						std::list<ArcPosition>::iterator _iter = (*_it).vecPositions.end();
						--_iter;
						if (_float_equ((*_iter).nEndAngle, _ArcPosition.nStartAngle))
						{
							(*_iter).nEndAngle = _ArcPosition.nEndAngle;
						}
						else
							(*_it).vecPositions.push_back(_ArcPosition);

						if (_nRound || !_bRound)
							return _bModified;
					}
				}
			}
			else if (_float_great((*_it).nRadius, pArcInfo_->nRadius))
			{
				arcinfo_holder::iterator _itTemp = _it;
				if (++_itTemp == m_vecArcInfo.end())
				{
					if (_ArcPositionOrig.size() > 1)
					{
						if (_float_equ(_ArcPositionOrig.back().nEndAngle, _ArcPositionOrig.front().nStartAngle))
						{
							ArcInfo _ArcInfo = *pArcInfo_;
							_ArcInfo.vecPositions.front().nStartAngle = 0.;
							_ArcInfo.vecPositions.front().nEndAngle = 2 * ncmath::c_nPIE;
							m_vecArcInfo.push_back(_ArcInfo);
						}
						else
						{
							ArcInfo _ArcInfo = *pArcInfo_;
							_ArcInfo.vecPositions.clear();
							for (std::list<ArcPosition>::reverse_iterator _it = _ArcPositionOrig.rbegin(); _it != _ArcPositionOrig.rend(); ++_it)
							{
								_ArcInfo.vecPositions.push_back(*_it);
							}

							m_vecArcInfo.push_back(_ArcInfo);
						}
					}
					else
						m_vecArcInfo.push_back(*pArcInfo_);

					return false;
				}
			}
		}

		if (_ArcPositionOrig.size() > 1)
		{
			if (_float_equ(_ArcPositionOrig.back().nEndAngle, _ArcPositionOrig.front().nStartAngle))
			{
				ArcInfo _ArcInfo = *pArcInfo_;
				_ArcInfo.vecPositions.front().nStartAngle = 0.;
				_ArcInfo.vecPositions.front().nEndAngle = 2 * ncmath::c_nPIE;
				m_vecArcInfo.push_back(_ArcInfo);
			}
			else
			{
				ArcInfo _ArcInfo = *pArcInfo_;
				_ArcInfo.vecPositions.clear();
				for (std::list<ArcPosition>::reverse_iterator _it = _ArcPositionOrig.rbegin(); _it != _ArcPositionOrig.rend(); ++_it)
				{
					_ArcInfo.vecPositions.push_back(*_it);
				}

				m_vecArcInfo.push_back(_ArcInfo);
			}
		}
		else
			m_vecArcInfo.push_back(*pArcInfo_);

		return false;
	}
	else
	{
		if (_ArcPositionOrig.size() > 1)
		{
			if (_float_equ(_ArcPositionOrig.back().nEndAngle, _ArcPositionOrig.front().nStartAngle))
			{
				ArcInfo _ArcInfo = *pArcInfo_;
				_ArcInfo.vecPositions.front().nStartAngle = 0.;
				_ArcInfo.vecPositions.front().nEndAngle = 2 * ncmath::c_nPIE;
				m_vecArcInfo.push_back(_ArcInfo);
			}
			else
			{
				ArcInfo _ArcInfo = *pArcInfo_;
				_ArcInfo.vecPositions.clear();
				for (std::list<ArcPosition>::reverse_iterator _it = _ArcPositionOrig.rbegin(); _it != _ArcPositionOrig.rend(); ++_it)
				{
					_ArcInfo.vecPositions.push_back(*_it);
				}

				m_vecArcInfo.push_back(_ArcInfo);
			}
		}
		else
			m_vecArcInfo.push_back(*pArcInfo_);

		return false;
	}
}

//ֱյֱͣ꣬Ӹݵڴжȡֱյ
//úڴַӣǰҪȷöΪֱ  2009-12-8
void CCamRepeatedDelete::GetLineNode(IN const nce::CCamPath::NODE& Node_, IN OUT DPOINT3& nxCurPoint_)
{
	switch (Node_.nType)
	{
	case CCamPath::nt_line_x:
		{
			nxCurPoint_.x = Node_.ptEnd.x;
		}
		break;

	case CCamPath::nt_line_y:
		{
			nxCurPoint_.y = Node_.ptEnd.y;
		}
		break;

	case CCamPath::nt_line_z:
		{
			nxCurPoint_.z = Node_.ptEnd.z;
		}
		break;

	case CCamPath::nt_line_xy:
		{
			nxCurPoint_.x = Node_.ptEnd.x;
			nxCurPoint_.y = Node_.ptEnd.y;
		}
		break;

	case CCamPath::nt_line_zx:
		{
			nxCurPoint_.x = Node_.ptEnd.x;
			nxCurPoint_.z = Node_.ptEnd.z;
		}
		break;

	case CCamPath::nt_line_yz:
		{
			nxCurPoint_.y = Node_.ptEnd.y;
			nxCurPoint_.z = Node_.ptEnd.z;
		}
		break;

	case CCamPath::nt_line_xyz:
		{
			nxCurPoint_.x = Node_.ptEnd.x;
			nxCurPoint_.y = Node_.ptEnd.y;
			nxCurPoint_.z = Node_.ptEnd.z;
		}
		break;

	default:
		ASSERT(false);
		break;
	}
}

//ԲͣԲ꣬ӸݵڴжȡԲյ͸öԲ͹
//úڴַӣǰҪȷöΪԲ  2009-12-8
void CCamRepeatedDelete::GetArcNode(IN const nce::CCamPath::NODE& Node_, IN OUT DPOINT3& nxCurPoint_, OUT double& nBulge_)
{
	nBulge_ = Node_.nBulge;
	switch (Node_.nType)
	{
	case CCamPath::nt_arc_xy:
		nxCurPoint_.x = Node_.ptEnd.x;
		nxCurPoint_.y = Node_.ptEnd.y;
		break;

	case CCamPath::nt_arc_zx:
		nxCurPoint_.x = Node_.ptEnd.x;
		nxCurPoint_.z = Node_.ptEnd.z;
		break;

	case CCamPath::nt_arc_yz:
		nxCurPoint_.y = Node_.ptEnd.y;
		nxCurPoint_.z = Node_.ptEnd.z;
		break;

	default:
		ASSERT(false);
		break;
	}
}

//ԲͣԲ꣬ӸݵڴжȡԲ͸Բİ뾶
//úڴַӣǰҪȷöΪԲ  2009-12-8
void CCamRepeatedDelete::GetCircleNode(IN const CCamPath::NODE& Node_, IN OUT DPOINT3& nxCurPoint_, OUT double& nRadius_)
{
	nRadius_ = Node_.nRadius;
	switch (Node_.nType)
	{
	case CCamPath::nt_circle_xy_cw:
	case CCamPath::nt_circle_xy_ccw:
		{
			nxCurPoint_.x = Node_.ptCenter.x;
			nxCurPoint_.y = Node_.ptCenter.y;
		}
		break;

	case CCamPath::nt_circle_zx_cw:
	case CCamPath::nt_circle_zx_ccw:
		{
			nxCurPoint_.x = Node_.ptCenter.x;
			nxCurPoint_.z = Node_.ptCenter.z;
		}
		break;

	case CCamPath::nt_circle_yz_cw:
	case CCamPath::nt_circle_yz_ccw:
		{
			nxCurPoint_.y = Node_.ptCenter.y;
			nxCurPoint_.z = Node_.ptCenter.z;
		}
		break;

	default:
		ASSERT(false);
		break;
	}
}

void CCamRepeatedDelete::CamRepeatedDelete_Hole(IN OUT CCamGroup* pDestCamGroup_)
{
	for (CamObjectList::iterator _it = pDestCamGroup_->GetObjectsList()->begin(); _it != pDestCamGroup_->GetObjectsList()->end();)
	{
		if ((*_it)->GetType() == camhole)
		{
			if (ModifyHole(&((CCamHole*)(*_it))->GetStart()))
			{
				CCamHole* _pHole = reinterpret_cast<CCamHole*>(*_it);
				delete _pHole;
				_it = pDestCamGroup_->GetObjectsList()->erase(_it);
			}
			else
				++_it;
		}
		else if ((*_it)->GetType() == camgroup)
		{
			CamRepeatedDelete_Hole((CCamGroup*)(*_it));
			++_it;
		}
		else
			++_it;
	}
}

//õǷظõĳԲ߶ϻѴĳõͬʾõظĵ  2010-7-12
bool CCamRepeatedDelete::ModifyHole(const DPOINT3* pHolePoint_)
{
	holeinfo_holder::iterator _itera = m_vecHoleInfo.begin();
	for (; _itera != m_vecHoleInfo.end(); ++_itera)
	{
		if (_float_equ((*_itera).x, pHolePoint_->x) && _float_equ((*_itera).y, pHolePoint_->y))
			return true;
		else if (_float_great(pHolePoint_->x, (*_itera).x) || (_float_equ(pHolePoint_->x, (*_itera).x) && _float_great(pHolePoint_->y, (*_itera).y)))
			break;
	}

	for (lineinfo_holder::iterator _it = m_vecLineInfo_SlopeUnExist.begin(); _it != m_vecLineInfo_SlopeUnExist.end(); ++_it)
	{
		if (_float_equ((*_it).nCoefficientA, pHolePoint_->x))
		{
			for (std::list<LinePosition>::iterator _iter = (*_it).vecPositions.begin(); _iter != (*_it).vecPositions.end(); ++_iter)
			{
				if (_float_great(pHolePoint_->y, (*_iter).ptEndPoint.y))
					continue;
				else if (_float_ge(pHolePoint_->y, (*_iter).ptStartPoint.y) && _float_le(pHolePoint_->y, (*_iter).ptEndPoint.y))
					return true;
				else
					break;
			}
		}
		else if (_float_great((*_it).nCoefficientA, pHolePoint_->x))
			break;
	}

	for (lineinfo_holder::iterator _it = m_vecLineInfo_SlopeExist.begin(); _it != m_vecLineInfo_SlopeExist.end(); ++_it)
	{
		if (_float_equ_CoeB(pHolePoint_->y, (*_it).nCoefficientA * pHolePoint_->x + (*_it).nCoefficientB))
		{
			for (std::list<LinePosition>::iterator _iter = (*_it).vecPositions.begin(); _iter != (*_it).vecPositions.end(); ++_iter)
			{
				if (_float_great(pHolePoint_->x, (*_iter).ptEndPoint.x))
					continue;
				else if (_float_ge(pHolePoint_->x, (*_iter).ptStartPoint.x) && _float_le(pHolePoint_->x, (*_iter).ptEndPoint.x))
					return true;
				else
					break;
			}
		}
	}

	for (arcinfo_holder::iterator _it = m_vecArcInfo.begin(); _it != m_vecArcInfo.end(); ++_it)
	{
		double _nDis = sqrt((pHolePoint_->x - (*_it).ptCenterPoint.x) * (pHolePoint_->x - (*_it).ptCenterPoint.x)
							+ (pHolePoint_->y - (*_it).ptCenterPoint.y) *(pHolePoint_->y - (*_it).ptCenterPoint.y));
		if (_float_equ(_nDis, (*_it).nRadius))
		{
			double _nAngle = ncmath::D2GetNormalAngle(pHolePoint_->x - (*_it).ptCenterPoint.x, pHolePoint_->y - (*_it).ptCenterPoint.y);

			for (std::list<ArcPosition>::iterator _iter = (*_it).vecPositions.begin(); _iter != (*_it).vecPositions.end(); ++_iter)
			{
				if (_float_great(_nAngle, (*_iter).nEndAngle))
					continue;
				else if (_float_ge(_nAngle, (*_iter).nStartAngle) && _float_le(_nAngle, (*_iter).nEndAngle))
					return true;
				else
					break;
			}
		}
	}

	m_vecHoleInfo.insert(_itera, *pHolePoint_);
	// õκͼζغϣ¼õ㣬Ȼ󷵻false 崺 2012-8-5
	return false;
}

double nce::CalculateBulge(double nAngleStart_, double nAngleEnd_)
{
	double _theta = (nAngleEnd_ - nAngleStart_) / 4.;
	ASSERT(!DOUBLE_EQU(fabs(_theta), ncmath::c_nPIE / 2.));
	double _nBulge = tan(_theta);
	return _nBulge;
}

bool CCamRepeatedDelete::DPOINT3_EQU(const DPOINT3& pt1_, const DPOINT3& pt2_)
{
	bool _bSkipAll = true;
	for (int _i = 0; _i != 3; ++_i)
	{
		if (!IsValidDouble(pt1_[_i]) && !IsValidDouble(pt2_[_i]))
		{
			continue;
		}
		// ûִcontinue˵һЧdouble 崺 2012-7-25
		_bSkipAll = false;
		if (!IsValidDouble(pt1_[_i]) || !IsValidDouble(pt2_[_i]))
		{
			return false;
		}
		// 
		if (!DOUBLE_EQU(pt1_[_i], pt2_[_i]))
		{
			return false;
		}
	}
	if (_bSkipAll)
	{
		return false;
	}
	return true;
}

size_t CCamRepeatedDelete::GetCamgroupSize(const CCamGroup* pCamGroup_)
{
	size_t _nSize = 0;
	for (CamObjectList::const_iterator _it = pCamGroup_->GetObjectsList()->begin(); _it != pCamGroup_->GetObjectsList()->end(); ++_it)
	{
		cam_t _type = (*_it)->GetType();
		if (_type == camhole || _type == campath)
		{
			++_nSize;
		}
		else if (_type == camgroup)
		{
			_nSize += GetCamgroupSize((CCamGroup*)(*_it));
		}
		else/* if(_type == camobject || _type == camscanlines)*/
		{
			ASSERT(FALSE);
		}
	}
	return _nSize;
}

// ڵlineInfo_ҵһСlineInfo_ĽڵĵΪֵҲʱvectorLineInfo_SlopeExist.end();
lineinfo_holder::const_iterator CCamRepeatedDelete::bsearchLineInfo(const LineInfo* lineInfo_, const lineinfo_holder& ListLineInfo_SlopeExist)
{
	lineinfo_holder::iterator iLineInfo;
	size_t _nSize = ListLineInfo_SlopeExist.size();
	if (_nSize == 0)
		return ListLineInfo_SlopeExist.end();

	lineinfo_holder::const_iterator _itBegin = ListLineInfo_SlopeExist.begin();
	lineinfo_holder::const_iterator _itEnd = ListLineInfo_SlopeExist.end();
	lineinfo_holder::const_iterator _itMiddle = ListLineInfo_SlopeExist.begin();
	_nSize = (_nSize - 1) / 2;
	while(_nSize--)
	{
		++_itMiddle;
	}
	LineInfo _MiddleLineInfo = *_itMiddle;
	if (lineInfo_ < &_MiddleLineInfo)
	{
		while(_itMiddle != _itEnd)
		{
			_itMiddle++;
			_MiddleLineInfo = *_itMiddle;
			if (lineInfo_ < &_MiddleLineInfo)
			{
				continue;
			}
			else
			{
				_itMiddle--;
				return (_itMiddle);
			}
		}
	}
	else
	{
		while(_itMiddle != _itBegin)
		{
			_itMiddle--;
			_MiddleLineInfo = *_itMiddle;
			if (lineInfo_ < &_MiddleLineInfo)
			{
				return _itMiddle;
			}
		}
	}

	return ListLineInfo_SlopeExist.end();
}

bool nce::LineInfo::operator<(const LineInfo& other_)
{
	ASSERT(bSlopeExist && other_.bSlopeExist);
	if (_float_great(nCoefficientA, other_.nCoefficientA))
	{
		return false;
	}
	if (_float_less(nCoefficientA, other_.nCoefficientA))
	{
		return true;
	}
	if (_float_equ(nCoefficientA, other_.nCoefficientA))
	{
		if (_float_great(nCoefficientB, other_.nCoefficientB))
		{
			return false;
		}
		else if (_float_less(nCoefficientB, other_.nCoefficientB))
		{
			return true;
		}
		else
		{
			ASSERT(_float_equ(nCoefficientB, other_.nCoefficientB));
			ASSERT(other_.vecPositions.size() == 1);
			ASSERT(vecPositions.size() == 1);

			DPOINT3 _ptStartPoint = other_.vecPositions.front().ptStartPoint;
			DPOINT3 _ptEndPointthis = vecPositions.front().ptEndPoint;

			if (_float_less(_ptEndPointthis.x, _ptStartPoint.x))
				return true;
			else
				return false;
		}
	}
	ASSERT(FALSE);
	return false;
}
