#include "stdafx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//static int s_counter;
void * __cdecl eng_malloc(size_t nSize)
{
	void *res = malloc(nSize);

//	s_counter++;
//	TRACE("eng_malloc: %d: %p\n", s_counter, res);
	return res;
}

void __cdecl eng_free(void * pUserData)
{
	free(pUserData);

//	s_counter--;
//	TRACE("eng_free: %d: %p\n", s_counter, pUserData);
}

struct JD_PATH_INFO_05;

struct X2 {
	BYTE* pData;
	int nSize;

	X2(void* pBuffer_, int size_);
	~X2();
	WORD* Decode5();
	WORD* Decode6();
	WORD* Decode7();
	WORD* Decode8();
	BYTE* Decode9();
};

X2::X2(void* pBuffer_, int size_)
{
	pData = new BYTE[size_];
	if (pData)
	{
		memcpy(pData, pBuffer_, size_);
		nSize = size_;
	}
}

X2::~X2()
{
	delete[] pData; 
}

void DecodePassword04(JD_PWD_04* pPwd_)
{
	X2 _x2(&pPwd_->nKey, sizeof(WORD));

	switch (pPwd_->nMethod)
	{
	case 5: 
		{
			WORD* _pDecoded = _x2.Decode5(); 
			if (_pDecoded)
				pPwd_->nKey = *_pDecoded;
		}
		break;

	case 6: 
		{
			WORD* _pDecoded = _x2.Decode6(); 
			if (_pDecoded)
				pPwd_->nKey = *_pDecoded;
		}
		break;

	case 7: 
		{
			WORD* _pDecoded = _x2.Decode7();
			if (_pDecoded)
				pPwd_->nKey = *_pDecoded;
		}
		break;

	case 8: 
		{
			WORD* _pDecoded = _x2.Decode8();
			if (_pDecoded)
				pPwd_->nKey = *_pDecoded;
		}
		break;

	case 9: 
		{
			BYTE* _pDecoded = _x2.Decode9();
			if (_pDecoded)
				pPwd_->nKey = (WORD)*_pDecoded;
			eng_free(_pDecoded);	// this line is added by zzk to fix memory leak.
		}
		break;

	default:
		return;
	}
	return;
}

void DecodePassword05(JD_PATH_INFO_05* pInfo_)
{
	X2 _x2(&pInfo_->nKey, sizeof(WORD));

	switch (pInfo_->nMethod)
	{
	case 5: 
		{
			WORD* _pDecoded = _x2.Decode5(); 
			if (_pDecoded)
				pInfo_->nKey = *_pDecoded;
		}
		break;

	case 6: 
		{
			WORD* _pDecoded = _x2.Decode6(); 
			if (_pDecoded)
				pInfo_->nKey = *_pDecoded;
		}
		break;

	case 7: 
		{
			WORD* _pDecoded = _x2.Decode7();
			if (_pDecoded)
				pInfo_->nKey = *_pDecoded;
		}
		break;

	case 8: 
		{
			WORD* _pDecoded = _x2.Decode8();
			if (_pDecoded)
				pInfo_->nKey = *_pDecoded;
		}
		break;

	case 9: 
		{
			BYTE* _pDecoded = _x2.Decode9();
			if (_pDecoded)
				pInfo_->nKey = (WORD)*_pDecoded;
			eng_free(_pDecoded);	// this line is added by zzk to fix memory leak.
		}
		break;

	default:
		return;
	}
	return;
}

__declspec(naked) void DecodeBuffer(
	BYTE* /* pBuffer */, 
	DWORD /* size */, 
	JD_PWD_04* /* pKey */)
{
	__asm {
		push ebx                             
		push ebp
		push esi
		mov esi,dword ptr ss:[esp+0X18]
		push edi
		mov ax,word ptr ds:[esi+0X2]			;  encode_method == ax
		cmp ax,0X5
		jl short L_LABEL1
		cmp ax,0X8
		jg short L_LABEL1
		movsx ecx,word ptr ds:[esi+0XA]			;  encode_method == 5, 6, 7, 8, goto here
		movsx edi,word ptr ds:[esi+0X6]
		mov eax,ecx
		cdq
		sub eax,edx								;  get abs(eax)?
		mov edx,dword ptr ss:[esp+0X18]			;  size == edx,         number of bytes to decode
		lea ecx,dword ptr ds:[ecx+edi-1]		;  index = ecx + edi - 1;
		sar eax,1
		cmp ecx,edx								;  index = size?
		jge short L_LABEL2
		mov ebx,dword ptr ss:[esp+0X14]			;  pBuffer == ebx

	L_LABEL5:
		test eax,eax							;  
		lea ecx,dword ptr ds:[edi+ebx]
		jle short L_LABEL3
		mov edx,eax

	L_LABEL4:
		mov bp,word ptr ds:[esi]				;  Unknown_Encoded1 == bp
		xor word ptr ds:[ecx],bp
		add ecx,2								;  move to next WORD
		dec edx
		jnz short L_LABEL4

	L_LABEL3:
		movsx edx,word ptr ds:[esi+0X8]        
		movsx ecx,word ptr ds:[esi+0XA]
		add edi,edx
		lea edx,dword ptr ds:[ecx+edi-1]
		mov ecx,dword ptr ss:[esp+0X18]
		cmp edx,ecx
		jl short L_LABEL5
		pop edi
		pop esi
		pop ebp
		pop ebx
		retn

	L_LABEL1:
		cmp ax,0X9                               
		jnz short L_LABEL2
		movsx ebp,word ptr ds:[esi+0X6]
		movsx edi,word ptr ds:[esi+0XA]
		mov ebx,dword ptr ss:[esp+0X18]
		mov dl,byte ptr ds:[esi]
		lea eax,dword ptr ds:[edi+ebp-1]
		cmp eax,ebx
		jge short L_LABEL2

	L_LABEL8:
		xor eax,eax                        
		test edi,edi
		jle short L_LABEL6
		mov ecx,dword ptr ss:[esp+0X14]
		add ecx,ebp

	L_LABEL7:
		xor byte ptr ds:[ecx+eax],dl       
		inc eax
		cmp eax,edi
		jl short L_LABEL7

	L_LABEL6:
		movsx eax,word ptr ds:[esi+0X8]      
		movsx ecx,word ptr ds:[esi+0XA]
		add ebp,eax
		lea eax,dword ptr ds:[ecx+ebp-1]
		cmp eax,ebx
		jl short L_LABEL8

	L_LABEL2:
		pop edi                            
		pop esi
		pop ebp
		pop ebx
		retn
	}
}

DWORD s_nDATA00419268[] =	// table 1
{
	0x01 ^ 0x55,    0x03 ^ 0x55,    0x05 ^ 0x55,    0x0F ^ 0x55,
	0x11 ^ 0x55,    0x33 ^ 0x55,    0x55 ^ 0x55,    0xFF ^ 0x55,
	0x1A ^ 0x55,    0x2E ^ 0x55,    0x72 ^ 0x55,    0x96 ^ 0x55,
	0xA1 ^ 0x55,    0xF8 ^ 0x55,    0x13 ^ 0x55,    0x35 ^ 0x55,
	0x5F ^ 0x55,    0xE1 ^ 0x55,    0x38 ^ 0x55,    0x48 ^ 0x55,
	0xD8 ^ 0x55,    0x73 ^ 0x55,    0x95 ^ 0x55,    0xA4 ^ 0x55,
	0xF7 ^ 0x55,    0x02 ^ 0x55,    0x06 ^ 0x55,    0x0A ^ 0x55,
	0x1E ^ 0x55,    0x22 ^ 0x55,    0x66 ^ 0x55,    0xAA ^ 0x55,
	0xE5 ^ 0x55,    0x34 ^ 0x55,    0x5C ^ 0x55,    0xE4 ^ 0x55,
	0x37 ^ 0x55,    0x59 ^ 0x55,    0xEB ^ 0x55,    0x26 ^ 0x55,
	0x6A ^ 0x55,    0xBE ^ 0x55,    0xD9 ^ 0x55,    0x70 ^ 0x55,
	0x90 ^ 0x55,    0xAB ^ 0x55,    0xE6 ^ 0x55,    0x31 ^ 0x55,
	0x53 ^ 0x55,    0xF5 ^ 0x55,    0x04 ^ 0x55,    0x0C ^ 0x55,
	0x14 ^ 0x55,    0x3C ^ 0x55,    0x44 ^ 0x55,    0xCC ^ 0x55,
	0x4F ^ 0x55,    0xD1 ^ 0x55,    0x68 ^ 0x55,    0xB8 ^ 0x55,
	0xD3 ^ 0x55,    0x6E ^ 0x55,    0xB2 ^ 0x55,    0xCD ^ 0x55,
	0x4C ^ 0x55,    0xD4 ^ 0x55,    0x67 ^ 0x55,    0xA9 ^ 0x55,
	0xE0 ^ 0x55,    0x3B ^ 0x55,    0x4D ^ 0x55,    0xD7 ^ 0x55,
	0x62 ^ 0x55,    0xA6 ^ 0x55,    0xF1 ^ 0x55,    0x08 ^ 0x55,
	0x18 ^ 0x55,    0x28 ^ 0x55,    0x78 ^ 0x55,    0x88 ^ 0x55,
	0x83 ^ 0x55,    0x9E ^ 0x55,    0xB9 ^ 0x55,    0xD0 ^ 0x55,
	0x6B ^ 0x55,    0xBD ^ 0x55,    0xDC ^ 0x55,    0x7F ^ 0x55,
	0x81 ^ 0x55,    0x98 ^ 0x55,    0xB3 ^ 0x55,    0xCE ^ 0x55,
	0x49 ^ 0x55,    0xDB ^ 0x55,    0x76 ^ 0x55,    0x9A ^ 0x55,
	0xB5 ^ 0x55,    0xC4 ^ 0x55,    0x57 ^ 0x55,    0xF9 ^ 0x55,
	0x10 ^ 0x55,    0x30 ^ 0x55,    0x50 ^ 0x55,    0xF0 ^ 0x55,
	0x0B ^ 0x55,    0x1D ^ 0x55,    0x27 ^ 0x55,    0x69 ^ 0x55,
	0xBB ^ 0x55,    0xD6 ^ 0x55,    0x61 ^ 0x55,    0xA3 ^ 0x55,
	0xFE ^ 0x55,    0x19 ^ 0x55,    0x2B ^ 0x55,    0x7D ^ 0x55,
	0x87 ^ 0x55,    0x92 ^ 0x55,    0xAD ^ 0x55,    0xEC ^ 0x55,
	0x2F ^ 0x55,    0x71 ^ 0x55,    0x93 ^ 0x55,    0xAE ^ 0x55,
	0xE9 ^ 0x55,    0x20 ^ 0x55,    0x60 ^ 0x55,    0xA0 ^ 0x55,
	0xFB ^ 0x55,    0x16 ^ 0x55,    0x3A ^ 0x55,    0x4E ^ 0x55,
	0xD2 ^ 0x55,    0x6D ^ 0x55,    0xB7 ^ 0x55,    0xC2 ^ 0x55,
	0x5D ^ 0x55,    0xE7 ^ 0x55,    0x32 ^ 0x55,    0x56 ^ 0x55,
	0xFA ^ 0x55,    0x15 ^ 0x55,    0x3F ^ 0x55,    0x41 ^ 0x55,
	0xC3 ^ 0x55,    0x5E ^ 0x55,    0xE2 ^ 0x55,    0x3D ^ 0x55,
	0x47 ^ 0x55,    0xC9 ^ 0x55,    0x40 ^ 0x55,    0xC0 ^ 0x55,
	0x5B ^ 0x55,    0xED ^ 0x55,    0x2C ^ 0x55,    0x74 ^ 0x55,
	0x9C ^ 0x55,    0xBF ^ 0x55,    0xDA ^ 0x55,    0x75 ^ 0x55,
	0x9F ^ 0x55,    0xBA ^ 0x55,    0xD5 ^ 0x55,    0x64 ^ 0x55,
	0xAC ^ 0x55,    0xEF ^ 0x55,    0x2A ^ 0x55,    0x7E ^ 0x55,
	0x82 ^ 0x55,    0x9D ^ 0x55,    0xBC ^ 0x55,    0xDF ^ 0x55,
	0x7A ^ 0x55,    0x8E ^ 0x55,    0x89 ^ 0x55,    0x80 ^ 0x55,
	0x9B ^ 0x55,    0xB6 ^ 0x55,    0xC1 ^ 0x55,    0x58 ^ 0x55,
	0xE8 ^ 0x55,    0x23 ^ 0x55,    0x65 ^ 0x55,    0xAF ^ 0x55,
	0xEA ^ 0x55,    0x25 ^ 0x55,    0x6F ^ 0x55,    0xB1 ^ 0x55,
	0xC8 ^ 0x55,    0x43 ^ 0x55,    0xC5 ^ 0x55,    0x54 ^ 0x55,
	0xFC ^ 0x55,    0x1F ^ 0x55,    0x21 ^ 0x55,    0x63 ^ 0x55,
	0xA5 ^ 0x55,    0xF4 ^ 0x55,    0x07 ^ 0x55,    0x09 ^ 0x55,
	0x1B ^ 0x55,    0x2D ^ 0x55,    0x77 ^ 0x55,    0x99 ^ 0x55,
	0xB0 ^ 0x55,    0xCB ^ 0x55,    0x46 ^ 0x55,    0xCA ^ 0x55,
	0x45 ^ 0x55,    0xCF ^ 0x55,    0x4A ^ 0x55,    0xDE ^ 0x55,
	0x79 ^ 0x55,    0x8B ^ 0x55,    0x86 ^ 0x55,    0x91 ^ 0x55,
	0xA8 ^ 0x55,    0xE3 ^ 0x55,    0x3E ^ 0x55,    0x42 ^ 0x55,
	0xC6 ^ 0x55,    0x51 ^ 0x55,    0xF3 ^ 0x55,    0x0E ^ 0x55,
	0x12 ^ 0x55,    0x36 ^ 0x55,    0x5A ^ 0x55,    0xEE ^ 0x55,
	0x29 ^ 0x55,    0x7B ^ 0x55,    0x8D ^ 0x55,    0x8C ^ 0x55,
	0x8F ^ 0x55,    0x8A ^ 0x55,    0x85 ^ 0x55,    0x94 ^ 0x55,
	0xA7 ^ 0x55,    0xF2 ^ 0x55,    0x0D ^ 0x55,    0x17 ^ 0x55,
	0x39 ^ 0x55,    0x4B ^ 0x55,    0xDD ^ 0x55,    0x7C ^ 0x55,
	0x84 ^ 0x55,    0x97 ^ 0x55,    0xA2 ^ 0x55,    0xFD ^ 0x55,
	0x1C ^ 0x55,    0x24 ^ 0x55,    0x6C ^ 0x55,    0xB4 ^ 0x55,
	0xC7 ^ 0x55,    0x52 ^ 0x55,    0xF6 ^ 0x55,    0x00 ^ 0x55,
};

DWORD s_nDATA00419668[] = // table 2
{
	0x16 ^ 0x55,    0x12 ^ 0x55,    0x11 ^ 0x55,    0x14 ^ 0x55,
	0x15 ^ 0x55,    0x16 ^ 0x55,    0x13 ^ 0x55,    0x26 ^ 0x55,
	0x77 ^ 0x55,    0x36 ^ 0x55,    0x06 ^ 0x55,    0x36 ^ 0x55,
	0x56 ^ 0x55,    0x30 ^ 0x55,    0x35 ^ 0x55,    0x29 ^ 0x55,
	0x33 ^ 0x55,    0x52 ^ 0x55,    0x41 ^ 0x55,    0x32 ^ 0x55,
	0x81 ^ 0x55,    0x26 ^ 0x55,    0x16 ^ 0x55,    0x15 ^ 0x55,
	0x16 ^ 0x55,    0x16 ^ 0x55,    0x34 ^ 0x55,    0x26 ^ 0x55,
	0x14 ^ 0x55,    0x81 ^ 0x55,    0x16 ^ 0x55,    0x51 ^ 0x55,
};

DWORD s_nDATA00418168[] = // table 3
{
	0xD1310BA6 ^ 0x55555555,    0x98DFB5AC ^ 0x55555555,    0x2FFD72DB ^ 0x55555555,    0xD01ADFB7 ^ 0x55555555,
	0xB8E1AFED ^ 0x55555555,    0x6A267E96 ^ 0x55555555,    0xBA7C9045 ^ 0x55555555,    0xF12C7F99 ^ 0x55555555,
	0x24A19947 ^ 0x55555555,    0xB3916CF7 ^ 0x55555555,    0x0801F2E2 ^ 0x55555555,    0x858EFC16 ^ 0x55555555,
	0x636920D8 ^ 0x55555555,    0x71574E69 ^ 0x55555555,    0xA458FEA3 ^ 0x55555555,    0xF4933D7E ^ 0x55555555,
	0x0D95748F ^ 0x55555555,    0x728EB658 ^ 0x55555555,    0x718BCD58 ^ 0x55555555,    0x82154AEE ^ 0x55555555,
	0x7B54A41D ^ 0x55555555,    0xC25A59B5 ^ 0x55555555,    0x9C30D539 ^ 0x55555555,    0x2AF26013 ^ 0x55555555,
	0xC5D1B023 ^ 0x55555555,    0x286085F0 ^ 0x55555555,    0xCA417918 ^ 0x55555555,    0xB8DB38EF ^ 0x55555555,
	0x8E79DCB0 ^ 0x55555555,    0x603A180E ^ 0x55555555,    0x6C9E0E8B ^ 0x55555555,    0xB01E8A3E ^ 0x55555555,
	0xD71577C1 ^ 0x55555555,    0xBD314B27 ^ 0x55555555,    0x78AF2FDA ^ 0x55555555,    0x55605C60 ^ 0x55555555,
	0xE65525F3 ^ 0x55555555,    0xAA55AB94 ^ 0x55555555,    0x57489862 ^ 0x55555555,    0x63E81440 ^ 0x55555555,
	0x55CA396A ^ 0x55555555,    0x2AAB10B6 ^ 0x55555555,    0xB4CC5C34 ^ 0x55555555,    0x1141E8CE ^ 0x55555555,
	0xA15486AF ^ 0x55555555,    0x7C72E993 ^ 0x55555555,    0xB3EE1411 ^ 0x55555555,    0x636FBC2A ^ 0x55555555,
	0x2BA9C55D ^ 0x55555555,    0x741831F6 ^ 0x55555555,    0xCE5C3E16 ^ 0x55555555,    0x9B87931E ^ 0x55555555,
	0xAFD6BA33 ^ 0x55555555,    0x6C24CF5C ^ 0x55555555,    0x7A325381 ^ 0x55555555,    0x28958677 ^ 0x55555555,
	0x3B8F4898 ^ 0x55555555,    0x6B4BB9AF ^ 0x55555555,    0xC4BFE81B ^ 0x55555555,    0x66282193 ^ 0x55555555,
	0x61D809CC ^ 0x55555555,    0xFB21A991 ^ 0x55555555,    0x487CAC60 ^ 0x55555555,    0x5DEC8032 ^ 0x55555555,
	0xEF845D5D ^ 0x55555555,    0xE98575B1 ^ 0x55555555,    0xDC262302 ^ 0x55555555,    0xEB651B88 ^ 0x55555555,
	0x23893E81 ^ 0x55555555,    0xD396ACC5 ^ 0x55555555,    0x0F6D6FF3 ^ 0x55555555,    0x83F44239 ^ 0x55555555,
	0x2E0B4482 ^ 0x55555555,    0xA4842004 ^ 0x55555555,    0x69C8F04A ^ 0x55555555,    0x9E1F9B5E ^ 0x55555555,
	0x21C66842 ^ 0x55555555,    0xF6E96C9A ^ 0x55555555,    0x670C9C61 ^ 0x55555555,    0xABD388F0 ^ 0x55555555,
	0x6A51A0D2 ^ 0x55555555,    0xD8542F68 ^ 0x55555555,    0x960FA728 ^ 0x55555555,    0xAB5133A3 ^ 0x55555555,
	0x6EEF0B6C ^ 0x55555555,    0x137A3BE4 ^ 0x55555555,    0xBA3BF050 ^ 0x55555555,    0x7EFB2A98 ^ 0x55555555,
	0xA1F1651D ^ 0x55555555,    0x39AF0176 ^ 0x55555555,    0x66CA593E ^ 0x55555555,    0x82430E88 ^ 0x55555555,
	0x8CEE8619 ^ 0x55555555,    0x456F9FB4 ^ 0x55555555,    0x7D84A5C3 ^ 0x55555555,    0x3B8B5EBE ^ 0x55555555,
	0xE06F75D8 ^ 0x55555555,    0x85C12073 ^ 0x55555555,    0x401A449F ^ 0x55555555,    0x56C16AA6 ^ 0x55555555,
	0x4ED3AA62 ^ 0x55555555,    0x363F7706 ^ 0x55555555,    0x1BFEDF72 ^ 0x55555555,    0x429B023D ^ 0x55555555,
	0x37D0D724 ^ 0x55555555,    0xD00A1248 ^ 0x55555555,    0xDB0FEAD3 ^ 0x55555555,    0x49F1C09B ^ 0x55555555,
	0x075372C9 ^ 0x55555555,    0x80991B7B ^ 0x55555555,    0x25D479D8 ^ 0x55555555,    0xF6E8DEF7 ^ 0x55555555,
	0xE3FE501A ^ 0x55555555,    0xB6794C3B ^ 0x55555555,    0x976CE0BD ^ 0x55555555,    0x04C006BA ^ 0x55555555,
	0xC1A94FB6 ^ 0x55555555,    0x409F60C4 ^ 0x55555555,    0x5E5C9EC2 ^ 0x55555555,    0x196A2463 ^ 0x55555555,
	0x68FB6FAF ^ 0x55555555,    0x3E6C53B5 ^ 0x55555555,    0x1339B2EB ^ 0x55555555,    0x3B52EC6F ^ 0x55555555,
	0x6DFC511F ^ 0x55555555,    0x9B30952C ^ 0x55555555,    0xCC814544 ^ 0x55555555,    0xAF5EBD09 ^ 0x55555555,
	0xBEE3D004 ^ 0x55555555,    0xDE334AFD ^ 0x55555555,    0x660F2807 ^ 0x55555555,    0x192E4BB3 ^ 0x55555555,
	0xC0CBA857 ^ 0x55555555,    0x45C8740F ^ 0x55555555,    0xD20B5F39 ^ 0x55555555,    0xB9D3FBDB ^ 0x55555555,
	0x5579C0BD ^ 0x55555555,    0x1A60320A ^ 0x55555555,    0xD6A100C6 ^ 0x55555555,    0x402C7279 ^ 0x55555555,
	0x679F25FE ^ 0x55555555,    0xFB1FA3CC ^ 0x55555555,    0x8EA5E9F8 ^ 0x55555555,    0xDB3222F8 ^ 0x55555555,
	0x3C7516DF ^ 0x55555555,    0xFD616B15 ^ 0x55555555,    0x2F501EC8 ^ 0x55555555,    0xAD0552AB ^ 0x55555555,
	0x323DB5FA ^ 0x55555555,    0xFD238760 ^ 0x55555555,    0x53317B48 ^ 0x55555555,    0x3E00DF82 ^ 0x55555555,
	0x9E5C57BB ^ 0x55555555,    0xCA6F8CA0 ^ 0x55555555,    0x1A87562E ^ 0x55555555,    0xDF1769DB ^ 0x55555555,
	0xD542A8F6 ^ 0x55555555,    0x287EFFC3 ^ 0x55555555,    0xAC6732C6 ^ 0x55555555,    0x8C4F5573 ^ 0x55555555,
	0x695B27B0 ^ 0x55555555,    0xBBCA58C8 ^ 0x55555555,    0xE1FFA35D ^ 0x55555555,    0xB8F011A0 ^ 0x55555555,
	0x10FA3D98 ^ 0x55555555,    0xFD2183B8 ^ 0x55555555,    0x4AFCB56C ^ 0x55555555,    0x2DD1D35B ^ 0x55555555,
	0x9A53E479 ^ 0x55555555,    0xB6F84565 ^ 0x55555555,    0xD28E49BC ^ 0x55555555,    0x4BFB9790 ^ 0x55555555,
	0xE1DDF2DA ^ 0x55555555,    0xA4CB7E33 ^ 0x55555555,    0x62FB1341 ^ 0x55555555,    0xCEE4C6E8 ^ 0x55555555,
	0xEF20CADA ^ 0x55555555,    0x36774C01 ^ 0x55555555,    0xD07E9EFE ^ 0x55555555,    0x2BF11FB4 ^ 0x55555555,
	0x95DBDA4D ^ 0x55555555,    0xAE909198 ^ 0x55555555,    0xEAAD8E71 ^ 0x55555555,    0x6B93D5A0 ^ 0x55555555,
	0xD08ED1D0 ^ 0x55555555,    0xAFC725E0 ^ 0x55555555,    0x8E3C5B2F ^ 0x55555555,    0x8E7594B7 ^ 0x55555555,
	0x8FF6E2FB ^ 0x55555555,    0xF2122B64 ^ 0x55555555,    0x8888B812 ^ 0x55555555,    0x900DF01C ^ 0x55555555,
	0x4FAD5EA0 ^ 0x55555555,    0x688FC31C ^ 0x55555555,    0xD1CFF191 ^ 0x55555555,    0xB3A8C1AD ^ 0x55555555,
	0x2F2F2218 ^ 0x55555555,    0xBE0E1777 ^ 0x55555555,    0xEA752DFE ^ 0x55555555,    0x8B021FA1 ^ 0x55555555,
	0xE5A0CC0F ^ 0x55555555,    0xB56F74E8 ^ 0x55555555,    0x18ACF3D6 ^ 0x55555555,    0xCE89E299 ^ 0x55555555,
	0xB4A84FE0 ^ 0x55555555,    0xFD13E0B7 ^ 0x55555555,    0x7CC43B81 ^ 0x55555555,    0xD2ADA8D9 ^ 0x55555555,
	0x165FA266 ^ 0x55555555,    0x80957705 ^ 0x55555555,    0x93CC7314 ^ 0x55555555,    0x211A1477 ^ 0x55555555,
	0xE6AD2065 ^ 0x55555555,    0x77B5FA86 ^ 0x55555555,    0xC75442F5 ^ 0x55555555,    0xFB9D35CF ^ 0x55555555,
	0xEBCDAF0C ^ 0x55555555,    0x7B3E89A0 ^ 0x55555555,    0xD6411BD3 ^ 0x55555555,    0xAE1E7E49 ^ 0x55555555,
	0x00250E2D ^ 0x55555555,    0x2071B35E ^ 0x55555555,    0x226800BB ^ 0x55555555,    0x57B8E0AF ^ 0x55555555,
	0x2464369B ^ 0x55555555,    0xF009B91E ^ 0x55555555,    0x5563911D ^ 0x55555555,    0x59DFA6AA ^ 0x55555555,
	0x78C14389 ^ 0x55555555,    0xD95A537F ^ 0x55555555,    0x207D5BA2 ^ 0x55555555,    0x02E5B9C5 ^ 0x55555555,
	0x83260376 ^ 0x55555555,    0x6295CFA9 ^ 0x55555555,    0x11C81968 ^ 0x55555555,    0x4E734A41 ^ 0x55555555,
	0xB3472DCA ^ 0x55555555,    0x7B14A94A ^ 0x55555555,    0x1B510052 ^ 0x55555555,    0x9A532915 ^ 0x55555555,
	0xD60F573F ^ 0x55555555,    0xBC9BC6E4 ^ 0x55555555,    0x2B60A476 ^ 0x55555555,    0x81E67400 ^ 0x55555555,
	0x08BA6FB5 ^ 0x55555555,    0x571BE91F ^ 0x55555555,    0xF296EC6B ^ 0x55555555,    0x2A0DD915 ^ 0x55555555,
	0xB6636521 ^ 0x55555555,    0xE7B9F9B6 ^ 0x55555555,    0xFF34052E ^ 0x55555555,    0xC5855664 ^ 0x55555555,
	0x53B02D5D ^ 0x55555555,    0xA99F8FA1 ^ 0x55555555,    0x08BA4799 ^ 0x55555555,    0x6E85076A ^ 0x55555555,
	0x4B7A70E9 ^ 0x55555555,    0xB5B32944 ^ 0x55555555,    0xDB75092E ^ 0x55555555,    0xC4192623 ^ 0x55555555,
	0xAD6EA6B0 ^ 0x55555555,    0x49A7DF7D ^ 0x55555555,    0x9CEE60B8 ^ 0x55555555,    0x8FEDB266 ^ 0x55555555,
	0xECAA8C71 ^ 0x55555555,    0x699A17FF ^ 0x55555555,    0x5664526C ^ 0x55555555,    0xC2B19EE1 ^ 0x55555555,
	0x193602A5 ^ 0x55555555,    0x75094C29 ^ 0x55555555,    0xA0591340 ^ 0x55555555,    0xE4183A3E ^ 0x55555555,
	0x3F54989A ^ 0x55555555,    0x5B429D65 ^ 0x55555555,    0x6B8FE4D6 ^ 0x55555555,    0x99F73FD6 ^ 0x55555555,
	0xA1D29C07 ^ 0x55555555,    0xEFE830F5 ^ 0x55555555,    0x4D2D38E6 ^ 0x55555555,    0xF0255DC1 ^ 0x55555555,
	0x4CDD2086 ^ 0x55555555,    0x8470EB26 ^ 0x55555555,    0x6382E9C6 ^ 0x55555555,    0x021ECC5E ^ 0x55555555,
	0x09686B3F ^ 0x55555555,    0x3EBAEFC9 ^ 0x55555555,    0x3C971814 ^ 0x55555555,    0x6B6A70A1 ^ 0x55555555,
	0x687F3584 ^ 0x55555555,    0x52A0E286 ^ 0x55555555,    0xB79C5305 ^ 0x55555555,    0xAA500737 ^ 0x55555555,
	0x3E07841C ^ 0x55555555,    0x7FDEAE5C ^ 0x55555555,    0x8E7D44EC ^ 0x55555555,    0x5716F2B8 ^ 0x55555555,
	0xB03ADA37 ^ 0x55555555,    0xF0500C0D ^ 0x55555555,    0xF01C1F04 ^ 0x55555555,    0x0200B3FF ^ 0x55555555,
	0xAE0CF51A ^ 0x55555555,    0x3CB574B2 ^ 0x55555555,    0x25837A58 ^ 0x55555555,    0xDC0921BD ^ 0x55555555,
	0xD19113F9 ^ 0x55555555,    0x7CA92FF6 ^ 0x55555555,    0x94324773 ^ 0x55555555,    0x22F54701 ^ 0x55555555,
	0x3AE5E581 ^ 0x55555555,    0x37C2DADC ^ 0x55555555,    0xC8B57634 ^ 0x55555555,    0x9AF3DDA7 ^ 0x55555555,
	0xA9446146 ^ 0x55555555,    0x0FD0030E ^ 0x55555555,    0xECC8C73E ^ 0x55555555,    0xA4751E41 ^ 0x55555555,
	0xE238CD99 ^ 0x55555555,    0x3BEA0E2F ^ 0x55555555,    0x3280BBA1 ^ 0x55555555,    0x183EB331 ^ 0x55555555,
	0x4E548B38 ^ 0x55555555,    0x4F6DB908 ^ 0x55555555,    0x6F420D03 ^ 0x55555555,    0xF60A04BF ^ 0x55555555,
	0x2CB81290 ^ 0x55555555,    0x24977C79 ^ 0x55555555,    0x5679B072 ^ 0x55555555,    0xBCAF89AF ^ 0x55555555,
	0xDE9A771F ^ 0x55555555,    0xD9930810 ^ 0x55555555,    0xB38BAE12 ^ 0x55555555,    0xDCCF3F2E ^ 0x55555555,
	0x5512721F ^ 0x55555555,    0x2E6B7124 ^ 0x55555555,    0x501ADDE6 ^ 0x55555555,    0x9F84CD87 ^ 0x55555555,
	0x7A584718 ^ 0x55555555,    0x7408DA17 ^ 0x55555555,    0xBC9F9ABC ^ 0x55555555,    0xE94B7D8C ^ 0x55555555,
	0xEC7AEC3A ^ 0x55555555,    0xDB851DFA ^ 0x55555555,    0x63094366 ^ 0x55555555,    0xC464C3D2 ^ 0x55555555,
	0xEF1C1847 ^ 0x55555555,    0x3215D908 ^ 0x55555555,    0xDD433B37 ^ 0x55555555,    0x24C2BA16 ^ 0x55555555,
	0x12A14D43 ^ 0x55555555,    0x2A65C451 ^ 0x55555555,    0x50940002 ^ 0x55555555,    0x133AE4DD ^ 0x55555555,
	0x71DFF89E ^ 0x55555555,    0x10314E55 ^ 0x55555555,    0x81AC77D6 ^ 0x55555555,    0x5F11199B ^ 0x55555555,
	0x043556F1 ^ 0x55555555,    0xD7A3C76B ^ 0x55555555,    0x3C11183B ^ 0x55555555,    0x5924A509 ^ 0x55555555,
	0xF28FE6ED ^ 0x55555555,    0x97F1FBFA ^ 0x55555555,    0x9EBABF2C ^ 0x55555555,    0x1E153C6E ^ 0x55555555,
	0x86E34570 ^ 0x55555555,    0xEAE96FB1 ^ 0x55555555,    0x860E5E0A ^ 0x55555555,    0x5A3E2AB3 ^ 0x55555555,
	0x771FE71C ^ 0x55555555,    0x4E3D06FA ^ 0x55555555,    0x2965DCB9 ^ 0x55555555,    0x99E71D0F ^ 0x55555555,
	0x803E89D6 ^ 0x55555555,    0x5266C825 ^ 0x55555555,    0x2E4CC978 ^ 0x55555555,    0x9C10B36A ^ 0x55555555,
	0xC6150EBA ^ 0x55555555,    0x94E2EA78 ^ 0x55555555,    0xA5FC3C53 ^ 0x55555555,    0x1E0A2DF4 ^ 0x55555555,
	0xF2F74EA7 ^ 0x55555555,    0x361D2B3D ^ 0x55555555,    0x1939260F ^ 0x55555555,    0x19C27960 ^ 0x55555555,
	0x5223A708 ^ 0x55555555,    0xF71312B6 ^ 0x55555555,    0xEBADFE6E ^ 0x55555555,    0xEAC31F66 ^ 0x55555555,
	0xE3BC4595 ^ 0x55555555,    0xA67BC883 ^ 0x55555555,    0xB17F37D1 ^ 0x55555555,    0x018CFF28 ^ 0x55555555,
	0xC332DDEF ^ 0x55555555,    0xBE6C5AA5 ^ 0x55555555,    0x65582185 ^ 0x55555555,    0x68AB9802 ^ 0x55555555,
	0xEECEA50F ^ 0x55555555,    0xDB2F953B ^ 0x55555555,    0x2AEF7DAD ^ 0x55555555,    0x5B6E2F84 ^ 0x55555555,
	0x1521B628 ^ 0x55555555,    0x29076170 ^ 0x55555555,    0xECDD4775 ^ 0x55555555,    0x619F1510 ^ 0x55555555,
	0x13CCA830 ^ 0x55555555,    0xEB61BD96 ^ 0x55555555,    0x0334FE1E ^ 0x55555555,    0xAA0363CF ^ 0x55555555,
	0xB5735C90 ^ 0x55555555,    0x4C70A239 ^ 0x55555555,    0xD59E9E0B ^ 0x55555555,    0xCBAADE14 ^ 0x55555555,
	0xEECC86BC ^ 0x55555555,    0x60622CA7 ^ 0x55555555,    0x9CAB5CAB ^ 0x55555555,    0xB2F3846E ^ 0x55555555,
	0x648B1EAF ^ 0x55555555,    0x19BDF0CA ^ 0x55555555,    0xA02369B9 ^ 0x55555555,    0x655ABB50 ^ 0x55555555,
	0x40685A32 ^ 0x55555555,    0x3C2AB4B3 ^ 0x55555555,    0x319EE9D5 ^ 0x55555555,    0xC021B8F7 ^ 0x55555555,
	0x9B540B19 ^ 0x55555555,    0x875FA099 ^ 0x55555555,    0x95F7997E ^ 0x55555555,    0x623D7DA8 ^ 0x55555555,
	0xF837889A ^ 0x55555555,    0x97E32D77 ^ 0x55555555,    0x11ED935F ^ 0x55555555,    0x16681281 ^ 0x55555555,
	0x0E358829 ^ 0x55555555,    0xC7E61FD6 ^ 0x55555555,    0x96DEDFA1 ^ 0x55555555,    0x7858BA99 ^ 0x55555555,
	0x57F584A5 ^ 0x55555555,    0x1B227263 ^ 0x55555555,    0x9B83C3FF ^ 0x55555555,    0x1AC24696 ^ 0x55555555,
	0xCDB30AEB ^ 0x55555555,    0x532E3054 ^ 0x55555555,    0x8FD948E4 ^ 0x55555555,    0x6DBC3128 ^ 0x55555555,
	0x58EBF2EF ^ 0x55555555,    0x34C6FFEA ^ 0x55555555,    0xFE28ED61 ^ 0x55555555,    0xEE7C3C73 ^ 0x55555555,
	0x5D4A14D9 ^ 0x55555555,    0xE864B7E3 ^ 0x55555555,    0x42105D14 ^ 0x55555555,    0x203E13E0 ^ 0x55555555,
	0x45EEE2B6 ^ 0x55555555,    0xA3AAABEA ^ 0x55555555,    0xDB6C4F15 ^ 0x55555555,    0xFACB4FD0 ^ 0x55555555,
	0xC742F442 ^ 0x55555555,    0xEF6ABBB5 ^ 0x55555555,    0x654F3B1D ^ 0x55555555,    0x41CD2105 ^ 0x55555555,
	0xD81E799E ^ 0x55555555,    0x86854DC7 ^ 0x55555555,    0xE44B476A ^ 0x55555555,    0x3D816250 ^ 0x55555555,
	0xCF62A1F2 ^ 0x55555555,    0x5B8D2646 ^ 0x55555555,    0xFC8883A0 ^ 0x55555555,    0xC1C7B6A3 ^ 0x55555555,
	0x7F1524C3 ^ 0x55555555,    0x69CB7492 ^ 0x55555555,    0x47848A0B ^ 0x55555555,    0x5692B285 ^ 0x55555555,
	0x095BBF00 ^ 0x55555555,    0xAD19489D ^ 0x55555555,    0x1462B174 ^ 0x55555555,    0x23820E00 ^ 0x55555555,
	0x58428D2A ^ 0x55555555,    0x0C55F5EA ^ 0x55555555,    0x1DADF43E ^ 0x55555555,    0x233F7061 ^ 0x55555555,
	0x3372F092 ^ 0x55555555,    0x8D937E41 ^ 0x55555555,    0xD65FECF1 ^ 0x55555555,    0x6C223BDB ^ 0x55555555,
	0x7CDE3759 ^ 0x55555555,    0xCBEE7460 ^ 0x55555555,    0x4085F2A7 ^ 0x55555555,    0xCE77326E ^ 0x55555555,
	0xA6078084 ^ 0x55555555,    0x19F8509E ^ 0x55555555,    0xE8EFD855 ^ 0x55555555,    0x61D99735 ^ 0x55555555,
	0xA969A7AA ^ 0x55555555,    0xC50C06C2 ^ 0x55555555,    0x5A04ABFC ^ 0x55555555,    0x800BCADC ^ 0x55555555,
	0x9E447A2E ^ 0x55555555,    0xC3453484 ^ 0x55555555,    0xFDD56705 ^ 0x55555555,    0x0E1E9EC9 ^ 0x55555555,
	0xDB73DBD3 ^ 0x55555555,    0x105588CD ^ 0x55555555,    0x675FDA79 ^ 0x55555555,    0xE3674340 ^ 0x55555555,
	0xC5C43465 ^ 0x55555555,    0x713E38D8 ^ 0x55555555,    0x3D28F89E ^ 0x55555555,    0xF16DFF20 ^ 0x55555555,
	0x153E21E7 ^ 0x55555555,    0x8FB03D4A ^ 0x55555555,    0xE6E39F2B ^ 0x55555555,    0xDB83ADF7 ^ 0x55555555,
	0xE93D5A68 ^ 0x55555555,    0x948140F7 ^ 0x55555555,    0xF64C261C ^ 0x55555555,    0x94692934 ^ 0x55555555,
	0x411520F7 ^ 0x55555555,    0x7602D4F7 ^ 0x55555555,    0xBCF46B2E ^ 0x55555555,    0xD4A20068 ^ 0x55555555,
	0xD4082471 ^ 0x55555555,    0x3320F46A ^ 0x55555555,    0x43B7D4B7 ^ 0x55555555,    0x500061AF ^ 0x55555555,
	0x1E39F62E ^ 0x55555555,    0x97244546 ^ 0x55555555,    0x14214F74 ^ 0x55555555,    0xBF8B8840 ^ 0x55555555,
	0x4D95FC1D ^ 0x55555555,    0x96B591AF ^ 0x55555555,    0x70F4DDD3 ^ 0x55555555,    0x66A02F45 ^ 0x55555555,
	0xBFBC09EC ^ 0x55555555,    0x03BD9785 ^ 0x55555555,    0x7FAC6DD0 ^ 0x55555555,    0x31CB8504 ^ 0x55555555,
	0x96EB27B3 ^ 0x55555555,    0x55FD3941 ^ 0x55555555,    0xDA2547E6 ^ 0x55555555,    0xABCA0A9A ^ 0x55555555,
	0x28507825 ^ 0x55555555,    0x530429F4 ^ 0x55555555,    0x0A2C86DA ^ 0x55555555,    0xE9B66DFB ^ 0x55555555,
	0x68DC1462 ^ 0x55555555,    0xD7486900 ^ 0x55555555,    0x680EC0A4 ^ 0x55555555,    0x27A18DEE ^ 0x55555555,
	0x4F3FFEA2 ^ 0x55555555,    0xE887AD8C ^ 0x55555555,    0xB58CE006 ^ 0x55555555,    0x7AF4D6B6 ^ 0x55555555,
	0xAACE1E7C ^ 0x55555555,    0xD3375FEC ^ 0x55555555,    0xCE78A399 ^ 0x55555555,    0x406B2A42 ^ 0x55555555,
	0x20FE9E35 ^ 0x55555555,    0xD9F385B9 ^ 0x55555555,    0xEE39D7AB ^ 0x55555555,    0x3B124E8B ^ 0x55555555,
	0x1DC9FAF7 ^ 0x55555555,    0x4B6D1856 ^ 0x55555555,    0x26A36631 ^ 0x55555555,    0xEAE397B2 ^ 0x55555555,
	0x3A6EFA74 ^ 0x55555555,    0xDD5B4332 ^ 0x55555555,    0x6841E7F7 ^ 0x55555555,    0xCA7820FB ^ 0x55555555,
	0xFB0AF54E ^ 0x55555555,    0xD8FEB397 ^ 0x55555555,    0x454056AC ^ 0x55555555,    0xBA489527 ^ 0x55555555,
	0x55533A3A ^ 0x55555555,    0x20838D87 ^ 0x55555555,    0xFE6BA9B7 ^ 0x55555555,    0xD096954B ^ 0x55555555,
	0x55A867BC ^ 0x55555555,    0xA1159A58 ^ 0x55555555,    0xCCA92963 ^ 0x55555555,    0x99E1DB33 ^ 0x55555555,
	0xA62A4A56 ^ 0x55555555,    0x3F3125F9 ^ 0x55555555,    0x5EF47E1C ^ 0x55555555,    0x9029317C ^ 0x55555555,
	0xFDF8E802 ^ 0x55555555,    0x04272F70 ^ 0x55555555,    0x80BB155C ^ 0x55555555,    0x05282CE3 ^ 0x55555555,
	0x95C11548 ^ 0x55555555,    0xE4C66D22 ^ 0x55555555,    0x48C1133F ^ 0x55555555,    0xC70F86DC ^ 0x55555555,
	0x07F9C9EE ^ 0x55555555,    0x41041F0F ^ 0x55555555,    0x404779A4 ^ 0x55555555,    0x5D886E17 ^ 0x55555555,
	0x325F51EB ^ 0x55555555,    0xD59BC0D1 ^ 0x55555555,    0xF2BCC18F ^ 0x55555555,    0x41113564 ^ 0x55555555,
	0x257B7834 ^ 0x55555555,    0x602A9C60 ^ 0x55555555,    0xDFF8E8A3 ^ 0x55555555,    0x1F636C1B ^ 0x55555555,
	0x0E12B4C2 ^ 0x55555555,    0x02E1329E ^ 0x55555555,    0xAF664FD1 ^ 0x55555555,    0xCAD18115 ^ 0x55555555,
	0x6B2395E0 ^ 0x55555555,    0x333E92E1 ^ 0x55555555,    0x3B240B62 ^ 0x55555555,    0xEEBEB922 ^ 0x55555555,
	0x85B2A20E ^ 0x55555555,    0xE6BA0D99 ^ 0x55555555,    0xDE720C8C ^ 0x55555555,    0x2DA2F728 ^ 0x55555555,
	0xD0127845 ^ 0x55555555,    0x95B794FD ^ 0x55555555,    0x647D0862 ^ 0x55555555,    0xE7CCF5F0 ^ 0x55555555,
	0x5449A36F ^ 0x55555555,    0x877D48FA ^ 0x55555555,    0xC39DFD27 ^ 0x55555555,    0xF33E8D1E ^ 0x55555555,
	0x0A476341 ^ 0x55555555,    0x992EFF74 ^ 0x55555555,    0x3A6F6EAB ^ 0x55555555,    0xF4F8FD37 ^ 0x55555555,
	0xA812DC60 ^ 0x55555555,    0xA1EBDDF8 ^ 0x55555555,    0x991BE14C ^ 0x55555555,    0xDB6E6B0D ^ 0x55555555,
	0xC67B5510 ^ 0x55555555,    0x6D672C37 ^ 0x55555555,    0x2765D43B ^ 0x55555555,    0xDCD0E804 ^ 0x55555555,
	0xF1290DC7 ^ 0x55555555,    0xCC00FFA3 ^ 0x55555555,    0xB5390F92 ^ 0x55555555,    0x690FED0B ^ 0x55555555,
	0x667B9FFB ^ 0x55555555,    0xCEDB7D9C ^ 0x55555555,    0xA091CF0B ^ 0x55555555,    0xD9155EA3 ^ 0x55555555,
	0xBB132F88 ^ 0x55555555,    0x515BAD24 ^ 0x55555555,    0x7B9479BF ^ 0x55555555,    0x763BD6EB ^ 0x55555555,
	0x37392EB3 ^ 0x55555555,    0xCC115979 ^ 0x55555555,    0x8026E297 ^ 0x55555555,    0xF42E312D ^ 0x55555555,
	0x6842ADA7 ^ 0x55555555,    0xC66A2B3B ^ 0x55555555,    0x12754CCC ^ 0x55555555,    0x782EF11C ^ 0x55555555,
	0x6A124237 ^ 0x55555555,    0xB79251E7 ^ 0x55555555,    0x06A1BBE6 ^ 0x55555555,    0x4BFB6350 ^ 0x55555555,
	0x1A6B1018 ^ 0x55555555,    0x11CAEDFA ^ 0x55555555,    0x3D25BDD8 ^ 0x55555555,    0xE2E1C3C9 ^ 0x55555555,
	0x44421659 ^ 0x55555555,    0x0A121386 ^ 0x55555555,    0xD90CEC6E ^ 0x55555555,    0xD5ABEA2A ^ 0x55555555,
	0x64AF674E ^ 0x55555555,    0xDA86A85F ^ 0x55555555,    0xBEBFE988 ^ 0x55555555,    0x64E4C3FE ^ 0x55555555,
	0x9DBC8057 ^ 0x55555555,    0xF0F7C086 ^ 0x55555555,    0x60787BF8 ^ 0x55555555,    0x6003604D ^ 0x55555555,
	0xD1FD8346 ^ 0x55555555,    0xF6381FB0 ^ 0x55555555,    0x7745AE04 ^ 0x55555555,    0xD736FCCC ^ 0x55555555,
	0x83426B33 ^ 0x55555555,    0xF01EAB71 ^ 0x55555555,    0xB0804187 ^ 0x55555555,    0x3C005E5F ^ 0x55555555,
	0x77A057BE ^ 0x55555555,    0xBDE8AE24 ^ 0x55555555,    0x55464299 ^ 0x55555555,    0xBF582E61 ^ 0x55555555,
	0x4E58F48F ^ 0x55555555,    0xF2DDFDA2 ^ 0x55555555,    0xF474EF38 ^ 0x55555555,    0x8789BDC2 ^ 0x55555555,
	0x5366F9C3 ^ 0x55555555,    0xC8B38E74 ^ 0x55555555,    0xB475F255 ^ 0x55555555,    0x46FCD9B9 ^ 0x55555555,
	0x7AEB2661 ^ 0x55555555,    0x8B1DDF84 ^ 0x55555555,    0x846A0E79 ^ 0x55555555,    0x915F95E2 ^ 0x55555555,
	0x466E598E ^ 0x55555555,    0x20B45770 ^ 0x55555555,    0x8CD55591 ^ 0x55555555,    0xC902DE4C ^ 0x55555555,
	0xB90BACE1 ^ 0x55555555,    0xBB8205D0 ^ 0x55555555,    0x11A86248 ^ 0x55555555,    0x7574A99E ^ 0x55555555,
	0xB77F19B6 ^ 0x55555555,    0xE0A9DC09 ^ 0x55555555,    0x662D09A1 ^ 0x55555555,    0xC4324633 ^ 0x55555555,
	0xE85A1F02 ^ 0x55555555,    0x09F0BE8C ^ 0x55555555,    0x4A99A025 ^ 0x55555555,    0x1D6EFE10 ^ 0x55555555,
	0x1AB93D1D ^ 0x55555555,    0x0BA5A4DF ^ 0x55555555,    0xA186F20F ^ 0x55555555,    0x2868F169 ^ 0x55555555,
	0xDCB7DA83 ^ 0x55555555,    0x573906FE ^ 0x55555555,    0xA1E2CE9B ^ 0x55555555,    0x4FCD7F52 ^ 0x55555555,
	0x50115E01 ^ 0x55555555,    0xA70683FA ^ 0x55555555,    0xA002B5C4 ^ 0x55555555,    0x0DE6D027 ^ 0x55555555,
	0x9AF88C27 ^ 0x55555555,    0x773F8641 ^ 0x55555555,    0xC3604C06 ^ 0x55555555,    0x61A806B5 ^ 0x55555555,
	0xF0177A28 ^ 0x55555555,    0xC0F586E0 ^ 0x55555555,    0x006058AA ^ 0x55555555,    0x30DC7D62 ^ 0x55555555,
	0x11E69ED7 ^ 0x55555555,    0x2338EA63 ^ 0x55555555,    0x53C2DD94 ^ 0x55555555,    0xC2C21634 ^ 0x55555555,
	0xBBCBEE56 ^ 0x55555555,    0x90BCB6DE ^ 0x55555555,    0xEBFC7DA1 ^ 0x55555555,    0xCE591D76 ^ 0x55555555,
	0x6F05E409 ^ 0x55555555,    0x4B7C0188 ^ 0x55555555,    0x39720A3D ^ 0x55555555,    0x7C927C24 ^ 0x55555555,
	0x86E3725F ^ 0x55555555,    0x724D9DB9 ^ 0x55555555,    0x1AC15BB4 ^ 0x55555555,    0xD39EB8FC ^ 0x55555555,
	0xED545578 ^ 0x55555555,    0x08FCA5B5 ^ 0x55555555,    0xD83D7CD3 ^ 0x55555555,    0x4DAD0FC4 ^ 0x55555555,
	0x1E50EF5E ^ 0x55555555,    0xB161E6F8 ^ 0x55555555,    0xA28514D9 ^ 0x55555555,    0x6C51133C ^ 0x55555555,
	0x6FD5C7E7 ^ 0x55555555,    0x56E14EC4 ^ 0x55555555,    0x362ABFCE ^ 0x55555555,    0xDDC6C837 ^ 0x55555555,
	0xD79A3234 ^ 0x55555555,    0x92638212 ^ 0x55555555,    0x670EFA8E ^ 0x55555555,    0x406000E0 ^ 0x55555555,
	0x3A39CE37 ^ 0x55555555,    0xD3FAF5CF ^ 0x55555555,    0xABC27737 ^ 0x55555555,    0x5AC52D1B ^ 0x55555555,
	0x5CB0679E ^ 0x55555555,    0x4FA33742 ^ 0x55555555,    0xD3822740 ^ 0x55555555,    0x99BC9BBE ^ 0x55555555,
	0xD5118E9D ^ 0x55555555,    0xBF0F7315 ^ 0x55555555,    0xD62D1C7E ^ 0x55555555,    0xC700C47B ^ 0x55555555,
	0xB78C1B6B ^ 0x55555555,    0x21A19045 ^ 0x55555555,    0xB26EB1BE ^ 0x55555555,    0x6A366EB4 ^ 0x55555555,
	0x5748AB2F ^ 0x55555555,    0xBC946E79 ^ 0x55555555,    0xC6A376D2 ^ 0x55555555,    0x6549C2C8 ^ 0x55555555,
	0x530FF8EE ^ 0x55555555,    0x468DDE7D ^ 0x55555555,    0xD5730A1D ^ 0x55555555,    0x4CD04DC6 ^ 0x55555555,
	0x2939BBDB ^ 0x55555555,    0xA9BA4650 ^ 0x55555555,    0xAC9526E8 ^ 0x55555555,    0xBE5EE304 ^ 0x55555555,
	0xA1FAD5F0 ^ 0x55555555,    0x6A2D519A ^ 0x55555555,    0x63EF8CE2 ^ 0x55555555,    0x9A86EE22 ^ 0x55555555,
	0xC089C2B8 ^ 0x55555555,    0x43242EF6 ^ 0x55555555,    0xA51E03AA ^ 0x55555555,    0x9CF2D0A4 ^ 0x55555555,
	0x83C061BA ^ 0x55555555,    0x9BE96A4D ^ 0x55555555,    0x8FE51550 ^ 0x55555555,    0xBA645BD6 ^ 0x55555555,
	0x2826A2F9 ^ 0x55555555,    0xA73A3AE1 ^ 0x55555555,    0x4BA99586 ^ 0x55555555,    0xEF5562E9 ^ 0x55555555,
	0xC72FEFD3 ^ 0x55555555,    0xF752F7DA ^ 0x55555555,    0x3F046F69 ^ 0x55555555,    0x77FA0A59 ^ 0x55555555,
	0x80E4A915 ^ 0x55555555,    0x87B08601 ^ 0x55555555,    0x9B09E6AD ^ 0x55555555,    0x3B3EE593 ^ 0x55555555,
	0xE990FD5A ^ 0x55555555,    0x9E34D797 ^ 0x55555555,    0x2CF0B7D9 ^ 0x55555555,    0x022B8B51 ^ 0x55555555,
	0x96D5AC3A ^ 0x55555555,    0x017DA67D ^ 0x55555555,    0xD1CF3ED6 ^ 0x55555555,    0x7C7D2D28 ^ 0x55555555,
	0x1F9F25CF ^ 0x55555555,    0xADF2B89B ^ 0x55555555,    0x5AD6B472 ^ 0x55555555,    0x5A88F54C ^ 0x55555555,
	0xE029AC71 ^ 0x55555555,    0xE019A5E6 ^ 0x55555555,    0x47B0ACFD ^ 0x55555555,    0xED93FA9B ^ 0x55555555,
	0xE8D3C48D ^ 0x55555555,    0x283B57CC ^ 0x55555555,    0xF8D56629 ^ 0x55555555,    0x79132E28 ^ 0x55555555,
	0x785F0191 ^ 0x55555555,    0xED756055 ^ 0x55555555,    0xF7960E44 ^ 0x55555555,    0xE3D35E8C ^ 0x55555555,
	0x15056DD4 ^ 0x55555555,    0x88F46DBA ^ 0x55555555,    0x03A16125 ^ 0x55555555,    0x0564F0BD ^ 0x55555555,
	0xC3EB9E15 ^ 0x55555555,    0x3C9057A2 ^ 0x55555555,    0x97271AEC ^ 0x55555555,    0xA93A072A ^ 0x55555555,
	0x1B3F6D9B ^ 0x55555555,    0x1E6321F5 ^ 0x55555555,    0xF59C66FB ^ 0x55555555,    0x26DCF319 ^ 0x55555555,
	0x7533D928 ^ 0x55555555,    0xB155FDF5 ^ 0x55555555,    0x03563482 ^ 0x55555555,    0x8ABA3CBB ^ 0x55555555,
	0x28517711 ^ 0x55555555,    0xC20AD9F8 ^ 0x55555555,    0xABCC5167 ^ 0x55555555,    0xCCAD925F ^ 0x55555555,
	0x4DE81751 ^ 0x55555555,    0x3830DC8E ^ 0x55555555,    0x379D5862 ^ 0x55555555,    0x9320F991 ^ 0x55555555,
	0xEA7A90C2 ^ 0x55555555,    0xFB3E7BCE ^ 0x55555555,    0x5121CE64 ^ 0x55555555,    0x774FBE32 ^ 0x55555555,
	0xA8B6E37E ^ 0x55555555,    0xC3293D46 ^ 0x55555555,    0x48DE5369 ^ 0x55555555,    0x6413E680 ^ 0x55555555,
	0xA2AE0810 ^ 0x55555555,    0xDD6DB224 ^ 0x55555555,    0x69852DFD ^ 0x55555555,    0x09072166 ^ 0x55555555,
	0xB39A460A ^ 0x55555555,    0x6445C0DD ^ 0x55555555,    0x586CDECF ^ 0x55555555,    0x1C20C8AE ^ 0x55555555,
	0x5BBEF7DD ^ 0x55555555,    0x1B588D40 ^ 0x55555555,    0xCCD2017F ^ 0x55555555,    0x6BB4E3BB ^ 0x55555555,
	0xDDA26A7E ^ 0x55555555,    0x3A59FF45 ^ 0x55555555,    0x3E350A44 ^ 0x55555555,    0xBCB4CDD5 ^ 0x55555555,
	0x72EACEA8 ^ 0x55555555,    0xFA6484BB ^ 0x55555555,    0x8D6612AE ^ 0x55555555,    0xBF3C6F47 ^ 0x55555555,
	0xD29BE463 ^ 0x55555555,    0x542F5D9E ^ 0x55555555,    0xAEC2771B ^ 0x55555555,    0xF64E6370 ^ 0x55555555,
	0x740E0D8D ^ 0x55555555,    0xE75B1357 ^ 0x55555555,    0xF8721671 ^ 0x55555555,    0xAF537D5D ^ 0x55555555,
	0x4040CB08 ^ 0x55555555,    0x4EB4E2CC ^ 0x55555555,    0x34D2466A ^ 0x55555555,    0x0115AF84 ^ 0x55555555,
	0xE1B00428 ^ 0x55555555,    0x95983A1D ^ 0x55555555,    0x06B89FB4 ^ 0x55555555,    0xCE6EA048 ^ 0x55555555,
	0x6F3F3B82 ^ 0x55555555,    0x3520AB82 ^ 0x55555555,    0x011A1D4B ^ 0x55555555,    0x277227F8 ^ 0x55555555,
	0x611560B1 ^ 0x55555555,    0xE7933FDC ^ 0x55555555,    0xBB3A792B ^ 0x55555555,    0x344525BD ^ 0x55555555,
	0xA08839E1 ^ 0x55555555,    0x51CE794B ^ 0x55555555,    0x2F32C9B7 ^ 0x55555555,    0xA01FBAC9 ^ 0x55555555,
	0xE01CC87E ^ 0x55555555,    0xBCC7D1F6 ^ 0x55555555,    0xCF0111C3 ^ 0x55555555,    0xA1E8AAC7 ^ 0x55555555,
	0x1A908749 ^ 0x55555555,    0xD44FBD9A ^ 0x55555555,    0xD0DADECB ^ 0x55555555,    0xD50ADA38 ^ 0x55555555,
	0x0339C32A ^ 0x55555555,    0xC6913667 ^ 0x55555555,    0x8DF9317C ^ 0x55555555,    0xE0B12B4F ^ 0x55555555,
	0xF79E59B7 ^ 0x55555555,    0x43F5BB3A ^ 0x55555555,    0xF2D519FF ^ 0x55555555,    0x27D9459C ^ 0x55555555,
	0xBF97222C ^ 0x55555555,    0x15E6FC2A ^ 0x55555555,    0x0F91FC71 ^ 0x55555555,    0x9B941525 ^ 0x55555555,
	0xFAE59361 ^ 0x55555555,    0xCEB69CEB ^ 0x55555555,    0xC2A86459 ^ 0x55555555,    0x12BAA8D1 ^ 0x55555555,
	0xB6C1075E ^ 0x55555555,    0xE3056A0C ^ 0x55555555,    0x10D25065 ^ 0x55555555,    0xCB03A442 ^ 0x55555555,
	0xE0EC6E0E ^ 0x55555555,    0x1698DB3B ^ 0x55555555,    0x4C98A0BE ^ 0x55555555,    0x3278E964 ^ 0x55555555,
	0x9F1F9532 ^ 0x55555555,    0xE0D392DF ^ 0x55555555,    0xD3A0342B ^ 0x55555555,    0x8971F21E ^ 0x55555555,
	0x1B0A7441 ^ 0x55555555,    0x4BA3348C ^ 0x55555555,    0xC5BE7120 ^ 0x55555555,    0xC37632D8 ^ 0x55555555,
	0xDF359F8D ^ 0x55555555,    0x9B992F2E ^ 0x55555555,    0xE60B6F47 ^ 0x55555555,    0x0FE3F11D ^ 0x55555555,
	0xE54CDA54 ^ 0x55555555,    0x1EDAD891 ^ 0x55555555,    0xCE6279CF ^ 0x55555555,    0xCD3E7E6F ^ 0x55555555,
	0x1618B166 ^ 0x55555555,    0xFD2C1D05 ^ 0x55555555,    0x848FD2C5 ^ 0x55555555,    0xF6FB2299 ^ 0x55555555,
	0xF523F357 ^ 0x55555555,    0xA6327623 ^ 0x55555555,    0x93A83531 ^ 0x55555555,    0x56CCCD02 ^ 0x55555555,
	0xACF08162 ^ 0x55555555,    0x5A75EBB5 ^ 0x55555555,    0x6E163697 ^ 0x55555555,    0x88D273CC ^ 0x55555555,
	0xDE966292 ^ 0x55555555,    0x81B949D0 ^ 0x55555555,    0x4C50901B ^ 0x55555555,    0x71C65614 ^ 0x55555555,
	0xE6C6C7BD ^ 0x55555555,    0x327A140A ^ 0x55555555,    0x45E1D006 ^ 0x55555555,    0xC3F27B9A ^ 0x55555555,
	0xC9AA53FD ^ 0x55555555,    0x62A80F00 ^ 0x55555555,    0xBB25BFE2 ^ 0x55555555,    0x35BDD2F6 ^ 0x55555555,
	0x71126905 ^ 0x55555555,    0xB2040222 ^ 0x55555555,    0xB6CBCF7C ^ 0x55555555,    0xCD769C2B ^ 0x55555555,
	0x53113EC0 ^ 0x55555555,    0x1640E3D3 ^ 0x55555555,    0x38ABBD60 ^ 0x55555555,    0x2547ADF0 ^ 0x55555555,
	0xBA38209C ^ 0x55555555,    0xF746CE76 ^ 0x55555555,    0x77AFA1C5 ^ 0x55555555,    0x20756060 ^ 0x55555555,
	0x85CBFE4E ^ 0x55555555,    0x8AE88DD8 ^ 0x55555555,    0x7AAAF9B0 ^ 0x55555555,    0x4CF9AA7E ^ 0x55555555,
	0x1948C25C ^ 0x55555555,    0x02FB8A8C ^ 0x55555555,    0x01C36AE4 ^ 0x55555555,    0xD6EBE1F9 ^ 0x55555555,
	0x90D4F869 ^ 0x55555555,    0xA65CDEA0 ^ 0x55555555,    0x3F09252D ^ 0x55555555,    0xC208E69F ^ 0x55555555,
	0xB74E6132 ^ 0x55555555,    0xCE77E25B ^ 0x55555555,    0x578FDFE3 ^ 0x55555555,    0x3AC372E6 ^ 0x55555555,
};

DWORD s_nDATA00419168[] = // table 4
{
	0x428A2F98 ^ 0x55555555,    0x71374491 ^ 0x55555555,    0xB5C0FBCF ^ 0x55555555,    0xE9B5DBA5 ^ 0x55555555,
	0x3956C25B ^ 0x55555555,    0x59F111F1 ^ 0x55555555,    0x923F82A4 ^ 0x55555555,    0xAB1C5ED5 ^ 0x55555555,
	0xD807AA98 ^ 0x55555555,    0x12835B01 ^ 0x55555555,    0x243185BE ^ 0x55555555,    0x550C7DC3 ^ 0x55555555,
	0x72BE5D74 ^ 0x55555555,    0x80DEB1FE ^ 0x55555555,    0x9BDC06A7 ^ 0x55555555,    0xC19BF174 ^ 0x55555555,
	0xE49B69C1 ^ 0x55555555,    0xEFBE4786 ^ 0x55555555,    0x0FC19DC6 ^ 0x55555555,    0x240CA1CC ^ 0x55555555,
	0x2DE92C6F ^ 0x55555555,    0x4A7484AA ^ 0x55555555,    0x5CB0A9DC ^ 0x55555555,    0x76F988DA ^ 0x55555555,
	0x983E5152 ^ 0x55555555,    0xA831C66D ^ 0x55555555,    0xB00327C8 ^ 0x55555555,    0xBF597FC7 ^ 0x55555555,
	0xC6E00BF3 ^ 0x55555555,    0xD5A79147 ^ 0x55555555,    0x06CA6351 ^ 0x55555555,    0x14292967 ^ 0x55555555,
	0x27B70A85 ^ 0x55555555,    0x2E1B2138 ^ 0x55555555,    0x4D2C6DFC ^ 0x55555555,    0x53380D13 ^ 0x55555555,
	0x650A7354 ^ 0x55555555,    0x766A0ABB ^ 0x55555555,    0x81C2C92E ^ 0x55555555,    0x92722C85 ^ 0x55555555,
	0xA2BFE8A1 ^ 0x55555555,    0xA81A664B ^ 0x55555555,    0xC24B8B70 ^ 0x55555555,    0xC76C51A3 ^ 0x55555555,
	0xD192E819 ^ 0x55555555,    0xD6990624 ^ 0x55555555,    0xF40E3585 ^ 0x55555555,    0x106AA070 ^ 0x55555555,
	0x19A4C116 ^ 0x55555555,    0x1E376C08 ^ 0x55555555,    0x2748774C ^ 0x55555555,    0x34B0BCB5 ^ 0x55555555,
	0x391C0CB3 ^ 0x55555555,    0x4ED8AA4A ^ 0x55555555,    0x5B9CCA4F ^ 0x55555555,    0x682E6FF3 ^ 0x55555555,
	0x748F82EE ^ 0x55555555,    0x78A5636F ^ 0x55555555,    0x84C87814 ^ 0x55555555,    0x8CC70208 ^ 0x55555555,
	0x90BEFFFA ^ 0x55555555,    0xA4506CEB ^ 0x55555555,    0xBEF9A3F7 ^ 0x55555555,    0xC67178F2 ^ 0x55555555,
};

DWORD s_nDATA004197E8[] = // table 5
{
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000001,
	0x00000001,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000001,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000001,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000001,
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000001,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000001,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000000,    0x00000000,
	0x00000000,    0x00000000,    0x00000001,    0x00000000,
};

DWORD s_nDATA004198E8[] = // table 6
{
	0x00000001 + 0x00000068,    0x00000003 + 0x00000068,    0x00000005 + 0x00000068,    0x00000000 + 0x00000068,
	0x00000011 + 0x00000068,    0x00000033 + 0x00000068,    0x00000055 + 0x00000068,    0x00000075 + 0x00000068,
	0x0000001A + 0x00000068,    0x0000002E + 0x00000068,    0x00000072 + 0x00000068,    0x00000015 + 0x00000068,
	0x000000A1 + 0x00000068,    0x000000F8 + 0x00000068,    0x00000013 + 0x00000068,    0x00000035 + 0x00000068,
	0x000000A0 + 0x00000068,    0x00000039 + 0x00000068,    0x0000004B + 0x00000068,    0x000000DD + 0x00000068,
	0x0000007C + 0x00000068,    0x00000084 + 0x00000068,    0x00000097 + 0x00000068,    0x000000A2 + 0x00000068,
	0x000000FD + 0x00000068,    0x0000001C + 0x00000068,    0x00000024 + 0x00000068,    0x0000006C + 0x00000068,
	0x000000B4 + 0x00000068,    0x000000C7 + 0x00000068,    0x00000052 + 0x00000068,    0x000000F6 + 0x00000068,
	0x0000000F + 0x00000068,    0x000000C3 + 0x00000068,    0x0000005E + 0x00000068,    0x000000E2 + 0x00000068,
	0x0000003D + 0x00000068,    0x00000047 + 0x00000068,    0x000000C9 + 0x00000068,    0x00000040 + 0x00000068,
	0x000000C0 + 0x00000068,    0x0000005B + 0x00000068,    0x000000ED + 0x00000068,    0x0000002C + 0x00000068,
	0x00000074 + 0x00000068,    0x0000009C + 0x00000068,    0x000000BF + 0x00000068,    0x000000DA + 0x00000068,
	0x000000FF + 0x00000068,    0x000000FB + 0x00000068,    0x00000016 + 0x00000068,    0x0000003A + 0x00000068,
	0x0000004E + 0x00000068,    0x000000D2 + 0x00000068,    0x0000006D + 0x00000068,    0x000000B7 + 0x00000068,
	0x000000C2 + 0x00000068,    0x0000005D + 0x00000068,    0x000000E7 + 0x00000068,    0x00000032 + 0x00000068,
	0x00000056 + 0x00000068,    0x000000FA + 0x00000068,    0x00000096 + 0x00000068,    0x0000003F + 0x00000068,
	0x00000041 + 0x00000068,    0x0000009F + 0x00000068,    0x000000BA + 0x00000068,    0x000000D5 + 0x00000068,
	0x00000064 + 0x00000068,    0x000000AC + 0x00000068,    0x000000EF + 0x00000068,    0x0000002A + 0x00000068,
	0x0000007E + 0x00000068,    0x00000082 + 0x00000068,    0x0000009D + 0x00000068,    0x000000BC + 0x00000068,
	0x000000DF + 0x00000068,    0x0000007A + 0x00000068,    0x0000008E + 0x00000068,    0x00000089 + 0x00000068,
	0x00000080 + 0x00000068,    0x0000009B + 0x00000068,    0x000000B6 + 0x00000068,    0x000000C1 + 0x00000068,
	0x00000058 + 0x00000068,    0x000000E8 + 0x00000068,    0x00000023 + 0x00000068,    0x00000065 + 0x00000068,
	0x000000AF + 0x00000068,    0x000000EA + 0x00000068,    0x00000025 + 0x00000068,    0x0000006F + 0x00000068,
	0x000000B1 + 0x00000068,    0x000000C8 + 0x00000068,    0x00000043 + 0x00000068,    0x000000C5 + 0x00000068,
	0x00000054 + 0x00000068,    0x000000FC + 0x00000068,    0x0000001F + 0x00000068,    0x00000021 + 0x00000068,
	0x00000063 + 0x00000068,    0x000000A5 + 0x00000068,    0x000000F4 + 0x00000068,    0x00000007 + 0x00000068,
	0x00000009 + 0x00000068,    0x0000001B + 0x00000068,    0x0000002D + 0x00000068,    0x00000077 + 0x00000068,
	0x00000099 + 0x00000068,    0x000000B0 + 0x00000068,    0x000000CB + 0x00000068,    0x00000046 + 0x00000068,
	0x000000CA + 0x00000068,    0x00000045 + 0x00000068,    0x000000CF + 0x00000068,    0x0000004A + 0x00000068,
	0x000000DE + 0x00000068,    0x00000079 + 0x00000068,    0x0000008B + 0x00000068,    0x00000086 + 0x00000068,
	0x00000091 + 0x00000068,    0x000000A8 + 0x00000068,    0x000000E3 + 0x00000068,    0x0000003E + 0x00000068,
	0x00000042 + 0x00000068,    0x000000C6 + 0x00000068,    0x00000051 + 0x00000068,    0x000000F3 + 0x00000068,
	0x0000000E + 0x00000068,    0x00000012 + 0x00000068,    0x00000036 + 0x00000068,    0x0000005A + 0x00000068,
	0x000000EE + 0x00000068,    0x00000029 + 0x00000068,    0x0000007B + 0x00000068,    0x0000008D + 0x00000068,
	0x0000008C + 0x00000068,    0x0000008F + 0x00000068,    0x0000008A + 0x00000068,    0x00000085 + 0x00000068,
	0x00000094 + 0x00000068,    0x000000A7 + 0x00000068,    0x000000F2 + 0x00000068,    0x0000000D + 0x00000068,
	0x00000017 + 0x00000068,    0x00000053 + 0x00000068,    0x000000F5 + 0x00000068,    0x00000004 + 0x00000068,
	0x0000000C + 0x00000068,    0x00000014 + 0x00000068,    0x0000003C + 0x00000068,    0x00000044 + 0x00000068,
	0x000000CC + 0x00000068,    0x0000004F + 0x00000068,    0x000000D1 + 0x00000068,    0x00000068 + 0x00000068,
	0x000000B8 + 0x00000068,    0x000000D3 + 0x00000068,    0x0000006E + 0x00000068,    0x000000B2 + 0x00000068,
	0x000000CD + 0x00000068,    0x0000004C + 0x00000068,    0x000000D4 + 0x00000068,    0x00000067 + 0x00000068,
	0x000000A9 + 0x00000068,    0x000000E0 + 0x00000068,    0x0000003B + 0x00000068,    0x0000004D + 0x00000068,
	0x000000D7 + 0x00000068,    0x00000062 + 0x00000068,    0x000000A6 + 0x00000068,    0x000000F1 + 0x00000068,
	0x00000008 + 0x00000068,    0x00000018 + 0x00000068,    0x00000028 + 0x00000068,    0x00000078 + 0x00000068,
	0x00000088 + 0x00000068,    0x00000083 + 0x00000068,    0x0000009E + 0x00000068,    0x000000B9 + 0x00000068,
	0x000000D0 + 0x00000068,    0x0000006B + 0x00000068,    0x000000BD + 0x00000068,    0x000000DC + 0x00000068,
	0x0000007F + 0x00000068,    0x00000081 + 0x00000068,    0x00000098 + 0x00000068,    0x000000B3 + 0x00000068,
	0x000000CE + 0x00000068,    0x00000049 + 0x00000068,    0x000000DB + 0x00000068,    0x00000076 + 0x00000068,
	0x0000009A + 0x00000068,    0x000000B5 + 0x00000068,    0x000000C4 + 0x00000068,    0x00000057 + 0x00000068,
	0x000000F9 + 0x00000068,    0x00000010 + 0x00000068,    0x00000030 + 0x00000068,    0x00000050 + 0x00000068,
	0x000000F0 + 0x00000068,    0x0000000B + 0x00000068,    0x0000001D + 0x00000068,    0x00000027 + 0x00000068,
	0x00000069 + 0x00000068,    0x000000BB + 0x00000068,    0x000000D6 + 0x00000068,    0x00000061 + 0x00000068,
	0x000000A3 + 0x00000068,    0x000000FE + 0x00000068,    0x00000019 + 0x00000068,    0x0000002B + 0x00000068,
	0x0000007D + 0x00000068,    0x00000087 + 0x00000068,    0x00000092 + 0x00000068,    0x000000AD + 0x00000068,
	0x000000EC + 0x00000068,    0x0000002F + 0x00000068,    0x00000071 + 0x00000068,    0x00000093 + 0x00000068,
	0x000000AE + 0x00000068,    0x000000E9 + 0x00000068,    0x00000020 + 0x00000068,    0x00000060 + 0x00000068,
	0x0000005F + 0x00000068,    0x000000E1 + 0x00000068,    0x00000038 + 0x00000068,    0x00000048 + 0x00000068,
	0x000000D8 + 0x00000068,    0x00000073 + 0x00000068,    0x00000095 + 0x00000068,    0x000000A4 + 0x00000068,
	0x000000F7 + 0x00000068,    0x00000002 + 0x00000068,    0x00000006 + 0x00000068,    0x0000000A + 0x00000068,
	0x0000001E + 0x00000068,    0x00000022 + 0x00000068,    0x00000066 + 0x00000068,    0x000000AA + 0x00000068,
	0x000000E5 + 0x00000068,    0x00000034 + 0x00000068,    0x0000005C + 0x00000068,    0x000000E4 + 0x00000068,
	0x00000037 + 0x00000068,    0x00000059 + 0x00000068,    0x000000EB + 0x00000068,    0x00000026 + 0x00000068,
	0x0000006A + 0x00000068,    0x000000BE + 0x00000068,    0x000000D9 + 0x00000068,    0x00000070 + 0x00000068,
	0x00000090 + 0x00000068,    0x000000AB + 0x00000068,    0x000000E6 + 0x00000068,    0x00000031 + 0x00000068,
};

__declspec(naked) WORD* X2::Decode5()
{
	__asm {
		push edi                                         
		mov edi,ecx
		mov eax,dword ptr ds:[edi+4]
		test eax,eax
		jle short LABEL1
		cmp dword ptr ds:[edi],0
		je short LABEL1
		push ebp
		push esi
		xor ebp,ebp
		xor ecx,ecx
		xor esi,esi
		test eax,eax
		jle short LABEL2
		push ebx

	LABEL7:
		cmp ebp,0x3FF                                      
		jle short LABEL3
		xor ebp,ebp

	LABEL3:
		mov eax,dword ptr ds:[edi]                        
		mov dl,byte ptr ds:[ebp*4+s_nDATA00418168]
		add eax,esi
		mov bl,byte ptr ds:[eax]
		xor bl,dl
		inc ebp
		mov byte ptr ds:[eax],bl
		mov eax,dword ptr ds:[edi]
		lea edx,dword ptr ds:[eax+esi]
		movzx ax,byte ptr ds:[eax+esi]
		or ah,0x58
		cmp ecx,7
		jle short LABEL4
		xor ecx,ecx

	LABEL4:
		and eax,0x0FFFF                                     
		ror eax,cl
		test al,1
		je short LABEL5
		and al,0x0FE
		jmp short LABEL6

	LABEL5:
		or al,1                                           
		LABEL6:
		rol eax,cl                                        
		inc ecx
		inc esi
		mov byte ptr ds:[edx],al
		mov eax,dword ptr ds:[edi+4]
		cmp esi,eax
		jl short LABEL7
		pop ebx

	LABEL2:
		mov eax,dword ptr ds:[edi]                         
		pop esi
		pop ebp
		pop edi
		retn

	LABEL1:
		xor eax,eax                                       
		pop edi
		retn
	}
}

__declspec(naked) void _Decode6_Sub()
{
	__asm {
		mov eax,dword ptr ss:[esp+8]
		test eax,eax
		jle short LABEL1
		mov ecx,dword ptr ss:[esp+4]
		push esi
		mov esi,eax

	LABEL3:
		mov al,byte ptr ds:[ecx]         
		mov dl,al
		and dl,0x80
		movzx dx,dl
		shl al,1
		test dx,dx
		mov byte ptr ds:[ecx],al
		je short LABEL2
		or al,1
		mov byte ptr ds:[ecx],al

	LABEL2:
		dec esi                                             
		jnz short LABEL3
		pop esi

	LABEL1:
		retn 8                                             
	}
}

__declspec(naked) WORD* X2::Decode6()
{
	__asm {
		push edi                                          
		mov edi,ecx
		mov eax,dword ptr ds:[edi+4]
		test eax,eax
		jle short LABEL1
		cmp dword ptr ds:[edi],0
		je short LABEL1
		push ebx
		push ebp
		push esi
		xor ebx,ebx
		xor esi,esi
		xor ebp,ebp
		test eax,eax
		jle short LABEL2

	LABEL5:
		cmp esi,0x3F                                        
		jle short LABEL3
		xor esi,esi

	LABEL3:
		mov eax,dword ptr ds:[edi]                        
		mov cl,byte ptr ds:[esi*4+s_nDATA00419168]
		add eax,ebp
		mov dl,byte ptr ds:[eax]
		xor dl,cl
		inc esi
		cmp ebx,8
		mov byte ptr ds:[eax],dl
		jle short LABEL4
		xor ebx,ebx

	LABEL4:
		mov edx,dword ptr ds:[edi]                        
		push ebx
		add edx,ebp
		mov ecx,edi
		push edx
		call _Decode6_Sub
		mov eax,dword ptr ds:[edi+4]
		inc ebx
		inc ebp
		cmp ebp,eax
		jl short LABEL5

	LABEL2:
		mov eax,dword ptr ds:[edi]                         
		pop esi
		pop ebp
		pop ebx
		pop edi
		retn
		LABEL1:
		xor eax,eax                                        
		pop edi
		retn
	}
}

__declspec(naked) WORD* X2::Decode7()
{
	__asm {
		push ebp
		mov ebp,ecx                                              
		mov eax,dword ptr ss:[ebp+4]                             
		test eax,eax                                             
		jle short L_FAILED                              
		cmp dword ptr ss:[ebp],0                                 
		je short L_FAILED                               
		push edi                                                 
		xor edx,edx                                              
		xor edi,edi                                              
		test eax,eax                                             
		jle short LABEL1                              
		push ebx                                                 
		push esi   
		
	LABEL3:
		cmp edx,0x1F                                              
		jle short LABEL2                             
		xor edx,edx       
		
	LABEL2:
		mov eax,dword ptr ss:[ebp]    
		mov ebx,dword ptr ds:[edx*4+s_nDATA00419668]	
		lea esi,dword ptr ds:[eax+edi]                          
		mov al,byte ptr ds:[eax+edi]                            
		mov ecx,eax                                             
		and ecx,0xFF                                             
		cmp ecx,ebx                                             
		mov cl,bl                                               
		sub al,cl                                               
		xor ecx,ecx                                             
		mov byte ptr ds:[esi],al                                
		mov eax,dword ptr ss:[ebp]                              
		add eax,edi                                             
		inc edx                                                 
		inc edi                                                 
		mov cl,byte ptr ds:[eax]                                
		mov cl,byte ptr ds:[ecx*4+s_nDATA00419268]							
		mov byte ptr ds:[eax],cl                                
		mov eax,dword ptr ss:[ebp+4]                            
		cmp edi,eax                                             
		jl short LABEL3                                
		pop esi                                                  
		pop ebx       
		
	LABEL1:
		mov eax,dword ptr ss:[ebp]        
		pop edi                                                  
		pop ebp                                                  
		retn                                        
		
	L_FAILED:
		xor eax,eax                                
		pop ebp                                                  
		retn                                                     
	}
}

__declspec(naked) WORD* X2::Decode8()
{
	__asm {
		sub esp,0x44                                         
		mov edx,ecx
		mov dword ptr ss:[esp],edx
		mov eax,dword ptr ds:[edx+4]
		test eax,eax
		jle LABEL1
		cmp dword ptr ds:[edx],0
		je LABEL1
		push ebx
		xor ebx,ebx
		test eax,eax
		jle LABEL2
		push ebp
		push esi
		push edi

	LABEL8:
		mov eax,dword ptr ds:[edx]                        
		xor ecx,ecx
		xor edx,edx
		mov dl,byte ptr ds:[eax+ebx]
		lea edi,dword ptr ds:[eax+ebx]
		lea eax,dword ptr ss:[esp+0x14]

	LABEL3:
		mov esi,1                                       
		shl esi,cl														
		and esi,edx
		neg esi
		sbb esi,esi
		add eax,4
		neg esi
		mov dword ptr ds:[eax-4],esi
		inc ecx
		cmp ecx,8
		jl short LABEL3
		mov eax, OFFSET s_nDATA004197E8
		lea ecx,dword ptr ss:[esp+0x34]
	
	LABEL5:
		mov dword ptr ds:[ecx],0                         
		lea edx,dword ptr ss:[esp+0x14]
		mov esi,8

	LABEL4:
		mov ebp,dword ptr ds:[edx]                      
		add edx,4
		imul ebp,dword ptr ds:[eax]
		add dword ptr ds:[ecx],ebp
		add eax,4
		dec esi
		jnz short LABEL4
		add ecx,4
		cmp eax, OFFSET s_nDATA004197E8[0x100]
		jl short LABEL5
		xor edx,edx
		xor ecx,ecx
		lea eax,dword ptr ss:[esp+0x34]

	LABEL7:
		cmp dword ptr ds:[eax],1                         
		jnz short LABEL6
		mov esi,1
		shl esi,cl
		add edx,esi

	LABEL6:
		inc ecx                                          
		add eax,4
		cmp ecx,8
		jl short LABEL7
		mov byte ptr ds:[edi],dl
		mov edx,dword ptr ss:[esp+0x10]
		inc ebx
		cmp ebx,dword ptr ds:[edx+4]
		jl LABEL8
		pop edi
		pop esi
		pop ebp

	LABEL2:
		mov eax,dword ptr ds:[edx]                        
		pop ebx
		add esp,0x44
		retn

	LABEL1:
		xor eax,eax                                        
		add esp,0x44
		retn
	}
}

__declspec(naked) void Decode9_Sub()
{
	__asm {
		mov edx,dword ptr ss:[esp+8]
		xor eax,eax
		push esi
		test edx,edx
		jle short D9D_LABEL1
		mov ecx,dword ptr ss:[esp+8]
		mov esi,dword ptr ss:[esp+0x10]

	D9D_LABEL3:
		cmp dword ptr ds:[ecx],esi
		je short D9D_LABEL2
		inc eax
		add ecx,4
		cmp eax,edx
		jl short D9D_LABEL3

	D9D_LABEL1:
		or eax, 0xFFFFFFFF    

	D9D_LABEL2:
		pop esi
		retn 0x0C
	}
}

__declspec(naked) BYTE* X2::Decode9()
{
	__asm {
		sub esp,8                                          
		push esi
		mov esi,ecx
		mov eax,dword ptr ds:[esi+4]
		test eax,eax
		jle LABEL1
		cmp dword ptr ds:[esi],0
		je LABEL1
		cdq
		sub eax,edx
		push ebp
		sar eax,1
		push edi
		push eax
		call eng_malloc	// old code is call new
		mov ebp,eax
		mov eax,dword ptr ds:[esi+4]
		add esp,4
		xor edi,edi
		test eax,eax
		mov dword ptr ss:[esp+0x10],ebp
		jle short LABEL2
		push ebx

	LABEL3:
		mov eax,dword ptr ds:[esi]                       
		xor ecx,ecx
		add eax,edi
		xor ebx,ebx
		mov cl,byte ptr ds:[eax]
		mov bl,byte ptr ds:[eax+1]
		push ecx
		push 0x100
		push OFFSET s_nDATA004198E8
		mov ecx,esi
		call Decode9_Sub
		push ebx
		push 0x100
		push OFFSET s_nDATA004198E8
		mov ecx,esi
		mov dword ptr ss:[esp+0x1C],eax
		call Decode9_Sub
		mov ecx,eax
		mov bl,byte ptr ss:[esp+0x10]
		cdq
		and edx,7
		add eax,edx
		sar eax,3
		mov dl,al
		shl dl,4
		add dl,bl
		mov ebx,dword ptr ds:[esi]
		shl al,3
		mov byte ptr ds:[ebx+edi],dl
		mov edx,dword ptr ds:[esi]
		add edx,edi
		sub cl,al
		add edi,2
		mov bl,byte ptr ds:[edx]
		xor bl,cl
		inc ebp
		mov byte ptr ds:[edx],bl
		mov eax,dword ptr ds:[esi]
		mov cl,byte ptr ds:[eax+edi-2]
		mov byte ptr ss:[ebp-1],cl
		mov eax,dword ptr ds:[esi+4]
		cmp edi,eax
		jl short LABEL3
		mov ebp,dword ptr ss:[esp+0x14]	// return the memory allocated by eng_malloc
		pop ebx

	LABEL2:
		mov edx,dword ptr ds:[esi]                         
		push edx                                          
		call dword ptr [free]	// call free to release memory X2::pData
		add esp,4
		mov eax,ebp				// set return to eax
		mov dword ptr ds:[esi],0
		mov dword ptr ds:[esi+4],0
		pop edi
		pop ebp
		pop esi
		add esp,8
		retn

	LABEL1:
		xor eax,eax                                      
		pop esi
		add esp,8
		retn
	}
}

__declspec(naked) BOOL ReadCode(
	BYTE* /* pSection */, 
	DWORD* /* pOffset */, 
	JD_PATH_INFO_05* /* pInfo */, 
	BYTE* /* pBuffer */)
{
	__asm {
		mov eax,dword ptr ss:[esp+8]			;  
		mov edx,dword ptr ss:[esp+4]			;  Arg1: pSection
		push esi
		mov esi,dword ptr ss:[esp+0x14]			;  Arg4
		mov ecx,dword ptr ds:[eax]				;  ecx <== *pOffset
		push edi
		mov edi,dword ptr ss:[esp+0x14]			;  Arg3
		mov cl,byte ptr ds:[ecx+edx]			;  cl <== pSection[*p2]
		mov byte ptr ds:[esi],cl				;  *pBuffer <== cl
		mov edx,dword ptr ds:[eax]
		inc edx
		mov dword ptr ds:[eax],edx				;  p2++
		movsx eax,word ptr ds:[edi+0x40]
		cmp eax,0								;  Switch (cases 0..9)
		je short CASE_0356789
		cmp eax,1
		je short CASE_12
		cmp eax,2
		je short CASE_12
		cmp eax,3
		je short CASE_0356789
		cmp eax,4
		je short CASE_4
		cmp eax,5
		je short CASE_0356789
		cmp eax,6
		je short CASE_0356789
		cmp eax,7
		je short CASE_0356789
		cmp eax,8
		je short CASE_0356789
		cmp eax,9
		je short CASE_0356789

		jmp CASE_DEFAULT

	CASE_12:
		mov dl,byte ptr ds:[edi+0x42]			;  Cases 1,2 of switch 00401832
		mov al,byte ptr ds:[esi]
		xor al,dl
		pop edi
		mov byte ptr ds:[esi],al
		mov eax,1
		pop esi
		retn

	CASE_4:
		mov cx,word ptr ds:[edi+0x42]				;  Case 4 of switch 00401832
		test cx,cx
		jl short CASE_DEFAULT
		cmp cx,7
		jg short CASE_DEFAULT
		mov al,byte ptr ds:[esi]
		movsx edx,cx
		mov ecx,8
		sub ecx,edx
		mov dl,al
		shl dl,cl
		mov cl,byte ptr ds:[edi+0x42]
		shr al,cl
		or dl,al
		mov byte ptr ds:[esi],dl

	CASE_0356789:
		pop edi                            ;  Cases 0,3,5,6,7,8,9 of switch 00401832
		mov eax,1
		pop esi
		retn

	CASE_DEFAULT:
		pop edi                            ;  Default case of switch 00401832
		xor eax,eax
		pop esi
		retn
	}
}

__declspec(naked) BOOL ReadDWORD(
	BYTE* /* pSection */, 
	DWORD* /* pOffset */, 
	JD_PATH_INFO_05* /* pInfo */, 
	DWORD /* code */, 
	void* /* pBuffer */, 
	DWORD /* size */)
{
	__asm {
		mov eax,dword ptr ss:[esp+0x18]                     ;  eax <== size_
		mov edx,dword ptr ss:[esp+8]						;  edx <== pOffset
		push ebx
		push ebp
		push esi
		mov esi,dword ptr ds:[edx]							;  esi <== offset
		lea ebp,dword ptr ds:[eax*4]						;  ebp <== size_ * 4
		mov eax,dword ptr ss:[esp+0x10]                     ;  eax <== path_section
		mov ecx,ebp
		add esi,eax											;  esi <== path_section + offset
		mov eax,dword ptr ss:[esp+0x20]                     ;  eax <== pBuffer
		mov ebx,ecx											;  ebx <== size_ * 4
		push edi
		mov edi,eax											;  copy size_ DWORD from section[offset] to pBuffer
		shr ecx,2
		rep movs dword ptr es:[edi],dword ptr ds:[esi]
		mov ecx,ebx
		and ecx,3
		rep movs byte ptr es:[edi],byte ptr ds:[esi]
		mov edi,dword ptr ds:[edx]
		add edi,ebp
		mov dword ptr ds:[edx],edi							;  update *pOffset_
		mov edi,dword ptr ss:[esp+0x1C]
		movsx ecx,word ptr ds:[edi+0x40]                    ;  ecx <== nMethod
		mov dl,byte ptr ds:[edi+0x42]                       ;  dl <== nKey

		cmp ecx,0											;  Switch (cases 0..9)
		je CASE_0
		cmp ecx,1
		je CASE_1
		cmp ecx,2
		je CASE_2
		cmp ecx,3
		je CASE_3
		cmp ecx,4
		je CASE_4
		cmp ecx,5
		je CASE_5678
		cmp ecx,6
		je CASE_5678
		cmp ecx,7
		je CASE_5678
		cmp ecx,8
		je CASE_5678
		cmp ecx,9
		je CASE_9
		jmp CASE_DEFAULT

	CASE_1:
		xor ecx,ecx                                       ;  Case 1 of switch JDSimu_004018F2
		test ebp,ebp
		jle CASE_0

	JDSimu_0040190C:
		mov bl,byte ptr ds:[ecx+eax]
		xor bl,dl
		mov byte ptr ds:[ecx+eax],bl
		inc ecx
		cmp ecx,ebp
		jl short JDSimu_0040190C
		pop edi
		pop esi
		pop ebp
		mov eax,1
		pop ebx
		retn

	CASE_2:
		xor ecx,ecx                                       ;  Case 2 of switch JDSimu_004018F2
		test ebp,ebp
		jle CASE_0
		mov dl,byte ptr ss:[esp+0x20]

	JDSimu_00401931:
		mov bl,byte ptr ds:[ecx+eax]
		xor bl,dl
		mov byte ptr ds:[ecx+eax],bl
		inc ecx
		cmp ecx,ebp
		jl short JDSimu_00401931
		pop edi
		pop esi
		pop ebp
		mov eax,1
		pop ebx
		retn

	CASE_3:
		movsx ecx,word ptr ds:[edi+0x42]                    ;  Case 3 of switch JDSimu_004018F2
		cmp ecx,0
		je short L_CASE_0                                         ;  Switch (cases 0..3)
		cmp ecx,1
		je short L_CASE_1
		cmp ecx,2
		je short L_CASE_2
		cmp ecx,3
		je short L_CASE_3
		jmp short CASE_DEFAULT

	L_CASE_0:
		xor ecx,ecx                                       ;  Case 0 of switch JDSimu_0040194C
		mov edx,1
		jmp short JDSimu_00401984

	L_CASE_1:
		mov ecx,1                                         ;  Case 1 of switch JDSimu_0040194C
		mov edx,2
		jmp short JDSimu_00401984

	L_CASE_2:
		mov ecx,2                                         ;  Case 2 of switch JDSimu_0040194C
		mov edx,3
		jmp short JDSimu_00401984

	L_CASE_3:
		mov ecx,3                                         ;  Case 3 of switch JDSimu_0040194C
		xor edx,edx
	
	JDSimu_00401984:
		mov esi,dword ptr ss:[esp+0x28]                     ;  esi <== size_
		test esi,esi
		jle CASE_0
		add eax,edx
		sub ecx,edx

	JDSimu_00401994:
		mov bl,byte ptr ds:[eax]
		mov dl,byte ptr ds:[ecx+eax]
		mov byte ptr ds:[ecx+eax],bl
		mov byte ptr ds:[eax],dl
		add eax,4
		dec esi
		jnz short JDSimu_00401994
		pop edi
		pop esi
		pop ebp
		mov eax,1
		pop ebx
		retn

	CASE_4:
		mov cx,word ptr ds:[edi+0x42]                       ;  Case 4 of switch JDSimu_004018F2
		test cx,cx
		jl short CASE_DEFAULT
		cmp cx,7
		jg short CASE_DEFAULT
		xor esi,esi
		test ebp,ebp
		jle short CASE_0
	
	JDSimu_004019C3:
		movsx ebx,word ptr ds:[edi+0x42]
		mov dl,byte ptr ds:[esi+eax]
		mov ecx,8
		sub ecx,ebx
		mov bl,dl
		shl bl,cl
		mov cl,byte ptr ds:[edi+0x42]
		shr dl,cl
		or bl,dl
		mov byte ptr ds:[esi+eax],bl
		inc esi
		cmp esi,ebp
		jl short JDSimu_004019C3
		pop edi
		pop esi
		pop ebp
		mov eax,1
		pop ebx
		retn

	CASE_5678:
		shr ebp,1                                         ;  Cases 5,6,7,8 of switch JDSimu_004018F2
		mov ecx,ebp
		test ecx,ecx
		jle short CASE_0
	
	JDSimu_004019F6:
		mov dx,word ptr ds:[edi+0x42]
		xor word ptr ds:[eax],dx
		add eax,2
		dec ecx
		jnz short JDSimu_004019F6
		pop edi
		pop esi
		pop ebp
		mov eax,1
		pop ebx
		retn

	CASE_9:
		xor ecx,ecx                                       ;  Case 9 of switch JDSimu_004018F2
		test ebp,ebp
		jle short CASE_0

	JDSimu_00401A13:
		mov bl,byte ptr ds:[ecx+eax]
		xor bl,dl
		mov byte ptr ds:[ecx+eax],bl
		inc ecx
		cmp ecx,ebp
		jl short JDSimu_00401A13

	CASE_0:
		pop edi                                           ;  Case 0 of switch JDSimu_004018F2
		pop esi
		pop ebp
		mov eax,1
		pop ebx
		retn

	CASE_DEFAULT:
		pop edi                                           ;  Default case of switch JDSimu_0040194C
		pop esi
		pop ebp
		xor eax,eax
		pop ebx
		retn
	}
}

__declspec(naked) BOOL ReadSection(
	BYTE* /* pSection */, 
	DWORD* /* pOffset */, 
	JD_PATH_INFO_05* /* pInfo */, 
	DWORD /* code */, 
	void* /* pBuffer */)
{
	__asm {
		mov eax,dword ptr ss:[esp+8]
		push ebp
		mov ebp,dword ptr ss:[esp+8]
		push esi
		mov ecx,dword ptr ds:[eax]
		mov esi,dword ptr ss:[esp+0x1C]
		add ecx,ebp
		mov ebp,dword ptr ss:[esp+0x14]
		push edi
		mov edx,dword ptr ds:[ecx]
		mov dword ptr ds:[esi],edx
		mov edi,dword ptr ds:[eax]
		add edi,4
		mov dword ptr ds:[eax],edi
		mov cl,byte ptr ss:[ebp+0x42]
		movsx eax,word ptr ss:[ebp+0x40]

		cmp eax,0                                         ;  Switch (cases 0..4)
		je CASE_03
		cmp eax,1
		je CASE_1
		cmp eax,2
		je CASE_2
		cmp eax,3
		je CASE_03
		cmp eax,4
		je CASE_4
		jmp CASE_DEFAULT

	CASE_1:
		xor eax,eax                                       ;  Case 1 of switch 00401A99

	JDSimu_00401AA7:
		mov dl,byte ptr ds:[eax+esi]
		xor dl,cl
		mov byte ptr ds:[eax+esi],dl
		inc eax
		cmp eax,4
		jl short JDSimu_00401AA7
		pop edi
		pop esi
		mov eax,1
		pop ebp
		retn

	CASE_2:
		mov cl,byte ptr ss:[esp+0x1C]                       ;  Case 2 of switch 00401A99
		xor eax,eax

	JDSimu_00401AC4:
		mov dl,byte ptr ds:[eax+esi]
		xor dl,cl
		mov byte ptr ds:[eax+esi],dl
		inc eax
		cmp eax,4
		jl short JDSimu_00401AC4

	CASE_4:
		mov ax,word ptr ss:[ebp+0x42]                       ;  Case 4 of switch 00401A99
		test ax,ax
		jl short CASE_DEFAULT
		cmp ax,7
		jg short CASE_DEFAULT
		xor edi,edi

	JDSimu_00401AE3:
		movsx edx,word ptr ss:[ebp+0x42]
		mov al,byte ptr ds:[edi+esi]
		mov ecx,8
		sub ecx,edx
		mov dl,al
		shl dl,cl
		mov cl,byte ptr ss:[ebp+0x42]
		shr al,cl
		or dl,al
		mov byte ptr ds:[edi+esi],dl
		inc edi
		cmp edi,4
		jl short JDSimu_00401AE3

	CASE_03:
		pop edi                                           ;  Cases 0,3 of switch 00401A99
		pop esi
		mov eax,1
		pop ebp
		retn

	CASE_DEFAULT:
		pop edi                                           ;  Default case of switch 00401A99
		pop esi
		xor eax,eax
		pop ebp
		retn
	}
}

void CorrectTables()
{
	static bool _s_bCorrected = false;
	if (_s_bCorrected)
		return;

	_s_bCorrected = true;

	///////////////////////////////
	// begin to correct tables ...

	int _i;

	// DWORD s_nDATA00419268[] =
	for (_i = 0; _i < _countof(s_nDATA00419268); ++_i)
	{
		s_nDATA00419268[_i] ^= 0x55;
	}

	// DWORD s_nDATA00419668[] = 
	for (_i = 0; _i < _countof(s_nDATA00419668); ++_i)
	{
		s_nDATA00419668[_i] ^= 0x55;
	}

	// DWORD s_nDATA00418168[] = 
	for (_i = 0; _i < _countof(s_nDATA00418168); ++_i)
	{
		s_nDATA00418168[_i] ^= 0x555555;
	}

	// DWORD s_nDATA00419168[] = 
	for (_i = 0; _i < _countof(s_nDATA00419168); ++_i)
	{
		s_nDATA00419168[_i] ^= 0x55555555;
	}

	// DWORD s_nDATA004197E8[] = 
	// nothing need to do.

	// DWORD s_nDATA004198E8[] = 
	for (_i = 0; _i < _countof(s_nDATA004198E8); ++_i)
	{
		s_nDATA004198E8[_i] -= 0x00000068;
	}

	return;
}
