// ************************************************************************** //
// Nce3DViewImp.cpp : implementation of the CNce3DViewImp_V1 class
// Copyright(c)2013 Weihong Company. All rights reserved.
//
// Abstract:
//   ļʵNce3DViewImpʵú
// *********************************************** ----  2016-10-10****** //
#include "StdAfx.h"
#include "Nce3DViewImp_V1.h"


#define MaxBitmapWidth 2048 // 1024 3
#define MinBitmapWidth 256
using namespace Nce3DView;

//  GPC  ת3D cut off
class GPCConvertHelper
{
public:
	typedef std::vector<gpc_vertex> std_vertex_list;
	typedef std::vector<gpc_polygon> gpc_polygon_list;
	typedef std::vector<std_vertex_list> std_polygon_list;
	enum ExpandType_t{Expand_One, Expand_4V4 , Expand_All};
	enum ConvertType_t{Convert_All, Convert_Part1_4};

public:
	GPCConvertHelper() : m_pRootAreaData(NULL){};
	~GPCConvertHelper(){};

public:
	void Initialize(Transform3DList& listData_, double nWidth_);
	void ConvertCutOffArea(IN const Polyline2DList& listRecords_, OUT Polygon3DListGroup& listCutOffDatas_, ExpandType_t nExpandType_);

protected:
	void _convertArea(IN const TransformData3D& area_, OUT std_vertex_list& listvertexs_);
	void _convertPolygon(IN const Polyline2DList& listPolylines_, OUT std_polygon_list& listPolygons_);
	void _gpc_convert_tristrip(IN std_vertex_list& polygon_, double nMin_, double nMax_,
		OUT Polygon3DListGroup& listCutOffDatas_, ConvertType_t nConvertType_);
	void _get_MinMax_width(IN std_vertex_list& polygon_, double& nMin_, double& nMax_);
	void _set_offset_polygon(IN OUT std_vertex_list& polygonSrc_, double nOffset_);
	inline int _IsInArea(int id_, double& nMin_, double& nMax_);

protected:
	Transform3DList* m_pRootAreaData;
	std_polygon_list m_vectorBaseArea;
	double m_nWidth;
};
static GPCConvertHelper g_gpcConvertHelper;
Vector4 GLPick(Vector4& vt_);
Vector4 UnGLPick(Vector4& vt_);
Vector4 GetNormalVector(const Vector4 &vec1_, const Vector4 &vec2_, const Vector4 &vec3_);
double GetEllipsePerimeter(double nLongRadius_,double nShortRadius_);
void SolveArc(IN Vector4 ptStart_,
			  IN Vector4 ptEnd_,
			  IN double nBulge_,
			  OUT Vector4* pptCenter_,
			  OUT double* pnRadius_,
			  OUT double* pnStartAngle_,
			  OUT double* pnSweptAngle_);

CNce3DViewImp_V1::CNce3DViewImp_V1()
{
	m_hWnd = NULL;
	m_hDC = NULL;
	m_hRC = NULL;
	m_nZNearAndFar = 50;
	m_clrBackground = RGB(0, 0, 0);
	m_clrAlpha = RGB(255, 254, 255);
	m_pBmpTexture = NULL;
	m_nBmpWidth = 0;
	m_nBmpHeight = 0;
	m_nBmpZoomRatio = 1;
	m_pRGBAData = NULL;
	m_pBmpDC = NULL;
	m_nTextureID = -1;
	m_bMaterialLight = false;
	m_bBlend = false;
	m_nBaseZoom = 1.f;
	m_nRotate = 0;
	m_nOffsetY = 0.f;
	m_nZoom = 1.f;
	m_nBaseZoomRatio = 1.f;
	m_nTubeType = QuadTube;
	m_nPosition = LOOKAT_FRONT;
	m_bShowCoordinate = false;
	m_nOpenglWidth = 100.f;
	m_nOpenglHeight = 100.f;
	m_nAuxiliaryWidth = 0.f;
	m_nTubeWidth = 10;
	m_nTubeHeight = 100;
	m_nMaxWidth = 100;
	m_bDrawTube = true;
	m_nCadMinHeight = 0;
	m_nCadMaxHeight = 0;
	m_nCadMinWidth = 0;
	m_nCadMaxWidth = 0;
}

CNce3DViewImp_V1::~CNce3DViewImp_V1()
{
	wglMakeCurrent(NULL, NULL);
	if (m_hRC != NULL)
		wglDeleteContext(m_hRC);
	if (m_hDC != NULL)
		ReleaseDC(m_hWnd, m_hDC);
	if (m_pBmpTexture != NULL)
		delete m_pBmpTexture;
	if (m_pRGBAData != NULL)
		delete[] m_pRGBAData;
	if (m_pBmpDC != NULL)
		delete m_pBmpDC;
	if( m_nTextureID != -1)
		glDeleteTextures(1, &m_nTextureID);
}

void CNce3DViewImp_V1::DrawTube(bool bSwitch_)
{
	m_bDrawTube = bSwitch_;
}

// ʼopenGL ----  2016-08-10
bool CNce3DViewImp_V1::Initialize(HWND hWnd_)
{
	ASSERT(hWnd_);
	int _nPixelFormat = 0;
	m_hDC = GetDC(hWnd_);
	m_hWnd = hWnd_;
	PIXELFORMATDESCRIPTOR _pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR), // ˽ṹĴС
		2,                             // ˽ṹİ汾
		PFD_DRAW_TO_WINDOW |           // ڴϻͼλͼϣ
		PFD_SUPPORT_OPENGL |           // ڴ֧ʹOpenGL
		PFD_DOUBLEBUFFER,              // ʹ˫ģʽ
		PFD_TYPE_RGBA,                 // ʹRGBAɫģʽ
		24,                            // 洢ɫݵλ
		0,0,0,0,0,0,
		0,0,
		0,0,0,0,0,
		32,                           // ȻС
		0,
		0,
		PFD_MAIN_PLANE,               // ƽϻͼ
		0,
		0,0,
	};

	// 豸ѡѵظʽ
	_nPixelFormat = ChoosePixelFormat(m_hDC, &_pfd);
	if (_nPixelFormat == 0)
	{
		return false;
	}

	// ChoosePixelFormatĽ,豸ظʽ
	SetPixelFormat(m_hDC, _nPixelFormat, &_pfd);

	// OpenGLھ
	m_hRC = ::wglCreateContext(m_hDC);
	if (m_hRC == NULL)
	{
		TRACE(_T("OpenGl rendering context fail!"));
		return false;
	}

	if (!wglMakeCurrent(m_hDC, m_hRC))
	{
		TRACE(_T("OpenGl rendering context fail!"));
		return false ;
	}

	glMatrixMode(GL_PROJECTION );
	glShadeModel(GL_SMOOTH);									// ɫΪƽģʽ,ɫֵ㷨л
	//glEnable(GL_POINT_SMOOTH);
	//glEnable(GL_LINE_SMOOTH);
	//glHint(GL_POINT_SMOOTH_HINT, GL_NICEST); // Make round points, not square points  
	//glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);  // Antialias the lines 
	glEnable(GL_DEPTH_TEST);									// Z_BufferȲ
	glEnable(GL_COLOR_MATERIAL);								// ϵɫ
	glClearColor(0, 0, 0, 0);									// ñɫ
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);			// Ҫͬʱɫ
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glLoadIdentity();											// ʼ
	EnableMaterialLight(true);
	EnableBlend(true);
	//GLint _nTextureMaxSize;
	//glGetIntegerv(GL_MAX_TEXTURE_SIZE, &_nTextureMaxSize);
	return true;
}

void CNce3DViewImp_V1::ShowCoordinate(bool bSwitch_)
{
	m_bShowCoordinate = bSwitch_;
}

bool CNce3DViewImp_V1::IsShowCoordinate()
{
	return m_bShowCoordinate;
}

bool CNce3DViewImp_V1::IsMaterialLight()
{
	return m_bMaterialLight;
}

void CNce3DViewImp_V1::EnableBlend(bool bSwitch_)
{
	if (m_bBlend == bSwitch_)
		return;
	m_bBlend = bSwitch_;
	if (m_bBlend)
	{
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	else
	{
		glDisable(GL_BLEND);
	}
}

void CNce3DViewImp_V1::EnableMaterialLight(bool bSwitch_)
{
	if (m_bMaterialLight == bSwitch_)
		return;
	m_bMaterialLight = bSwitch_;
	if (m_bMaterialLight)
	{
		glEnable(GL_NORMALIZE);
		glEnable(GL_COLOR_MATERIAL);
		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
		const static GLfloat _nMatAmbient[] = {1.0f,1.0f,1.0f,1.0f};				// 
		const static GLfloat _nMatDiffuse[] = {1.0f,1.0f,1.0f,1.0f};				// 
		const static GLfloat _nMatSpecular[] = {1.0f,1.0f,1.0f,1.0f};				// 淴
		const static GLfloat _nMat_emission[] = {0.0,0.0,0.0,1.0f};					// 
		glMaterialfv(GL_FRONT, GL_AMBIENT, _nMatAmbient);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, _nMatDiffuse);
		glMaterialfv(GL_FRONT, GL_SPECULAR, _nMatSpecular);
		glMaterialfv(GL_FRONT, GL_EMISSION, _nMat_emission);
		glMaterialf (GL_FRONT, GL_SHININESS, 128);
		glPushMatrix();
		glLoadIdentity();
		const static GLfloat _nLightAmbient[] = {0.15f, 0.15f, 0.15f, 1.0f};             // 
		const static GLfloat _nLightDiffuse[] = {0.75f, 0.75f, 0.75f, 1.0f};             // 
		const static GLfloat _nLightSpecular[] = {1.0f, 1.0f, 1.0f, 1.0f};               // 
		const static GLfloat _nLightPosition[] = {0.0f, 50.0f, 50.0f, 0.0f};             // Դλ
		const static GLfloat _nSpotLightDirectin[] = {0.0f, 0.0f, -1.0f, 1.0f};          // ۹Ƶķ
		glLightfv(GL_LIGHT0, GL_AMBIENT, _nLightAmbient);
		glLightfv(GL_LIGHT0, GL_DIFFUSE, _nLightDiffuse);
		glLightfv(GL_LIGHT0, GL_SPECULAR, _nLightSpecular);
		glLightfv(GL_LIGHT0, GL_POSITION, _nLightPosition);
		glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, _nSpotLightDirectin);
		glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 0);
		glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 180);
		glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, 1.0f);
		glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0.0f);
		glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.0f);
		glEnable(GL_LIGHT0);
		glEnable(GL_LIGHTING);
		glPopMatrix();
	}
	else
	{
		glDisable(GL_NORMALIZE);
		glDisable(GL_COLOR_MATERIAL);
		glDisable(GL_LIGHT0);
		glDisable(GL_LIGHTING);
	}
}

// ĵ ----  2016-10-28
void CNce3DViewImp_V1::ScaleCentre(int nX_, int nY_, double nValue_)
{
	Vector4 _vtStart(0., (m_nBmpHeight / m_nBmpZoomRatio) * 0.5, 0., 1.);
	Vector4 _vtEnd(0., -(m_nBmpHeight / m_nBmpZoomRatio) * 0.5, 0., 1.);
	Vector4 _winStart = UnGLPick(_vtStart);
	Vector4 _winEnd = UnGLPick(_vtEnd);
	if (nY_ < _winStart.y || nY_ > _winEnd.y)
	{
		Scale(nValue_);
		return;
	}
	double _nk = (nY_ - _winStart.y) / (_winStart.y - _winEnd.y);
	double _nGLY1 = _nk * (_vtStart.y - _vtEnd.y) + _vtStart.y;
	Scale(nValue_);
	_winStart = UnGLPick(_vtStart);
	_winEnd = UnGLPick(_vtEnd);
	_nk = (nY_ - _winStart.y) / (_winStart.y - _winEnd.y);
	double _nGLY2 = _nk * (_vtStart.y - _vtEnd.y) + _vtStart.y;
	double _nOffsetY = _nGLY2 - _nGLY1;
	Translate(_nOffsetY);
}

// źFollowHeightShowһ ----  2016-10-28
void CNce3DViewImp_V1::OptimumScale()
{
	double _nRatio = double(2) / (m_nTubeWidth + 20);
	Scale(_nRatio / m_nZoom);
	//FollowHeightABS(m_nTubeHeight / 2);
}

void CNce3DViewImp_V1::OptimumView()
{
	// Ŀǰ̶Ϊʾġ
	double _nMinHeight = max(m_nCadMinHeight, 0);
	double _nMaxHeight = min(m_nCadMaxHeight, m_nTubeHeight);
	double _nMinWidth = max(m_nCadMinWidth, 0);
	double _nMaxWidth = min(m_nCadMaxWidth, m_nMaxWidth);
	double _nStepHeight = fabs(m_nCadMaxHeight - m_nCadMinHeight);
	if (_nStepHeight > 0 || m_nCadMinHeight > 0)
	{
		LoadIdentity();
		double _nRot = (_nMinWidth) / m_nMaxWidth *360;
		RotateABS(_nRot);
		double _nRatio = double(2) / (_nStepHeight + 20) * m_nBaseZoomRatio;
		double _nRatioW = double(2) / (m_nTubeWidth + 20);
		if (_nRatio > _nRatioW)
			_nRatio = _nRatioW;
		if (_nRatio < m_nBaseZoom)
			_nRatio = m_nBaseZoom;
		Scale(_nRatio);
		double _nFollowHeight = (_nMinHeight + _nMaxHeight) / 2;
		FollowHeightABS(_nFollowHeight);
	}
	else
	{
		LookAt(GetLookAtType());
	}
}

double CNce3DViewImp_V1::GetRotateAngle()
{
	return m_nRotate;
}

// ߶ʾͼ ----  2016-10-28
bool CNce3DViewImp_V1::FollowHeightShow(double nHeight_)
{
	double _nHeight = m_nBmpHeight / m_nBmpZoomRatio;
	double _nOffsetHeight = _nHeight * 0.5 - nHeight_;
	if (fabs(_nOffsetHeight) > (_nHeight / 2 + 20))
		return false;
	Vector4 _vtStart(0.,_nOffsetHeight, 0., 1.);
	Vector4 _winStart = UnGLPick(_vtStart);
	if (_winStart.y < 20 || _winStart.y > m_nOpenglHeight - 20)
	{
		glLoadIdentity();
		glScaled(m_nZoom, m_nZoom, m_nZoom);
		glRotated(m_nRotate, 0, 1, 0);
		m_nOffsetY = 0;
		Translate(-_nOffsetHeight);
		return true;
	}
	return false;
}

// ж ƶ ----  2016-12-06
void CNce3DViewImp_V1::FollowHeightABS(double nHeight_)
{
	double _nHeight = m_nTubeHeight;
	double _nOffsetHeight = _nHeight * 0.5 - nHeight_;
	glLoadIdentity();
	glScaled(m_nZoom, m_nZoom, m_nZoom);
	glRotated(m_nRotate, 0, 1, 0);
	m_nOffsetY = 0;
	Translate(-_nOffsetHeight);
}

//  ----  2016-10-28
void CNce3DViewImp_V1::Scale(double nValue_)
{
	double _nZoom = m_nZoom * nValue_;
	double _nWidthRatio = double(2) / (m_nTubeWidth + 20);
	double _nMinRatio = _nZoom / m_nBaseZoom;
	double _nMaxRatio = _nZoom / _nWidthRatio;
	if (_nMaxRatio > 10 || _nMinRatio < 0.2)
		return;
	m_nZoom *= nValue_;
	glScaled(nValue_, nValue_, nValue_);
	m_nOffsetY /= nValue_;
}

// ƽ ----  2016-10-28
void CNce3DViewImp_V1::Translate(double nValue_)
{
	m_nOffsetY += nValue_;
	glTranslated(0, nValue_, 0);
}

// ת ----  2016-10-28
void CNce3DViewImp_V1::Rotate(double nAngle_)
{
	glRotated(nAngle_, 0, 1, 0);
	m_nRotate += nAngle_;
	m_nRotate = fmod(m_nRotate, 360);
	if (m_nRotate < 0.0)
	{
		m_nRotate += 360.0;
	}
	if (m_nRotate >= 360.0)
	{
		m_nRotate -= 360.0;
	}
	ASSERT(m_nRotate >= 0.0 && m_nRotate < 360.0);
}

void CNce3DViewImp_V1::RotateABS(double nAngle_)
{
	Rotate((360 - m_nRotate) + (360 - nAngle_));
}

void CNce3DViewImp_V1::DragUp(double nStep_)
{
	double _nOffset = m_nOffsetY;
	double _nHeight = m_nBmpHeight;
	Vector4 _vtEnd(0., -(m_nBmpHeight / m_nBmpZoomRatio) * 0.5, 0., 1.);
	Vector4 _vtWin = UnGLPick(_vtEnd);
	if (_vtWin.y < m_nOpenglHeight * 0.5)
		return;

	double _nStepHeight = m_nBmpHeight / m_nOpenglHeight;
	if (m_nBmpZoomRatio > 0)
		_nStepHeight = _nStepHeight / m_nBmpZoomRatio;
	if (m_nPosition == LOOKAT_UP)
		_nStepHeight = _nStepHeight / sin(M_PI / 9);
	double _nStep = fabs(nStep_) / m_nZoom * m_nBaseZoom * _nStepHeight;
	_nOffset += _nStep;
	Translate(_nOffset - m_nOffsetY);
}

void CNce3DViewImp_V1::DragDown(double nStep_)
{
	double _nOffset = m_nOffsetY;
	double _nHeight = m_nBmpHeight;
	Vector4 _vtEnd(0., (m_nBmpHeight / m_nBmpZoomRatio) * 0.5, 0., 1.);
	Vector4 _vtWin = UnGLPick(_vtEnd);
	if (_vtWin.y > m_nOpenglHeight * 0.5)
		return;

	double _nStepHeight = m_nBmpHeight / m_nOpenglHeight;
	if (m_nBmpZoomRatio > 0)
		_nStepHeight = _nStepHeight / m_nBmpZoomRatio;
	if (m_nPosition == LOOKAT_UP)
		_nStepHeight = _nStepHeight / sin(M_PI / 9);
	double _nStep = fabs(nStep_) / m_nZoom * m_nBaseZoom * _nStepHeight;
	_nOffset -= _nStep;
	Translate(_nOffset - m_nOffsetY);
}

void CNce3DViewImp_V1::RotateLeft(double nSpeed_/* = 1.f*/)
{
	double _nWidthRatio = double(2) / (m_nTubeWidth + 20);
	double _nMaxRatio = m_nZoom / _nWidthRatio;
	double _nRot = 1.0;
	if (_nMaxRatio > 1)
		_nRot = (1 / _nMaxRatio) + (_nMaxRatio / 30);
	Rotate(-2 * nSpeed_ * _nRot);
}

void CNce3DViewImp_V1::RotateRight(double nSpeed_/* = 1.f*/)
{
	double _nWidthRatio = double(2) / (m_nTubeWidth + 20);
	double _nMaxRatio = m_nZoom / _nWidthRatio;
	double _nRot = 1.0;
	if (_nMaxRatio > 1)
		_nRot = (1 / _nMaxRatio) + (_nMaxRatio / 30);
	Rotate(2 * nSpeed_ * _nRot);
}

void CNce3DViewImp_V1::ZoomIn(double nSpeed_/* = 1.f*/)
{
	Scale(nSpeed_ * 1.01);
}

void CNce3DViewImp_V1::ZoomOut(double nSpeed_/* = 1.f*/)
{
	Scale(nSpeed_ * 0.99);
}

void CNce3DViewImp_V1::LoadIdentity()
{
	glLoadIdentity();
	m_nRotate = 0;
	m_nOffsetY = 0.0f;
	m_nZoom = 1.0f;
}

void CNce3DViewImp_V1::LookAt(LookAtType_t nPosition_)
{
	ASSERT(nPosition_ == LOOKAT_FRONT || nPosition_ == LOOKAT_UP);
	if (nPosition_ == LOOKAT_FRONT)
	{
		LoadIdentity();
		Scale(m_nBaseZoom);
		m_nPosition = nPosition_;
	}
	else if(nPosition_ == LOOKAT_UP)
	{
		LoadIdentity();
		glRotated(290, 1, 0, 0);
		if (m_nTubeHeight > m_nTubeWidth)
		{
			if ((m_nTubeHeight / m_nTubeWidth) > (m_nOpenglHeight / m_nOpenglWidth))
				Scale(m_nBaseZoom * min(2.0, (m_nTubeHeight / m_nTubeWidth) / (m_nOpenglHeight / m_nOpenglWidth)));
			else
				Scale(m_nBaseZoom);
		}
		else
			Scale(m_nBaseZoom);
		m_nPosition = nPosition_;
	}
	else
	{
		return;
	}
}

LookAtType_t CNce3DViewImp_V1::GetLookAtType()
{
	return m_nPosition;
}

TubeType_t CNce3DViewImp_V1::GetTubeType()
{
	return m_nTubeType;
}

void CNce3DViewImp_V1::Resize(int nX_, int nY_, int nWidth_, int nHeight_)
{
	if (nWidth_ * nHeight_ == 0)
		return;
	glPushMatrix();
	glViewport((GLint)nX_, (GLint)nY_, (GLint)nWidth_, (GLint)nHeight_);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	if (nWidth_ <= nHeight_)
		glOrtho(-1.0, 1.0, -1.0 * (GLfloat)nHeight_ / (GLfloat)nWidth_, 1.0 * (GLfloat)nHeight_ / (GLfloat)nWidth_, -m_nZNearAndFar, m_nZNearAndFar);
	else
		glOrtho(-1.0 * (GLfloat)nWidth_ / (GLfloat)nHeight_, 1.0 * (GLfloat)nWidth_ / (GLfloat)nHeight_, -1.0, 1.0, -m_nZNearAndFar, m_nZNearAndFar);
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	m_nOpenglWidth = nWidth_;
	m_nOpenglHeight = nHeight_;
	CalculateBaseZoom();
}

void CNce3DViewImp_V1::SetParams(TubeType_t nTubeType_, BaseTubeParams* pParamDatas_)
{
	ASSERT(pParamDatas_);
	ASSERT(nTubeType_ == QuadTube || nTubeType_ == CircularTube
		|| nTubeType_ == RoundRectTube || nTubeType_ == EllipseTube);
	m_nTubeType = nTubeType_;
	if (nTubeType_ == QuadTube)
	{
		QuadTubeParams* _pParamData = (QuadTubeParams*)pParamDatas_;
		_SetQuadTubeParams(_pParamData);
	}
	else if (nTubeType_ == CircularTube)
	{
		CircularTubeParams* _pParamData = (CircularTubeParams*)pParamDatas_;
		_SetCircularTubeParams(_pParamData);
	}
	else if (nTubeType_ == RoundRectTube)
	{
		RoundRectTubeParams* _pParamData = (RoundRectTubeParams*)pParamDatas_;
		_SetRoundRectTubeParams(_pParamData);
	}
	else if (nTubeType_ == EllipseTube)
	{
		EllipseTubeParams* _pParamData = (EllipseTubeParams*)pParamDatas_;
		_SetEllipseTubeParams(_pParamData);
	}
	else
	{
		ASSERT(false);
	}
	CalculateAuxiliary();
	LookAt(GetLookAtType());
}

void CNce3DViewImp_V1::CalculateBaseZoom()
{
	double _nRatio = (m_nOpenglWidth < m_nOpenglHeight) ? (m_nOpenglHeight / m_nOpenglWidth) : 1.f;
	if (m_nTubeHeight > m_nTubeWidth)
	{
		_nRatio = (m_nOpenglWidth < m_nOpenglHeight) ? (m_nOpenglHeight / m_nOpenglWidth) : 1.f;
		if ((m_nTubeHeight / m_nTubeWidth) < (m_nOpenglHeight / m_nOpenglWidth))
		{
			_nRatio *= (m_nTubeHeight / m_nTubeWidth) / (m_nOpenglHeight / m_nOpenglWidth);
		}
	}
	else
	{
		_nRatio = (m_nOpenglHeight < m_nOpenglWidth) ? (m_nOpenglWidth / m_nOpenglHeight) : 1.f;
	}
	m_nBaseZoomRatio = _nRatio;
	double _nMaxZoom = max(m_nTubeHeight + 20, m_nTubeWidth + 20);
	m_nBaseZoom = double(2) / _nMaxZoom * _nRatio;
}

// 跽ܲ ----  2016-10-28
void CNce3DViewImp_V1::_SetQuadTubeParams(QuadTubeParams* pParamDatas_)
{
	ASSERT(pParamDatas_);
	m_QPData.nA = pParamDatas_->nA;
	m_QPData.nB = pParamDatas_->nB;
	m_QPData.nH = pParamDatas_->nH;
	m_QPData.nR = pParamDatas_->nR;
	_CreateQuadTubeBitmap();
	LoadIdentity();
	m_nTubeWidth = max(pParamDatas_->nA, pParamDatas_->nB);
	m_nTubeHeight = pParamDatas_->nH;
	m_nMaxWidth = m_nBmpWidth / m_nBmpZoomRatio;
	CalculateBaseZoom();
	Scale(m_nBaseZoom);
	_CalculateQuadTubeData();
}

// Բܲ ----  2016-10-28
void CNce3DViewImp_V1::_SetCircularTubeParams(CircularTubeParams* pParamDatas_)
{
	ASSERT(pParamDatas_);
	m_CPData.nR = pParamDatas_->nR;
	m_CPData.nH = pParamDatas_->nH;
	_CreateCircularTubeBitmap();
	LoadIdentity();
	m_nTubeWidth = pParamDatas_->nR * 2;
	m_nTubeHeight = pParamDatas_->nH;
	m_nMaxWidth = m_nBmpWidth / m_nBmpZoomRatio;
	CalculateBaseZoom();
	Scale(m_nBaseZoom);
	_CalculateCircularTubeData();
}

// ͹ܲ ----  2016-10-28
void CNce3DViewImp_V1::_SetRoundRectTubeParams(RoundRectTubeParams* pParamDatas_)
{
	ASSERT(pParamDatas_);
	m_RPData.nA = pParamDatas_->nA;
	m_RPData.nB = pParamDatas_->nB;
	m_RPData.nH = pParamDatas_->nH;
	_CreateRoundRectTubeBitmap();
	LoadIdentity();
	m_nTubeWidth = max(pParamDatas_->nA, pParamDatas_->nB);
	m_nTubeHeight = pParamDatas_->nH;
	m_nMaxWidth = m_nBmpWidth / m_nBmpZoomRatio;
	CalculateBaseZoom();
	Scale(m_nBaseZoom);
	_CalculateRoundRectTubeData();
}

// Բܲ ----  2016-10-28
void CNce3DViewImp_V1::_SetEllipseTubeParams(EllipseTubeParams* pParamDatas_)
{
	// Բܳ
	ASSERT(pParamDatas_);
	m_EPData.nA = pParamDatas_->nA;
	m_EPData.nB = pParamDatas_->nB;
	m_EPData.nH = pParamDatas_->nH;
	double _nb = min(m_EPData.nA, m_EPData.nB);
	double _na = max(m_EPData.nA, m_EPData.nB);
	double _nL = GetEllipsePerimeter(_na, _nb);
	_CreateEllipseTubeBitmap();
	LoadIdentity();
	m_nTubeWidth = max(pParamDatas_->nA * 2, pParamDatas_->nB * 2);
	m_nTubeHeight = pParamDatas_->nH;
	m_nMaxWidth = m_nBmpWidth / m_nBmpZoomRatio;
	CalculateBaseZoom();
	Scale(m_nBaseZoom);
	_CalculateEllipseTubeData();
}

void CNce3DViewImp_V1::_CreateBaseTubeBitmap()
{
	if (m_pBmpTexture != NULL)
	{
		delete m_pBmpTexture;
	}
	m_pBmpTexture = new CBitmap;
	CDC* _pGLDC = new CDC;
	HDC _hDC = ::GetDC(NULL);
	_pGLDC->Attach(_hDC);
	//޶ ͼƬӴ,ֹ֧ܲĵĸ ----  2016-10-19
	m_pBmpTexture->CreateCompatibleBitmap(_pGLDC, (int)(m_nBmpWidth + m_nAuxiliaryWidth), (int)m_nBmpHeight);
	if (m_pBmpDC != NULL)
	{
		delete m_pBmpDC;
	}
	m_pBmpDC = new CDC;
	m_pBmpDC->CreateCompatibleDC(_pGLDC);
	m_pBmpDC->SelectObject(m_pBmpTexture);
	m_pBmpDC->FillSolidRect(0, 0, (int)(m_nBmpWidth + m_nAuxiliaryWidth), (int)m_nBmpHeight, RGB(255, 254, 253));
	BitmapToOpenGLData(m_pBmpDC, m_pBmpTexture, (int)m_nBmpWidth, (int)m_nBmpHeight);
	CreateTextures((int)m_nBmpWidth, (int)m_nBmpHeight);
	::ReleaseDC(NULL, _hDC);
	delete _pGLDC;
}

// ɷܵbitmap ----  2016-10-28
void CNce3DViewImp_V1::_CreateQuadTubeBitmap()
{
	double _nWidth = (m_QPData.nA + m_QPData.nB) * 2;
	double _nHeight = m_QPData.nH;
	m_vecOrigin.x = 0.f;
	m_vecOrigin.y = 0.f;
	double _nMin = min(_nWidth, _nHeight);
	double _nMax = max(_nWidth, _nHeight);
	double _nMaxWidth = MaxBitmapWidth;
	if (_nMax > _nMaxWidth)
	{
		m_nBmpZoomRatio = _nMaxWidth / _nMax;
	}
	else
	{
		if (_nMin < MinBitmapWidth)
		{
			m_nBmpZoomRatio = min(_nMaxWidth / _nMax, MinBitmapWidth / _nMin);
		}
		else
		{
			m_nBmpZoomRatio = 1;
		}
	}
	m_nBmpWidth = _nWidth * m_nBmpZoomRatio;
	m_nBmpHeight = _nHeight * m_nBmpZoomRatio;
	m_nAuxiliaryWidth = m_nBmpZoomRatio * m_QPData.nA;
	_CreateBaseTubeBitmap();
}

// Բܵbitmap ----  2016-10-28
void CNce3DViewImp_V1::_CreateCircularTubeBitmap()
{
	double _nWidth = m_CPData.nR * 2 * M_PI;
	double _nHeight = m_CPData.nH;
	m_vecOrigin.x = 0.f;
	m_vecOrigin.y = 0.f;
	double _nMax = max(_nWidth, _nHeight);
	double _nMaxWidth = MaxBitmapWidth; 
	if (_nMax > _nMaxWidth)
	{
		m_nBmpZoomRatio = _nMaxWidth / _nMax;
	}
	else
	{
		m_nBmpZoomRatio = 1;
	}
	m_nBmpWidth = _nWidth * m_nBmpZoomRatio;
	m_nBmpHeight = _nHeight * m_nBmpZoomRatio;
	m_nAuxiliaryWidth = m_nBmpWidth * 0.25;
	_CreateBaseTubeBitmap();
}

// ιܵbitmap ----  2016-11-01
void CNce3DViewImp_V1::_CreateRoundRectTubeBitmap()
{
	double _nWidth = m_RPData.nB * M_PI + m_RPData.nA * 2;		//ݶ
	double _nHeight = m_RPData.nH;
	m_vecOrigin.x = 0.f;
	m_vecOrigin.y = 0.f;
	double _nMax = max(_nWidth, _nHeight);
	double _nMaxWidth = MaxBitmapWidth;
	if (_nMax > _nMaxWidth)
	{
		m_nBmpZoomRatio = _nMaxWidth / _nMax;
	}
	else
	{
		m_nBmpZoomRatio = 1;
	}
	m_nBmpWidth = _nWidth * m_nBmpZoomRatio;
	m_nBmpHeight = _nHeight * m_nBmpZoomRatio;
	m_nAuxiliaryWidth = m_nBmpWidth * 0.25;
	_CreateBaseTubeBitmap();
}

void CNce3DViewImp_V1::_CreateEllipseTubeBitmap()
{
	// Բܳ
	double _nb = min(m_EPData.nA, m_EPData.nB);
	double _na = max(m_EPData.nA, m_EPData.nB);	
	double _nL = GetEllipsePerimeter(_na, _nb);
	double _nWidth = _nL;		//ݶ
	double _nHeight = m_EPData.nH;
	m_vecOrigin.x = 0.f;
	m_vecOrigin.y = 0.f;
	double _nMax = max(_nWidth, _nHeight);
	double _nMaxWidth = MaxBitmapWidth;
	if (_nMax > _nMaxWidth)
	{
		m_nBmpZoomRatio = _nMaxWidth / _nMax;
	}
	else
	{
		m_nBmpZoomRatio = 1;
	}
	m_nBmpWidth = _nWidth * m_nBmpZoomRatio;
	m_nBmpHeight = _nHeight * m_nBmpZoomRatio;
	m_nAuxiliaryWidth = m_nBmpWidth * 0.25;
	_CreateBaseTubeBitmap();
}

// 㷽ܵ ----  2016-10-28
void CNce3DViewImp_V1::_CalculateQuadTubeData()
{
	m_vectorTexs.clear();
	m_vectorVTs.clear();
	m_vectorNormals.clear();
	m_vectorTransform3D.clear();
	double _nStepLong = m_QPData.nA - 2 * m_QPData.nR;
	double _nStepWidth = m_QPData.nB - 2 * m_QPData.nR;
	double _nSrcX = m_QPData.nA / 2;
	double _nSrcZ = m_QPData.nB / 2;
	double _nx = _nStepLong / 2;
	double _ny = m_QPData.nH / 2;
	double _nz = _nStepWidth / 2;
	Vector4 _vecVTs[21];
	int _nSlices = 20 * ((m_QPData.nR <= 0) ? 0 : 1);
	double _nStepR = 2 * m_QPData.nR; //m_QPData.nR * M_PI * 0.5;
	double _nWidth = (_nStepLong + _nStepWidth) * 2 + 4 * _nStepR;
	double _nHeight = m_QPData.nH;
	double _nTexStart = _nStepR / 2;
	double _nStartTexCood = _nTexStart / _nWidth;
	double _nEndTexCood = (_nTexStart + _nStepLong) / _nWidth;
	double _nStepAngle = M_PI_2 / _nSlices;
	double _nTexStep = _nStepR / _nSlices;

	// 1
	for (int _i = 0; _i <= _nSlices / 2; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI * 1.25 + _nStepAngle * _i) * m_QPData.nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI * 1.25 + _nStepAngle * _i) * m_QPData.nR;
	}
	for (int _i = 0; _i < _nSlices / 2; _i++)
	{
		_nStartTexCood =(_i * _nTexStep) / _nWidth;
		_nEndTexCood = ((_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
	// 1
	_nStartTexCood = _nTexStart / _nWidth;
	_nEndTexCood = (_nTexStart + _nStepLong) / _nWidth;
	PushVector3D(Vector4(-_nx, -_ny, _nSrcZ), Vector4(_nx, -_ny, _nSrcZ), _nStartTexCood, _nEndTexCood);

	// 2
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI_2 * 3 + _nStepAngle * _i) * m_QPData.nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(M_PI_2 * 3 + _nStepAngle * _i) * m_QPData.nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
	// 2
	_nStartTexCood =(_nTexStart + _nStepLong + _nStepR) / _nWidth;
	_nEndTexCood = (_nTexStart + _nStepLong + _nStepR + _nStepWidth) / _nWidth;
	PushVector3D(Vector4(_nSrcX, -_ny, _nz), Vector4(_nSrcX, -_ny, -_nz), _nStartTexCood, _nEndTexCood);

	// 3
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(_nStepAngle * _i) * m_QPData.nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(_nStepAngle * _i) * m_QPData.nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong + _nStepR + _nStepWidth + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong + _nStepR + _nStepWidth + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
	// 3
	_nStartTexCood =(_nTexStart + _nStepLong + _nStepWidth + _nStepR * 2) / _nWidth;
	_nEndTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth + _nStepR *2) / _nWidth;
	PushVector3D(Vector4(_nx, -_ny, -_nSrcZ), Vector4(-_nx, -_ny, -_nSrcZ), _nStartTexCood, _nEndTexCood);

	// 4
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(M_PI_2 + _nStepAngle * _i) * m_QPData.nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI_2 + _nStepAngle * _i) * m_QPData.nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth + _nStepR * 2 + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth +  _nStepR * 2 + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
	// 4
	_nStartTexCood =(_nTexStart + _nStepLong * 2 + _nStepWidth +_nStepR * 3) / _nWidth;
	_nEndTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth * 2 +_nStepR * 3) / _nWidth;
	PushVector3D(Vector4(-_nSrcX, -_ny, -_nz), Vector4(-_nSrcX, -_ny, _nz), _nStartTexCood, _nEndTexCood);

	// 1
	for (int _i = 0; _i <= _nSlices / 2; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI + _nStepAngle * _i) * m_QPData.nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI + _nStepAngle * _i) * m_QPData.nR;
	}
	for (int _i = 0; _i < _nSlices / 2; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth * 2 +_nStepR * 3 + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth *2 +_nStepR * 3 + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
}

// ιܵ ----  2016-11-01
void CNce3DViewImp_V1::_CalculateRoundRectTubeData()
{
	m_vectorTexs.clear();
	m_vectorVTs.clear();
	m_vectorNormals.clear();
	m_vectorTransform3D.clear();
	double _nStepLong = m_RPData.nA;
	double _nStepWidth = 0;
	double _nSrcX = m_RPData.nA / 2;
	double _nSrcZ = m_RPData.nB / 2;
	double _nR = m_RPData.nB * 0.5;
	double _nx = _nStepLong * 0.5;
	double _ny = m_RPData.nH * 0.5;
	double _nz = _nStepWidth * 0.5;
	Vector4 _vecVTs[21];
	int _nSlices = 20;
	double _nStepR = _nR * M_PI_2;
	double _nWidth = _nStepLong * 2 + 4 * _nStepR;
	double _nHeight = m_RPData.nH;

	double _nTexStart = 0;
	double _nStartTexCood = _nTexStart / _nWidth;
	double _nEndTexCood = (_nTexStart + _nStepLong) / _nWidth;
	double _nStepAngle = M_PI_2 / _nSlices;
	double _nTexStep = _nStepR / _nSlices;

	// 1 Ҫֳ
	_nStartTexCood = _nTexStart / _nWidth;
	_nEndTexCood = (_nTexStart + _nStepLong / 2) / _nWidth;
	PushVector3D(Vector4(-_nx, -_ny, _nSrcZ), Vector4(0, -_ny, _nSrcZ), _nStartTexCood, _nEndTexCood);

	_nStartTexCood = (_nTexStart + _nStepLong / 2) / _nWidth;
	_nEndTexCood = (_nTexStart + _nStepLong) / _nWidth;
	PushVector3D(Vector4(0, -_ny, _nSrcZ), Vector4(_nx, -_ny, _nSrcZ), _nStartTexCood, _nEndTexCood);

	// 2
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI_2 * 3 + _nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(M_PI_2 * 3 + _nStepAngle * _i) * _nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 3
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(_nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(_nStepAngle * _i) * _nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong + _nStepR + _nStepWidth + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong + _nStepR + _nStepWidth + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
	// 3 ҲҪֳ
	_nStartTexCood =(_nTexStart + _nStepLong + _nStepWidth + _nStepR * 2) / _nWidth;
	_nEndTexCood = (_nTexStart + _nStepLong * 1.5 + _nStepWidth + _nStepR *2) / _nWidth;
	PushVector3D(Vector4(_nx, -_ny, -_nSrcZ), Vector4(0, -_ny, -_nSrcZ), _nStartTexCood, _nEndTexCood);

	_nStartTexCood = _nEndTexCood;
	_nEndTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth + _nStepR *2) / _nWidth;
	PushVector3D(Vector4(0, -_ny, -_nSrcZ), Vector4(-_nx, -_ny, -_nSrcZ), _nStartTexCood, _nEndTexCood);

	// 4
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(M_PI_2 + _nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI_2 + _nStepAngle * _i) * _nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth + _nStepR * 2 + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth +  _nStepR * 2 + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 1
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI + _nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI + _nStepAngle * _i) * _nR;
	}
	for (int _i = 0; _i < _nSlices ; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth * 2 +_nStepR * 3 + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepLong * 2 + _nStepWidth *2 +_nStepR * 3 + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
}

double CNce3DViewImp_V1::_GetEllipseSlices(double nA_, double nB_, double nSlices_)
{
	double _nSlicesD = (2 * M_PI) / (nSlices_ * 4);
	double _nSlicesSize = nSlices_ * 4;
	double _nSlicesLen = 0;
	for (int _i = 1; _i <= _nSlicesSize; _i++)
	{
		double _nDx = sin(_nSlicesD * _i) * nB_ - sin(_nSlicesD * (_i - 1)) * nB_;
		double _nDy = cos(_nSlicesD * _i) * nA_ - cos(_nSlicesD * (_i - 1)) * nA_;
		_nSlicesLen += sqrt((_nDx * _nDx) + (_nDy * _nDy));
	}
	return _nSlicesLen;
}

void CNce3DViewImp_V1::_CalculateEllipseTubeData()
{
	m_vectorTexs.clear();
	m_vectorVTs.clear();
	m_vectorNormals.clear();
	m_vectorTransform3D.clear();
	double _nA = m_EPData.nA;
	double _nB = m_EPData.nB;
	double _nx = 0;
	double _ny = m_EPData.nH / 2;
	double _nz = 0;
	Vector4 _vecVTs[51];
	int _nSlices = 40;
	double _nb = min(m_EPData.nA, m_EPData.nB);
	double _na = max(m_EPData.nA, m_EPData.nB);
	double _nL = _GetEllipseSlices(_na, _nb, _nSlices);
	double _nStepR = _nL * 0.25;
	double _nWidth = _nL;
	double _nHeight = m_EPData.nH;
	double _nTexStart = _nStepR;
	double _nStartTexCood = _nTexStart / _nWidth;
	double _nEndTexCood = _nTexStart / _nWidth;
	double _nStepAngle = M_PI_2 / _nSlices;
	double _nTexStep = _nStepR / _nSlices;
	double _nSummationLen = 0;
	// 1
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI_2 * 3 + _nStepAngle * _i) * _nB;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(M_PI_2 * 3 + _nStepAngle * _i) * _nA;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood =_nSummationLen / _nWidth;
		_nSummationLen += sqrt((_vecVTs[_i + 1].x - _vecVTs[_i].x) * (_vecVTs[_i + 1].x - _vecVTs[_i].x) +
			(_vecVTs[_i + 1].z - _vecVTs[_i].z) * (_vecVTs[_i + 1].z - _vecVTs[_i].z));
		_nEndTexCood = _nSummationLen / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 2
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(_nStepAngle * _i) * _nB;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(_nStepAngle * _i) * _nA;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood =_nSummationLen / _nWidth;
		_nSummationLen += sqrt((_vecVTs[_i + 1].x - _vecVTs[_i].x) * (_vecVTs[_i + 1].x - _vecVTs[_i].x) +
			(_vecVTs[_i + 1].z - _vecVTs[_i].z) * (_vecVTs[_i + 1].z - _vecVTs[_i].z));
		_nEndTexCood = _nSummationLen / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 3
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(M_PI_2 + _nStepAngle * _i) * _nB;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI_2 + _nStepAngle * _i) * _nA;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood =_nSummationLen / _nWidth;
		_nSummationLen += sqrt((_vecVTs[_i + 1].x - _vecVTs[_i].x) * (_vecVTs[_i + 1].x - _vecVTs[_i].x) +
			(_vecVTs[_i + 1].z - _vecVTs[_i].z) * (_vecVTs[_i + 1].z - _vecVTs[_i].z));
		_nEndTexCood = _nSummationLen / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 4
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI + _nStepAngle * _i) * _nB;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI + _nStepAngle * _i) * _nA;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood =_nSummationLen / _nWidth;
		_nSummationLen += sqrt((_vecVTs[_i + 1].x - _vecVTs[_i].x) * (_vecVTs[_i + 1].x - _vecVTs[_i].x) +
			(_vecVTs[_i + 1].z - _vecVTs[_i].z) * (_vecVTs[_i + 1].z - _vecVTs[_i].z));
		_nEndTexCood = _nSummationLen / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
}

// Բܵ ----  2016-10-28
void CNce3DViewImp_V1::_CalculateCircularTubeData()
{
	m_vectorTexs.clear();
	m_vectorVTs.clear();
	m_vectorNormals.clear();
	m_vectorTransform3D.clear();
	double _nR = m_CPData.nR;
	double _nx = 0;
	double _ny = m_CPData.nH / 2;
	double _nz = 0;
	Vector4 _vecVTs[51];
	int _nSlices = 50;
	double _nStepR = m_CPData.nR * M_PI * 0.5;
	double _nWidth = 4 * _nStepR;
	double _nHeight = m_CPData.nH;
	double _nTexStart = _nStepR;
	double _nStartTexCood = _nTexStart / _nWidth;
	double _nEndTexCood = _nTexStart / _nWidth;
	double _nStepAngle = M_PI_2 / _nSlices;
	double _nTexStep = _nStepR / _nSlices;

	// 1
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI_2 * 3 + _nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(M_PI_2 * 3 + _nStepAngle * _i) * _nR;
	}

	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood =(_i * _nTexStep) / _nWidth;
		_nEndTexCood = ((_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 2
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(_nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = _nx + cos(_nStepAngle * _i) * _nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 3
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = -_nz - sin(M_PI_2 + _nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI_2 + _nStepAngle * _i) * _nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepR + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepR + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}

	// 4
	for (int _i = 0; _i <= _nSlices; _i++)
	{
		_vecVTs[_i].z = _nz - sin(M_PI + _nStepAngle * _i) * _nR;
		_vecVTs[_i].y = -_ny;
		_vecVTs[_i].x = -_nx + cos(M_PI + _nStepAngle * _i) * _nR;
	}
	for (int _i = 0; _i < _nSlices; _i++)
	{
		_nStartTexCood = (_nTexStart + _nStepR * 2 + _i * _nTexStep) / _nWidth;
		_nEndTexCood = (_nTexStart + _nStepR * 2 + (_i + 1) * _nTexStep) / _nWidth;
		PushVector3D(_vecVTs[_i], _vecVTs[_i + 1], _nStartTexCood, _nEndTexCood);
	}
}

void CNce3DViewImp_V1::_DrawCircularTube()
{
	int _nCutSize = static_cast<int>(m_vectorCutData3D.size());
	ASSERT(m_vectorTexs.size() == m_vectorVTs.size());
	int _nSize = (int)m_vectorTexs.size();
	ASSERT(_nCutSize == _nSize / 4);
	// οʱ ----  2016-10-14
	int _nOffset = 0;
	int _nStep = (_nSize / 4);
	double _nStepAngle = double(_nStep) / 90.f; // ÿǶȴĸ
	_nOffset = _nStep - int(_nStepAngle * m_nRotate);
	if (_nOffset < 0)
		_nOffset = _nOffset + _nSize;
	_nOffset = _nOffset - _nOffset % 4; // 4ı һ4㡣

	ASSERT(_nOffset % 4 == 0);
	_DrawShareTube(_nOffset, _nCutSize, _nSize);
}

void CNce3DViewImp_V1::_DrawRoundRectTube()
{

}

void CNce3DViewImp_V1::_DrawEllipseTube()
{

}

void CNce3DViewImp_V1::_DrawQuadTube()
{
	int _nCutSize = static_cast<int>(m_vectorCutData3D.size());
	ASSERT(m_vectorTexs.size() == m_vectorVTs.size());
	int _nSize = (int)m_vectorTexs.size();
	ASSERT(_nCutSize == _nSize / 4);
	// οʱ ----  2016-10-14
	// ȺοЧѡ
	int _nOffset = 0;
	int _nStep = (_nSize / 4);
	if (m_nRotate < 90)
		_nOffset = _nStep;
	else if (m_nRotate < 180)
		_nOffset = 0;
	else if (m_nRotate < 270)
		_nOffset = _nStep * 3;
	else if (m_nRotate < 360)
		_nOffset = _nStep * 2;
	ASSERT(_nOffset % 4 == 0);
	_DrawShareTube(_nOffset, _nCutSize, _nSize);
}

void CNce3DViewImp_V1::_DrawShareTube(int nOffset_, int nCutSize_, int nMainSize_)
{
	int _nSize = nMainSize_;
	int _nOffset = nOffset_;
	int _nCutSize = nCutSize_;
	ASSERT(_nCutSize == _nSize / 4);
	ASSERT(_nOffset % 4 == 0);
	int _nCutOffset = _nOffset / 4;
	int _nHalfSize = _nSize / 2;
	int _nCutHalfSize = _nCutSize / 2;

	// һ cut object
	glEnable(GL_POLYGON_OFFSET_FILL);
	glPolygonOffset( 1., 1.);
	glColor4ub(255, 0, 0, 0);
	for (int _i = 0; _i < _nCutHalfSize; _i++)
	{
		int _nStart = _nCutOffset + _i;
		if (_nStart >= _nCutSize)
		{
			_nStart = _nStart - _nCutSize;
		}
		ASSERT(_nStart < _nCutSize);
		Polygon3DList& _tempPolygonList = m_vectorCutData3D[_nStart];
		int _nPolygonSize = static_cast<int>(_tempPolygonList.size());
		for (int _j = 0; _j < _nPolygonSize; _j++)
		{
			Polygon3D& _Polygon = _tempPolygonList[_j];
			int _nPointSize = static_cast<int>(_Polygon.size());
			glBegin(GL_TRIANGLE_STRIP);
			for (int _k = 0; _k < _nPointSize; _k++)
			{
				glVertex3d(_Polygon[_k].x, _Polygon[_k].y, _Polygon[_k].z);
			}
			glEnd();
		}
	}
	//glDisable(GL_POLYGON_OFFSET_FILL);

	glPolygonOffset( 2., 5.);
	glColor4ub(255, 255, 255, 255);
	glBegin(GL_QUADS);
	for (int _i = 0; _i < _nHalfSize; _i++)
	{
		int _nStart = _nOffset + _i;
		if (_nStart >= _nSize)
		{
			_nStart = _nStart - _nSize;
		}
		if (_nStart % 4 == 0)
			glNormal3d(m_vectorNormals[_nStart / 4].x, m_vectorNormals[_nStart / 4].y, m_vectorNormals[_nStart / 4].z);
		glTexCoord2d(m_vectorTexs[_nStart].x, m_vectorTexs[_nStart].y);
		glVertex4d(m_vectorVTs[_nStart].x, m_vectorVTs[_nStart].y, m_vectorVTs[_nStart].z, m_vectorVTs[_nStart].w);
	}
	glEnd();

	// ǰһ cut object
	//glEnable(GL_POLYGON_OFFSET_FILL);
	glPolygonOffset( 1., 1.);
	glColor4ub(255, 0, 0, 0);
	for (int _i = _nCutHalfSize; _i < _nCutSize; _i++)
	{
		int _nStart = _nCutOffset + _i;
		if (_nStart >= _nCutSize)
		{
			_nStart = _nStart - _nCutSize;
		}
		ASSERT(_nStart < _nCutSize);
		Polygon3DList& _tempPolygonList = m_vectorCutData3D[_nStart];
		int _nPolygonSize = static_cast<int>(_tempPolygonList.size());
		for (int _j = 0; _j < _nPolygonSize; _j++)
		{
			Polygon3D& _Polygon = _tempPolygonList[_j];
			int _nPointSize = static_cast<int>(_Polygon.size());
			glBegin(GL_TRIANGLE_STRIP);
			for (int _k = 0; _k < _nPointSize; _k++)
			{
				glVertex3d(_Polygon[_k].x, _Polygon[_k].y, _Polygon[_k].z);
			}
			glEnd();
		}
	}

	glPolygonOffset( 2., 5.);
	glColor4ub(255, 255, 255, 255);
	glBegin(GL_QUADS);
	for (int _i = _nHalfSize; _i < _nSize; _i++)
	{
		int _nStart = _nOffset + _i;
		if (_nStart >= _nSize)
		{
			_nStart = _nStart - _nSize;
		}
		if (_nStart % 4 == 0)
			glNormal3d(m_vectorNormals[_nStart / 4].x, m_vectorNormals[_nStart / 4].y, m_vectorNormals[_nStart / 4].z);
		glTexCoord2d(m_vectorTexs[_nStart].x, m_vectorTexs[_nStart].y);
		glVertex4d(m_vectorVTs[_nStart].x, m_vectorVTs[_nStart].y, m_vectorVTs[_nStart].z, m_vectorVTs[_nStart].w);
	}
	glEnd();
	glDisable(GL_POLYGON_OFFSET_FILL);
}

// תopenglʶ ----  2016-10-14
void CNce3DViewImp_V1::BitmapToOpenGLData(CDC* pBmpDC_, CBitmap* pBitmap_, int nWidth_, int nHeight_)
{
	ASSERT(pBmpDC_ && pBitmap_ && nWidth_ && nHeight_);
	int _nBufsize =nWidth_ * nHeight_ * 4;
	if (m_pRGBAData != NULL)
	{
		delete[] m_pRGBAData;
	}

	m_pRGBAData = new BYTE[_nBufsize];
	memset(m_pRGBAData, 255, sizeof(BYTE) * _nBufsize);
	struct
	{
		BITMAPINFOHEADER bih;
		RGBQUAD col[2];
	}_bic;
	BITMAPINFO *_pInfo = (BITMAPINFO*)&_bic;
	_pInfo->bmiHeader.biSize = sizeof(_pInfo->bmiHeader);
	_pInfo->bmiHeader.biWidth = nWidth_;
	_pInfo->bmiHeader.biHeight = nHeight_;
	_pInfo->bmiHeader.biPlanes = 1;
	_pInfo->bmiHeader.biBitCount = 32;
	_pInfo->bmiHeader.biCompression = BI_RGB;
	_pInfo->bmiHeader.biSizeImage = _nBufsize;
	_pInfo->bmiHeader.biXPelsPerMeter = 1;
	_pInfo->bmiHeader.biYPelsPerMeter = 1;
	_pInfo->bmiHeader.biClrUsed = 0;
	_pInfo->bmiHeader.biClrImportant = 0;
	_pInfo->bmiColors[0].rgbBlue = 8;
	_pInfo->bmiColors[0].rgbGreen = 8;
	_pInfo->bmiColors[0].rgbRed = 8;
	_pInfo->bmiColors[0].rgbReserved = 8;
	GetDIBits(pBmpDC_->GetSafeHdc(), (HBITMAP)pBitmap_->GetSafeHandle(), 0, nHeight_, m_pRGBAData, _pInfo, DIB_RGB_COLORS);
	COLORREF _clr = m_clrAlpha;
	BYTE _r = GetRValue(m_clrAlpha), _g = GetGValue(m_clrAlpha), _b = GetBValue(m_clrAlpha);
	for (int _i = 0; _i < nHeight_; _i++)
	{
		for (int _j = 0; _j < nWidth_; _j++)
		{
			int _nk =int(_i * nWidth_ * 4 + _j * 4);
			if (m_pRGBAData[_nk] == _b && m_pRGBAData[_nk + 1] == _g && m_pRGBAData[_nk + 2] == _r)
			{
				m_pRGBAData[_nk + 3] = 0;
			}
			else
			{
				m_pRGBAData[_nk + 3] = 255;
			}
		}
	}
}

// opengͼ ----  2016-10-14
void CNce3DViewImp_V1::CreateTextures(int nWidth_, int nHeight_)
{	
	ASSERT(m_pRGBAData);
	ASSERT(nWidth_ * nHeight_);
	if (m_nTextureID != -1)
	{
		glDeleteTextures(1, &m_nTextureID);
		m_nTextureID = -1;
	}
	glGenTextures(1, &m_nTextureID);
	ASSERT(m_nTextureID != -1);
	if (m_nTextureID <= 0)
		return;
	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
	glBindTexture(GL_TEXTURE_2D, m_nTextureID);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D, 4, nWidth_, nHeight_, GL_BGRA_EXT, GL_UNSIGNED_BYTE, m_pRGBAData);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, m_nTextureID);
}

void CNce3DViewImp_V1::ReviseCoord(Polyline2DList& listRecords_, Polyline2DList& listRevise_)
{
	for (Polyline2DList::iterator _it = listRecords_.begin(); _it != listRecords_.end(); _it++)
	{
		Polyline2DItem _item = *_it;
		Polyline2D& _polylineItem = _item.PolylineNode;
		_polylineItem.nStartX *= m_nBmpZoomRatio;
		_polylineItem.nStartY *= m_nBmpZoomRatio;
		size_t _nSize = _polylineItem.vectorNodes.size();
		for (size_t _i = 0; _i < _nSize; _i++)
		{
			_polylineItem.vectorNodes[_i].nEndX *= m_nBmpZoomRatio;
			_polylineItem.vectorNodes[_i].nEndY *= m_nBmpZoomRatio;
		}
		listRevise_.push_back(_item);
	}
}

Vector4 CNce3DViewImp_V1::ReviseCoord(Vector4& vecPoint2D_)
{
	Vector4 _retVector;
	_retVector.x = vecPoint2D_.x * m_nBmpZoomRatio;
	_retVector.y =vecPoint2D_.y * m_nBmpZoomRatio;
	return _retVector;
}

void CNce3DViewImp_V1::TrackClear()
{
	m_vectorAddDatas.clear();
}

void CNce3DViewImp_V1::GetDataMaxRect(Polyline2DList& listRecords_, double& nMinWidth_, double& nMaxWidth_,
									  double& nMinHeight_, double& nMaxHeight_)
{
	bool _bInit = false;
	Polyline2DList *_plistCalculateRevise = &listRecords_;
	for (Polyline2DList::iterator _it = _plistCalculateRevise->begin(); _it != _plistCalculateRevise->end(); _it++)
	{
		Polyline2D& _polylineItem = _it->PolylineNode;
		int _nSize = (int)(_polylineItem.vectorNodes.size());
		nMinWidth_ = _bInit ? min(_polylineItem.nStartX, nMinWidth_) : _polylineItem.nStartX;
		nMaxWidth_ = _bInit ? max(_polylineItem.nStartX, nMaxWidth_) : _polylineItem.nStartX;
		nMinHeight_ = _bInit ? min(_polylineItem.nStartY ,nMinHeight_) : _polylineItem.nStartY;
		nMaxHeight_ = _bInit ? max(_polylineItem.nStartY ,nMaxHeight_) : _polylineItem.nStartY;
		_bInit = true;
		for (int _i = 0;_i < _nSize; _i++)
		{
			nMinWidth_ = min(_polylineItem.vectorNodes[_i].nEndX, nMinWidth_);
			nMaxWidth_ = max(_polylineItem.vectorNodes[_i].nEndX, nMaxWidth_);
			nMinHeight_ = min(_polylineItem.vectorNodes[_i].nEndY ,nMinHeight_);
			nMaxHeight_ = max(_polylineItem.vectorNodes[_i].nEndY ,nMaxHeight_);
		}
	}
}

// ȥ(ο) ----  2016-12-01
void CNce3DViewImp_V1::FillCutOffDataGDI2D(Polyline2DList& listRecords_, double nOffset_)
{
	Polyline2DList *_plistCalculateRevise = &listRecords_;
	for (Polyline2DList::iterator _it = _plistCalculateRevise->begin(); _it != _plistCalculateRevise->end(); _it++)
	{
		Polyline2D& _polylineItem = _it->PolylineNode;
		int _nSize = (int)(_polylineItem.vectorNodes.size());
		POINT* _pPolygonData = new POINT[_nSize + 1];
		_pPolygonData[0].x = (int)((_polylineItem.nStartX + nOffset_)* m_nBmpZoomRatio);
		_pPolygonData[0].y = (int)(_polylineItem.nStartY * m_nBmpZoomRatio);
		for (int _i = 0;_i < _nSize; _i++)
		{
			_pPolygonData[_i+1].x = (int)((_polylineItem.vectorNodes[_i].nEndX + nOffset_) * m_nBmpZoomRatio);
			_pPolygonData[_i+1].y = (int)(_polylineItem.vectorNodes[_i].nEndY * m_nBmpZoomRatio);
		}
		CPen _pen(PS_SOLID, 1, m_clrAlpha);
		CBrush _brush(m_clrAlpha);
		m_pBmpDC->SelectObject(_pen);
		m_pBmpDC->SelectObject(_brush);
		m_pBmpDC->Polygon(_pPolygonData, _nSize + 1);
		delete[] _pPolygonData;
	}
}

void CNce3DViewImp_V1::SetCutOffData(Polyline2DList& listRecords_)
{
	m_pBmpDC->FillSolidRect(0, 0, (int)(m_nBmpWidth + m_nAuxiliaryWidth), (int)m_nBmpHeight, RGB(255, 255, 255));
	// չʱҪ⴦
	if (m_nTubeType == CircularTube)
	{
		double _nMinWidth = 0, _nMaxWidth = 0, _nMinHeight = 0, _nMaxHeight = 0;
		GetDataMaxRect(listRecords_, _nMinWidth, _nMaxWidth, _nMinHeight, _nMaxHeight);
		int _nStart = 0;
		int _nEnd = 0;
		double _nDiv = _nMinWidth / m_nMaxWidth;
		_nStart = (int)floor(_nDiv);
		_nDiv = _nMaxWidth / m_nMaxWidth;
		_nEnd = (int)floor(_nDiv);
		for (int _i = _nStart; _i <= _nEnd; _i++)
		{
			FillCutOffDataGDI2D(listRecords_, -_i * m_nMaxWidth);
		}
	}
	else
		FillCutOffDataGDI2D(listRecords_, 0);
	// ͬҲҪ档
	TransparentBlt(m_pBmpDC->m_hDC, 0, 0, (int)(m_nAuxiliaryWidth), (int)(m_nBmpHeight),
		m_pBmpDC->m_hDC, (int)m_nBmpWidth, 0,
		(int)(m_nAuxiliaryWidth), (int)(m_nBmpHeight),
		RGB(255, 255, 255));
	BitmapToOpenGLData(m_pBmpDC, m_pBmpTexture, (int)m_nBmpWidth, (int)m_nBmpHeight);
	CreateTextures((int)m_nBmpWidth, (int)m_nBmpHeight);
}

void CNce3DViewImp_V1::Point2DToPoint3D(IN OUT Polygon3DListGroup& PolygonSrc_)
{
	int _nSize = static_cast<int>(PolygonSrc_.size());
	ASSERT(_nSize < static_cast<int>(m_vectorTransform3D.size()));
	for (int _i = 0; _i < _nSize; _i++)
	{
		Polygon3DList& _tempPolygonList = PolygonSrc_[_i];
		int _nPolygonSize = static_cast<int>(_tempPolygonList.size());
		for (int _j = 0; _j < _nPolygonSize; _j++)
		{
			Polygon3D& _Polygon = _tempPolygonList[_j];
			int _nPointSize = static_cast<int>(_Polygon.size());
			for (int _k = 0; _k < _nPointSize; _k++)
			{
				_Polygon[_k] = m_vectorTransform3D[_i].Point2DToPoint3D(_Polygon[_k]);
			}
		}
	}
}

void CNce3DViewImp_V1::Point2DToPoint3D(IN Polyline3DList& PointsSrc_,OUT Polyline3DList& PointsDst_)
{
	int _nSize = static_cast<int>(PointsSrc_.size());
	int _nTransformSize = static_cast<int>(m_vectorTransform3D.size());
	for (int _i = 0; _i < _nSize; _i++)
	{
		Line3DItem& _ptItem = PointsSrc_[_i];
		Line3DItem _newPtItem;
		_newPtItem.clrPenColor = _ptItem.clrPenColor;
		ASSERT(_ptItem.vectorLines.size() == 1);
		Vector4& _pt = _ptItem.vectorLines[0];
		for (int _j = 0; _j < _nTransformSize; _j++)
		{
			if (m_vectorTransform3D[_j].Contain(_pt))
			{
				_newPtItem.vectorLines.push_back(m_vectorTransform3D[_j].Point2DToPoint3D(_pt));
				break;
			}
		}
		if (_newPtItem.vectorLines.size() > 0)
		{
			PointsDst_.push_back(_newPtItem);
		}
	}
}

void CNce3DViewImp_V1::SetCutOffData_GPC(Polyline2DList& listRecords_)
{
	ASSERT(m_vectorTransform3D.size() % 5 == 0);
	m_vectorCutData3D.clear();
	m_vectorCutData3D.resize(m_vectorTransform3D.size() / 5 * 4);
	if (m_nTubeType == CircularTube)
	{
		g_gpcConvertHelper.ConvertCutOffArea(listRecords_, m_vectorCutData3D, GPCConvertHelper::Expand_All);
	}
	else if(m_nTubeType == QuadTube)
	{
		g_gpcConvertHelper.ConvertCutOffArea(listRecords_, m_vectorCutData3D, GPCConvertHelper::Expand_4V4);
	}
	else
		g_gpcConvertHelper.ConvertCutOffArea(listRecords_, m_vectorCutData3D, GPCConvertHelper::Expand_One);
	Point2DToPoint3D(m_vectorCutData3D);
}

void CNce3DViewImp_V1::SetData(DrawDataType_t nType_, Polyline2DList& listRecords_)
{
	ASSERT(nType_ ==DDT_TRACK || nType_ == DDT_CADOBJ || nType_ == DDT_CUTOFF);
	ASSERT(m_pBmpTexture !=NULL && m_pBmpDC != NULL);
	if (m_pBmpTexture ==NULL || m_pBmpDC == NULL)
		return;

	Polyline2DList *_plistCalculateRevise = &listRecords_;
	Polyline3DList _newPolyline3DList;
	Polyline3DList _newAllPlaneList;
	Polyline3DList _newPointList;
	for (Polyline2DList::iterator _it = _plistCalculateRevise->begin(); _it != _plistCalculateRevise->end(); _it++)
	{
		CalculatePolyline2D(_it->PolylineNode, _it->clrPenColor, _newPolyline3DList, _newPointList);
	}

	// ԲܵչĴ
	if (m_nTubeType == CircularTube)
	{
		TransformForAllPlane2D(_newPolyline3DList, _newAllPlaneList);
	}
	else if (m_nTubeType == QuadTube)
	{
		TransformForPlane4V4(_newPolyline3DList, _newAllPlaneList);
		//TransformForAllPlane2D(_newPolyline3DList, _newAllPlaneList);
	}
	else
	{
		_newAllPlaneList = _newPolyline3DList;
	}

	if (nType_ == DDT_CADOBJ)
	{
		m_vectorBaseDatas.clear();
		m_vectorBasePoints.clear();
		m_nCadMinWidth = 0;
		m_nCadMaxWidth = 0;
		m_nCadMinHeight = 0;
		m_nCadMaxHeight = 0;
		// תϢ
		Point2DToPoint3D(_newPointList, m_vectorBasePoints);
		GetDataMaxRect(listRecords_, m_nCadMinWidth, m_nCadMaxWidth, m_nCadMinHeight, m_nCadMaxHeight);
		// תϢ
		TransformLine2DTOLine3D(_newAllPlaneList, m_vectorBaseDatas);
	}
	else if (nType_ == DDT_TRACK)
	{
		m_vectorAddDatas.clear();
		TransformLine2DTOLine3D(_newAllPlaneList, m_vectorAddDatas);
	}
	else if (nType_ == DDT_CUTOFF)
	{
		//SetCutOffData(listRecords_);
		SetCutOffData_GPC(listRecords_);
	}
	else
	{
		ASSERT(false);
	}
}

void CNce3DViewImp_V1::DrawPolylineGDI2D(Polyline3DList& parentList_)
{
	int _nSize = (int)parentList_.size();
	for (int _i = 0; _i< _nSize; _i++)
	{
		Line3DItem& _lineItem = parentList_[_i];
		int _nLineSize = (int)_lineItem.vectorLines.size();
		CPen _pen(PS_SOLID, 1, _lineItem.clrPenColor);
		m_pBmpDC->SelectObject(_pen);
		for(int _j = 0;_j < _nLineSize; _j = _j + 2)
		{
			Vector4 _startPoint = ReviseCoord(_lineItem.vectorLines[_j]);
			Vector4 _endPoint = ReviseCoord(_lineItem.vectorLines[_j + 1]);
			m_pBmpDC->MoveTo((int)_startPoint.x, (int)_startPoint.y);
			m_pBmpDC->LineTo((int)_endPoint.x, (int)_endPoint.y);
		}
	}
}

// ת չ߸4
void CNce3DViewImp_V1::TransformForPlane4V4(Polyline3DList& SrcList_, Polyline3DList& DstList_)
{
	int _nSize = (int)SrcList_.size();
	for (int _i = 0; _i< _nSize; _i++)
	{
		Line3DItem& _lineItem = SrcList_[_i];
		Line3DItem _newItem;
		_newItem.clrPenColor = _lineItem.clrPenColor;
		int _nLineSize = (int)_lineItem.vectorLines.size();
		for(int _j = 0; _j < _nLineSize; _j = _j + 2)
		{
			Vector4 _startPoint = _lineItem.vectorLines[_j];
			Vector4 _endPoint = _lineItem.vectorLines[_j + 1];
			if (_startPoint.x <= _endPoint.x)
				TransformLine4V4(_startPoint, _endPoint, _newItem.vectorLines);
			else
				TransformLine4V4(_endPoint, _startPoint, _newItem.vectorLines);
		}
		DstList_.push_back(_newItem);
	}
}

void CNce3DViewImp_V1::TransformLine4V4(Vector4& ptStart_, Vector4& ptEnd_, std::vector<Vector4>& DstList_)
{
	double _nWidth = m_nMaxWidth;
	double _nHeight = m_nTubeHeight;
	double _nStart = ptStart_.x;
	double _nEnd = ptEnd_.x;
	double _nRatio = 0;
	int _nRatioType = 0;
	double _nStep = 0;

	Vector4 _newStartPoint(ptStart_.x, ptStart_.y);
	Vector4 _newEndPoint(ptEnd_.x, ptEnd_.y);
	if (!DOUBLE_EQU_ZERO(_newEndPoint.x - _newStartPoint.x))
	{
		_nRatio = (_newEndPoint.y - _newStartPoint.y) / (_newEndPoint.x - _newStartPoint.x);
		_nRatioType = 1;
	}

	// 44Χ
	if ((_nStart > 2 * _nWidth) || (_nEnd < -_nWidth))
		return;
	// ǰڴ ƵΧڡ
	// һǷڷΧڡ
	_nStep = 0;
	if (_nStart <= -_nWidth)
	{
		_nStep = -_nWidth - _nStart;
	}
	Vector4 _itemStart = _newStartPoint;
	if (_nStep == 0) // ûнȡ
	{
		_itemStart.x = _newStartPoint.x;
		_itemStart.y = _newStartPoint.y;
	}
	else
	{
		_itemStart.x = _newStartPoint.x + _nStep;
		_itemStart.y = (_nRatioType == 1) ? (_itemStart.y + _nStep * _nRatio) : _itemStart.y;
	}

	// ڶǷڷΧڡ
	_nStep = 0;
	if (_nEnd >= 2 * _nWidth)
	{
		_nStep = 2 * _nWidth - _nStart;
	}
	Vector4 _itemEnd;
	if (_nStep == 0) // ûнȡ
	{
		_itemEnd.x = _newEndPoint.x;
		_itemEnd.y = _newEndPoint.y;
	}
	else
	{
		_itemEnd.x = _newStartPoint.x + _nStep;
		_itemEnd.y = (_nRatioType == 1) ? (_newStartPoint.y + _nStep * _nRatio) : _newStartPoint.y;
	}

	TransformLine2D(_itemStart, _itemEnd, DstList_);
}

// ܶ ----  2016-12-01
void CNce3DViewImp_V1::TransformForAllPlane2D(Polyline3DList& SrcList_, Polyline3DList& DstList_)
{
	int _nSize = (int)SrcList_.size();
	for (int _i = 0; _i< _nSize; _i++)
	{
		Line3DItem& _lineItem = SrcList_[_i];
		Line3DItem _newItem;
		_newItem.clrPenColor = _lineItem.clrPenColor;
		int _nLineSize = (int)_lineItem.vectorLines.size();
		for(int _j = 0; _j < _nLineSize; _j = _j + 2)
		{
			Vector4 _startPoint = _lineItem.vectorLines[_j];
			Vector4 _endPoint = _lineItem.vectorLines[_j + 1];
			if (_startPoint.x <= _endPoint.x)
				TransformLine2D(_startPoint, _endPoint, _newItem.vectorLines);
			else
				TransformLine2D(_endPoint, _startPoint, _newItem.vectorLines);
		}
		DstList_.push_back(_newItem);
	}
}

// е߶תһλƽڣһԲܳΪһλƽ档
void CNce3DViewImp_V1::TransformLine2D(Vector4& ptStart_, Vector4& ptEnd_, std::vector<Vector4>& DstList_)
{
	double _nWidth = m_nMaxWidth;
	double _nHeight = m_nTubeHeight;
	double _nStart = ptStart_.x;
	double _nEnd = ptEnd_.x;
	double _nRatio = 0;
	int _nRatioType = 0;
	double _nStep = 0;
	// ǰڴ ƵΧڡ
	if (_nStart < 0)
	{
		double _nMod = fmod(_nStart, _nWidth);
		if (_nMod < 0)
		{
			_nMod = _nMod + _nWidth;
		}
		_nStep = _nMod - _nStart;
	}

	if (_nStart >= _nWidth)
	{
		double _nMod = fmod(_nStart, _nWidth);
		if (_nMod >= _nWidth)
		{
			_nMod = _nMod - _nWidth;
		}
		_nStep = _nMod - _nStart;
	}

	Vector4 _newStartPoint(ptStart_.x + _nStep, ptStart_.y);
	Vector4 _newEndPoint(ptEnd_.x + _nStep, ptEnd_.y);
	_nStart = _newStartPoint.x;
	_nEnd = _newEndPoint.x;
	_nRatio = 0;
	_nRatioType = 0;
	if (!DOUBLE_EQU_ZERO(_newEndPoint.x - _newStartPoint.x))
	{
		_nRatio = (_newEndPoint.y - _newStartPoint.y) / (_newEndPoint.x - _newStartPoint.x);
		_nRatioType = 1;
	}

	// תɿȷΧ֮ڡ
	if (_nEnd <= _nWidth)
	{
		DstList_.push_back(_newStartPoint);
		DstList_.push_back(_newEndPoint);
	}
	else
	{
		Vector4 _itemStart = _newStartPoint;
		Vector4 _itemEnd;
		_itemEnd.x = _nWidth;
		_itemEnd.y = (_nRatioType == 1) ? (_itemStart.y + (_nWidth - _itemStart.x) * _nRatio) : _itemStart.y;
		DstList_.push_back(_itemStart);
		DstList_.push_back(_itemEnd);
		TransformLine2D(_itemEnd, _newEndPoint, DstList_);
	}
}

void CNce3DViewImp_V1::CalculateCutLine(Vector4& ptStart_, Vector4& ptEnd_, std::vector<Vector4>& DstList_)
{
	int _nTransformSize = (int)m_vectorTransform3D.size();
	Vector4 _startPoint = ptStart_;
	Vector4 _endPoint = ptEnd_;
	for (int _i = 0; _i< _nTransformSize; _i++)
	{
		double _nStart = ptStart_.x;
		double _nEnd = ptEnd_.x;
		double _nRatio = 0;
		int _nRatioType = 0;
		if (!DOUBLE_EQU_ZERO(ptEnd_.x - ptStart_.x))
		{
			_nRatio = (ptEnd_.y - ptStart_.y) / (ptEnd_.x - ptStart_.x);
			_nRatioType = 1;
		}

		TransformData3D _nDate = m_vectorTransform3D[_i];
		Vector4 _itemStart;
		Vector4 _itemEnd;
		if (_nDate.Contain(_startPoint.x) == 0)					//
		{
			_itemStart.x = _startPoint.x;
			_itemStart.y = _startPoint.y;
			int _nRetContain = _nDate.Contain(_endPoint.x);
			if (_nRetContain == 0)								// ұҲ
			{
				_itemEnd.x = _endPoint.x;
				_itemEnd.y = _endPoint.y;
				if (_itemStart.y > m_nTubeHeight && _itemEnd.y > m_nTubeHeight)
				{
					return;
				}

				Vector4 _pt3D = _nDate.Point2DToPoint3D(_itemStart);
				DstList_.push_back(_pt3D);
				_pt3D = _nDate.Point2DToPoint3D(_itemEnd);
				DstList_.push_back(_pt3D);
				return;
			}
			else	
			{
				_itemEnd.x = _nDate.nEndX2D;
				_itemEnd.y = (_nRatioType == 1) ? (_startPoint.y + (_nDate.nEndX2D - _startPoint.x) * _nRatio) : _startPoint.y;

				if (_itemStart.y > m_nTubeHeight && _itemEnd.y > m_nTubeHeight)
				{
					_startPoint = _itemEnd;
					continue;
				}
				Vector4 _pt3D = _nDate.Point2DToPoint3D(_itemStart);
				DstList_.push_back(_pt3D);
				_pt3D = _nDate.Point2DToPoint3D(_itemEnd);
				DstList_.push_back(_pt3D);
				_startPoint = _itemEnd;
			}
		}
		else if (_nDate.Contain(_startPoint.x) == -2)			// ұ߳
		{
			continue;
		}
		else													// ߳
		{
			if (_nDate.Contain(_endPoint.x) == -1)				// 
				return;
			_itemEnd.x = _nDate.nStartX2D;
			_itemEnd.y = (_nRatioType == 1) ? (_startPoint.y + (_nDate.nStartX2D - _startPoint.x) * _nRatio) : _startPoint.y;
			_startPoint = _itemEnd;
			_i--;
		}
	}
}

void CNce3DViewImp_V1::TransformLine2DTOLine3D(Polyline3DList& SrcList_, Polyline3DList& DstList_)
{
	int _nSize = (int)SrcList_.size();
	for (int _i = 0; _i< _nSize; _i++)
	{
		Line3DItem& _lineItem = SrcList_[_i];
		Line3DItem _newItem;
		_newItem.clrPenColor = _lineItem.clrPenColor;
		int _nLineSize = (int)_lineItem.vectorLines.size();
		for(int _j = 0; _j < _nLineSize; _j = _j + 2)
		{
			Vector4 _startPoint = _lineItem.vectorLines[_j];
			Vector4 _endPoint = _lineItem.vectorLines[_j + 1];
			if (_startPoint.x <= _endPoint.x)
				CalculateCutLine(_startPoint, _endPoint, _newItem.vectorLines);
			else
				CalculateCutLine(_endPoint, _startPoint, _newItem.vectorLines);
		}
		DstList_.push_back(_newItem);
	}
}

void CNce3DViewImp_V1::CalculatePolyline2D(const Polyline2D& polylineItem_, COLORREF penColor_, Polyline3DList& lineList_, Polyline3DList& pointList_)
{
	size_t _nSize = polylineItem_.vectorNodes.size();
	Line3DItem _lineItem;
	_lineItem.clrPenColor = penColor_;
	if (polylineItem_.vectorNodes.size() == 0) // һ㡣
	{
		Vector4 _startPoint(polylineItem_.nStartX, polylineItem_.nStartY);
		_lineItem.vectorLines.push_back(_startPoint);
		pointList_.push_back(_lineItem);
		return;
	}
	else
	{
		Vector4 _startPoint(polylineItem_.nStartX, polylineItem_.nStartY);
		Vector4 _vecStart(polylineItem_.nStartX, - polylineItem_.nStartY);
		for (size_t _i = 0; _i < _nSize; _i++) 
		{
			NODE2D _segment = polylineItem_.vectorNodes[_i];
			if (_segment.nBulge == 0.0)
			{
				Vector4 _endPoint(polylineItem_.vectorNodes[_i].nEndX, polylineItem_.vectorNodes[_i].nEndY);
				_lineItem.vectorLines.push_back(_startPoint);
				_lineItem.vectorLines.push_back(_endPoint);
				_startPoint = Vector4(_endPoint.x, _endPoint.y);
			}
			else
			{
				Vector4 _vecEnd(_segment.nEndX, -_segment.nEndY);
				Vector4 _ptCenter(c_nINVALID_DOUBLE, c_nINVALID_DOUBLE);
				double _nRadius = c_nINVALID_DOUBLE;
				double _nStartAngle = c_nINVALID_DOUBLE;
				double _nSweptAngle = c_nINVALID_DOUBLE;

				SolveArc(_vecStart, _vecEnd, _segment.nBulge,
					&_ptCenter, &_nRadius, &_nStartAngle, &_nSweptAngle);
				ASSERT(IsValidDouble(_ptCenter.x) && IsValidDouble(_ptCenter.y));
				ASSERT(IsValidDouble(_nRadius) && DOUBLE_GREAT_ZERO(_nRadius));
				ASSERT(IsValidDouble(_nStartAngle) && 0. <= _nStartAngle && _nStartAngle < 2. * M_PI);
				ASSERT(IsValidDouble(_nSweptAngle) && -2. * M_PI <= _nSweptAngle && DOUBLE_LESS(_nSweptAngle, 2. * M_PI));

				// ȡβΪ2أǲ PIE/180 ~ PIE/3 ֮䣬Բ
				// ϣûߵİ취滭Բ3DҪӵݡ
				int _nN = Round((2. * abs(_nSweptAngle) * _nRadius) / 2.f);
				int _nMinN = max(3, Round(3. * abs(_nSweptAngle) / M_PI));
				int _nMaxN = max(3, Round(180. * abs(_nSweptAngle) / M_PI));
				_nN = min(max(_nMinN, _nN), _nMaxN);
				double _nDeltaAngle = _nSweptAngle / (double)_nN;
				for (int _i = 1; _i <= _nN; _i++)
				{
					double _nAngle = _nStartAngle + (double)_i * _nDeltaAngle;
					Vector4 _pt(_ptCenter.x + _nRadius * cos(_nAngle), _ptCenter.y + _nRadius * sin(_nAngle));
					//m_pBmpDC->LineTo((int)_pt.x, -(int)_pt.y);
					Vector4 _endPoint(_pt.x, - _pt.y);
					_lineItem.vectorLines.push_back(_startPoint);
					_lineItem.vectorLines.push_back(_endPoint);
					_startPoint = Vector4(_endPoint.x, _endPoint.y);
				}
			}
			_vecStart = Vector4(_segment.nEndX, -_segment.nEndY);
		}
	}
	lineList_.push_back(_lineItem);
}

void CNce3DViewImp_V1::DrawPolyline2D(const Polyline2D& polylineItem_)
{
	size_t _nSize = polylineItem_.vectorNodes.size();
	if (polylineItem_.vectorNodes.size() == 0) // һ㡣
	{
		m_pBmpDC->Ellipse((int)polylineItem_.nStartX, (int)polylineItem_.nStartY, (int)polylineItem_.nStartX + 1, (int)polylineItem_.nStartY + 1);
	}
	else
	{
		m_pBmpDC->MoveTo((int)polylineItem_.nStartX, (int)polylineItem_.nStartY);
		Vector4 _vecStart(polylineItem_.nStartX, -polylineItem_.nStartY);
		for (size_t _i = 0; _i < _nSize; _i++)
		{
			NODE2D _segment = polylineItem_.vectorNodes[_i];
			if (_segment.nBulge == 0.0)
			{
				m_pBmpDC->LineTo((int)polylineItem_.vectorNodes[_i].nEndX, (int)polylineItem_.vectorNodes[_i].nEndY);
			}
			else
			{
				Vector4 _vecEnd(_segment.nEndX, -_segment.nEndY);
				Vector4 _ptCenter(c_nINVALID_DOUBLE, c_nINVALID_DOUBLE);
				double _nRadius = c_nINVALID_DOUBLE;
				double _nStartAngle = c_nINVALID_DOUBLE;
				double _nSweptAngle = c_nINVALID_DOUBLE;

				SolveArc(_vecStart, _vecEnd, _segment.nBulge,
					&_ptCenter, &_nRadius, &_nStartAngle, &_nSweptAngle);
				ASSERT(IsValidDouble(_ptCenter.x) && IsValidDouble(_ptCenter.y));
				ASSERT(IsValidDouble(_nRadius) && DOUBLE_GREAT_ZERO(_nRadius));
				ASSERT(IsValidDouble(_nStartAngle) && 0. <= _nStartAngle && _nStartAngle < 2. * M_PI);
				ASSERT(IsValidDouble(_nSweptAngle) && -2. * M_PI <= _nSweptAngle && DOUBLE_LESS(_nSweptAngle, 2. * M_PI));

				// ȡβΪ2أǲ PIE/180 ~ PIE/3 ֮䣬Բ
				// ϣûߵİ취滭Բ
				int _nN = Round((2. * abs(_nSweptAngle) * _nRadius) / 2.f);
				int _nMinN = max(3, Round(3. * abs(_nSweptAngle) / M_PI));
				int _nMaxN = max(3, Round(180. * abs(_nSweptAngle) / M_PI));
				_nN = min(max(_nMinN, _nN), _nMaxN);
				double _nDeltaAngle = _nSweptAngle / (double)_nN;
				for (int _i = 1; _i <= _nN; _i++)
				{
					double _nAngle = _nStartAngle + (double)_i * _nDeltaAngle;
					Vector4 _pt(_ptCenter.x + _nRadius * cos(_nAngle), _ptCenter.y + _nRadius * sin(_nAngle));
					m_pBmpDC->LineTo((int)_pt.x, -(int)_pt.y);
				}
			}
			_vecStart = Vector4(_segment.nEndX, -_segment.nEndY);
		}
	}
}

void CNce3DViewImp_V1::DrawPolyline3D(Polyline3DList& listLines3D_, float nLineWidth_)
{
	glDisable(GL_LIGHT0);
	glDisable(GL_LIGHTING);
	glLineWidth(nLineWidth_);
	int _nSize = (int)listLines3D_.size();
	glBegin(GL_LINES);
	for (int _i = 0; _i< _nSize; _i++)
	{
		Line3DItem& _lineItem = listLines3D_[_i];
		glColor4ub(GetRValue(_lineItem.clrPenColor), GetGValue(_lineItem.clrPenColor),
			GetBValue(_lineItem.clrPenColor), 255);
		int _nLineSize = (int)_lineItem.vectorLines.size();
		for (int _j = 0; _j < _nLineSize; _j++)
		{
			Vector4 _pt = _lineItem.vectorLines[_j];
			glVertex4d(_pt.x, _pt.y, _pt.z, 1.0);
		}
	}
	glEnd();
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);
}

void CNce3DViewImp_V1::DrawPoint3D(Polyline3DList& listPoints3D_, float nPointSize_)
{
	glDisable(GL_LIGHT0);
	glDisable(GL_LIGHTING);
	glPointSize(nPointSize_);
	int _nSize = (int)listPoints3D_.size();
	glBegin(GL_POINTS);
	for (int _i = 0; _i< _nSize; _i++)
	{
		Line3DItem& _lineItem = listPoints3D_[_i];
		glColor4ub(GetRValue(_lineItem.clrPenColor), GetGValue(_lineItem.clrPenColor),
			GetBValue(_lineItem.clrPenColor), 255);
		int _nPointSize = (int)_lineItem.vectorLines.size();
		for (int _j = 0; _j < _nPointSize; _j++)
		{
			Vector4 _pt = _lineItem.vectorLines[_j];
			glVertex4d(_pt.x, _pt.y, _pt.z, 1.0);
		}
	}
	glEnd();
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);
}

void CNce3DViewImp_V1::DrawXYZ()
{
	double _nzoom = 2000000;
	glLineWidth(1);
	glColor4ub(255, 255, 255, 255);
	glBegin(GL_LINES);
	glVertex4d(1 * _nzoom, 0, 0, 1.0);
	glVertex4d(-1 * _nzoom, 0, 0, 1.0);
	glColor4ub(255, 0, 0, 255);
	glVertex4d(0, 1 * _nzoom, 0, 1.0);
	glVertex4d(0, -1 * _nzoom, 0, 1.0);
	glColor4ub(255, 0, 255, 255);
	glVertex4d(0, 0, 1 * _nzoom, 1.0);
	glVertex4d(0, 0, -1 * _nzoom, 1.0);
	glEnd();
}

//  1/4 ߸4档
void CNce3DViewImp_V1::CalculateAuxiliary()
{
	// ߸4
	//if (m_nTubeType == RoundRectTube)
	//{

	//	return;
	//}
	// ⡣
	int _nSize = (int)m_vectorTransform3D.size();
	int _nAuxiSize = _nSize / 4;
	//Ȱѻ4Žȥ
	g_gpcConvertHelper.Initialize(m_vectorTransform3D, m_nMaxWidth);
	// ͵һͬ
	for (int _i = 0; _i< _nAuxiSize; _i++)
	{
		TransformData3D _itemData = m_vectorTransform3D[_i];
		_itemData.nStartX2D += m_nMaxWidth;
		_itemData.nEndX2D += m_nMaxWidth;
		m_vectorTransform3D.push_back(_itemData);
	}

	// ҪοյĶ
	m_vectorCutData3D.clear();
	m_vectorCutData3D.resize(_nSize);
}

void CNce3DViewImp_V1::PushVector3D(Vector4 vecStart_, Vector4 vecEnd_, double nStartTexCood_, double nEndTexCood_)
{
	m_vectorTexs.push_back(Vector4(nStartTexCood_, 0));
	m_vectorTexs.push_back(Vector4(nStartTexCood_, 1));
	m_vectorTexs.push_back(Vector4(nEndTexCood_, 1));
	m_vectorTexs.push_back(Vector4(nEndTexCood_, 0));
	Vector4 _vecVTs[3];
	Vector4 _vecVt = vecStart_;
	m_vectorVTs.push_back(_vecVt);
	_vecVTs[0] = _vecVt;
	_vecVt.y = -_vecVt.y;
	m_vectorVTs.push_back(_vecVt);
	_vecVTs[1] = _vecVt;
	_vecVt = vecEnd_;
	_vecVt.y = -_vecVt.y;
	m_vectorVTs.push_back(_vecVt);
	_vecVTs[2] = _vecVt;
	_vecVt.y = -_vecVt.y;
	m_vectorVTs.push_back(_vecVt);
	m_vectorNormals.push_back(GetNormalVector(_vecVTs[0], _vecVTs[1], _vecVTs[2]));

	// ת
	TransformData3D _tData3D;
	_tData3D.nStartX2D = nStartTexCood_ * m_nMaxWidth;
	_tData3D.nEndX2D = nEndTexCood_ * m_nMaxWidth;
	_tData3D.nX3D = vecStart_.x;
	_tData3D.nZ3D = vecStart_.z;
	double _nStep2D = _tData3D.nEndX2D - _tData3D.nStartX2D;
	double _nStepX2D = vecEnd_.x - vecStart_.x;
	double _nStepZ2D = vecEnd_.z - vecStart_.z;
	if (DOUBLE_EQU_ZERO(_nStep2D))
		return;
	_tData3D.nXRatio = _nStepX2D / _nStep2D;
	_tData3D.nZRatio = _nStepZ2D / _nStep2D;
	_tData3D.nY = m_nTubeHeight;
	m_vectorTransform3D.push_back(_tData3D);
}

void CNce3DViewImp_V1::Redraw()
{
	glClearColor(GLfloat(GetRValue(m_clrBackground)) / 255.0f,
		GLfloat(GetGValue(m_clrBackground)) / 255.0f, GLfloat(GetBValue(m_clrBackground)) / 255.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	if (m_bMaterialLight)
	{
		glPushMatrix();
		glLoadIdentity();
		const static GLfloat _nLightPosition[] = {0.0f, 35.0f, 50.0f, 0.0f};             // Դλ
		const static GLfloat _nSpotLightDirectin[] = {0.0f, 0.0f, -1.0f, 1.0f};          // ۹Ƶķ
		glLightfv(GL_LIGHT0, GL_POSITION, _nLightPosition);
		glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, _nSpotLightDirectin);
		glPopMatrix();
	}

	if (m_bDrawTube)
	{
		if (m_nTubeType == QuadTube)
			_DrawQuadTube();
		else if (m_nTubeType == CircularTube)
			_DrawCircularTube();
		else if (m_nTubeType == RoundRectTube)
			_DrawQuadTube();
		else if (m_nTubeType == EllipseTube)
			_DrawCircularTube();
		else
			ASSERT(false);
	}
	DrawPoint3D(m_vectorBasePoints, 2);
	glPushMatrix();
	glScaled(1.005, 1., 1.005);
	DrawPolyline3D(m_vectorAddDatas, 3);
	glPopMatrix();
	DrawPolyline3D(m_vectorBaseDatas, 2);
	if (m_bShowCoordinate)
		DrawXYZ();
	::SwapBuffers(m_hDC);
}

inline void VectorNormalize(Vector4& vec_)
{
	double _nNormalize = 1.0f;
	_nNormalize =(double)sqrt(vec_.x * vec_.x + vec_.y * vec_.y + vec_.z * vec_.z);
	if (IsZero(_nNormalize))
	{
		return;
	}
	_nNormalize = 1 / _nNormalize;
	vec_.x *= _nNormalize;
	vec_.y *= _nNormalize;
	vec_.z *= _nNormalize;
}

inline Vector4 VectorCross(const Vector4 &vec1_, const Vector4 &vec2_)
{
	Vector4 _vecRet;
	_vecRet.x = vec1_.y * vec2_.z - vec2_.y * vec1_.z;
	_vecRet.y = vec1_.z * vec2_.x - vec1_.x * vec2_.z;
	_vecRet.z = vec1_.x * vec2_.y - vec2_.x * vec1_.y;
	return _vecRet;
}

inline double VectortLength(const Vector4 &vec_)
{
	double _nValue = vec_.x * vec_.x
		+ vec_.y * vec_.y
		+ vec_.z * vec_.z;
	return sqrt(_nValue);
}

inline Vector4 VectorSub(const Vector4 &vec1_, const Vector4 &vec2_)
{
	Vector4 _vecRet;
	_vecRet.x = vec1_.x - vec2_.x;
	_vecRet.y = vec1_.y - vec2_.y;
	_vecRet.z = vec1_.z - vec2_.z;
	return _vecRet;
}

inline Vector4 VectorAdd(const Vector4 &vec1_, const Vector4 &vec2_)
{
	Vector4 _vecRet;
	_vecRet.x = vec1_.x + vec2_.x;
	_vecRet.y = vec1_.y + vec2_.y;
	_vecRet.z = vec1_.z + vec2_.z;
	return _vecRet;
}

inline Vector4 VectorMultiply(const Vector4 &vec1_, const double nNum_)
{
	Vector4 _vecRet;
	_vecRet.x = vec1_.x * nNum_;
	_vecRet.y = vec1_.y * nNum_;
	_vecRet.z = vec1_.z * nNum_;
	return _vecRet;
}

Vector4 GetNormalVector(const Vector4 &vec1_, const Vector4 &vec2_, const Vector4 &vec3_)
{
	Vector4 _vec1 = VectorSub(vec1_, vec2_);
	Vector4 _vec2 = VectorSub(vec3_, vec2_);
	Vector4 _vecRet = VectorCross(_vec1, _vec2);
	VectorNormalize(_vecRet);
	return _vecRet;
}

void SolveArc(IN Vector4 ptStart_,
			  IN Vector4 ptEnd_,
			  IN double nBulge_,
			  OUT Vector4* pptCenter_,
			  OUT double* pnRadius_,
			  OUT double* pnStartAngle_,
			  OUT double* pnSweptAngle_)
{
	//  
	if (DOUBLE_LE_ZERO(VectortLength(VectorSub(ptEnd_, ptStart_))) || DOUBLE_EQU_ZERO(nBulge_))
	{
		ASSERT(FALSE);
		return;
	}

	if (!pptCenter_ && !pnRadius_ && !pnStartAngle_ && !pnSweptAngle_)
		return;

	// Ҽҳ 
	Vector4 _vecChord =VectorSub(ptEnd_, ptStart_);
	double _nChordLen = VectortLength(_vecChord);
	ASSERT(DOUBLE_GREAT_ZERO(_nChordLen));

	// Ľǣչ 
	double _nAlpha = 4. * atan(nBulge_);
	ASSERT(DOUBLE_NOT_ZERO(_nAlpha));
	ASSERT(_nAlpha < 2. * M_PI && _nAlpha > -2. * M_PI);
	if (pnSweptAngle_)
		*pnSweptAngle_ = _nAlpha;

	// 뾶 
	double _nRadius = abs((_nChordLen * 0.5) / sin(_nAlpha * 0.5));
	if (pnRadius_)
		*pnRadius_ = _nRadius;

	// Բ 
	double _nCenterToChord = abs(_nRadius * cos(_nAlpha * 0.5));
	Vector4 _ptMidChord = VectorMultiply(VectorAdd(ptStart_, ptEnd_), 0.5);
	Vector4 _vecMidChordToCenter(-1. * _vecChord.y, _vecChord.x);
	VectorNormalize(_vecMidChordToCenter);
	_vecMidChordToCenter = VectorMultiply(_vecMidChordToCenter, _nCenterToChord);
	if (nBulge_ < 0.0 && nBulge_ > -1.0 ||
		nBulge_ > 0.0 && nBulge_ > 1.0)
	{
		_vecMidChordToCenter = VectorMultiply(_vecMidChordToCenter, -1.);
	}

	Vector4 _ptCenter = VectorAdd(_ptMidChord, _vecMidChordToCenter);
	if (pptCenter_)
		*pptCenter_ = _ptCenter;

	// ʼ 
	double _nStartAngle = atan2(ptStart_.y - _ptCenter.y, ptStart_.x - _ptCenter.x);
	ASSERT(IsValidDouble(_nStartAngle) && _nStartAngle <= M_PI && _nStartAngle >= -1.0 * M_PI);
	_nStartAngle += 2.0 * M_PI;
	if (_nStartAngle >= 2.0 * M_PI)
		_nStartAngle -= 2.0 * M_PI;

	ASSERT(_nStartAngle >= 0.0 && _nStartAngle < 2.0 * M_PI);
	if (pnStartAngle_)
		*pnStartAngle_ = _nStartAngle;
}

Vector4 UnGLPick(Vector4& vt_)
{
	Vector4 _vtRet;
	double _nWinX = 0;
	double _nWinY = 0;
	double _nWinZ = 0;
	int _nViewport[4];
	double _nModelMatrix[16], _nProjMatrix[16];
	glReadBuffer(GL_BACK);
	glGetIntegerv(GL_VIEWPORT, _nViewport);
	glGetDoublev(GL_MODELVIEW_MATRIX, _nModelMatrix);
	glGetDoublev(GL_PROJECTION_MATRIX, _nProjMatrix);
	gluProject(vt_.x, vt_.y, vt_.z, _nModelMatrix, _nProjMatrix, _nViewport, &_nWinX, &_nWinY, &_nWinZ);
	_vtRet.x = _nWinX;
	_vtRet.y = _nViewport[3] - _nWinY;        //ϽΪԭ - ֵ
	return _vtRet;
}

// Ļϵ pick top point ----  2016-11-07
Vector4 GLPick(Vector4& vt_)
{
	int _nViewport[4];
	double _nModelMatrix[16], _nProjMatrix[16];
	Vector4 _vtRet;
	glReadBuffer(GL_BACK);
	glGetIntegerv(GL_VIEWPORT, _nViewport);
	glGetDoublev(GL_MODELVIEW_MATRIX, _nModelMatrix);
	glGetDoublev(GL_PROJECTION_MATRIX, _nProjMatrix);
	double _nGLX = 0, _nGLY = 0, _nGLZ = 0;
	gluUnProject(vt_.x, _nViewport[3] - vt_.y, 0, _nModelMatrix, _nProjMatrix, _nViewport, &_nGLX, &_nGLY, &_nGLZ);
	_vtRet = Vector4(_nGLX, _nGLY,_nGLZ,1);
	return _vtRet;
}

double GetEllipsePerimeter(double nLongRadius_,double nShortRadius_)
{
	double _nEccentricity = sqrt(pow(nLongRadius_, 2) - pow(nShortRadius_, 2)) / nLongRadius_;
	ASSERT((nLongRadius_ >= nShortRadius_) && DOUBLE_GREAT_ZERO(nShortRadius_));
	ASSERT((_nEccentricity >= 0.) && (_nEccentricity <= 1.0));
	if ((_nEccentricity < 0.) || (_nEccentricity > 1.0))
	{
		ASSERT(false);
		return 0.;
	}

	// ڶȫԲ֣Matlabellipke.mеõ
	double m = _nEccentricity * _nEccentricity;
	double a0 = 1.0;
	double b0 = sqrt(1.0 - m);
	double s0 = m;
	int i1 = 0;
	double a1 = 1.0;
	double mm = 1.0;
	while (mm > c_nTolerance)
	{
		a1 = (a0 + b0) * 0.5;
		double b1 = sqrt(a0 * b0);
		double c1 = (a0 - b0) * 0.5;
		double w1 = (2 << i1++) * (c1 * c1);
		mm = w1;
		s0 += w1;
		a0 = a1;
		b0 = b1;
	}

	double k = M_PI / (2.0 * a1);
	double e = k * (1.0 - s0 * 0.5);

	// Բܳ
	double _nPerimeter = 4.0 * nLongRadius_ * e;
	return _nPerimeter;
}

int TransformData3D::Contain(double x)
{
	if (x < nStartX2D) //߳
		return -1;
	else if(x > nEndX2D) // ұ߳
		return -2;
	return 0;
}

bool TransformData3D::Contain(Vector4& pt_)
{
	if (pt_.x >= nStartX2D && pt_.x <= nEndX2D && pt_.y >= 0 && pt_.y <= nY)
		return true;
	return false;
}

Vector4 TransformData3D::Point2DToPoint3D(Vector4& pt_)
{
	Vector4 _retPt3D;
	double _nStep = (pt_.x - nStartX2D);
	_retPt3D.x = nX3D + nXRatio * _nStep;
	_retPt3D.z = nZ3D + nZRatio * _nStep;
	_retPt3D.y = nY * 0.5 - pt_.y;
	if (_retPt3D.y > nY * 0.5)
		_retPt3D.y = nY * 0.5;
	if (_retPt3D.y < -nY * 0.5)
		_retPt3D.y = -nY * 0.5;
	return _retPt3D;
}

// תڼĶ ----  2016-12-19
void GPCConvertHelper::_convertPolygon(IN const Polyline2DList& listPolylines_, OUT std_polygon_list& listPolygons_)
{
	for (Polyline2DList::const_iterator _it = listPolylines_.begin(); _it != listPolylines_.end(); _it++)
	{
		const Polyline2D& _polylineItem = _it->PolylineNode;
		int _nSize = (int)(_polylineItem.vectorNodes.size());
		std_vertex_list _gpcPolygon;
		gpc_vertex _gpcPoint;
		_gpcPoint.x = _polylineItem.nStartX;
		_gpcPoint.y = _polylineItem.nStartY;
		_gpcPolygon.push_back(_gpcPoint);
		for (int _i = 0;_i < _nSize; _i++)
		{
			_gpcPoint.x = _polylineItem.vectorNodes[_i].nEndX;
			_gpcPoint.y = _polylineItem.vectorNodes[_i].nEndY;
			_gpcPolygon.push_back(_gpcPoint);
		}
		listPolygons_.push_back(_gpcPolygon);
	}
}

void GPCConvertHelper::_get_MinMax_width(IN std_vertex_list& polygon_, double& nMin_, double& nMax_)
{
	int _nSize = static_cast<int>(polygon_.size());
	ASSERT(_nSize > 0);
	nMax_ = nMin_ = polygon_[0].x;
	for (int _i = 0; _i < _nSize; _i++)
	{
		nMax_ = max(polygon_[_i].x, nMax_);
		nMin_ = min(polygon_[_i].x, nMin_);
	}
}

inline int GPCConvertHelper::_IsInArea(int id_, double& nMin_, double& nMax_)
{
	ASSERT(m_pRootAreaData);
	ASSERT(id_ >= 0 && id_ < static_cast<int>(m_pRootAreaData->size()));
	TransformData3D& _Transform3DItem = (*m_pRootAreaData)[id_];
	if (_Transform3DItem.Contain(nMin_) == -2) //ұ
		return 1;
	if (_Transform3DItem.Contain(nMax_) == -1) //
		return 2;
	return 0;
}

void GPCConvertHelper::_set_offset_polygon(IN OUT std_vertex_list& polygonSrc_, double nOffset_)
{
	int _nSize = static_cast<int>(polygonSrc_.size());
	for (int _i = 0; _i < _nSize; _i++)
	{
		polygonSrc_[_i].x = polygonSrc_[_i].x + nOffset_;
	}
}

// ת opengl ֻʶ͹ΣǷŵӦָ ----  2016-12-19
void GPCConvertHelper::_gpc_convert_tristrip(IN std_vertex_list& polygon_, double nMin_, double nMax_,
											 OUT Polygon3DListGroup& listCutOffDatas_, ConvertType_t nConvertType_)
{
	ASSERT(m_vectorBaseArea.size() > 0);
	ASSERT(listCutOffDatas_.size() == m_vectorBaseArea.size());
	ASSERT(nConvertType_ == Convert_All || nConvertType_ == Convert_Part1_4);
	int _nSize = static_cast<int>(m_vectorBaseArea.size());
	ASSERT(_nSize % 4 == 0);
	if (nConvertType_ == Convert_Part1_4)
		_nSize = _nSize / 4;
	for (int _i = 0; _i < _nSize; _i++)
	{
		int _nRet = _IsInArea(_i, nMin_, nMax_);
		if (_nRet == 1) // ұ
			continue;
		if (_nRet == 2) // 
			break;
		std_vertex_list& _item = m_vectorBaseArea[_i];
		gpc_vertex_list _gpc_src;
		gpc_vertex_list _gpc_dst;
		gpc_polygon _polygonSrc;
		gpc_polygon _polygonDst;
		gpc_tristrip _result_tristrip;
		_gpc_src.num_vertices = static_cast<int>(polygon_.size());
		_gpc_src.vertex = &polygon_[0];
		_polygonSrc.hole = NULL;
		_polygonSrc.num_contours = 1;
		_polygonSrc.contour = &_gpc_src;
		_gpc_dst.num_vertices = static_cast<int>(_item.size());
		_gpc_dst.vertex = &_item[0];
		_polygonDst.hole = NULL;
		_polygonDst.num_contours = 1;
		_polygonDst.contour = &_gpc_dst;
		gpc_tristrip_clip(GPC_INT, &_polygonSrc, &_polygonDst, &_result_tristrip);
		for (int _j = 0; _j < _result_tristrip.num_strips; _j++)
		{
			Polygon3D _newPolygon3D;
			Vector4 _point3D;
			for (int _k = 0; _k < _result_tristrip.strip[_j].num_vertices; _k++)
			{
				_point3D.x = _result_tristrip.strip[_j].vertex[_k].x;
				_point3D.y = _result_tristrip.strip[_j].vertex[_k].y;
				_newPolygon3D.push_back(_point3D);
			} 
			// ŵͬķ
			listCutOffDatas_[_i].push_back(_newPolygon3D);
		}
		gpc_free_tristrip(&_result_tristrip);
	}
}

// 2άת3ά cut off  ----  2016-12-16
void GPCConvertHelper::ConvertCutOffArea(IN const Polyline2DList& listRecords_, OUT Polygon3DListGroup& listCutOffDatas_, ExpandType_t nExpandType_)
{
	ASSERT(listCutOffDatas_.size() == m_vectorBaseArea.size());
	ASSERT(nExpandType_ == Expand_One || nExpandType_ == Expand_All || nExpandType_ == Expand_4V4);
	std_polygon_list _listPolygons;
	_convertPolygon(listRecords_, _listPolygons);
	int _nSize = static_cast<int>(_listPolygons.size());
	for (int _i = 0; _i < _nSize; _i++)
	{
		double _nMinWidth = 0 , _nMaxWidth = 0;
		_get_MinMax_width(_listPolygons[_i], _nMinWidth, _nMaxWidth);
		if (nExpandType_ == Expand_One)				// һ
		{
			_gpc_convert_tristrip(_listPolygons[_i], _nMinWidth, _nMaxWidth, listCutOffDatas_, Convert_All);
			if (_nMaxWidth > m_nWidth)
			{
				_set_offset_polygon(_listPolygons[_i], -m_nWidth);
				_gpc_convert_tristrip(_listPolygons[_i], _nMinWidth - m_nWidth, _nMaxWidth - m_nWidth, listCutOffDatas_, Convert_Part1_4);
			}
		}
		else if(nExpandType_ == Expand_4V4) // ұ߸4
		{
			_set_offset_polygon(_listPolygons[_i], m_nWidth);
			_gpc_convert_tristrip(_listPolygons[_i], _nMinWidth + m_nWidth, _nMaxWidth + m_nWidth, listCutOffDatas_, Convert_All);

			_set_offset_polygon(_listPolygons[_i], -m_nWidth);
			_gpc_convert_tristrip(_listPolygons[_i], _nMinWidth, _nMaxWidth, listCutOffDatas_, Convert_All);

			_set_offset_polygon(_listPolygons[_i], -m_nWidth);
			_gpc_convert_tristrip(_listPolygons[_i], _nMinWidth - m_nWidth, _nMaxWidth - m_nWidth, listCutOffDatas_, Convert_All);
		}
		else									// е
		{
			int _nStart = 0;
			int _nEnd = 0;
			double _nDiv = _nMinWidth / m_nWidth;
			_nStart = (int)floor(_nDiv);
			_nDiv = _nMaxWidth / m_nWidth;
			_nEnd = (int)floor(_nDiv);
			_set_offset_polygon(_listPolygons[_i], -_nStart * m_nWidth);
			for (int _j = _nStart; _j <= _nEnd; _j++)
			{
				_gpc_convert_tristrip(_listPolygons[_i],_nMinWidth - _j * m_nWidth, _nMaxWidth - _j * m_nWidth, listCutOffDatas_, Convert_All);
				_set_offset_polygon(_listPolygons[_i], -m_nWidth);
			}
		}
	}
}

void GPCConvertHelper::_convertArea(IN const TransformData3D& area_, OUT std_vertex_list& areaVertexs_)
{
	gpc_vertex _gpcPoint;
	_gpcPoint.x = area_.nStartX2D;
	_gpcPoint.y = 0;
	areaVertexs_.push_back(_gpcPoint);
	_gpcPoint.x = area_.nStartX2D;
	_gpcPoint.y = area_.nY;
	areaVertexs_.push_back(_gpcPoint);
	_gpcPoint.x = area_.nEndX2D;
	_gpcPoint.y = area_.nY;
	areaVertexs_.push_back(_gpcPoint);
	_gpcPoint.x = area_.nEndX2D;
	_gpcPoint.y = 0;
	areaVertexs_.push_back(_gpcPoint);
	_gpcPoint.x = area_.nStartX2D;
	_gpcPoint.y = 0;
	areaVertexs_.push_back(_gpcPoint);
}

void GPCConvertHelper::Initialize(Transform3DList& listData_, double nWidth_)
{
	m_pRootAreaData = &listData_;
	m_vectorBaseArea.clear();
	int _nSize = static_cast<int>(listData_.size());
	for (int _i = 0; _i < _nSize; _i++)
	{
		TransformData3D& _item = listData_[_i];
		std_vertex_list _newArea;
		_convertArea(_item, _newArea);
		m_vectorBaseArea.push_back(_newArea);
	}
	m_nWidth = nWidth_;
}