// TraceCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "TrackCtrl.h"
#include "TraceCtrlCustomizeDlg.h"
#include "TCACCDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Constants and definitions
double g_ratio[RATIO_COUNT] = 
{
	5.0e-2,		//5%
	1.0e-1,		//10%
	2.0e-1,		//20%
	5.0e-1,		//50%
	1.0e0,		//100%
	2.0e0,		//200%
	5.0e0,		//500%
	1.0e1,		//1000%
	2.0e1,		//2000%
	5.0e1,		//5000%
	1.0e2,		//10000%
};

const static TCHAR* s_szNCTRACEVIEW_CLASS[] ={
	_T("s_szNCTRACEVIEW_CLASS_{1E068523-505E-11D6-A9D2-0000E2556D2C}"),
	_T("s_szNCTRACEVIEW_CLASS_{34E52D98-BB3F-4B39-91A7-5B19D9CAB4CC}"),
	_T("s_szNCTRACEVIEW_CLASS_{F611121E-D9D3-4F5A-B444-45A1D54156FF}"),
	_T("s_szNCTRACEVIEW_CLASS_{46C3B512-EE07-4127-AADE-A318F6B7CB7D}"),
};

/***********************************************************************
꣬ṩCTraceCtrlBaseʵͬķFUNCTIONҪͬ
ơ
**********************************************************************/

/////////////////////////////////////////////////////////////////////////////
//

// TODO zhengzhikai 2017-12-7 Żmemcpy
inline void _tam(TRANSMATRIX* pP_, TRANSMATRIX* pM1_, TRANSMATRIX* pM2_)
{
	TRANSMATRIX	_matrix;
	for (int _row = 0; _row < 3; _row++)
		for (int _col = 0; _col < 3; _col++)
		{
			_matrix[_row][_col]	= (*pM1_)[_row][0] * (*pM2_)[0][_col] + 
								  (*pM1_)[_row][1] * (*pM2_)[1][_col] +
								  (*pM1_)[_row][2] * (*pM2_)[2][_col];
		}
		memcpy(pP_, &_matrix, sizeof(_matrix));
		return;
}
/////////////////////////////////////////////////////////////////////////////
// CTraceCtrl
IMPLEMENT_DYNAMIC(CTraceCtrl, CWnd)

BEGIN_MESSAGE_MAP(CTraceCtrl, CWnd)
	//{{AFX_MSG_MAP(CTraceCtrl)
	ON_WM_CONTEXTMENU()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_MOUSEMOVE()
	ON_WM_GETDLGCODE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SETCURSOR()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_SYSKEYDOWN()
	ON_WM_WINDOWPOSCHANGED()
	ON_WM_MOUSEWHEEL()
	ON_COMMAND_RANGE(IDCMD_TRACECTRL_first, IDCMD_TRACECTRL_last, OnCommandRange)
	ON_UPDATE_COMMAND_UI_RANGE(IDCMD_TRACECTRL_first, IDCMD_TRACECTRL_last, OnUpdateCommandRange)
	ON_COMMAND(IDCMD_TRACECTRL_SYSTEM_CUSTOMIZE, OnToolCustomize)
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, &OnToolTipNeedText)  
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

GETSTRING  DataProvider::GetString = NULL;
VFUNCTION DataProvider::FreeGetStringPtr = NULL;

CTraceCtrl::CTraceCtrl()
	:CTraceCtrlBase(),
	m_nxAreaMax(0.0, 0.0, 0.0), 
	m_nxAreaMin(0.0, 0.0, 0.0),
	m_nxWorkcoorOrg(0.0, 0.0, 0.0)
{
	//{{AFX_DATA_FIELD default value
	memset(m_clrPens, 0, sizeof(m_clrPens));	// initialize to RGB(0, 0, 0)
	m_clrPens[PEN_G00] = RGB(255, 255 , 0);
	m_clrPens[PEN_G01] = RGB(0, 255, 255);
	m_clrPens[PEN_G02] = RGB(0, 255, 255);
	m_clrPens[PEN_G03] = RGB(0, 255, 255);
	//
	m_clrPens[PEN_G00_SIMU] =RGB(0,0,0);;
	m_clrPens[PEN_G01_SIMU] = RGB(0, 0, 128);
	m_clrPens[PEN_G02_SIMU] = RGB(0, 0, 128);
	m_clrPens[PEN_G03_SIMU] = RGB(0, 0, 128);
	//
	m_clrPens[PEN_RULER] = RGB(0, 0, 0);
	m_clrPens[PEN_GRID] = RGB(128, 0, 128);
	//
	m_clrPens[PEN_COOR] = RGB(0, 255, 0);
	m_clrPens[PEN_COORDARKEN] = RGB(0, 128, 0);
	m_clrPens[PEN_SELECTED] = RGB(0, 255, 0);
	//
	m_clrTrackBkFrom = RGB(0,0,0);//RGB(163, 113, 217);
	m_clrTrackLineNum = RGB(0, 0, 0);   
	m_clrTrackBkTo =RGB(0,0,0); //RGB(0, 0, 128);
	m_clrPens[PEN_STARTPOINT] = CLR_TRANSPARENT;

	m_bGradientFill = true;
	m_bDrawWorkAreaFrame = true;
	m_bShowCoor = true;
	m_bDrawGrid = false;
	m_b2DMode = false;
	m_bIsFileTrackFirst = true;
	m_bInitPerDoc = false;
	m_bIsShowLineNumber = false;
	//}}AFX_DATA_FIELD end

	m_clrBackground = RGB(255,255,255);//GetSysColor(COLOR_3DFACE);ĳɰɫ
	m_clrShadow = GetSysColor(COLOR_3DFACE);
	m_clrHilit = GetSysColor(COLOR_3DHILIGHT);
	
	m_clrBorder = CLR_TRANSPARENT;
	m_nBorderFormat = 0;
	m_nShowSpeed = _SHOW_SPEED_NO;

	// then load the saved parameters
	m_ptCross.x = m_ptCross.y = m_ptCross.z = c_nINVALID_NCNODEEX_REAL;
	m_WorkAreaMin.x = m_WorkAreaMin.y = m_WorkAreaMin.z = 0.0;
	m_WorkAreaMax.x = m_WorkAreaMax.y = m_WorkAreaMax.z = 500.0;

	m_nOperation = MOVE;
	m_nSelectMode = CTrackRecorder::OR;
	m_bReceiveArrowMsgs = false;

	m_nCoorX = 0;
	m_nNumofRecordToPaint = 0;
	m_nLastGType = 0;
	m_nProjectMode = PROJ_ISOMETRIC_SE;
	SetTransformMatrix(m_b2DMode ? PROJ_TOP : PROJ_ISOMETRIC_SE);

	RegisterWndClass();

	m_dc.m_pGPen = m_pens;
	m_dc.m_pSelectedLinePen = &m_pens[PEN_SELECTED];

	m_HitField.from = m_HitField.to = -1;

	m_bIsSimu = m_bPageFault = false;
	m_nFileTrackSize = 0;
	m_bSimulating = false;
	m_nCompressNccmd_Old = 2;	// not accessed yet
	m_nTimerCounter = 0;
	m_nClassNameIndex = 0;
	CreatContextMenu(true);
	m_nAccKey = 'S';
	m_bUpdateTrackUI = false;
	rectDC=NULL;
	rectBmp=NULL;

	m_dataprovider = new DataProvider;

	memset(m_LastNccmd, 0, sizeof(m_LastNccmd));

	m_bTrackLoaded = false;
}

CTraceCtrl::~CTraceCtrl()
{
	if(rectDC != NULL)	delete rectDC;
	if(rectBmp != NULL)  delete rectBmp;
	if(m_dataprovider!=NULL) delete m_dataprovider;
	if(s_szAxisName != NULL) delete[] s_szAxisName;
}

BOOL CTraceCtrl::RegisterWndClass()
{
	static int _s_nRegister = -1;

	_s_nRegister++;
	
	if(_s_nRegister > 3)
		return false;

	m_nClassNameIndex = _s_nRegister;

	WNDCLASS _wndcls;
	memset(&_wndcls, 0, sizeof(WNDCLASS));   // start with NULL defaults
	_wndcls.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	_wndcls.lpfnWndProc = ::DefWindowProc;
	_wndcls.hInstance = AfxGetInstanceHandle();
	_wndcls.hCursor = ::LoadCursor(NULL, IDC_ARROW);
	_wndcls.hbrBackground =(HBRUSH)(COLOR_WINDOW + 1);
	_wndcls.lpszClassName = s_szNCTRACEVIEW_CLASS[m_nClassNameIndex];
	//_wndcls.lpszClassName = s_szNCTRACEVIEW_CLASS;

	//_s_bRegister = RegisterClass(&_wndcls);
	return RegisterClass(&_wndcls);
}

BOOL CTraceCtrl::PreCreateWindow(CREATESTRUCT& cs_)
{
	cs_.lpszClass = s_szNCTRACEVIEW_CLASS[m_nClassNameIndex];
	return CWnd::PreCreateWindow(cs_);
}

//LPCTSTR CTraceCtrl::GetTraceWndClassName()
//{
//	return s_szNCTRACEVIEW_CLASS;
//}

void CTraceCtrl::Initialize()
{
	double _naxes = m_dataprovider->GetAxesNumber();
	if(_naxes > 0)
	{
		m_nAxesNumber = (int)_naxes;
		s_szAxisName = new LPCTSTR[(int)_naxes]();

		for(int i = 0 ;i<_naxes;i++)
		{
			s_szAxisName[i] = m_dataprovider->GetAxisName(i);
		}
	}
	else
	{
		s_szAxisName = new LPCTSTR[c_nNUMOF_AXIS];
		for(int i=0;i<c_nNUMOF_AXIS;i++)
		{
			switch(i)
			{
			case 0:
					s_szAxisName[i] = _T("X");
				break;
			case 1:
					s_szAxisName[i] = _T("Y");
				break;
			case 2:
					s_szAxisName[i] = _T("Z");
				break;
			default:
				break;
			}
		}
	}

	UpdateDrawingTools();
	UpdateChanges(true);

	//AXDOUBLE_KERNEL _cur = m_pTrackProvider->GetCurPos();

	AXDOUBLE_KERNEL _cur = GetCurPos(); //add yuewenxue
	NCNODEEX::POINT3D _pos((NCNODEEX::REAL)_cur[m_nX],
		(NCNODEEX::REAL)_cur[m_nY], (NCNODEEX::REAL)_cur[m_nZ]);

	m_ptLastPoint.x = _pos.x;
	m_ptLastPoint.y = _pos.y;
	m_ptLastPoint.z = _pos.z;

	SetTimer(IDTIMER_READNCCMD, 83, NULL);
	SetTimer(IDTIMER_CONTINUE_PLAYBACK, c_nCONTINUEPLAYBACK_TIMER_INTERVAL, NULL);

	if (!m_TrackRecord.IsOpen())
	{
		if (!m_TrackRecord.Open())
			ShowMessage(s_csCREATE_TEMPFILE_ERROR,LOG_ERROR);
	}

	m_dc.SetLogicalRef(m_ptLastPoint.x, m_ptLastPoint.y);
	ClearView();
	CenterCursor();
	OnCommandRange(IDCMD_TRACECTRL_FITWINDOW);
	return;
}

void CTraceCtrl::CreatContextMenu(bool bHasContextMenu_)
{
    if(m_contextMenu != NULL)
	{
		m_contextMenu.DestroyMenu();
	}

	if(bHasContextMenu_ == true)
	{
	  m_contextMenu.CreatePopupMenu();
	}

	if(IsMenu(this->m_contextMenu))
	{
		TCHAR _szTempString[256];
		GetString(L"s_csTRACECTRL_CLEARVIEW",_szTempString, _countof(_szTempString), s_csTRACECTRL_CLEARVIEW);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_CLEARVIEW,_szTempString);
		m_contextMenu.AppendMenu(MF_SEPARATOR);
		GetString(L"s_csTRACECTRL_MOVE",_szTempString, _countof(_szTempString), s_csTRACECTRL_MOVE);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_MOVE,_szTempString);
		GetString(L"s_csTRACECTRL_ZOOMOUT",_szTempString, _countof(_szTempString), s_csTRACECTRL_ZOOMOUT);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_ZOOMOUT,_szTempString);
		GetString(L"s_csTRACECTRL_ZOOMIN",_szTempString, _countof(_szTempString), s_csTRACECTRL_ZOOMIN);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_ZOOMIN,_szTempString);
		GetString(L"s_csTRACECTRL_CENTER",_szTempString, _countof(_szTempString), s_csTRACECTRL_CENTER);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_CENTER,_szTempString);
		GetString(L"s_csTRACECTRL_FITWINDOW",_szTempString, _countof(_szTempString), s_csTRACECTRL_FITWINDOW);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_FITWINDOW,_szTempString);
		GetString(L"s_csTRACECTRL_CURRENT",_szTempString, _countof(_szTempString), s_csTRACECTRL_CURRENT);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_CURRENT,_szTempString);
		GetString(L"s_csTRACECTRL_CUSTOMIZE",_szTempString, _countof(_szTempString), s_csTRACECTRL_CUSTOMIZE);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_SYSTEM_CUSTOMIZE,_szTempString);
		m_contextMenu.AppendMenu(MF_SEPARATOR);
		GetString(L"s_csTRACECTRL_PROJ_FRONT",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_FRONT);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_FRONT,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_BACK",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_BACK);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_BACK,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_TOP",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_TOP);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_TOP,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_BOTTOM",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_BOTTOM);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_BOTTOM,_szTempString);
	    GetString(L"s_csTRACECTRL_PROJ_LEFT",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_LEFT);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_LEFT,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_RIGHT",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_RIGHT);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_RIGHT,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_ISOMETRIC_SW",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_ISOMETRIC_SW);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_ISOMETRIC_SW,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_ISOMETRIC_NW",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_ISOMETRIC_NW);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_ISOMETRIC_NW,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_ISOMETRIC_SE",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_ISOMETRIC_SE);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_ISOMETRIC_SE,_szTempString);
		GetString(L"s_csTRACECTRL_PROJ_ISOMETRIC_NE",_szTempString, _countof(_szTempString), s_csTRACECTRL_PROJ_ISOMETRIC_NE);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_PROJ_ISOMETRIC_NE,_szTempString);
		m_contextMenu.AppendMenu(MF_SEPARATOR);
		GetString(L"s_csTRACECTRL_LOAD_TRACK",_szTempString, _countof(_szTempString), s_csTRACECTRL_LOAD_TRACK);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_LOAD_TRACK,_szTempString);
		GetString(L"s_csTRACECTRL_STOP_LOAD_TRACK",_szTempString, _countof(_szTempString), s_csTRACECTRL_STOP_LOAD_TRACK);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_STOP_LOAD_TRACK,_szTempString);
		GetString(L"s_csTRACECTRL_CLEAR_TRACK",_szTempString, _countof(_szTempString), s_csTRACECTRL_CLEAR_TRACK);
		m_contextMenu.AppendMenu(MF_STRING,IDCMD_TRACECTRL_CLEAR_TRACK,_szTempString);
	}
}

void CTraceCtrl::EnableTimer(bool bOn_)
{
	if (bOn_)
	{
		UpdateChanges(false);
		SetTimer(IDTIMER_CONTINUE_PLAYBACK, c_nCONTINUEPLAYBACK_TIMER_INTERVAL, NULL);
	}
	else
	{
		KillTimer(IDTIMER_CONTINUE_PLAYBACK);

		// reset it, so that UpdateChanges() can be called at the next timer on.
		m_nTimerCounter = 0;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTraceCtrl general operations

void CTraceCtrl::ClearView()
{
	//עͷڴ⣬̵߳ддڴ档 add yuewenxue
	// (0) close the track recorder to free memory

	KillDrawTimer();
	m_TrackRecord.Close();
	if (!m_TrackRecord.Open())
		ShowMessage(s_csCREATE_TEMPFILE_ERROR,LOG_ERROR);
	ResetDrawTimer();

	// (1) clear the track recorder
	//ʱҪ¼ϸ add ywx
	NCNODEEX _rec; 
	_rec.bSelected = false;
	_rec.nGType = 0;
	_rec.pt3D.x = (NCNODEEX::REAL)m_ptLastPoint.x;
	_rec.pt3D.y = (NCNODEEX::REAL)m_ptLastPoint.y;
	_rec.pt3D.z = (NCNODEEX::REAL)m_ptLastPoint.z;
	_rec.nFilePos = m_nLastFP;
	_rec.nLineOrID = m_nLastLineNoOrID; 
	_rec.nOffset = m_nOffset;
	_rec.nFileType = m_nFileType;
	_rec.pt2D.x = _rec.pt2D.y = -1;
	m_TrackRecord.Reset(&_rec);

	// (2) clear the trace bound rectangle
	m_TraceArea.Clear();

	// (3) clear the track bitmap in the playbck DC
	m_dc.m_nNextPoint = 0;

	// (4) last, invalidate the whole view
	if (m_hWnd)
		InvalidateRect(NULL);
}

void CTraceCtrl::ClearTrackRecordPosInfo()
{
	NCNODEEX* _pRec = m_TrackRecord.GetBase();
	int _nCount =  m_TrackRecord.GetSize();
	for (int _i = 0; _i < _nCount; _i++)
	{
		_pRec->nFilePos = EOF;
		_pRec->nLineOrID = 0; 
		_pRec->nOffset = 0;
		_pRec++;
	}
}

void CTraceCtrl::CalculateLayout(int cx_, int cy_)
{
	m_rcSpeed.left = c_nVIEW_EDGE;
	m_rcSpeed.top = c_nVIEW_EDGE;
	m_rcSpeed.right = cx_ - c_nVIEW_EDGE;
	m_rcSpeed.bottom = cy_ - c_nVIEW_EDGE;

	if (m_dc.SetDimension(cx_, cy_) && m_hWnd)
		InvalidateRect(NULL);
}

void CTraceCtrl::UpdateChanges(bool bArbitrary_)
{
	bool _bDirty = bArbitrary_;
	bool _AreaChanged = false;
	bool _bSimu = IsSimulating();

	//AXDOUBLE_KERNEL _minArea = m_pTrackProvider->GetAreaMin();
	//AXDOUBLE_KERNEL _maxArea = m_pTrackProvider->GetAreaMax(); add yuewenxue
	AXDOUBLE_KERNEL _minArea = GetAreaMin();
	AXDOUBLE_KERNEL _maxArea = GetAreaMax(); //add yuewenxue
	if (bArbitrary_ || 
		(m_nxAreaMax != _maxArea) || 
		(m_nxAreaMin != _minArea))
	{
		m_WorkAreaMax.x = (NCNODEEX::REAL)_maxArea[m_nX];	// in mm
		m_WorkAreaMax.y = (NCNODEEX::REAL)_maxArea[m_nY];	// in mm
		m_WorkAreaMax.z = (NCNODEEX::REAL)_maxArea[m_nZ];	// in mm
		m_WorkAreaMin.x = (NCNODEEX::REAL)_minArea[m_nX];	// in mm
		m_WorkAreaMin.y = (NCNODEEX::REAL)_minArea[m_nY];	// in mm
		m_WorkAreaMin.z = (NCNODEEX::REAL)_minArea[m_nZ];	// in mm

		ASSERT(m_WorkAreaMax.x >= m_WorkAreaMin.x);
		ASSERT(m_WorkAreaMax.y >= m_WorkAreaMin.y);
		ASSERT(m_WorkAreaMax.z >= m_WorkAreaMin.z);

		m_WorkAreaVertex[0].x = m_WorkAreaMin.x;
		m_WorkAreaVertex[0].y = m_WorkAreaMin.y;
		m_WorkAreaVertex[0].z = m_WorkAreaMin.z;
		//
		m_WorkAreaVertex[1].x = m_WorkAreaMin.x;
		m_WorkAreaVertex[1].y = m_WorkAreaMax.y;
		m_WorkAreaVertex[1].z = m_WorkAreaMin.z;
		//
		m_WorkAreaVertex[2].x = m_WorkAreaMax.x;
		m_WorkAreaVertex[2].y = m_WorkAreaMin.y;
		m_WorkAreaVertex[2].z = m_WorkAreaMin.z;
		//
		m_WorkAreaVertex[3].x = m_WorkAreaMax.x;
		m_WorkAreaVertex[3].y = m_WorkAreaMax.y;
		m_WorkAreaVertex[3].z = m_WorkAreaMin.z;
		//
		m_WorkAreaVertex[4].x = m_WorkAreaMin.x;
		m_WorkAreaVertex[4].y = m_WorkAreaMin.y;
		m_WorkAreaVertex[4].z = m_WorkAreaMax.z;
		//
		m_WorkAreaVertex[5].x = m_WorkAreaMin.x;
		m_WorkAreaVertex[5].y = m_WorkAreaMax.y;
		m_WorkAreaVertex[5].z = m_WorkAreaMax.z;
		//
		m_WorkAreaVertex[6].x = m_WorkAreaMax.x;
		m_WorkAreaVertex[6].y = m_WorkAreaMin.y;
		m_WorkAreaVertex[6].z = m_WorkAreaMax.z;
		//
		m_WorkAreaVertex[7].x = m_WorkAreaMax.x;
		m_WorkAreaVertex[7].y = m_WorkAreaMax.y;
		m_WorkAreaVertex[7].z = m_WorkAreaMax.z;


		m_nxAreaMax = _maxArea;
		m_nxAreaMin = _minArea;

		_bDirty = true;
		_AreaChanged = true;
	}

	if (bArbitrary_ ||_bSimu != m_bIsSimu )
	{
		m_bIsSimu = _bSimu;
		_bDirty = true;
	}

	// track recorder status
	if (bArbitrary_ || (m_bPageFault != m_TrackRecord.IsPageFault()))
	{
		m_bPageFault = m_TrackRecord.IsPageFault();
		_bDirty = true;
	}

	if (bArbitrary_ || (m_nMemorySize != m_TrackRecord.GetMemorySize()))
	{
		m_nMemorySize = m_TrackRecord.GetMemorySize();
		_bDirty = true;
	}

	bool _bOrgChanged = false;
	AXDOUBLE_KERNEL _org = GetWorkcoorOrg(); 
		if (_org != m_nxWorkcoorOrg)
		{
			_bOrgChanged = true;
			m_nxWorkcoorOrg = _org;
		} 

	int _ftsize = 0;
	if (m_TrackRecordNode.IsOpen() && !m_TrackRecordNode.IsEmpty())
		_ftsize = m_TrackRecordNode.GetSize();
	bool _bTrackChanged = false;
	if (_ftsize != m_nFileTrackSize)
	{
		_bTrackChanged = false;
		m_nFileTrackSize = _ftsize;
	}

	if (_bOrgChanged || _bTrackChanged || _AreaChanged)
	{
		// clear the track bitmap in the playbck DC
		m_dc.m_nNextPoint = 0;
		_bDirty = true;
	}

	if (_bDirty && m_hWnd && IsWindowVisible())
		InvalidateRect(NULL);
	return;
}

inline POINTD CTraceCtrl::CubicTransformCenterPointer3D(const NCNODEEX::POINT3D& pt1_, const NCNODEEX::POINT3D& pt2_)
{
	POINTD _pt;
	NCNODEEX::POINT3D _pt3;

	_pt3.x = (NCNODEEX::REAL)((pt1_.x + pt2_.x) / 2.);
	_pt3.y = (NCNODEEX::REAL)((pt1_.y + pt2_.y) / 2.);
	_pt3.z = (NCNODEEX::REAL)((pt1_.z + pt2_.z) / 2.);
	_pt = CubicTransform(&_pt3);
	return _pt;
}

POINTD CTraceCtrl::GetWorkpieceCenterPoint()
{
	if (m_bIsFileTrackFirst)
	{
		if (m_TrackRecordNode.IsOpen())
		{
			//AXDOUBLE_KERNEL _org = GetWorkcoorOrg(); 
			//NCNODEEX::POINT3D _org3D(
			//	(NCNODEEX::REAL)_org[m_nX],
			//	(NCNODEEX::REAL)_org[m_nY],
			//	(NCNODEEX::REAL)_org[m_nZ]);

			NCNODEEX::POINT3D _org3D(0.0,0.0,0.0);

			if (m_traceAreaUpdate.IsMachValid())
				return CubicTransformCenterPointer3D(
				m_traceAreaUpdate.ptMachMin + _org3D,
				m_traceAreaUpdate.ptMachMax + _org3D);
			if (m_traceAreaUpdate.IsMotionValid())
				return CubicTransformCenterPointer3D(
				m_traceAreaUpdate.ptMotionMin + _org3D, 
				m_traceAreaUpdate.ptMotionMax + _org3D); 
		}
	}

	if (m_TraceArea.IsMachValid())
		return CubicTransformCenterPointer3D(m_TraceArea.ptMachMin, m_TraceArea.ptMachMax);
	
	if (m_TraceArea.IsMotionValid())
		return CubicTransformCenterPointer3D(m_TraceArea.ptMotionMin, m_TraceArea.ptMotionMax);

	return CubicTransformCenterPointer3D(m_WorkAreaMin, m_WorkAreaMax);
}

/////////////////////////////////////////////////////////////////////////////
// CTraceCtrl drawing

void CTraceCtrl::CreatePen(CPen* pPen_, COLORREF clr_)
{
	if (clr_ == CLR_TRANSPARENT)
		pPen_->CreateStockObject(NULL_PEN);
	else
		pPen_->CreatePen(PS_SOLID, 0, clr_);
}

void CTraceCtrl::CreateBrush(CBrush* pBrush_, COLORREF clr_)
{
	if (clr_ == CLR_TRANSPARENT)
		pBrush_->CreateStockObject(NULL_BRUSH);
	else
		pBrush_->CreateSolidBrush(clr_);
}

void CTraceCtrl::UpdateDrawingTools()
{
	DestroyDrawingTools();
	CreateDrawingTools();
}

void CTraceCtrl::DestroyDrawingTools()
{
	// clear old objects
	for (int _i = 0; _i < c_nNUMOF_PENS; _i++)
		m_pens[_i].DeleteObject();

	m_brushBackground.DeleteObject();
	m_fontMark.DeleteObject();
}

void CTraceCtrl::CreateDrawingTools()
{
	// calculate m_nCharHeight
	TEXTMETRIC _tm;
	CWindowDC dc(this);
	GetTextMetrics(dc,&_tm);
	m_nCharHeight = abs(_tm.tmAscent);

	for (int _i = 0; _i < c_nNUMOF_PENS; _i++)
	{
		if (_i == PEN_GRID)
			continue;			// skip to create pen for grid, we will create it later.

		CreatePen(m_pens + _i, m_clrPens[_i]);
	}

	// create grid pen
	LOGBRUSH _lb;
	_lb.lbColor = m_clrPens[PEN_GRID];
	_lb.lbHatch = 0;
	_lb.lbStyle = BS_SOLID;
	m_pens[PEN_GRID].CreatePen(PS_COSMETIC | PS_ALTERNATE, 1, &_lb);

	CreateBrush(&m_brushBackground, m_clrTrackBkFrom);
	m_fontMark.CreatePointFont(120, _T("SYSTEM"));

	// in order to clear the track bitmap in the playbck DC
	m_dc.m_nNextPoint = 0;
}

BOOL CTraceCtrl::PreTranslateMessage(MSG* pMsg_) 
{
    if (m_ToolTip.m_hWnd && pMsg_->hwnd == m_hWnd)
    {
        switch(pMsg_->message)
        {
        case WM_LBUTTONDOWN:    
        case WM_MOUSEMOVE:
        case WM_LBUTTONUP:    
        case WM_RBUTTONDOWN:
        case WM_MBUTTONDOWN:    
        case WM_RBUTTONUP:
        case WM_MBUTTONUP:
            m_ToolTip.RelayEvent(pMsg_);
            break;
        }
    }

	if ((pMsg_->message == WM_KEYDOWN)
		&& (GetKeyState(VK_CONTROL) < 0)
		&& (pMsg_->wParam == VK_BACK))
	{
		ShowNextSpeed();
		return TRUE;
	}

	if((pMsg_->message == WM_KEYDOWN)
		&& (GetKeyState(VK_CONTROL) < 0))
	{
		if(OnKeyCmd(pMsg_->wParam))
			return true;
	}

    return FALSE;
}

bool CTraceCtrl::OnKeyCmd(UINT nChar_)
{
	switch (nChar_)
	{
	case 'Z':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_ISOMETRIC_SW);
		return true;
	case 'X':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_BOTTOM);
		return true;
	case 'C':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_ISOMETRIC_SE);
		return true;
	case 'A':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_LEFT);
		return true;
	case 'S':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_FRONT);
		return true;
	case 'B':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_BACK);
		return true;
	case 'D':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_RIGHT);
		return true;
	case 'Q':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_ISOMETRIC_NW);
		return true;
	case 'W':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_TOP);
		return true;
	case 'E':
		OnCommandRange(IDCMD_TRACECTRL_PROJ_ISOMETRIC_NE);
		return true;
	case 'F': 
		OnCommandRange(IDCMD_TRACECTRL_FITWINDOW);
		return true;
	case 'N':
		OnCommandRange(IDCMD_TRACECTRL_CENTER);
		return true;
	case 'P':
		OnCommandRange(IDCMD_TRACECTRL_CURRENT);
		return true;
	case 'T':
		OnCommandRange(IDCMD_TRACECTRL_CLEARVIEW);
		return true;
	case 'L':
		if(!m_dataprovider->IsLoadFile())
			return true;

		OnCommandRange(IDCMD_TRACECTRL_LOAD_TRACK);
		return true;
	case 'R':
		if(!m_TrackRecordNode.IsOpen())
			return true;

		OnCommandRange(IDCMD_TRACECTRL_CLEAR_TRACK);
		return true;
	case 'H':
		if(!m_bUpdateTrackUI)
			return true;

		OnCommandRange(IDCMD_TRACECTRL_STOP_LOAD_TRACK);
		return true;
	case 'I':
		OnCommandRange(IDCMD_TRACECTRL_ZOOMIN);
		return true;
	case 'O':
		OnCommandRange(IDCMD_TRACECTRL_ZOOMOUT);
		return true;
	case 'V':
		OnCommandRange(IDCMD_TRACECTRL_MOVE);
		return true;
	case 'M':
		OnToolCustomize();
		return true;
	}

	CPoint _pt(0, 0);
	CPoint _pt0(0, 0);
	POINTD _pt_lp, _pt0_lp;

	POINTD _ptCenter;

	switch (nChar_)
	{
	//case '1':
	//	SetSelectMode(CTrackRecorder::OR);
	//	break;
	//case '2':
	//	SetSelectMode(CTrackRecorder::NOT);
	//	break;
	//case '3':
	//	SetSelectMode(CTrackRecorder::XOR);
	//	break;
	////case 'M':
	////	SetOperation(MOVE);
	////	break;
	////case 'N':
	////	SetOperation(SELECT);
	////	break;
	//case 0xBE: /* '>', '.' */
	//case VK_ADD:
	//case 0xBB:
	//	ZoomOut();
	//	break;
	//case 0xBC: /* ' < ', ',' */
	//case VK_SUBTRACT:
	//case 0xBD:
	//	ZoomIn();
	//	break;
	//case VK_RETURN:
	//	m_bReceiveArrowMsgs = true;
	//	if (m_hWnd)
	//		InvalidateRect(NULL);
	//	break;
	//case VK_ESCAPE:
	//	m_bReceiveArrowMsgs = false;
	//	if (m_hWnd)
	//		InvalidateRect(NULL);
	//	break;

	case ' ': // space
		switch (m_nOperation)
		{
		case ZOOMOUT:
			SetOperation(ZOOMIN);
			break;
		case ZOOMIN:
			SetOperation(MOVE);
			break;
		case MOVE:
			SetOperation(ZOOMOUT);
			break;
		case SELECT:
			SetOperation(MOVE);
			break;
		}
		break;
	//
	case VK_LEFT:
		_pt.x = c_nLINE_STEP;
		_pt.y = 0;
		goto _MOVE_TRACK;
	case VK_UP:
		_pt.x = 0;
		_pt.y = c_nLINE_STEP;
		goto _MOVE_TRACK;
	case VK_RIGHT:
		_pt.x = -1 * c_nLINE_STEP;
		_pt.y = 0;
		goto _MOVE_TRACK;
	case VK_DOWN:
		_pt.x = 0;
		_pt.y = -1 * c_nLINE_STEP;
		goto _MOVE_TRACK;

	default:
		return false; // not a key command
	}

	return true; 

_MOVE_TRACK:
	m_dc.DPtoLP_SM(&_pt0, &_pt0_lp);
	m_dc.DPtoLP_SM(&_pt, &_pt_lp);
	OffsetLogicalRef(_pt_lp.x - _pt0_lp.x, _pt_lp.y - _pt0_lp.y);
	if (m_hWnd)
		InvalidateRect(NULL);
	return true;
}

bool CTraceCtrl::OnKeyCmd1(UINT nChar_)
{

	CPoint _pt(0, 0);
	CPoint _pt0(0, 0);
	POINTD _pt_lp, _pt0_lp;

	POINTD _ptCenter;

	switch (nChar_)
	{
	case ' ': // space
		switch (m_nOperation)
		{
		case ZOOMOUT:
			SetOperation(ZOOMIN);
			break;
		case ZOOMIN:
			SetOperation(MOVE);
			break;
		case MOVE:
			SetOperation(ZOOMOUT);
			break;
		case SELECT:
			SetOperation(MOVE);
			break;
		}
		break;
	//
	case VK_LEFT:
		_pt.x = c_nLINE_STEP;
		_pt.y = 0;
		goto _MOVE_TRACK;
	case VK_UP:
		_pt.x = 0;
		_pt.y = c_nLINE_STEP;
		goto _MOVE_TRACK;
	case VK_RIGHT:
		_pt.x = -1 * c_nLINE_STEP;
		_pt.y = 0;
		goto _MOVE_TRACK;
	case VK_DOWN:
		_pt.x = 0;
		_pt.y = -1 * c_nLINE_STEP;
		goto _MOVE_TRACK;

	default:
		return false; // not a key command
	}

	return true; 

_MOVE_TRACK:
	m_dc.DPtoLP_SM(&_pt0, &_pt0_lp);
	m_dc.DPtoLP_SM(&_pt, &_pt_lp);
	OffsetLogicalRef(_pt_lp.x - _pt0_lp.x, _pt_lp.y - _pt0_lp.y);
	if (m_hWnd)
		InvalidateRect(NULL);
	return true;
}


//0 left 1 up 2 right 3 down
void CTraceCtrl::MoveTrack(UINT id)
{
	CPoint _pt(0, 0);
	CPoint _pt0(0, 0);
	POINTD _pt_lp, _pt0_lp;

	switch(id)
	{
	case 0:
		_pt.x = c_nLINE_STEP;
		_pt.y = 0;
		break;
	case 1:
		_pt.x = 0;
		_pt.y = c_nLINE_STEP;
		break;
	case 2:
		_pt.x = -1 * c_nLINE_STEP;
		_pt.y = 0;
		break;
	case 3:
		_pt.x = 0;
		_pt.y = -1 * c_nLINE_STEP;
		break;
	default:
		return;
	}

	m_dc.DPtoLP_SM(&_pt0, &_pt0_lp);
	m_dc.DPtoLP_SM(&_pt, &_pt_lp);
	OffsetLogicalRef(_pt_lp.x - _pt0_lp.x, _pt_lp.y - _pt0_lp.y);
	if (m_hWnd)
		InvalidateRect(NULL);
}

void CTraceCtrl::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	if (::IsMenu(m_contextMenu.m_hMenu))
	{
		CRect _rc; 
		GetWindowRect(&_rc);
		
		if (!PtInRect(&_rc, point))
			point = _rc.CenterPoint();

		// Display a popup menu as a floating popup menu in the
		// client area of the window.
		const UINT _c_nFlags = TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON;
	
		//update menuitem state
		CCmdUI _ui;
		_ui.m_pMenu = &m_contextMenu;
		_ui.m_nIndexMax = m_contextMenu.GetMenuItemCount();
		for (_ui.m_nIndex = 0; _ui.m_nIndex < _ui.m_nIndexMax; _ui.m_nIndex++)
		{
			_ui.m_nID = m_contextMenu.GetMenuItemID(_ui.m_nIndex);
			if (_ui.m_nID == 0)
				continue; 
			_ui.DoUpdate(this, TRUE);   
		}

		//owner is this trace control
		//m_contextMenu.TrackPopupMenu(_c_nFlags,	point.x, point.y, GetParentFrame());    
		m_contextMenu.TrackPopupMenu(_c_nFlags,	point.x, point.y, this);  
	}
}

bool CTraceCtrl::OnSysKeyCmd(UINT nChar_)
{
	if (m_b2DMode)
		return false;

	POINTD _pt = GetWorkpieceCenterPoint();
	switch (nChar_)
	{
	case VK_LEFT:
		RotateZ(-10 * c_nPIE / 180);
		break;
	case VK_UP:
		RotateX(-10 * c_nPIE / 180);
		break;
	case VK_RIGHT:
		RotateZ(10 * c_nPIE / 180);
		break;
	case VK_DOWN:
		RotateX(10 * c_nPIE / 180);
		break;
	case VK_PRIOR:
		RotateY(10 * c_nPIE / 180);
		break;
	case VK_NEXT:
		RotateY(-10 * c_nPIE / 180);
		break;

	default:
		return false;
	}

	CenterWorkpiece(&_pt);
	if (m_hWnd)
	{
		// if the track is empty and the current point is zero. CenterWorkpiece()
		// function does not set m_dc.m_nNextPoint to zero. So we set it now.
		//
		// clear the track bitmap in the playbck DC
		m_dc.m_nNextPoint = 0;
		InvalidateRect(NULL);
	}
	return true;
}

void CTraceCtrl::DrawRuler(CSimuDCEx* pDC_)
{
	pDC_->GetAreaShowXYZValue(true);
	static const CRect _s_rcTest(0, 0, 40, 40);
	static const double _s_scale[] = {
		1, 2, 5,
		10, 20, 50,
		100, 200, 500,
		1000, 2000, 5000,
		10000, 20000, 50000,
		100000, 200000, 500000, };

	if (pDC_->GetAreaXYZ()->IsRectEmpty())
		return;

	int		_i;
	TCHAR	_szBuffer[120];
	RECTD	_rcTest;
	double	_temp, _sub, _end;
	int		_temp2;
	RECTD	_rcArea;
	CRect	_rcRuler(c_RULE_DIP.cx, c_RULE_DIP.cy, c_nDIMRULER - 1, c_nDIMRULER);
	int		_scale_height = abs(_rcRuler.Height()) / 4;

	// Note:
	//	Because this function needs to convert the CSimuDCEx mapping mode to workpiece
	//	coor from its machining coor, it uses a local CSimuDCEx in order to isolate
	//	the change.
	CSimuDCEx _dc;
	_dc.CopyAttributes(pDC_);

	pDC_->SelectStockObject(ANSI_VAR_FONT);
	pDC_->SetBkMode(TRANSPARENT);
	// the text color will be set later

	// convert map mode to workpiece coor. from machining coor.
	double _offset[3];

		AXDOUBLE_KERNEL _org = GetWorkcoorOrg(); 
		_offset[0] = _org[m_nX];
		_offset[1] = _org[m_nY];
		_offset[2] = _org[m_nZ];
	

	static NCNODEEX::POINT3D _s_vX(1, 0, 0), _s_vY(0, 1, 0), _s_vZ(0, 0, 1);
	POINTD _v[3];
	_v[0] = CubicTransform(&_s_vX);
	_v[1] = CubicTransform(&_s_vY);
	_v[2] = CubicTransform(&_s_vZ);

	bool _valid_x_ruler = false;
	bool _valid_y_ruler = false;
	double _sign_x = 1;
	double _sign_y = 1;
	for (_i = 0; _i < 3; _i++)
		if (fabs(fabs(_v[_i].x) - 1) < c_nFLOAT_TOLERANCE)
		{
			pDC_->OffsetLogicalRef(-1 * _offset[_i] * _v[_i].x, 0);
			_sign_x = _v[_i].x;
			_valid_x_ruler = true;
			break;
		}
	for (_i = 0; _i < 3; _i++)
		if (fabs(fabs(_v[_i].y) - 1) < c_nFLOAT_TOLERANCE)
		{
			 pDC_->OffsetLogicalRef(0, -1 * _offset[_i] * _v[_i].y);
			_sign_y = _v[_i].y;
			_valid_y_ruler = true;
			break;
		}

	pDC_->DPtoLP_SM(&_s_rcTest /* in DP */, &_rcTest);	// to mm
	double _scale = fabs(_rcTest.right - _rcTest.left);		// to mm
	for (_i = 0; _i < _countof(_s_scale); _i++)
	{
		if (_scale < _s_scale[_i])
		{
			_scale = _s_scale[_i];	// to logic coor., i.e. in mm again
			break;
		}
	}
	if (_i >= _countof(_s_scale))
	{
		ASSERT(FALSE);	// out of range
		return;
	}
	CRect _rc(pDC_->GetAreaXYZ());
	_rc.InflateRect(1, 1, 1, 1);
	pDC_->DPtoLP_SM(&_rc, &_rcArea);
	if (_rcArea.bottom > _rcArea.top)
	{
		double _t = _rcArea.bottom;
		_rcArea.bottom = _rcArea.top;
		_rcArea.top = _t;
	}
	if (_rcArea.left > _rcArea.right)
	{
		double _t = _rcArea.left;
		_rcArea.left = _rcArea.right;
		_rcArea.right = _t;
	}

	pDC_->SetTextColor(m_clrPens[PEN_RULER]);
	pDC_->SelectObject(m_pens[PEN_RULER]);

	/////////////////////
	// first, draw X-ruler
	_temp = int(_rcArea.left / _scale) * _scale;
	if (_rcArea.left < 0)
		_temp -= _scale;
	_end = _rcArea.right + _scale;
	while (_temp < _end)
	{
		if ((_temp >= _rcArea.left) &&(_temp < _rcArea.right))
		{
			_temp2 = pDC_->LPtoDPx_SM(_temp);
			pDC_->MoveTo(_temp2, _rcRuler.top);
			pDC_->LineTo(_temp2, _rcRuler.bottom);

			if (_valid_x_ruler && m_bDrawGrid)
			{
				pDC_->SelectObject(m_pens[PEN_GRID]);
				pDC_->LineTo(_temp2, _rc.bottom);
				pDC_->SelectObject(m_pens[PEN_RULER]);
			}

			if (_valid_x_ruler)
			{
				_itot_s(_round(_temp * _sign_x), _szBuffer, _countof(_szBuffer), 10);
				pDC_->TextOut(_temp2 + 1, _rcRuler.top, _szBuffer, _tcslen(_szBuffer));
			}
		}

		// draw sub-scale
		_sub = _temp;
		_temp += _scale;
		_i = 0;
		while (_sub < _temp)
		{
			if ((_sub >= _rcArea.left) && (_sub < _rcArea.right))
			{
				_temp2 = pDC_->LPtoDPx_SM(_sub);
				if (_i == 5)
					pDC_->MoveTo(_temp2,  _rcRuler.bottom - _scale_height*2);
				else
					pDC_->MoveTo(_temp2,  _rcRuler.bottom - _scale_height);
				pDC_->LineTo(_temp2, _rcRuler.bottom);
				if ((_i == 5) && _valid_x_ruler && m_bDrawGrid)
				{
					pDC_->SelectObject(m_pens[PEN_GRID]);
					pDC_->LineTo(_temp2, _rc.bottom);
					pDC_->SelectObject(m_pens[PEN_RULER]);
				}
			}
			_i ++;
			_sub = _temp - _scale + _scale * _i / 10;
		}
	}

	/////////////////////
	// then draw Y-ruler
	_temp = int(_rcArea.bottom / _scale) * _scale;
	if (_rcArea.bottom < 0)
		_temp -= _scale;
	_end = _rcArea.top + _scale;
	while (_temp < _end)
	{
		if ((_temp >= _rcArea.bottom) &&(_temp < _rcArea.top))
		{
			_temp2 = pDC_->LPtoDPy_SM(_temp);
			pDC_->MoveTo(_rcRuler.left, _temp2);
			pDC_->LineTo(_rcRuler.right, _temp2);

			if (_valid_y_ruler && m_bDrawGrid)
			{
				pDC_->SelectObject(m_pens[PEN_GRID]);
				pDC_->LineTo(_rc.right, _temp2);
				pDC_->SelectObject(m_pens[PEN_RULER]);
			}

			if (_valid_y_ruler)
			{
				_itot_s(_round(_temp * _sign_y), _szBuffer, _countof(_szBuffer), 10);
				TCHAR* _pch = (TCHAR*)_szBuffer;
				while (*_pch)
				{
					pDC_->TextOut(_rcRuler.left, _temp2, _pch, 1);
					_pch++;
					_temp2 += m_nCharHeight;
				}
			}
		}

		// draw sub-scale
		_sub = _temp;
		_temp += _scale;
		_i = 0;
		while (_sub < _temp)
		{
			if ((_sub >= _rcArea.bottom) &&(_sub < _rcArea.top))
			{
				_temp2 = pDC_->LPtoDPy_SM(_sub);
				if (_i == 5)
					pDC_->MoveTo(_rcRuler.right - _scale_height*2, _temp2);
				else
					pDC_->MoveTo(_rcRuler.right - _scale_height, _temp2);
				pDC_->LineTo(_rcRuler.right, _temp2);

				if ((_i == 5) && _valid_y_ruler && m_bDrawGrid)
				{
					pDC_->SelectObject(m_pens[PEN_GRID]);
					pDC_->LineTo(_rc.right, _temp2);
					pDC_->SelectObject(m_pens[PEN_RULER]);
				}
			}
			_i ++;
			_sub = _temp - _scale + _scale * _i / 10;
		}
	}

	// restore attributes
		pDC_->CopyAttributes(&_dc);

	return;
}

void CTraceCtrl::DrawDecorators()
{
	DrawMarks(&m_dc);
	DrawCoor(&m_dc);
	DrawCurrentCoor(&m_dc);

	NCNODEEX::POINT3D _lp((NCNODEEX::REAL)m_ptLastPoint.x, 
						  (NCNODEEX::REAL)m_ptLastPoint.y, 
						  (NCNODEEX::REAL)m_ptLastPoint.z);
	DrawCrosses(&m_dc, &_lp);

	const CRect* _prcArea = m_dc.GetAreaXYZ();

	if (!_prcArea->IsRectEmpty())
	{
		m_dc.SelectStockObject(ANSI_VAR_FONT);
		m_dc.SetTextColor(m_clrPens[PEN_RULER]);
		m_dc.SetBkMode(TRANSPARENT);

		int _mem_used = m_TrackRecord.GetMemorySize();
		int _mem_max = m_TrackRecord.GetMaxMemorySize();
		if (m_TrackRecordNode.IsOpen())
		{
			_mem_used += m_TrackRecordNode.GetMemorySize();
			_mem_max += m_TrackRecordNode.GetMaxMemorySize();
		}

		TCHAR _szBuffer[256];
		TCHAR _szTempString[256]={0};
		TCHAR _szTempString1[256]={0};

		GetString(L"s_csTRACKRECORD_INFO",_szTempString, _countof(_szTempString), s_csTRACKRECORD_INFO); 
		GetString(L"s_csTRACKRECORD_AUTOCLR",_szTempString1, _countof(_szTempString), s_csTRACKRECORD_AUTOCLR);
		_sntprintf_s(_szBuffer, _countof(_szBuffer),_szTempString, 
			_mem_used / (1024 * 1024), 
			_mem_max / (1024 * 1024),  
			(m_TrackRecord.IsPageFault() || m_TrackRecordNode.IsPageFault())? _szTempString1 : L"");

		m_dc.TextOut(_prcArea->left + 2, _prcArea->bottom + 2, _szBuffer, _tcslen(_szBuffer));
	}

	CRect _rect;
	GetClientRect(&_rect);
	DrawBorder(&m_dc, _rect, m_clrBorder, (bf_t)m_nBorderFormat);

	if (GetFocus() == this)
	{
		CRect _rc; 
		if (m_bReceiveArrowMsgs)
			_rc = _prcArea;
		else
			GetClientRect(&_rc);

	//	DrawFocusFrame(&m_dc, &_rc); // add yuewenxue ע͵ڿؼʱı߿
	}

	return;
}

void CTraceCtrl::DrawCoor(CSimuDCEx* pDC_)
{
	//static LPCTSTR _s_pszAxis[] =
	//{
	//	_T("X"), _T("Y"), _T("Z"),
	//};

	const CRect* _pRect = pDC_->GetAreaXYZ();
	if ((_pRect->Width() < 100) || (_pRect->Height() < 100))
		return;

	int _numof = c_nNUMOF_AXIS;
	if(m_nAxesNumber < c_nNUMOF_AXIS)
		_numof = m_nAxesNumber;
	for (int _axis = 0; _axis < _numof; _axis++)
	{
		if (m_matrixTrans[_axis][1] > c_nFLOAT_TOLERANCE)
		{
			pDC_->SelectObject(m_pens[PEN_COORDARKEN]);
			pDC_->SetTextColor(m_clrPens[PEN_COORDARKEN]);
		}
		else
		{
			pDC_->SelectObject(m_pens[PEN_COOR]);
			pDC_->SetTextColor(m_clrPens[PEN_COOR]);
		}

		pDC_->MoveTo(_pRect->left + 50, _pRect->bottom - 50);
		pDC_->LineTo(int(_pRect->left + 50 + m_matrixTrans[_axis][0] * 25),
			int(_pRect->bottom - 50  - m_matrixTrans[_axis][2] * 25));
		pDC_->TextOut(int(_pRect->left + 50 + m_matrixTrans[_axis][0] * 30),
			int(_pRect->bottom - 50  - m_matrixTrans[_axis][2] * 30), s_szAxisName[_axis]);
	}
	return;
}

void CTraceCtrl::DrawCurrentCoor(CSimuDCEx* pDC_)
{
	if (m_bShowCoor == false) 
	{
		return;
	}

	const CRect* _pRect = pDC_->GetAreaXYZ();
	if ((_pRect->Width() < 100) || (_pRect->Height() < 100))
		return;

	AXDOUBLE_KERNEL _machcoor = GetCurPos();
	AXDOUBLE_KERNEL _cur;
	if(!IsSimulating())
	{
		AXDOUBLE_KERNEL _workcoor = _machcoor - GetWorkcoorOrg();
		 _cur = _workcoor;	  
	}
	else
		 _cur = _machcoor;	
	static const int _nLineHeight = 20;
	
	CRect _rc;
	_rc.left = _pRect->right - 170;
	_rc.top = _pRect->top + 25;
	_rc.right = _pRect->right - 15;
	_rc.bottom = _rc.top + _nLineHeight * c_nNUMOF_AXIS;

	pDC_->BitBlt(_rc.left, _rc.top, _rc.Width(), _rc.Height(),
		&m_dc.m_CacheDC,
		_rc.left, _rc.top,
		SRCCOPY);

	CFont _font;
	_font.CreateFont(-13, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, _T("Consolas"));
	CFont* _pOldFont = pDC_->SelectObject(&_font);
	pDC_->SetTextColor(m_clrPens[PEN_COOR]);

	CString _strWC[c_nNUMOF_AXIS];
	int _numof = c_nNUMOF_AXIS;
	if(m_nAxesNumber < c_nNUMOF_AXIS)
		_numof = m_nAxesNumber;

	for (int _i = 0; _i < _numof; _i++)
	{
		CString _str;
		if (m_nUnitSystem == 0)
			_str.Format(_T("%.3f"), _cur[_i]); 
		else
			_str.Format(_T("%.4f"), _cur[_i]);

		//-0.000->0.000
		NormalizeFloatString(_str);
		_strWC[_i].Format(_T("%10s:%10s"), s_szAxisName[_i], _str);
		pDC_->TextOut(_rc.left, _rc.top + _i * _nLineHeight, _strWC[_i]);		
	}

	pDC_->SelectObject(_pOldFont);
}

void CTraceCtrl::DrawLineNoInfo(CSimuDCEx* pDC_)
{
	const CRect* _pRect = pDC_->GetAreaXYZ();
	if ((_pRect->Width() < 100) || (_pRect->Height() < 100))
		return;

	static const int _s_nLineHeight = 20;

	CRect _rect;
	_rect.left = _pRect->right - 170;
	_rect.top = _pRect->bottom + 2;
	_rect.right = _pRect->right - 2;
	_rect.bottom = _rect.top + _s_nLineHeight;

	pDC_->BitBlt(_rect.left, 
		         _rect.top, 
		         _rect.Width(), 
		         _rect.Height(), 
		         &m_dc.m_CacheDC,
		         _rect.left, 
		         _rect.top, 
		         SRCCOPY);

	CFont _font;
	_font.CreateFont(-13, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, _T("Consolas"));
	CFont* _pOldFont = pDC_->SelectObject(&_font);
	if (m_clrTrackLineNum == CLR_TRANSPARENT) 
	{
		pDC_->SetTextColor(0x00FFFFFF);
	}
	else
	{
		pDC_->SetTextColor(m_clrTrackLineNum);
	}

	pDC_->SetBkMode(TRANSPARENT);
	TCHAR _szBuffer[256]={0};
	TCHAR _szTempString[256]={0};
	if (m_HitField.from != -1)
	{
		NCNODEEX* _pBase = m_TrackRecord.GetBase();
		if (_pBase[m_HitField.from + 1].nFilePos != EOF)
		{
			if (m_bIsShowLineNumber)   
			{
				GetString(L"s_csHITTRACK_LINENO", _szTempString, _countof(_szTempString), s_csHITTRACK_LINENO);
				NCNODEEX& _Node = _pBase[m_HitField.from + 1];

				if (_Node.nFileType == ENG)
					_tcscat_s(_szTempString, _T("-%u"));

				_sntprintf_s(_szBuffer, _countof(_szBuffer), _szTempString, _Node.nLineOrID, _Node.nOffset);
			}
		}
	}
	
	m_dc.TextOut(_rect.left, _rect.top, _szBuffer, _tcslen(_szBuffer));
	pDC_->SelectObject(_pOldFont);
}

void CTraceCtrl::EraseCrosses(CSimuDCEx* pDC_)
{
	if (IsValidNcnodeexReal(m_ptCross.x))
		_DrawCrosses(pDC_, &m_ptCross);
}

void CTraceCtrl::DrawCrosses(CSimuDCEx* pDC_, const NCNODEEX::POINT3D* pPos_)
{
	if (pDC_->GetAreaXYZ()->IsRectEmpty())
		return;

	m_ptCross = *pPos_;
	_DrawCrosses(pDC_, pPos_);
}

void CTraceCtrl::DrawMarks(CSimuDCEx* pDC_)
{
	const CRect* _pRect = pDC_->GetAreaXYZ();
	if ((_pRect->Width() < 100) ||(_pRect->Height() < 100))
		return;

	TCHAR _szTempstring[256]={0};
	CString _str;
	 GetString(L"s_csMARK_SIMU",_szTempstring, _countof(_szTempstring), s_csMARK_SIMU);
	if (IsSimulating())
		_str += _szTempstring; 
	
	switch (m_nProjectMode)
	{
	case PROJ_ISOMETRIC_SE:
		 GetString(L"s_csTRACECTRL_VIEW_SE",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_SE);
		_str+=_szTempstring;
		break;
	case PROJ_ISOMETRIC_NW:
		GetString(L"s_csTRACECTRL_VIEW_NW",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_NW);
		_str+=_szTempstring;
		break;
	case PROJ_ISOMETRIC_NE:
		GetString(L"s_csTRACECTRL_VIEW_NE",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_NE);
		_str+=_szTempstring;
		break;
	case PROJ_ISOMETRIC_SW:
		GetString(L"s_csTRACECTRL_VIEW_SW",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_SW);
		_str+=_szTempstring;
		break;
	case PROJ_LEFT:
		GetString(L"s_csTRACECTRL_VIEW_LEFT",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_LEFT);
		_str+=_szTempstring;
		break;
	case PROJ_TOP:
		GetString(L"s_csTRACECTRL_VIEW_TOP",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_TOP);
		_str+=_szTempstring;
		break;
	case PROJ_RIGHT:
		GetString(L"s_csTRACECTRL_VIEW_RIGHT",_szTempstring,_countof(_szTempstring), s_csTRACECTRL_VIEW_RIGHT);
		_str+=_szTempstring;
		break;
	case PROJ_BOTTOM:
		GetString(L"s_csTRACECTRL_VIEW_BOTTOM",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_BOTTOM);
		_str+=_szTempstring;
		break;
	case PROJ_FRONT:
		GetString(L"s_csTRACECTRL_VIEW_FRONT",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_FRONT);
		_str+=_szTempstring;
		break;
	case PROJ_BACK:
		GetString(L"s_csTRACECTRL_VIEW_BACK",_szTempstring, _countof(_szTempstring), s_csTRACECTRL_VIEW_BACK);
		_str+=_szTempstring;
		break;
	}

	if (m_nShowSpeed != _SHOW_SPEED_NO
		&& !m_bSimulating)
	{
		int _i;
		for (_i = 0; _i < c_nNUMOF_SHOWSPEEDPROMPT; _i++)
		{
			if (m_nShowSpeed == (_SHOW_SPEED_NO + _i))
				break;
		}
		if (_i >= c_nNUMOF_SHOWSPEEDPROMPT)
			_i = 0;

		switch (_SHOW_SPEED_NO + _i)
		{
			case _SHOW_SPEED_NO:
				_str += _T("");
 				break;
			case _SHOW_SPEED_SUM:
				GetString(L"s_csMARK_SPEED_SUM",_szTempstring, _countof(_szTempstring), s_csMARK_SPEED_SUM);
				_str += _szTempstring;
				break;
			case _SHOW_SPEED_X:
				GetString(L"s_csMARK_SPEED_X",_szTempstring, _countof(_szTempstring), s_csMARK_SPEED_X);
				_str += _szTempstring;
				break;
			case _SHOW_SPEED_Y:
				GetString(L"s_csMARK_SPEED_Y",_szTempstring, _countof(_szTempstring), s_csMARK_SPEED_Y);
				_str += _szTempstring;
				break;
			case _SHOW_SPEED_Z:
				GetString(L"s_csMARK_SPEED_Z",_szTempstring, _countof(_szTempstring), s_csMARK_SPEED_Z);
				_str += _szTempstring;
				break;
			case _SHOW_SPEED_DELTAX:
				GetString(L"s_csMARK_SPEED_DELTAX",_szTempstring, _countof(_szTempstring), s_csMARK_SPEED_DELTAX);
				_str += _szTempstring;
				break;
			case _SHOW_SPEED_DELTAY:
				GetString(L"s_csMARK_SPEED_DELTAY",_szTempstring, _countof(_szTempstring), s_csMARK_SPEED_DELTAY);
				_str += _szTempstring;
				break;
			case _SHOW_SPEED_DELTAZ:
				GetString(L"s_csMARK_SPEED_DELTAZ",_szTempstring, _countof(_szTempstring), s_csMARK_SPEED_DELTAZ);
				_str += _szTempstring;
				break;
			case _SHOW_DEBUG:
				GetString(L"s_csMARK_DEBUG",_szTempstring, _countof(_szTempstring), s_csMARK_DEBUG);
				_str += _szTempstring;
				break;
			default:
				ASSERT(false);
		}
	}

	if (!_str.IsEmpty())
	{
		pDC_->SelectObject(&m_fontMark);
		pDC_->SetTextColor(m_clrPens[PEN_COOR]);
		pDC_->TextOut(_pRect->left + 8, _pRect->top + 8, _str);
	}
	SetRectDC();
}

void CTraceCtrl::_DrawCrosses(CSimuDCEx* pDC_, const NCNODEEX::POINT3D* pPos_)
{
	//DrawCurrentCoor(pDC_);
	pDC_->ClipAreaXYZ();
	POINTD _cur = CubicTransform(pPos_);
	pDC_->MoveTo_LP(_cur);
	pDC_->DrawCross();
	pDC_->ClipNull();
	return;
}

void CTraceCtrl::FillBackground(CSimuDCEx* pDC_, LPCRECT prc_)
{
	if (!m_bGradientFill)
	{
		pDC_->FillRect(prc_, &m_brushBackground);
	}
	else
	{
		TRIVERTEX        _vert[3];
		GRADIENT_RECT    _grect;
		_vert[0].x      = prc_->left;
		_vert[0].y      = prc_->top;
		_vert[0].Red    = ((WORD)GetRValue(m_clrTrackBkFrom)) << 8;
		_vert[0].Green  = ((WORD)GetGValue(m_clrTrackBkFrom)) << 8;
		_vert[0].Blue   = ((WORD)GetBValue(m_clrTrackBkFrom)) << 8;
		_vert[0].Alpha  = 0x0000;

		_vert[1].x      = prc_->right;
		_vert[1].y      = prc_->bottom;
		_vert[1].Red    = ((WORD)GetRValue(m_clrTrackBkTo)) << 8;
		_vert[1].Green  = ((WORD)GetGValue(m_clrTrackBkTo)) << 8;
		_vert[1].Blue   = ((WORD)GetBValue(m_clrTrackBkTo)) << 8;
		_vert[1].Alpha  = 0x0000;

		_vert[2].Red = ((WORD)GetRValue(m_clrTrackLineNum)) << 8;   
		_vert[2].Green = ((WORD)GetGValue(m_clrTrackLineNum)) << 8;
		_vert[2].Blue = ((WORD)GetBValue(m_clrTrackLineNum)) << 8;
		_vert[2].Alpha = 0x0000;

		_grect.UpperLeft  = 0;
		_grect.LowerRight = 1;
		::GradientFill(pDC_->m_hDC, _vert, 2, &_grect, 1, GRADIENT_FILL_RECT_V);
	}
	return;
}

void CTraceCtrl::DrawTrack(CSimuDCEx* pDC_)
{
	SIZE _size = m_dc.GetDimension();
	CRect _rect(0, 0, _size.cx, _size.cy);
	if (_rect.IsRectEmpty())
		return;

	if (m_dc.m_nNextPoint == 0) // no cached track picture
		Playback();

	pDC_->BitBlt(0, 0, _rect.right, _rect.bottom,
		&m_dc.m_CacheDC,
		0, 0,
		SRCCOPY);

	int _last_permanent = m_TrackRecord.GetSize() - 1;
	// This is the index of the last permanent point.

	// draw the last line, which is un-permanent line.
	if ((_last_permanent > 0) && (int(m_dc.m_nNextPoint) == _last_permanent))
	{
		NCNODEEX* _pBase = m_TrackRecord.GetBase();
		NCNODEEX* _prec;
		POINTD _cur;

		// set clip rectangle
		pDC_->ClipAreaXYZ();
		_prec = _pBase + m_dc.m_nNextPoint - 1;
		_cur = CubicTransform(&_prec->pt3D);
		pDC_->MoveTo_LP(_cur);
		_prec->pt2D = pDC_->m_ptLastDP;

		_prec++;

		if (_prec->bSelected)
			pDC_->SelectObject(m_pens[PEN_SELECTED]);
		else
			pDC_->SelectObject(m_pens[_prec->nGType]);

		_cur = CubicTransform(&_prec->pt3D);
		pDC_->LineTo_LP(_cur);
		_prec->pt2D = pDC_->m_ptLastDP;
		pDC_->ClipNull();
	}
	return;
}

void CTraceCtrl::Playback()
{
	// rect for the entire area
	SIZE _size = m_dc.GetDimension();
	CRect _rect(0, 0, _size.cx, _size.cy);
	if (_rect.IsRectEmpty())
		return;

	// because this function is driven by timer, we set a re-enter guard again.
	// First, switch the output DC to the memory DC
	m_dc.OutputToMemory();

	if (m_dc.m_nNextPoint == 0)	// case needs to draw the whole track
	{
		// draw ruler and frame of the track-area
		m_dc.ClipNull();
		m_dc.FillSolidRect(&_rect, m_clrBackground);

		// draw background
		FillBackground(&m_dc, m_dc.GetAreaXYZ());

		DrawRuler(&m_dc);

		CRect _rc3dRect(m_dc.GetAreaXYZ());
		_rc3dRect.InflateRect(1, 1, 1, 1);
		m_dc.Draw3dRect(&_rc3dRect, m_clrShadow, m_clrHilit);

		m_dc.ClipAreaXYZ();
		if (m_bDrawWorkAreaFrame)
		{
			const static int _s_cBorderStart[cNUMOF_BORDER] =
			{0, 1, 2, 3, 4, 5, 6, 7, 0, 1, 2, 3};
			const static int _s_cBorderEnd[cNUMOF_BORDER] =
			{1, 3, 0, 2, 5, 7, 4, 6, 4, 5, 6, 7};
			POINTD _vertex[8];
			int _i;
			for (_i = 0; _i < cNUMOF_VERTEX; _i++)
				_vertex[_i] = CubicTransform(m_WorkAreaVertex + _i);

			// calculate the invisible vertex
			int _x = m_matrixTrans[0][1] > 0 ? 2 : 0;
			int _y = m_matrixTrans[1][1] > 0 ? 1 : 0;
			int _z = m_matrixTrans[2][1] > 0 ? 4 : 0;
			int _invisible_vertex = _x + _y + _z;

			// first, draw the invisible borders
			m_dc.SelectObject(&m_pens[PEN_COORDARKEN]);
			for (_i = 0; _i < cNUMOF_BORDER; _i++)
			{
				int _sv = _s_cBorderStart[_i];
				int _ev = _s_cBorderEnd[_i];
				if ((_sv == _invisible_vertex) ||(_ev == _invisible_vertex))
				{
					m_dc.MoveTo_LP(_vertex[_sv]);
					m_dc.LineTo_LP(_vertex[_ev]);
				}
			}
			// then, draw the invisible borders
			m_dc.SelectObject(&m_pens[PEN_COOR]);
			for (_i = 0; _i < cNUMOF_BORDER; _i++)
			{
				int _sv = _s_cBorderStart[_i];
				int _ev = _s_cBorderEnd[_i];
				if ((_sv != _invisible_vertex) &&(_ev != _invisible_vertex))
				{
					m_dc.MoveTo_LP(_vertex[_sv]);
					m_dc.LineTo_LP(_vertex[_ev]);
				}
			}
		}// end draw the frame of WorkArea

		// draw the background track if need
		if (m_TrackRecordNode.IsOpen() && !m_TrackRecordNode.IsEmpty())
		{
			NCNODEEX* _pBase = m_TrackRecordNode.GetBase();
			NCNODEEX* _pMax = _pBase + m_TrackRecordNode.GetSize();
			if (!m_dataprovider->TrackIsIdle())
				_pMax--;
			
			//AXDOUBLE_KERNEL _org = GetWorkcoorOrg();  
			//NCNODEEX::REAL _org_x = (NCNODEEX::REAL)_org[m_nX];
			//NCNODEEX::REAL _org_y = (NCNODEEX::REAL)_org[m_nY];
			//NCNODEEX::REAL _org_z = (NCNODEEX::REAL)_org[m_nZ];
			NCNODEEX::REAL _org_x = 0;
			NCNODEEX::REAL _org_y = 0;
			NCNODEEX::REAL _org_z = 0;

			NCNODEEX::POINT3D _pt;
			_pt.x = _pBase->pt3D.x + _org_x;
			_pt.y = _pBase->pt3D.y + _org_y;
			_pt.z = _pBase->pt3D.z + _org_z;

			POINTD _cur = CubicTransform(&_pt);
			m_dc.MoveTo_LP(_cur);
			_pBase->pt2D = m_dc.m_ptLastDP;
			m_dc.SetBackupLineType(PEN_G00_SIMU);
			m_dc.BeginPolylineTo();

			for (NCNODEEX* _prec = _pBase + 1; _prec < _pMax; _prec++)
			{
				int _line_type = _prec->nGType;
				if(_line_type & FLG_G02)
					_line_type = 2;
				else if(_line_type & FLG_G03)
					_line_type = 3;
				else if(_line_type &FLG_G01)
					_line_type=1;
				else if(_line_type & FLG_GXX)
					_line_type = 0;

				if (m_dc.m_nLineType != PEN_G00_SIMU + _line_type)
				{
					// before changing pen, flush the buffer
					m_dc.FlushPolylineToBuffer();
					m_dc.SetBackupLineType(PEN_G00_SIMU + _line_type);
				}

				_pt.x = _prec->pt3D.x + _org_x;
				_pt.y = _prec->pt3D.y + _org_y;
				_pt.z = _prec->pt3D.z + _org_z;

				POINTD _curt = CubicTransform(&_pt);
				m_dc.PolylineTo_LP(_curt);
				_prec->pt2D = m_dc.m_ptLastDP;
			}
			m_dc.EndPolylineTo();

			// resort m_dc
			m_dc.SetBackupLineType(PEN_G00);

		}

		// set the current point of the backup DC in the m_dc
		if (m_TrackRecord.IsOpen())
		{
			NCNODEEX* _pBase = m_TrackRecord.GetBase();
			POINTD _cur = CubicTransform(&_pBase->pt3D);
			m_dc.MoveTo_LP(_cur);
			_pBase->pt2D = m_dc.m_ptLastDP;

			m_dc.m_nNextPoint = 1;
			m_dc.SetBackupLineType(PEN_G00);
		}
	} // end background setting and drawing at the first time

	if (m_TrackRecord.IsOpen())
	{
		int _nLastPoint = m_TrackRecord.GetSize() - 1;
		// This is the index of the last permanent point. This function only paints the
		// permanent lines, which are lines between the permanent points. The last line,
		// which is a un-permanent line, is painted by CTraceCtrl::DrawTrack().

		if (int(m_dc.m_nNextPoint) < _nLastPoint)
		{
			__int64 _tick_start = NcGetTickCount();
			int _records = 0;
			NCNODEEX* _pBase = m_TrackRecord.GetBase();
			NCNODEEX* _pMax = _pBase + _nLastPoint;

			m_dc.BeginPolylineTo();
			for (NCNODEEX* _prec = _pBase + m_dc.m_nNextPoint; _prec < _pMax; _prec++)
			{
				int _line_type = _prec->nGType;
				if (_prec->bSelected)
					_line_type = -1;
				if (m_dc.m_nLineType != _line_type)
				{
					// before changing pen, flush the buffer
					m_dc.FlushPolylineToBuffer();
					m_dc.SetBackupLineType(_line_type);
				}
				POINTD _cur = CubicTransform(&_prec->pt3D);
				m_dc.PolylineTo_LP(_cur);
				_prec->pt2D = m_dc.m_ptLastDP;

				// check escaped time
				if (!(++_records % 1024))
				{
					__int64 _tick_end = NcGetTickCount();
					if (_tick_end - _tick_start > 50)
					{
						// too lang time at this time, quit this function first, and the function
						// ContinuePlayback(), which is called periodly by timer, will call me again.
						break;
					}
				}
			}
			m_dc.EndPolylineTo();
			m_dc.m_nNextPoint += _records;
		}
	}
	
	// switch back the output DC
	m_dc.OutputToScreen();
	return;
}

void CTraceCtrl::ContinuePlayback()
{
	// because this function is driven by timer, we set a re-enter guard again.
	if (m_bAlreadyInContinuePlayback)
	{
		ASSERT(false);
		return;
	}
	CReentryGuard _guard(m_bAlreadyInContinuePlayback);

	int _size = m_TrackRecord.GetSize();
	int _nNextPoint = m_dc.m_nNextPoint;	// backup before change

	if ((_nNextPoint >= _size - 1) ||		
		m_dc.GetAreaXYZ()->IsRectEmpty())
	{
		// we come here when track-drawing finished or the track-record 
		// is no changes since the last call.
		return;	
	}

	Playback();	// this call will update m_dc.m_nNextPoint

	if (_nNextPoint <= m_nNumofRecordToPaint - 1)
	{
		DrawTrack(&m_dc);

		// this is the last time.
		if (int(m_dc.m_nNextPoint) >= m_nNumofRecordToPaint - 1)
			DrawDecorators();
	}
	return;
}

void CTraceCtrl::DrawAreaXYZ(const NCNODEEX::POINT3D* pPos_, NCNODEEX* pDelta_)
{
	ASSERT(pPos_ && pDelta_);

	if (m_dc.GetAreaXYZ()->IsRectEmpty())
		return;

	m_dc.ClipAreaXYZ();
	POINTD _cur = CubicTransform(pPos_);
	m_dc.MoveTo_LP(_cur);
	_cur = CubicTransform(&pDelta_->pt3D);
	m_dc.LineTo_LP(_cur);
	m_dc.ClipNull();
	return;
}

//ٶȲͼ
void CTraceCtrl::ShowCmdType(CMD_HEADER* pCmd_)
{
	if(m_nShowSpeed == _SHOW_SPEED_NO
		|| (NULL == pCmd_)
		|| !(pCmd_->nCmd == ID_CMDDN_MOTION )
		|| m_bSimulating
/*			||pCmd_->nCmd == ID_CMDAP_FP_G
			||pCmd_->nCmd == ID_CMDAP_STRING*/
		)
	{
		return ;
	}

	CMD_NODE_MOTION* nodeMotion = NULL;

	WORD _gtype = 0;
	if(pCmd_->nCmd == ID_CMDDN_MOTION)
	{	
		nodeMotion = (CMD_NODE_MOTION*)pCmd_;
		_gtype = nodeMotion->nFlags & FLG_GXX;
			if(nodeMotion->nFlags & FLG_G02)
				_gtype = 2;
			else if(nodeMotion->nFlags & FLG_G03)
				_gtype = 3;
			else if(nodeMotion->nFlags & FLG_G01)
				_gtype = 1;
			else 
				_gtype = 0;
	}


	int _default_cycle_time_in_us = int(this->GetDeviceT() * 1e6);

	if (m_nShowSpeed != _SHOW_DEBUG)
	{
		// clear background
		if (++m_nCoorX > m_rcSpeed.right)
		{
			m_nCoorX = 0;
		}

		m_dc.SelectStockObject(BLACK_PEN);
		m_dc.MoveTo(m_nCoorX, m_rcSpeed.bottom);
		m_dc.LineTo(m_nCoorX, m_rcSpeed.bottom - 100);
		
		// draw NCCMD_KERNEL type
		if (pCmd_->nCmd == ID_CMDDN_MOTION)
		{
			if (_gtype > 3) 
				_gtype = 1;	// default is G01
			m_dc.SelectObject(&m_pens[_gtype]);
		}
		else
		{
			m_dc.SelectObject(&m_pens[PEN_COOR]);
		}
		m_dc.SelectObject(&m_pens[_gtype]);

		m_dc.MoveTo(m_nCoorX, m_rcSpeed.bottom - 2);
		m_dc.LineTo(m_nCoorX, m_rcSpeed.bottom - 4);
	}
	

	//switch(pCmd_->nCmd)
	//{
	//case ID_CMDAP_FP_G:
	//	{
	//		m_dc.SelectStockObject(WHITE_PEN);
	//		m_dc.MoveTo(m_nCoorX, m_rcSpeed.bottom - Y_BASE);
	//		m_dc.LineTo(m_nCoorX, m_rcSpeed.bottom - Y_VAL(50));
	//	}
	//	break;

	//case ID_CMDDN_MOTION:
	//	{

	if (NULL == nodeMotion)
		return;
			
			static AXDOUBLE_KERNEL _s_nxSpeedLast(0,0,0);
			static double _s_lastTime = 0;
			CMD_NODE_MOTION* lastMotion = (CMD_NODE_MOTION*)m_LastNccmd;

			AXDOUBLE_KERNEL _nxSpeed; 
			_nxSpeed[0] = (nodeMotion->nPoint.x - lastMotion->nPoint.x) * 1000000 / nodeMotion->nTime;
			_nxSpeed[1] = (nodeMotion->nPoint.y - lastMotion->nPoint.y) * 1000000 / nodeMotion->nTime;
			_nxSpeed[2] = (nodeMotion->nPoint.z - lastMotion->nPoint.z) * 1000000 / nodeMotion->nTime;
					
			int _nCoorY = m_rcSpeed.bottom - 40;
			if (_SHOW_SPEED_SUM == m_nShowSpeed)
				_nCoorY = m_rcSpeed.bottom - 18;
			
			int _nDelta = 0;
			switch (m_nShowSpeed)
			{
			case _SHOW_SPEED_SUM: _nDelta = _round(_nxSpeed.GetLength()); break;
			case _SHOW_SPEED_X:	_nDelta = int(_nxSpeed[m_nX]); break;
			case _SHOW_SPEED_Y: _nDelta = int(_nxSpeed[m_nY]); break;
			case _SHOW_SPEED_Z: _nDelta = int(_nxSpeed[m_nZ]); break;
			case _SHOW_SPEED_DELTAX: _nDelta = int((_nxSpeed[m_nX] - _s_nxSpeedLast[m_nX])*128/ (nodeMotion->nTime/_default_cycle_time_in_us)); break;
			case _SHOW_SPEED_DELTAY: _nDelta = int((_nxSpeed[m_nY] - _s_nxSpeedLast[m_nY])*128/ (nodeMotion->nTime/_default_cycle_time_in_us)); break;
			case _SHOW_SPEED_DELTAZ: _nDelta = int((_nxSpeed[m_nZ] - _s_nxSpeedLast[m_nZ])*128/ (nodeMotion->nTime/_default_cycle_time_in_us)); break; 
			case _SHOW_DEBUG:
			case _SHOW_SPEED_NO: 
			default: 
				_nDelta = 0;
				break;
			}
			
			CPen* _ppenOld = NULL;
			if ((nodeMotion->nTime < 10) || (lastMotion->nTime < 10))
				_ppenOld = m_dc.SelectObject(&m_pens[PEN_COOR]);
			m_dc.MoveTo(m_nCoorX, _nCoorY);
			m_dc.LineTo(m_nCoorX, _nCoorY - _nDelta);
			if (_ppenOld)
				m_dc.SelectObject(_ppenOld);
			
			memcpy(m_LastNccmd, nodeMotion, nodeMotion->nSize);
			memcpy(&_s_nxSpeedLast,&_nxSpeed,sizeof(_nxSpeed));
			_s_lastTime = nodeMotion->nTime;

	//	}
	//	break;

	//case ID_CMDAP_STRING:
	//	{
	//		if (m_nShowSpeed == _SHOW_DEBUG)
	//		{
	//			// clear background
	//			if (++m_nCoorX > m_rcSpeed.right)
	//				m_nCoorX = 0;
	//			m_dc.SelectStockObject(BLACK_PEN);
	//			m_dc.MoveTo(m_nCoorX, m_rcSpeed.bottom);
	//			m_dc.LineTo(m_nCoorX, m_rcSpeed.bottom - 100);
	//			
	//			// draw NCCMD_KERNEL type
	//			m_dc.SelectObject(&m_pens[PEN_COOR]);
	//			m_dc.MoveTo(m_nCoorX, m_rcSpeed.bottom - 2);
	//			m_dc.LineTo(m_nCoorX, m_rcSpeed.bottom - 4);
	//			
	//			m_dc.MoveTo(m_nCoorX, m_rcSpeed.bottom - Y_BASE);
	//			__int64 _v = pCmd_->nV64 / 1 - 0; 
	//			m_dc.LineTo(m_nCoorX, m_rcSpeed.bottom - Y_VAL(int(_v)));
	//		}
	//	}
	//	break;

	//default:
	//	break;
	//}

	return;
}

/***********************************************************************
ȡNCCMD_KERNELƵǰӹ켣ҰNCCMD_KERNEL¼m_TrackRecord -
***********************************************************************/
void CTraceCtrl::RecordNccmd(CMD_HEADER* pCmd_)
{
	ShowCmdType(pCmd_);
	
	switch (pCmd_->nCmd)
	{
	case ID_CMDDN_BEGIN:
		{
			CMDDN_BEGIN* _begin = (CMDDN_BEGIN*)pCmd_;
			if(_begin->nMSN == 0)
			{
				m_nLastFP = EOF;
				m_nLastGType = 0;
				m_nLastLineNoOrID = 0;  
				m_nOffset = 0;
			}

			m_bSimulating = m_dataprovider->IsSimulating();

			if (m_bSimulating)
			{
				SetTimer(IDTIMER_SIMULATOR, 5, NULL);
			}
		}
		break;

	case ID_CMDDN_END:
		{
			UpdateTrackWhileSimulating(true);
			m_nLastFP = EOF;
			m_nLastLineNoOrID = 0; 
			m_nOffset = 0;
			KillTimer(IDTIMER_SIMULATOR);
		};
		break;

	case ID_CMDAP_FP_G:
		{
			CMD_FP_G* _pFpg = (CMD_FP_G*)pCmd_;
			m_nLastFP = _pFpg->nFP;
			m_nLastLineNoOrID = _pFpg->nStatementCount;
			m_nOffset = _pFpg->nOffset;
			m_nFileType = _pFpg->nFileType;
		}
		break;

	case ID_CMDDN_MOTION:
		{
			CMD_NODE_MOTION* interMotion = (CMD_NODE_MOTION*)pCmd_;
			WORD _gtype = interMotion->nFlags & FLG_GXX;
				if(interMotion->nFlags & FLG_G02)
					_gtype = 2;
				else if(interMotion->nFlags & FLG_G03)
					_gtype = 3;
				else if(interMotion->nFlags &FLG_G01)
					_gtype = 1;
				else if(interMotion->nFlags & FLG_STARTPOINT)
					_gtype = 29;
				else 
					_gtype = 0;

				if (_gtype > CTraceCtrl::PEN_GOTHER && _gtype != CTraceCtrl::PEN_STARTPOINT) 
				_gtype = CTraceCtrl::PEN_GOTHER;

			NCNODEEX _rec;
			_rec.bSelected = false;
			_rec.nGType = (BYTE)_gtype;
			_rec.pt3D.x = (float)interMotion->nPoint.x;
			_rec.pt3D.y = (float)interMotion->nPoint.y;
			_rec.pt3D.z = (float)interMotion->nPoint.z;

			_rec.nFilePos = m_nLastFP;
			_rec.nLineOrID = m_nLastLineNoOrID; 
			_rec.nOffset = m_nOffset;
			_rec.nFileType = m_nFileType;
			_rec.pt2D.x = _rec.pt2D.y = -1;
			

			bool _bHasPulse = interMotion->nPoint.x != 0 
				|| interMotion->nPoint.y != 0 
				|| interMotion->nPoint.z != 0;
			if (_bHasPulse && !m_bSimulating)
			{
					m_dc.SelectObject(&m_pens[_gtype]);
					//ǰһӹĹ켣Ƶǰӹ켣 -
					NCNODEEX::POINT3D _lp((NCNODEEX::REAL)m_ptLastPoint.x, 
						(NCNODEEX::REAL)m_ptLastPoint.y, 
						(NCNODEEX::REAL)m_ptLastPoint.z);
					DrawAreaXYZ(&_lp, &_rec);
				
			}

			if ((m_nLastGType == 0) && (_gtype != 0))
				UpdateTraceMachArea();	// update it before updating m_ptLastPoint. 
										// it means that m_ptLastPoint is start-point.
			
			m_ptLastPoint.x = interMotion->nPoint.x;
			m_ptLastPoint.y = interMotion->nPoint.y;
			m_ptLastPoint.z = interMotion->nPoint.z;
			
			UpdateTraceMotionArea();
			if (0 != _gtype)
				UpdateTraceMachArea();	// update it after updating m_ptLastPoint. 
										// it means that m_ptLastPoint is end-point.
			
			m_nLastGType = _gtype; 
			
			// append it to recorder

			if(interMotion->nFlags & FLG_STARTPOINT)
			{
				CommitRecord(&_rec, CTrackRecorder::UNPACK_ALWAYS);
			}
			else if (!(interMotion->nFlags & FLG_FIRST))
			{
				if (_bHasPulse)
				{
					if((interMotion->nFlags & FLG_GXX) == 0)
					{
						CommitRecord(&_rec, CTrackRecorder::PACK_ALWAYS);
					}
					else if((interMotion->nFlags & FLG_G01))
					{
						CommitRecord(&_rec, CTrackRecorder::PACK_ALWAYS);
					}
					else if((interMotion->nFlags & FLG_G02))
					{
						CommitRecord(&_rec, CTrackRecorder::PACK_SMART);
					}
					else if((interMotion->nFlags & FLG_G03))
					{
						CommitRecord(&_rec, CTrackRecorder::PACK_SMART);
					}
					else if((interMotion->nFlags & FLG_GXX) == 1)
					{
						CommitRecord(&_rec, CTrackRecorder::PACK_SMART);
					}
					else
					{
						ASSERT(false);
					}
				}
			}
			else
			{
				CommitRecord(&_rec, CTrackRecorder::UNPACK_ALWAYS);
			}
		}
		break;

	case ID_CMDDN_DISTOFFSET:
		{
			::CMDDN_DISTOFFSET* distOffset = (CMDDN_DISTOFFSET*)pCmd_;

			m_ptLastPoint.x += distOffset->nxDistOffset[0]*360.;
			m_ptLastPoint.y += distOffset->nxDistOffset[1]*360.;
			m_ptLastPoint.z += distOffset->nxDistOffset[2]*360.;
			ASSERT(false);
		}
		break;

	default:
		break;
	}

	return;
}
/**********************************************************************
NCCMD_KERNELûеʱҪͬǰӹ켣.仰˵ϵͳУ
״̬ʱҪͨͬϵͳĵǰ -
**********************************************************************/
void CTraceCtrl::SynchronizeLastPoint()
{
	AXDOUBLE_KERNEL _nxCurPos = GetCurPos();

	if ((fabs(m_ptLastPoint.x - _nxCurPos[m_nX]) > 10 * m_nPerPulseX) ||
		(fabs(m_ptLastPoint.y - _nxCurPos[m_nY]) > 10 * m_nPerPulseY) ||
		(fabs(m_ptLastPoint.z - _nxCurPos[m_nZ]) > 10 * m_nPerPulseZ))
	{
		EraseCrosses(&m_dc);

		NCNODEEX _lastrec;
		_lastrec.bSelected = false;
		_lastrec.nGType = 0;
		_lastrec.pt3D.x = (NCNODEEX::REAL)m_ptLastPoint.x;
		_lastrec.pt3D.y = (NCNODEEX::REAL)m_ptLastPoint.y;
		_lastrec.pt3D.z = (NCNODEEX::REAL)m_ptLastPoint.z;
		_lastrec.nFilePos = m_nLastFP;
		_lastrec.nLineOrID = m_nLastLineNoOrID;
		_lastrec.nOffset = m_nOffset;
		_lastrec.nFileType = m_nFileType;
		_lastrec.pt2D.x = _lastrec.pt2D.y = -1;

		m_ptLastPoint.x = _nxCurPos[m_nX];
		m_ptLastPoint.y = _nxCurPos[m_nY];
		m_ptLastPoint.z = _nxCurPos[m_nZ];

		NCNODEEX _rec;
		_rec.bSelected = false;
		_rec.nGType = 0;
		_rec.pt3D.x = (NCNODEEX::REAL)_nxCurPos[m_nX];
		_rec.pt3D.y = (NCNODEEX::REAL)_nxCurPos[m_nY];
		_rec.pt3D.z = (NCNODEEX::REAL)_nxCurPos[m_nZ];
		_rec.nFilePos = m_nLastFP;
		_rec.nLineOrID = m_nLastLineNoOrID; 
		_rec.pt2D.x = _rec.pt2D.y = -1;
		//CommitRecord(&_rec, CTrackRecorder::UNPACK_ALWAYS);

		//m_dc.SelectObject(&m_pens[PEN_G00]);
		//DrawAreaXYZ(&_lastrec.pt3D, &_rec);
		UpdateTraceMotionArea();

		NCNODEEX::POINT3D _lp((NCNODEEX::REAL)m_ptLastPoint.x,
			(NCNODEEX::REAL)m_ptLastPoint.y,
			(NCNODEEX::REAL)m_ptLastPoint.z);
		DrawCrosses(&m_dc, &_lp); 
		DrawCurrentCoor(&m_dc);		
	}
	return;
}

// Description:
//	This function provides a rapid way to draw the track if we are in
//	simulation mode.
void CTraceCtrl::UpdateTrackWhileSimulating(bool bFinish_)
{
	if (IsSimulating()) 
	{
		int _size = m_TrackRecord.GetSize();
		if (_size < 3)
			return;
		NCNODEEX* _pBase = m_TrackRecord.GetBase();
		NCNODEEX* _pN_2 = _pBase + _size - 2;
		NCNODEEX* _pN_3 = _pBase + _size - 3;

		if (bFinish_)
		{
			_pN_2++;
			_pN_3++;
		}

		m_dc.SelectObject(&m_pens[_pN_2->nGType]);
		DrawAreaXYZ(&_pN_3->pt3D, _pN_2);
	}
	return;
}

void CTraceCtrl::CommitRecord(const NCNODEEX* pRec_, int flag_)
{
	// m_TrackRecord.Commit() returns true if packed, otherwise false. 
	// packing means that a new point is appended to the m_TrackRecord. 
	//
	// At this case, we update the track if we are in simulation mode.
	if (!m_TrackRecord.Commit(pRec_, flag_))
		UpdateTrackWhileSimulating();
	return;
}

/////////////////////////////////////////////////////////////////////////////
// CTraceCtrl transforming

void CTraceCtrl::SetZoomRatio(double ratio_)
{
	if (ratio_ < g_ratio[0])
		ratio_ = g_ratio[0];
	if (ratio_ > g_ratio[RATIO_COUNT - 1])
		ratio_ = g_ratio[RATIO_COUNT - 1];

	if (m_dc.SetZoomRatio(ratio_))	// changed
	{
		SetOperation(m_nOperation);	// update it
		InvalidateRect(NULL);
	}
	return;
}

double CTraceCtrl::GetFitZoomRatio()
{
	double _xp[2], _yp[2], _zp[2];

	bool _bInit = false;
	if (m_bIsFileTrackFirst)
	{
		
		if (m_TrackRecordNode.IsOpen())
		{		
			//AXDOUBLE_KERNEL _org = GetWorkcoorOrg(); 
			//NCNODEEX::REAL _org_x = (NCNODEEX::REAL)_org[m_nX];
			//NCNODEEX::REAL _org_y = (NCNODEEX::REAL)_org[m_nY];
			//NCNODEEX::REAL _org_z = (NCNODEEX::REAL)_org[m_nZ];

			NCNODEEX::REAL _org_x = 0.0;
			NCNODEEX::REAL _org_y = 0.0;
			NCNODEEX::REAL _org_z = 0.0;

			if (m_traceAreaUpdate.IsMachValid())
			{
				_xp[0] = m_traceAreaUpdate.ptMachMax.x + _org_x;
				_xp[1] = m_traceAreaUpdate.ptMachMin.x + _org_x;
				_yp[0] = m_traceAreaUpdate.ptMachMax.y + _org_y;
				_yp[1] = m_traceAreaUpdate.ptMachMin.y + _org_y;
				_zp[0] = m_traceAreaUpdate.ptMachMax.z + _org_z;
				_zp[1] = m_traceAreaUpdate.ptMachMin.z + _org_z;
				_bInit = true;
			}
			else if (m_traceAreaUpdate.IsMotionValid())
			{
				_xp[0] = m_traceAreaUpdate.ptMotionMax.x + _org_x;
				_xp[1] = m_traceAreaUpdate.ptMotionMin.x + _org_x;
				_yp[0] = m_traceAreaUpdate.ptMotionMax.y + _org_y;
				_yp[1] = m_traceAreaUpdate.ptMotionMin.y + _org_y;
				_zp[0] = m_traceAreaUpdate.ptMotionMax.z + _org_z;
				_zp[1] = m_traceAreaUpdate.ptMotionMin.z + _org_z;
				_bInit = true;
			} 
		}
	}

	if (!_bInit)
	{
		if (m_TraceArea.IsMachValid())
		{
			_xp[0] = m_TraceArea.ptMachMax.x;
			_xp[1] = m_TraceArea.ptMachMin.x;
			_yp[0] = m_TraceArea.ptMachMax.y;
			_yp[1] = m_TraceArea.ptMachMin.y;
			_zp[0] = m_TraceArea.ptMachMax.z;
			_zp[1] = m_TraceArea.ptMachMin.z;
		}
		else if (m_TraceArea.IsMotionValid())
		{
			_xp[0] = m_TraceArea.ptMotionMax.x;
			_xp[1] = m_TraceArea.ptMotionMin.x;
			_yp[0] = m_TraceArea.ptMotionMax.y;
			_yp[1] = m_TraceArea.ptMotionMin.y;
			_zp[0] = m_TraceArea.ptMotionMax.z;
			_zp[1] = m_TraceArea.ptMotionMin.z;
		}
		else
		{
			_xp[0] = m_WorkAreaMax.x;
			_xp[1] = m_WorkAreaMin.x;
			_yp[0] = m_WorkAreaMax.y;
			_yp[1] = m_WorkAreaMin.y;
			_zp[0] = m_WorkAreaMax.z;
			_zp[1] = m_WorkAreaMin.z;
		}
	}

	CSimuDCEx _dc;
	_dc.CopyAttributes(&m_dc);
	_dc.SetZoomRatio(1.0);

	int _x_min = INT_MAX, _y_min = INT_MAX, _x_max = INT_MIN, _y_max = INT_MIN;
	for (int _i = 0; _i < cNUMOF_VERTEX; _i++)
	{
		// get a vetex
		NCNODEEX::POINT3D _pt(
			(NCNODEEX::REAL)_xp[_i & 0x4 ? 1 : 0],
			(NCNODEEX::REAL)_yp[_i & 0x2 ? 1 : 0],
			(NCNODEEX::REAL)_zp[_i & 0x1 ? 1 : 0]);

		// convert it to 2D
		POINTD _pt2D = CubicTransform(&_pt);
		POINT _pt2D_dp;
		_dc.LPtoDP_SM(&_pt2D, &_pt2D_dp);

		// get min. and max.
		_x_min = min(_x_min, _pt2D_dp.x);
		_x_max = max(_x_max, _pt2D_dp.x);
		_y_min = min(_y_min, _pt2D_dp.y);
		_y_max = max(_y_max, _pt2D_dp.y);
	}

	const CRect* _pRect = m_dc.GetAreaXYZ();
	double _nRatio = g_ratio[RATIO_COUNT - 1]; // max ratio
	_nRatio = min(_nRatio, (double)(_pRect->Width() - 10) /(_x_max - _x_min));
	_nRatio = min(_nRatio, (double)(_pRect->Height() - 10) /(_y_max - _y_min));
	return _nRatio * 0.8;	// best fit is picture holds 80% of the window
}

void CTraceCtrl::SetOperation(_operation_t operation_)
{
	switch (operation_)
	{
	case SELECT:
	case MOVE:
		// do nothing
		break;

	case ZOOMIN:
	case ZOOMOUT:
		if (GetZoomRatio() >= g_ratio[RATIO_COUNT - 1])
			operation_ = ZOOMIN;
		else if (GetZoomRatio() <= g_ratio[0])
			operation_ = ZOOMOUT;
		break;

		// do nothing
		break;

	default:
		ASSERT(false);
		return;
	}

	m_nOperation = operation_;
	UpdateCursor();
	return;
}

void CTraceCtrl::SetSelectMode(CTrackRecorder::select_t operator_)
{
	switch (operator_)
	{
	case CTrackRecorder::NOT:
	case CTrackRecorder::OR:
	case CTrackRecorder::XOR:
		m_nSelectMode = operator_;
		break;

	case CTrackRecorder::NONE:
		ASSERT(false);
		return;
	}

	UpdateCursor();
	return;
}

bool CTraceCtrl::UpdateCursor()
{
	POINT _pt;
	GetCursorPos(&_pt);
	ScreenToClient(&_pt);

	if (m_dc.GetAreaXYZ()->PtInRect(_pt))
	{
		switch (m_nOperation)
		{
		case ZOOMOUT:
			::SetCursor(m_hcurZoomout);
			return true;
		case ZOOMIN:
			::SetCursor(m_hcurZoomin);
			return true;
		case MOVE:
			//::SetCursor(m_hcurMove);
			::SetCursor(m_hcurRelease);
			return true;
		case SELECT:
			if (m_nSelectMode == CTrackRecorder::OR)
				::SetCursor(m_hcurSelectOr);
			else if (m_nSelectMode == CTrackRecorder::NOT)
				::SetCursor(m_hcurSelectNot);
			else if (m_nSelectMode == CTrackRecorder::XOR)
				::SetCursor(m_hcurSelectXor);
			else
			{
				ASSERT(false);
				return false;
			}
			return true;
		default:
			ASSERT(false);
			return false;
		}
	}
	return false;
}

// center the workpiece
void CTraceCtrl::CenterWorkpiece(const POINTD* ppt_ /* = NULL */)
{
	double _nOffsetX = 0;
	double _nOffsetY = 0;

	if (NULL == ppt_)
	{
		POINTD _ptL;
		CPoint _pt0 = m_dc.GetAreaXYZ()->CenterPoint();
		m_dc.DPtoLP_SM(&_pt0, &_ptL);		
		
		_nOffsetX = _ptL.x;
		_nOffsetY = _ptL.y;
	}
	else
	{
		_nOffsetX = ppt_->x;
		_nOffsetY = ppt_->y;
	}

	POINTD _pt = GetWorkpieceCenterPoint();
	OffsetLogicalRef(_pt.x - _nOffsetX, _pt.y - _nOffsetY);
		
	if (m_hWnd)
		InvalidateRect(NULL);
}

// Center the current cutting pointer
void CTraceCtrl::CenterCursor()
{
	NCNODEEX::POINT3D _lp((NCNODEEX::REAL)m_ptLastPoint.x, 
						  (NCNODEEX::REAL)m_ptLastPoint.y, 
						  (NCNODEEX::REAL)m_ptLastPoint.z);
	POINTD _pt = CubicTransform(&_lp);
	CPoint _pt0 = m_dc.GetAreaXYZ()->CenterPoint();
	POINTD _ptL;
	m_dc.DPtoLP_SM(&_pt0, &_ptL);
	OffsetLogicalRef(_pt.x - _ptL.x, _pt.y - _ptL.y);
	if (m_hWnd)
		InvalidateRect(NULL);
}

void CTraceCtrl::RotateX(double angle_)
{
	TRANSMATRIX	_mt;
	_mt[0][0] = 1;
	_mt[0][1] = 0;
	_mt[0][2] = 0;
	_mt[1][0] = 0;
	_mt[1][1] = cos(angle_);
	_mt[1][2] = sin(angle_);
	_mt[2][0] = 0;
	_mt[2][1] = -sin(angle_);
	_mt[2][2] = cos(angle_);

	_tam(&m_matrixTrans, &m_matrixTrans, &_mt);
	return;
}

void CTraceCtrl::RotateY(double angle_)
{
	TRANSMATRIX	_mt;
	_mt[0][0] = cos(angle_);
	_mt[0][1] = 0;
	_mt[0][2] = -sin(angle_);
	_mt[1][0] = 0;
	_mt[1][1] = 1;
	_mt[1][2] = 0;
	_mt[2][0] = sin(angle_);
	_mt[2][1] = 0;
	_mt[2][2] = cos(angle_);

	_tam(&m_matrixTrans, &m_matrixTrans, &_mt);
	return;
}

void CTraceCtrl::RotateZ(double angle_)
{
	TRANSMATRIX	_mt;
	_mt[0][0] = cos(angle_);
	_mt[0][1] = sin(angle_);
	_mt[0][2] = 0;
	_mt[1][0] = -sin(angle_);
	_mt[1][1] = cos(angle_);
	_mt[1][2] = 0;
	_mt[2][0] = 0;
	_mt[2][1] = 0;
	_mt[2][2] = 1;

	_tam(&m_matrixTrans, &m_matrixTrans, &_mt);
	return;
}

void CTraceCtrl::SetTransformMatrix(_proj_t mode_)
{
	for (int _row = 0; _row < 3; _row++)
		for (int _col = 0; _col < 3; _col++)
			m_matrixTrans[_row][_col] = _row == _col ? 1 : 0;

	switch (mode_)
	{
	case PROJ_ISOMETRIC_SE:
		RotateZ(-1 * c_nANGLE_SITA * c_nPIE / 180);
		RotateX(c_nANGLE_FAI * c_nPIE / 180);
		break;
	case PROJ_ISOMETRIC_NW:
		RotateZ(c_nANGLE_SITA * c_nPIE / 180);
		RotateX(-1 * c_nANGLE_FAI * c_nPIE / 180);
		break;
	case PROJ_ISOMETRIC_SW:
		RotateZ(c_nANGLE_SITA * c_nPIE / 180);
		RotateX(c_nANGLE_FAI * c_nPIE / 180);
		break;
	case PROJ_ISOMETRIC_NE:
		RotateZ(-1 * c_nANGLE_SITA * c_nPIE / 180);
		RotateX(-1 * c_nANGLE_FAI * c_nPIE / 180);
		break;
	case PROJ_FRONT:
		break;
	case PROJ_BACK:
		RotateZ(180 * c_nPIE / 180);
		break;
	case PROJ_LEFT:
		RotateZ(90 * c_nPIE / 180);
		break;
	case PROJ_TOP:
		RotateX(90 * c_nPIE / 180);
		break;
	case PROJ_RIGHT:
		RotateZ(-90 * c_nPIE / 180);
		break;
	case PROJ_BOTTOM:
		RotateX(-90 * c_nPIE / 180);
		break;
	}

	if (m_hWnd)
	{
		// clear the track bitmap in the playbck DC
		m_dc.m_nNextPoint = 0;
		InvalidateRect(NULL);
	}
	return;
}

/////////////////////////////////////////////////////////////////////////////
// CTraceCtrl message handlers
int CTraceCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_hcurRelease = AfxGetApp()->LoadCursor(IDCSR_HAND_RELEASE);
	m_hcurCapture = AfxGetApp()->LoadCursor(IDCSR_HAND_CAPTURE);
	m_hcurMove = AfxGetApp()->LoadCursor(IDCSR_MOVE);
	m_hcurZoomin = AfxGetApp()->LoadCursor(IDCSR_ZOOMIN);
	m_hcurZoomout = AfxGetApp()->LoadCursor(IDCSR_ZOOMOUT);
	m_hcurSelectOr = AfxGetApp()->LoadCursor(IDCSR_SELECT_OR);
	m_hcurSelectNot = AfxGetApp()->LoadCursor(IDCSR_SELECT_NOT);
	m_hcurSelectXor = AfxGetApp()->LoadCursor(IDCSR_SELECT_XOR);
	m_dc.Bind(::GetDC(m_hWnd));

	// initialize attributes
	// m_dc.SelectObject(&m_pens[PEN_G00]);	// pens are not initialized yet
	m_dc.SelectStockObject(ANSI_VAR_FONT);
	m_dc.SelectStockObject(NULL_BRUSH);
	m_dc.SetBkMode(TRANSPARENT);

	EnableToolTips(TRUE);
	if (m_ToolTip.CreateEx(this, WS_POPUP | TTS_ALWAYSTIP, WS_EX_TOPMOST))
	{
		m_ToolTip.Activate(TRUE);
		m_ToolTip.SetMaxTipWidth(SHRT_MAX);
		m_ToolTip.SetDelayTime(TTDT_AUTOPOP, SHRT_MAX);
		m_ToolTip.SetDelayTime(TTDT_INITIAL, 200);
		m_ToolTip.SetDelayTime(TTDT_RESHOW, 200);
		m_ToolTip.AddTool(this);
	}

	Initialize();

	SetTimer(IDTIMER_UPDATE_TARCK, c_nCONTINUEPLAYBACK_TIMER_INTERVAL, NULL);

	// Do NOT call LoadTheme() directly, because the window does not finish its 
	// creating steps yet before this function and its caller returns!  Insteadly,
	// we use a message(WM_LOADTHEME) to trigger another virtual call after this
	// function returns.
	//GetTheme()->PostLoadThemeMessage(this);
	return 0;
}

void CTraceCtrl::OnDestroy()
{
	CWnd::OnDestroy();

	KillTimer(IDTIMER_READNCCMD);
	KillTimer(IDTIMER_UPDATE_TARCK);
	EnableTimer(false);
	MSG _msg;
	PeekMessage(&_msg, m_hWnd, WM_TIMER, WM_TIMER, PM_REMOVE);

	DestroyDrawingTools();
	m_TrackRecord.Close();
	m_TrackRecordNode.Close();

	HDC _hdc = m_dc.Unbind();
	::DeleteDC(_hdc);
	// because this DC was got at OnCreate(), we must delete it here!
}

void CTraceCtrl::OnSetFocus(CWnd* pOldWnd_)
{
	if (m_hWnd)
		InvalidateRect(NULL);
	return;
}

void CTraceCtrl::OnKillFocus(CWnd* pNewWnd_)
{
	m_bReceiveArrowMsgs = false;
	if (m_hWnd)
		InvalidateRect(NULL);
	return;
}

BOOL CTraceCtrl::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
	// return CWnd::OnEraseBkgnd(pDC);
}

void CTraceCtrl::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	if (m_ToolTip.m_hWnd)
	{
		m_ToolTip.DelTool(this);

		CRect _rc; GetClientRect(&_rc);
		m_ToolTip.AddTool(this, LPSTR_TEXTCALLBACK, &_rc, 10);
		//m_ToolTip.Activate(TRUE);
	}

	CalculateLayout(cx, cy);
}

BOOL CTraceCtrl::OnToolTipNeedText(UINT id_, NMHDR* pNMHDR_, LRESULT* pResult_)
{
    BOOL _bHandledNotify = FALSE;

    CPoint _point;
    ::GetCursorPos(&_point);
    ScreenToClient(&_point);

    CRect _rcClient;
    GetClientRect(_rcClient);

    // Make certain that the cursor is in the client rect, because the
    // mainframe also wants these messages to provide tooltips for the
    // toolbar.
    if (_rcClient.PtInRect(_point))
    {
        TOOLTIPTEXT* _pTTT = (TOOLTIPTEXT*)pNMHDR_;
		m_HitField = m_TrackRecord.HitTest(CTrackRecorder::NONE, _point);

        if (m_HitField.from != -1)
        {
			CString _strLineno;

			NCNODEEX* _pBase = m_TrackRecord.GetBase();
			if (_pBase[m_HitField.from].nFilePos != EOF)
			{
				//int _nLineno = m_pTrackProvider->GetLinenoFromFilePos(_pBase[m_HitField.from].nFilePos);

				//if (_nLineno != -1)
				//{
				//	CString _str; _str.Format(L"%d", _nLineno);
				//	_strLineno.Format(s_csHITTRACK_LINENO, (LPCTSTR)_str);
				//} add yuewenxue
			}

			// Adjust the text by filling in TOOLTIPTEXT
			::wcscpy_s(_pTTT->szText, _countof(_pTTT->szText), (LPCTSTR)_strLineno + 3); // skip |M| 
		}
		else
		{
			_pTTT->szText[0] = 0;
		}
		_bHandledNotify = TRUE;
	}
    return _bHandledNotify;
}

void CTraceCtrl::OnMouseMove(UINT nFlags_, CPoint point)
{
	if (!m_dc.GetAreaXYZ()->PtInRect(point))
		return;

	if (nFlags_ & MK_LBUTTON) // left-button is down
	{
		switch (m_nOperation)
		{
		case MOVE:
			::SetCursor(m_hcurCapture);
			MoveRect(m_ptLButtonDown);
			break;

		case SELECT:
			SelectRect(m_ptLButtonDown);
			break;

		case ZOOMOUT:
		case ZOOMIN:
			ZoomRect(m_ptLButtonDown);
			break;

		default:
			ASSERT(false);
			break;
		}
	}
	else
	{
		if (::IsWindow(m_ToolTip.m_hWnd))
		{
			LCRO_FIELD _HitField = m_TrackRecord.HitTest(CTrackRecorder::NONE, point);

			if (_HitField != m_HitField)
			{
				m_HitField = _HitField;
				DrawLineNoInfo(&m_dc);
			}
		}
	}

	return;
}

void CTraceCtrl::OnLButtonDown(UINT nFlags_, CPoint point)
{
	m_ptLButtonDown = point;

	if (m_nOperation == MOVE)
		::SetCursor(m_hcurCapture);

	if (IsWindowEnabled())
		SetFocus();
	CWnd::OnLButtonDown(nFlags_, point);
}

void CTraceCtrl::OnLButtonUp(UINT nFlags_, CPoint point)
{
	if (m_dc.GetAreaXYZ()->PtInRect(point))
	{
		if (m_nOperation == ZOOMIN)
			ZoomIn();
		else if (m_nOperation == ZOOMOUT)
			ZoomOut();
		else if (m_nOperation == SELECT)
		{
			::SetCursor(m_hcurRelease);
			SelectPoint(point);
		}
	}
	return;
}

BOOL CTraceCtrl::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	if (!UpdateCursor())
		return CWnd::OnSetCursor(pWnd, nHitTest, message);
	return TRUE;
}

void CTraceCtrl::OnPaint()
{
	CPaintDC _PaintDC(this); // device context for painting
	CRect* _prcClip =(CRect*)&_PaintDC.m_ps.rcPaint;
	ASSERT(m_dc.m_hDC == _PaintDC.m_hDC);
	// this window has its owned DC

	m_nNumofRecordToPaint = m_TrackRecord.GetSize();
	DrawTrack(&m_dc);
	DrawDecorators();

	m_nCoorX = 0;
	return;
}

void CTraceCtrl::OnKeyDown(UINT nChar_, UINT nRepCnt_, UINT nFlags_)
{
	if (!m_b2DMode && (m_nAccKey == nChar_) && !(GetKeyState(VK_CONTROL) < 0))
	{
		CTraceCtrlAccDlg _dlg(this);
		if (IDOK ==_dlg.DoModal())
		{
			UINT _nVirKey = _dlg.m_nResultVirKey;
			if (0 != _nVirKey)
				OnKeyCmd(_nVirKey);
		}
		SetFocus();
	}
	else if (!OnKeyCmd1(nChar_))
	{
		CWnd::OnKeyDown(nChar_, nRepCnt_, nFlags_);
	}
}

void CTraceCtrl::OnSysKeyDown(UINT nChar_, UINT nRepCnt_, UINT nFlags_)
{
	if (!OnSysKeyCmd(nChar_))
		CWnd::OnSysKeyDown(nChar_, nRepCnt_, nFlags_);
}

void CTraceCtrl::OnTimer(UINT nIDEvent_)
{
	if ((nIDEvent_ == IDTIMER_READNCCMD) || (nIDEvent_ == IDTIMER_SIMULATOR))
	{
		OnReadNccmd();
	}
	else if (nIDEvent_ == IDTIMER_CONTINUE_PLAYBACK)
	{
		ContinuePlayback();

		if (!((m_nTimerCounter++) % (1000 / c_nCONTINUEPLAYBACK_TIMER_INTERVAL)))
		{
			// we call it every 1000 ms
			UpdateChanges(false);
		}

		return;
	}
	else if (nIDEvent_ == IDTIMER_UPDATE_TARCK)
	{
		if(m_bUpdateTrackUI && m_dataprovider->TrackIsIdle())
		{
			m_bUpdateTrackUI = false;
			ASSERT(GetSafeHwnd());
			m_dc.m_nNextPoint = 0;
			
			//InvalidateRect(NULL, TRUE);
			InvalidateRect(NULL,FALSE);//Ʊɫֱӻ
		}	
		else if(m_TrackRecordNode.m_bUpdateTrack)
		{
			m_TrackRecordNode.m_bUpdateTrack=false;
			m_dc.m_nNextPoint = 0;
			InvalidateRect(NULL,FALSE);
		}
	}

	CWnd::OnTimer(nIDEvent_);
	return;
}

UINT CTraceCtrl::OnGetDlgCode()
{
	if (m_bReceiveArrowMsgs)
	{
		return DLGC_WANTARROWS | DLGC_WANTALLKEYS;
	}
	else
	{
		const MSG* _pMsg = CWnd::GetCurrentMessage();
		ASSERT(_pMsg->hwnd == m_hWnd);
		ASSERT(_pMsg->message == WM_GETDLGCODE);

		if (_pMsg->lParam)
		{
			__try {
				MSG* _pKeyMsg = (MSG*)_pMsg->lParam; 
				if (_pKeyMsg->message == WM_KEYDOWN)
				{
					switch (_pKeyMsg->wParam)
					{
					case VK_ESCAPE:
					case VK_RETURN:
						return DLGC_WANTALLKEYS;
					}
				}
			}
			__except(1)
			{
				TRACE(_T(""),0,0);
			}

			return DLGC_STATIC;
		}
		else	// no MSG structure sent with this message
		{
			return DLGC_WANTALLKEYS;
		}
	}
}

void CTraceCtrl::OnWindowPosChanged(WINDOWPOS* pWndPos_) 
{
	CWnd::OnWindowPosChanged(pWndPos_);
	
	if (pWndPos_->flags & SWP_SHOWWINDOW)
	{
		EnableTimer(IsWindowVisible() == TRUE);
	}
	else if (pWndPos_->flags & SWP_HIDEWINDOW)
	{
		EnableTimer(false);
	}
}

void CTraceCtrl::OnReadNccmd()
{
	ReadPulse();
	int i= 0;
	if (m_ChannelFifo.IsEmpty()
		&& m_dataprovider->IsIdleState())
	{
		// at some cases, the current position (machine coor.) may change due to the operation
		// such as bkref. so we need to synchronize m_ptLastPoint.
		SynchronizeLastPoint();
		
	}
	else if(!m_ChannelFifo.IsEmpty()) //channelfifoյʱ򲻱Ҫȡͻ add yuewenxue
	{
		EraseAssObject(NULL);
		CMD_HEADER _header;
		CMD_HEADER* _pHeader= (CMD_HEADER*)_malloca(512);
		while (true)
		{
			if (!m_ChannelFifo.PreReadStructHeader(&_header)||i++>=8000)
			{
				i=0;
				break;
			}

			ASSERT(_header.nSize<1024);
			*_pHeader = _header;
			m_ChannelFifo.ReadStruct(_pHeader);
			RecordNccmd(_pHeader);
		}

		_freea(_pHeader);
		i=0;
		NCNODEEX::POINT3D _lp((NCNODEEX::REAL)m_ptLastPoint.x, 
							  (NCNODEEX::REAL)m_ptLastPoint.y, 
							  (NCNODEEX::REAL)m_ptLastPoint.z);
		DrawAssObject(&_lp);
	}
	return;
}

void CTraceCtrl::ShowNextSpeed()
{
	int _i;
	for (_i = 0; _i < c_nNUMOF_SHOWSPEEDPROMPT; _i++)
	{
		if (m_nShowSpeed == (_SHOW_SPEED_NO + _i))
			break;
	}
	if (++_i >= c_nNUMOF_SHOWSPEEDPROMPT)
		_i = 0;
	
	m_nShowSpeed = (_show_speed_t)(_SHOW_SPEED_NO + _i);

	if(m_nShowSpeed == _SHOW_DEBUG)
	{
		m_nShowSpeed = _SHOW_SPEED_NO;
	}

	if (m_hWnd)
		InvalidateRect(NULL);

	//NCADPT_UPDATESIMPLEVAR_INSTRUCT* _psv = &GetNcKernel()->m_ss.m_sv;
	//if (m_nShowSpeed != _SHOW_SPEED_NO)
	//{
	//	if (_psv->bCompressNccmd)
	//	{
	//		m_nCompressNccmd_Old = _psv->bCompressNccmd;	// true

	//		_psv->bCompressNccmd = false;
	//		GetNcKernel()->UpdateSimpleVar(SV_COMPRESSNCCMD);
	//	}
	//}
	//else
	//{
	//	if (!_psv->bCompressNccmd && (m_nCompressNccmd_Old == 1))
	//	{
	//		_psv->bCompressNccmd = true;
	//		//GetNcKernel()->UpdateSimpleVar(SV_COMPRESSNCCMD);
	//	}

	//	m_nCompressNccmd_Old = 2; // not accessed
	//}
	return;
}

void CTraceCtrl::ZoomRect(POINT pt_)
{
	CPoint _pt; GetCursorPos(&_pt);
	ScreenToClient(&_pt);

	CRect _rc(pt_.x, pt_.y, _pt.x, _pt.y);
	CRectTracker _tracker(&_rc, CRectTracker::solidLine);
	m_dc.SetBkColor(0xFFFFFF);
	BOOL _ret = _tracker.TrackRubberBand(this, pt_);
	if (_ret)
	{
		_rc = _tracker.m_rect;
		_rc.NormalizeRect();

		// step1: offset logical ref. point
		POINTD _pt0L, _pt1L;

		CPoint _pt0 = m_dc.GetAreaXYZ()->CenterPoint();
		CPoint _pt1 = _rc.CenterPoint();
		m_dc.DPtoLP_SM(&_pt0, &_pt0L);
		m_dc.DPtoLP_SM(&_pt1, &_pt1L);

		OffsetLogicalRef(_pt1L.x - _pt0L.x, _pt1L.y - _pt0L.y);

		// step2: get the proper zoom-ratio
		const CRect* _pRect = m_dc.GetAreaXYZ();
		double _factor1 =(double)(_pRect->Width() - 10) / _rc.Width();
		double _factor2 =(double)(_pRect->Height() - 10) / _rc.Height();
		double _factor;
		if (m_nOperation == ZOOMOUT)
		{
			_factor = __min(_factor1, _factor2);
		}
		else
		{
			_factor1 = 1.0 / _factor1;
			_factor2 = 1.0 / _factor2;
			_factor = __min(_factor1, _factor2);
		}
		double _nRatio = GetZoomRatio();
		SetZoomRatio(_nRatio * _factor);
	}
	return;
}

void CTraceCtrl::ZoomOut()
{
	SetZoomRatio(GetZoomRatio() * 1.5);
}

void CTraceCtrl::ZoomIn()
{
	SetZoomRatio(GetZoomRatio() / 1.5);
}

void CTraceCtrl::MoveRect(POINT pt_)
{
	CRect _rc(-1, -1, pt_.x, pt_.y);
	CRectTracker _tracker(&_rc, CRectTracker::solidLine);
	m_dc.SetBkColor(0xFFFFFF);
	BOOL _ret = _tracker.Track(this, pt_);
	if (_ret)
	{
		RECTD _rcLp;
		_rc.left = _tracker.m_rect.right;
		_rc.top = _tracker.m_rect.bottom;
		m_dc.DPtoLP_SM(&_rc, &_rcLp);

		OffsetLogicalRef(_rcLp.right - _rcLp.left, _rcLp.bottom - _rcLp.top);
		if (m_hWnd)
			InvalidateRect(NULL);
	}
	return;
}

void CTraceCtrl::SelectPoint(POINT pt_)
{
	LCRO_FIELD _hit = m_TrackRecord.HitTest(m_nSelectMode, pt_);
	if (!_hit.IsEmpty())
	{
		// redraw track
		m_dc.m_nNextPoint = 0;
		if (m_hWnd)
			InvalidateRect(NULL);
	}
	return;
}

void CTraceCtrl::SelectRect(POINT pt_)
{
	CPoint _pt;
	GetCursorPos(&_pt);
	ScreenToClient(&_pt);

	CRect _rc(pt_.x, pt_.y, _pt.x, _pt.y);
	CRectTracker _tracker(&_rc, CRectTracker::solidLine);
	m_dc.SetBkColor(0xFFFFFF);
	BOOL _ret = _tracker.TrackRubberBand(this, pt_);
	if (_ret)
	{
		_rc = _tracker.m_rect;
		_rc.NormalizeRect();
		LCRO_FIELD _hit = m_TrackRecord.HitTest(m_nSelectMode, &_rc);
		if (!_hit.IsEmpty())
		{
			// redraw track
			m_dc.m_nNextPoint = 0;
			if (m_hWnd)
				InvalidateRect(NULL);
		}
	}
}

void CTraceCtrl::LoadFile()
{
	//if(m_TrackRecordNode.IsOpen())
	//{
	//	KillDrawTimer();
	//	m_TrackRecordNode.Close();	
	//	ResetDrawTimer();
	//}

	if (m_bInitPerDoc)
		ClearView();

	if (m_dataprovider->ClearTrackEnable())
	{
		m_TrackRecordNode.Reset(NULL);
		m_traceAreaUpdate.Clear();
		m_bTrackLoaded = false;
	}

	ClearTrackRecordPosInfo();
	m_dc.m_nNextPoint = 0;
	m_bUpdateTrackUI = true;
	m_TraceArea.Clear();
}

void CTraceCtrl::UnLoadFile()
{
	//if(m_TrackRecordNode.IsOpen())
	//{
	//	KillDrawTimer();
	//	m_TrackRecordNode.Close();	
	//	ResetDrawTimer();
	//}

	m_TrackRecordNode.Reset(NULL);
	m_dc.m_nNextPoint = 0;
	InvalidateRect(NULL, TRUE);
	m_bTrackLoaded = false;
}

void CTraceCtrl::ClearTrack()
{
	if(m_TrackRecordNode.IsOpen())
	{
		KillDrawTimer();
		m_TrackRecordNode.Close();	
		ResetDrawTimer();
	}

	m_traceAreaUpdate.Clear();
	m_TrackRecordNode.Reset(NULL);
	m_dc.m_nNextPoint = 0;
	InvalidateRect(NULL, TRUE);
	m_bTrackLoaded = false;
}

void CTraceCtrl::OnCommandRange(UINT id_)
{
	switch (id_)
	{
	case IDCMD_TRACECTRL_ZOOMOUT:
		SetOperation(CTraceCtrl::ZOOMOUT);
		ZoomOut();
		return;
	case IDCMD_TRACECTRL_ZOOMIN:
		SetOperation(CTraceCtrl::ZOOMIN);
		ZoomIn();
		return;
	case IDCMD_TRACECTRL_MOVE:
		SetOperation(CTraceCtrl::MOVE);
		return;
	case IDCMD_TRACECTRL_CLEARVIEW:
		ClearView();
		return;
	case IDCMD_TRACECTRL_FITWINDOW:
		SetZoomRatio(GetFitZoomRatio());
		CenterWorkpiece();
		return;
	case IDCMD_TRACECTRL_CENTER:
		CenterWorkpiece();
		return;
	case IDCMD_TRACECTRL_CURRENT:
		CenterCursor();
		return;

	case IDCMD_TRACECTRL_LOAD_TRACK:
		m_dataprovider->ClearTrack();
		ClearTrack();
		m_dataprovider->LockTrack();
		m_bTrackLoaded = true;
		return;
	case IDCMD_TRACECTRL_STOP_LOAD_TRACK:
		m_dataprovider->ClearTrack();
		ClearTrack();
		return;
	case IDCMD_TRACECTRL_CLEAR_TRACK:
		m_dataprovider->ClearTrack();
		ClearTrack();
		return;
	}

	if (m_b2DMode && (id_ != IDCMD_TRACECTRL_PROJ_TOP))
		return;

	POINTD _ptCenter = GetWorkpieceCenterPoint();
	switch (id_)
	{
	case IDCMD_TRACECTRL_PROJ_ISOMETRIC_SW:
		SetTransformMatrix(CTraceCtrl::PROJ_ISOMETRIC_SW);
		m_nProjectMode = CTraceCtrl::PROJ_ISOMETRIC_SW;
		break;
	case IDCMD_TRACECTRL_PROJ_BOTTOM:
		SetTransformMatrix(CTraceCtrl::PROJ_BOTTOM);
		m_nProjectMode = CTraceCtrl::PROJ_BOTTOM;
		break;
	case IDCMD_TRACECTRL_PROJ_ISOMETRIC_SE:
		SetTransformMatrix(CTraceCtrl::PROJ_ISOMETRIC_SE);
		m_nProjectMode = CTraceCtrl::PROJ_ISOMETRIC_SE;
		break;
	case IDCMD_TRACECTRL_PROJ_LEFT:
		SetTransformMatrix(CTraceCtrl::PROJ_LEFT);
		m_nProjectMode = CTraceCtrl::PROJ_LEFT;
		break;
	case IDCMD_TRACECTRL_PROJ_FRONT:
		SetTransformMatrix(CTraceCtrl::PROJ_FRONT);
		m_nProjectMode = CTraceCtrl::PROJ_FRONT;
		break;
	case IDCMD_TRACECTRL_PROJ_BACK:
		SetTransformMatrix(CTraceCtrl::PROJ_BACK);
		m_nProjectMode = CTraceCtrl::PROJ_BACK;
		break;
	case IDCMD_TRACECTRL_PROJ_RIGHT:
		SetTransformMatrix(CTraceCtrl::PROJ_RIGHT);
		m_nProjectMode = CTraceCtrl::PROJ_RIGHT;
		break;
	case IDCMD_TRACECTRL_PROJ_ISOMETRIC_NW:
		SetTransformMatrix(CTraceCtrl::PROJ_ISOMETRIC_NW);
		m_nProjectMode = CTraceCtrl::PROJ_ISOMETRIC_NW;
		break;
	case IDCMD_TRACECTRL_PROJ_TOP:
		SetTransformMatrix(CTraceCtrl::PROJ_TOP);
		m_nProjectMode = CTraceCtrl::PROJ_TOP;
		break;
	case IDCMD_TRACECTRL_PROJ_ISOMETRIC_NE:
		SetTransformMatrix(CTraceCtrl::PROJ_ISOMETRIC_NE);
		m_nProjectMode = CTraceCtrl::PROJ_ISOMETRIC_NE;
		break;
	default:
		return;
	}
	
	CenterWorkpiece(&_ptCenter);
	return;
}

void CTraceCtrl::OnUpdateCommandRange(CCmdUI* pCmdUI)
{
	switch (pCmdUI->m_nID)
	{
	case IDCMD_TRACECTRL_ZOOMOUT:
		pCmdUI->SetCheck(m_nOperation == CTraceCtrl::ZOOMOUT); 
		return;
	case IDCMD_TRACECTRL_ZOOMIN:
		pCmdUI->SetCheck(m_nOperation == CTraceCtrl::ZOOMIN); 
		return;
	case IDCMD_TRACECTRL_MOVE:
		pCmdUI->SetCheck(m_nOperation == CTraceCtrl::MOVE); 
		return;
	case IDCMD_TRACECTRL_CLEARVIEW:
		pCmdUI->Enable(!m_TrackRecord.IsEmpty());
		return;
	case IDCMD_TRACECTRL_CLEAR_TRACK:
		pCmdUI->Enable(!m_TrackRecordNode.IsEmpty());
		return;
	case IDCMD_TRACECTRL_LOAD_TRACK:
		if(m_dataprovider->IsLoadFile==NULL)
		{
			pCmdUI->Enable(FALSE);
		}else
		{
			pCmdUI->Enable(m_dataprovider->IsLoadFile());
			pCmdUI->SetCheck(!m_TrackRecordNode.IsEmpty());
		}
		return;
	case IDCMD_TRACECTRL_STOP_LOAD_TRACK:
		pCmdUI->Enable(m_bUpdateTrackUI);
		return;
	default:
		return;
	}
}

void CTraceCtrl::OnToolCustomize()
{

	CTraceCtrlCustomizeDlg _dlg(this);
	
	_dlg.m_wndClrBkGround.m_clrCurrent = m_clrTrackBkFrom;
	_dlg.m_wndClrBkLineNum.m_clrCurrent = m_clrTrackLineNum;   
	_dlg.m_wndClrBkGround1.m_clrCurrent = m_clrTrackBkTo;
	_dlg.m_wndClrCoor.m_clrCurrent = m_clrPens[PEN_COORDARKEN];
	_dlg.m_wndClrG00.m_clrCurrent = m_clrPens[PEN_G00];
	_dlg.m_wndClrG01.m_clrCurrent = m_clrPens[PEN_G01];
	_dlg.m_wndClrG02.m_clrCurrent = m_clrPens[PEN_G02];
	_dlg.m_wndClrG03.m_clrCurrent = m_clrPens[PEN_G03];
	_dlg.m_wndClrSimuG00.m_clrCurrent = m_clrPens[PEN_G00_SIMU];
	_dlg.m_wndClrSimuG01.m_clrCurrent = m_clrPens[PEN_G01_SIMU];
	_dlg.m_wndClrSimuG02.m_clrCurrent = m_clrPens[PEN_G02_SIMU];
	_dlg.m_wndClrSimuG03.m_clrCurrent = m_clrPens[PEN_G03_SIMU];
	_dlg.m_wndClrGrid.m_clrCurrent = m_clrPens[PEN_GRID];
	_dlg.m_wndClrSelectedTrace.m_clrCurrent = m_clrPens[PEN_SELECTED];
	_dlg.m_bDrawFrame = m_bDrawWorkAreaFrame;
	_dlg.m_bShowCoor = m_bShowCoor;
	_dlg.m_bLineNumber = m_bIsShowLineNumber;   
	_dlg.m_bDrawGrid = m_bDrawGrid;
	_dlg.m_bIsFileTrackFirst = m_bIsFileTrackFirst;
	_dlg.m_bInitPerDoc = m_bInitPerDoc;
	if (_dlg.DoModal() == IDOK)
	{
		m_clrPens[PEN_COORDARKEN] = _dlg.m_wndClrCoor.m_clrCurrent;
		m_clrTrackBkFrom = _dlg.m_wndClrBkGround.m_clrCurrent;
		m_clrTrackLineNum = _dlg.m_wndClrBkLineNum.m_clrCurrent;  
		m_clrTrackBkTo = _dlg.m_wndClrBkGround1.m_clrCurrent;
		m_clrPens[PEN_G00] = _dlg.m_wndClrG00.m_clrCurrent;
		m_clrPens[PEN_G01] = _dlg.m_wndClrG01.m_clrCurrent;
		m_clrPens[PEN_G02] = _dlg.m_wndClrG02.m_clrCurrent;
		m_clrPens[PEN_G03] = _dlg.m_wndClrG03.m_clrCurrent;
		m_clrPens[PEN_G00_SIMU] = _dlg.m_wndClrSimuG00.m_clrCurrent;
		m_clrPens[PEN_G01_SIMU] = _dlg.m_wndClrSimuG01.m_clrCurrent;
		m_clrPens[PEN_G02_SIMU] = _dlg.m_wndClrSimuG02.m_clrCurrent;
		m_clrPens[PEN_G03_SIMU] = _dlg.m_wndClrSimuG03.m_clrCurrent;
		
		m_clrPens[PEN_GRID] = _dlg.m_wndClrGrid.m_clrCurrent;
		m_clrPens[PEN_SELECTED] = _dlg.m_wndClrSelectedTrace.m_clrCurrent;

		m_bShowCoor = _dlg.m_bShowCoor ? true : false;
		m_bDrawWorkAreaFrame = _dlg.m_bDrawFrame ? true : false;
		m_bIsShowLineNumber = _dlg.m_bLineNumber ? true : false;   
		m_bDrawGrid = _dlg.m_bDrawGrid == TRUE;
		m_bIsFileTrackFirst = _dlg.m_bIsFileTrackFirst == TRUE;
		m_bInitPerDoc = _dlg.m_bInitPerDoc == TRUE;
	
		UpdateDrawingTools();
		this->m_dataprovider->Save();
	}

	this->SetFocus();
}

void CTraceCtrl::DrawAssObject(void* pVoid_)
{
	ASSERT(pVoid_);
	NCNODEEX::POINT3D* _p3Dpt = (NCNODEEX::POINT3D*)pVoid_;
	DrawCrosses(&m_dc, _p3Dpt);
	DrawCurrentCoor(&m_dc);
}

void CTraceCtrl::EraseAssObject(void* pVoid_)
{
	EraseCrosses(&m_dc);
}

BOOL CTraceCtrl::OnMouseWheel(UINT nFlags, short zDelta, CPoint point_)
{
	if (zDelta > 0)
		ZoomOut();
	else if (zDelta < 0)
		ZoomIn();

	return CWnd::OnMouseWheel(nFlags, zDelta, point_);
}

INT_PTR CTraceCtrl::OnToolHitTest(CPoint point, TOOLINFO* pTI) const
{
	if (!m_strToolTip.IsEmpty())
		pTI->lpszText = _tcsdup(m_strToolTip);

	return __super::OnToolHitTest(point, pTI);
}

void CTraceCtrl::SetRectDC()
{
	CSimuDCEx *pDC_=&m_dc;
	CRect*_pRect= pDC_->GetAreaShowXYZValue(true);

	CDC* rectOldDC=rectDC;
	CBitmap* rectOldBmp=rectBmp;
	rectDC = new CDC();
	rectDC->CreateCompatibleDC(pDC_);
	rectBmp = new CBitmap();	
	rectBmp->CreateCompatibleBitmap(pDC_,_pRect->Width(),_pRect->Height());
	rectDC->SelectObject(rectBmp);
	rectDC->BitBlt(0,0,_pRect->Width(),_pRect->Height(),pDC_,_pRect->left,_pRect->top,SRCCOPY);	
	pDC_->BitBlt(_pRect->left,_pRect->top,_pRect->Width(),_pRect->Height(),rectDC,0,0,SRCCOPY);
	if (rectOldBmp!=NULL)	
	{
		rectOldDC->DeleteDC();
		rectOldBmp->DeleteObject();

		delete rectOldDC;
		delete rectOldBmp;
	}
}

//  رջͼĶʱ
void CTraceCtrl::KillDrawTimer()
{
	KillTimer(IDTIMER_READNCCMD);
	KillTimer(IDTIMER_UPDATE_TARCK);
	KillTimer(IDTIMER_SIMULATOR);
	EnableTimer(false);
}

//ͼĶʱ
void CTraceCtrl::ResetDrawTimer()
{
	SetTimer(IDTIMER_READNCCMD, 83, NULL);
	SetTimer(IDTIMER_UPDATE_TARCK, c_nCONTINUEPLAYBACK_TIMER_INTERVAL, NULL);
	EnableTimer(true);
}



